import { OnApplicationBootstrap, OnApplicationShutdown, OnModuleInit } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { DataSource, Repository } from 'typeorm';
import { BackendDTO, BackendService, Devices, LicenseLimit } from './common/backendResponse.dto';
import { ILicenseInfo } from './config/License';
import { Backend } from './entity/backend.entity';
import { ObjectItem } from './entity/objectItem.entity';
interface Tables {
    total: number;
    hw_types: {
        [key: string]: {
            total: number;
            subsystems: {
                [key: string]: {
                    total: number;
                    tables: {
                        [key: string]: number;
                    };
                };
            };
        };
    };
}
export declare class AppService implements OnModuleInit, OnApplicationShutdown, OnApplicationBootstrap {
    private configService;
    private dataSource;
    private backendRepository;
    private objectItemsRepository;
    private logger;
    constructor(configService: ConfigService, dataSource: DataSource, backendRepository: Repository<Backend>, objectItemsRepository: Repository<ObjectItem>);
    onApplicationBootstrap(): Promise<void>;
    onApplicationShutdown(signal?: string): Promise<void>;
    onModuleInit(): Promise<void>;
    getDevices(): Promise<Devices>;
    getServices(): Promise<BackendService[]>;
    getInfo(): Promise<BackendDTO>;
    getLicenseLimits(): Promise<LicenseLimit[]>;
    getLicenseInfo(): Promise<ILicenseInfo>;
    getTables(): Promise<Tables>;
}
export {};
