import { RULE_TYPE } from '@const/adminGroups.constants';
import { BasicResponseDTO } from './basicResponse.dto';
export type RuleType = typeof RULE_TYPE[keyof typeof RULE_TYPE];
export declare class AdminRoleRule {
    rule_id: string;
    type: RuleType;
    value?: string;
    constructor(rule_id: string, type: RuleType, value?: string);
}
export declare class ConfigItem {
    title: string;
    isAllowed?: boolean;
    constructor(title: string, isAllowed?: boolean);
}
export declare class HwTypeConfigItem extends ConfigItem {
    hwType: string;
    constructor(title: string, hwType: string, isAllowed?: boolean);
}
export declare class ClassConfigFolder extends ConfigItem {
    class: string;
    children: HwTypeConfigItem[];
    constructor(title: string, pClass: string, isAllowed?: boolean);
}
export declare class AdminGroupsResponseDTO extends BasicResponseDTO {
    data: Array<ClassConfigFolder>;
}
