"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminGroupsResponseDTO = exports.ClassConfigFolder = exports.HwTypeConfigItem = exports.ConfigItem = exports.AdminRoleRule = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class AdminRoleRule {
    constructor(rule_id, type, value) {
        this.rule_id = rule_id;
        this.type = type;
        if (value !== undefined) {
            this.value = value;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { rule_id: { required: true, type: () => String }, type: { required: true, type: () => Object }, value: { required: false, type: () => String } };
    }
}
exports.AdminRoleRule = AdminRoleRule;
class ConfigItem {
    constructor(title, isAllowed) {
        this.title = title;
        if (isAllowed !== undefined) {
            this.isAllowed = isAllowed;
        }
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, isAllowed: { required: false, type: () => Boolean } };
    }
}
exports.ConfigItem = ConfigItem;
class HwTypeConfigItem extends ConfigItem {
    constructor(title, hwType, isAllowed) {
        super(title, isAllowed);
        this.hwType = hwType;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { hwType: { required: true, type: () => String } };
    }
}
exports.HwTypeConfigItem = HwTypeConfigItem;
class ClassConfigFolder extends ConfigItem {
    constructor(title, pClass, isAllowed) {
        super(title, isAllowed);
        this.class = pClass;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: true, type: () => String }, children: { required: true, type: () => [require("./adminGroups.dto").HwTypeConfigItem] } };
    }
}
exports.ClassConfigFolder = ClassConfigFolder;
class AdminGroupsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./adminGroups.dto").ClassConfigFolder] } };
    }
}
exports.AdminGroupsResponseDTO = AdminGroupsResponseDTO;
//# sourceMappingURL=adminGroups.dto.js.map