"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VendorKeysResponseDTO = exports.ArchitectureResponseDTO = exports.MetricsResponseDTO = exports.ClassesResponseDTO = exports.SubsystemsResponseDTO = exports.HwTypesResponseDTO = exports.ItemsSearchResponseDTO = exports.ItemAliasesResponseDTO = exports.ItemsResponseDTO = exports.PropsResponseDTO = exports.LabelsResponseDTO = exports.ItemGroupConfigurationRequest = exports.ItemGroupMetricRequest = exports.ItemGroupPreview = exports.RegexPreviewDTO = exports.Item = exports.Labels = exports.ItemIds = exports.Class = exports.Subsystem = exports.Architecture = exports.DeleteArchitecture = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const customGroup_dto_1 = require("./customGroup.dto");
class DeleteArchitecture {
    static _OPENAPI_METADATA_FACTORY() {
        return { hostcfg_id: { required: true, type: () => String } };
    }
}
exports.DeleteArchitecture = DeleteArchitecture;
class Architecture {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String }, object_id: { required: true, type: () => String }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, parents: { required: false, type: () => [String] }, children: { required: false, type: () => [String] }, agent_mapping: { required: false, type: () => String }, hostcfg_id: { required: false, type: () => String }, wwn: { required: false, type: () => String }, wwns: { required: false, type: () => [String] }, target_wwn: { required: true, type: () => String }, target_wwns: { required: true, type: () => [String] } };
    }
}
exports.Architecture = Architecture;
class Subsystem {
    static _OPENAPI_METADATA_FACTORY() {
        return { subsystem: { required: true, type: () => String }, label: { required: true, type: () => String }, hw_type: { required: false, type: () => String }, class: { required: false, type: () => String }, items: { required: false, type: () => [require("./architecture.dto").Item] } };
    }
}
exports.Subsystem = Subsystem;
class Class {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, class: { required: true, type: () => String }, active: { required: false, type: () => Boolean } };
    }
}
exports.Class = Class;
class ItemIds {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_ids: { required: true, type: () => [String] } };
    }
}
exports.ItemIds = ItemIds;
class Labels {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.Labels = Labels;
class Item {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String }, hw_type: { required: false, type: () => String }, _hw_type: { required: false, type: () => ({ label: { required: true, type: () => String } }) }, subsystem: { required: false, type: () => String }, _subsystem: { required: false, type: () => ({ label: { required: true, type: () => String } }) }, class: { required: false, type: () => String }, _class: { required: false, type: () => ({ label: { required: true, type: () => String } }) }, parents: { required: false, type: () => [require("./architecture.dto").Item] }, root_parent: { required: false, type: () => require("./architecture.dto").Item }, url: { required: false, type: () => String }, hostcfg_id: { required: false, type: () => String }, subsystem_detail: { required: false, type: () => require("./architecture.dto").Subsystem } };
    }
}
exports.Item = Item;
class RegexPreviewDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, device: { required: false, type: () => String }, regex: { required: false, type: () => Object }, subsystem: { required: true, type: () => String }, tags: { required: false, type: () => [String] }, parents: { required: false, type: () => ({ intersection: { required: true, type: () => Boolean }, tags: { required: false, type: () => [require("./customGroup.dto").ParentTag] }, item_ids: { required: false, type: () => [String] }, regex: { required: false, type: () => [require("./customGroup.dto").ParentRegex] } }) }, linuxExclude: { required: false, type: () => Boolean } };
    }
}
exports.RegexPreviewDTO = RegexPreviewDTO;
class ItemGroupPreview extends customGroup_dto_1.ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: true, type: () => String }, linuxExclude: { required: false, type: () => Boolean } };
    }
}
exports.ItemGroupPreview = ItemGroupPreview;
class ItemGroupMetricRequest extends customGroup_dto_1.ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.ItemGroupMetricRequest = ItemGroupMetricRequest;
class ItemGroupConfigurationRequest extends ItemGroupMetricRequest {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.ItemGroupConfigurationRequest = ItemGroupConfigurationRequest;
class LabelsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./architecture.dto").Labels } };
    }
}
exports.LabelsResponseDTO = LabelsResponseDTO;
class PropsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [Object] } };
    }
}
exports.PropsResponseDTO = PropsResponseDTO;
class ItemsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./architecture.dto").Item] } };
    }
}
exports.ItemsResponseDTO = ItemsResponseDTO;
class ItemAliasesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [Object] } };
    }
}
exports.ItemAliasesResponseDTO = ItemAliasesResponseDTO;
class ItemsSearchResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => Object } };
    }
}
exports.ItemsSearchResponseDTO = ItemsSearchResponseDTO;
class HwTypesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [Object] } };
    }
}
exports.HwTypesResponseDTO = HwTypesResponseDTO;
class SubsystemsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./architecture.dto").Subsystem] } };
    }
}
exports.SubsystemsResponseDTO = SubsystemsResponseDTO;
class ClassesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./architecture.dto").Class] } };
    }
}
exports.ClassesResponseDTO = ClassesResponseDTO;
class MetricsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [Object] } };
    }
}
exports.MetricsResponseDTO = MetricsResponseDTO;
class ArchitectureResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [Object] } };
    }
}
exports.ArchitectureResponseDTO = ArchitectureResponseDTO;
class VendorKeysResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [String] } };
    }
}
exports.VendorKeysResponseDTO = VendorKeysResponseDTO;
//# sourceMappingURL=architecture.dto.js.map