export declare enum Severity {
    OK = "ok",
    WARNING = "warning",
    ERROR = "error",
    UNKNOWN = "unknown"
}
export declare const MIRROR_COLORS: {
    readonly ok: "#8FD400";
    readonly error: "#e32636";
    readonly warning: "#ffa500";
    readonly unknown: "#94c5f9";
};
export declare const HSMSateSeverity: {
    consistent_copying: Severity;
    consistent_synchronized: Severity;
    inconsistent_copying: Severity;
    consistent_disconnected: Severity;
    inconsistent_disconnected: Severity;
    consistent_stopped: Severity;
    inconsistent_stopped: Severity;
    idling_disconnected: Severity;
    idling: Severity;
    "Copy Pending": Severity;
    "Target Copy Pending": Severity;
    "Full Duplex": Severity;
    "Target Full Duplex": Severity;
    Suspended: Severity;
    "Target Suspended": Severity;
    "Validation Required": Severity;
    "Invalid State": Severity;
    "Volume Inaccessible": Severity;
    PAIR: Severity;
    PSUS: Severity;
    PSUE: Severity;
    PausedDisconnected: Severity;
    ResumingConnected: Severity;
    ResumingRRSync: Severity;
    ResumingLocalSync: Severity;
    ResumingDataTransfer: Severity;
    Active: Severity;
    Idle: Severity;
    "Paused Cluster Full": Severity;
    PausedExceededMaxSnapshotCount: Severity;
    PausedManual: Severity;
    PausedManualRemote: Severity;
    PausedQoS: Severity;
    PausedSlowLink: Severity;
    PausedVolumeSizeMismatch: Severity;
    PausedXCopy: Severity;
    StoppedMisconfigured: Severity;
    PausedMisconfigured: Severity;
    New: Severity;
    "New-SyncFromSnap": Severity;
    "New-PreSynced": Severity;
    Syncing: Severity;
    Synced: Severity;
    NotSynced: Severity;
    Failsafe: Severity;
    Stale: Severity;
    Logging: Severity;
    Starting: Severity;
    Started: Severity;
    Stopped: Severity;
    "Stopped(Grow_Failed)": Severity;
    Backup: Severity;
    Restart: Severity;
};
