"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.vendorsStorage = exports.vendorsLan = exports.vendorsSan = void 0;
const hwTypeKey_constants_1 = require("./hwTypeKey.constants");
exports.vendorsSan = {
    BROADCOM: {
        label: '',
        helpUrl: 'https://xormon.com/install-network.php',
        devices: {
            BROCADE: { label: 'Brocade', hwType: hwTypeKey_constants_1.HwTypeKey.SANBRCD }
        }
    },
    CISCO: {
        label: '',
        helpUrl: 'https://xormon.com/install-network.php',
        devices: {
            CISCO: { label: 'Cisco', hwType: hwTypeKey_constants_1.HwTypeKey.SANCISCO }
        }
    },
    SANNAV: {
        label: '',
        helpUrl: 'https://xormon.com/install-network.php#SANnav',
        devices: {
            SANNAV: { label: 'SANnav', hwType: hwTypeKey_constants_1.HwTypeKey.SANNAV }
        }
    }
};
exports.vendorsLan = {
    CISCO_LAN: {
        label: '',
        helpUrl: 'https://xormon.com/install-network.php#LAN',
        devices: {
            CISCO: { label: 'Cisco switch', hwType: hwTypeKey_constants_1.HwTypeKey.LANCISCO }
        }
    },
    OTHERS_LAN: {
        label: '',
        helpUrl: 'https://xormon.com/install-network.php#LAN',
        devices: {
            OTHER: { label: 'Non-Cisco switch', hwType: hwTypeKey_constants_1.HwTypeKey.LANOTHERS }
        }
    }
};
exports.vendorsStorage = Object.freeze({
    CEPH: {
        label: 'CEPH',
        helpUrl: 'https://xormon.com/Ceph-monitoring.php',
        devices: {
            CEPH: { label: 'Ceph', hwType: hwTypeKey_constants_1.HwTypeKey.CEPH }
        }
    },
    COHESITY: {
        label: 'Cohesity',
        helpUrl: 'https://xormon.com/Cohesity-monitoring.php',
        devices: {
            DATAPROTECT: { label: 'DataProtect', hwType: hwTypeKey_constants_1.HwTypeKey.COHESITY }
        }
    },
    DATA_CORE: {
        label: 'DataCore',
        helpUrl: 'https://xormon.com/DataCore-SANsymphony-monitoring.php',
        devices: {
            SAN_SYMPHONY: { label: 'SANsymphony', hwType: hwTypeKey_constants_1.HwTypeKey.DATACORE }
        }
    },
    DDN: {
        label: 'DDN',
        helpUrl: 'https://xormon.com/DDN-monitoring.php',
        devices: {
            INTELLI_FLASH: { label: 'IntelliFlash', hwType: hwTypeKey_constants_1.HwTypeKey.DDNINTELLIFLASH }
        }
    },
    DELL_EMC: {
        label: 'Dell EMC²',
        helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php',
        devices: {
            CLARION: {
                label: "CLARiiON CX4", hwType: hwTypeKey_constants_1.HwTypeKey.VNX,
                helpUrl: "https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VNX"
            },
            DATADOMAIN: { label: "DataDomain", hwType: hwTypeKey_constants_1.HwTypeKey.DATADOMAIN, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#DATADOMAIN' },
            ELASTIC: { label: "Elastic Cloud Storage", hwType: hwTypeKey_constants_1.HwTypeKey.ECS, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ECS' },
            EQUALOGIC: { label: "EqualLogic", hwType: hwTypeKey_constants_1.HwTypeKey.EQUALOGIC },
            ISILON: { label: 'Isilon', hwType: hwTypeKey_constants_1.HwTypeKey.ISILON, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ISILON' },
            POWERFLEX: { label: "PowerFlex", hwType: hwTypeKey_constants_1.HwTypeKey.POWERFLEX, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#POWERFLEX' },
            POWERMAX: { label: "PowerMAX", hwType: hwTypeKey_constants_1.HwTypeKey.VMAX, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VMAX' },
            POWERSCALE: { label: "PowerScale", hwType: hwTypeKey_constants_1.HwTypeKey.ISILON, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ISILON' },
            POWERSTORE: { label: "PowerStore", hwType: hwTypeKey_constants_1.HwTypeKey.POWERSTORE, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#POWERSTORE' },
            POWERVAULT_MD3K: { label: "PowerVault MD3000", hwType: hwTypeKey_constants_1.HwTypeKey.ESERIES, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ME4' },
            POWERVAULT_ME4: { label: "PowerVault ME4", hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ME4-WBI' },
            POWERVAULT_ME5: { label: "PowerVault ME5", hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#ME4' },
            SCS_COMPELLENT: { label: "SC Series (Compellent)", hwType: hwTypeKey_constants_1.HwTypeKey.COMPELLENT, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#Compellent' },
            UNITY: { label: "Unity", hwType: hwTypeKey_constants_1.HwTypeKey.UNITY, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#UNITY' },
            VMAX: { label: "VMAX", hwType: hwTypeKey_constants_1.HwTypeKey.VMAX, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VMAX' },
            VNX_BLOCK: { label: "VNX block", hwType: hwTypeKey_constants_1.HwTypeKey.VNX },
            VNXE: { label: "VNXe", hwType: hwTypeKey_constants_1.HwTypeKey.VNXE, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VNXE' },
            VNX_CELERRA: { label: "VNX for file (Celerra)", hwType: hwTypeKey_constants_1.HwTypeKey.VNXF, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VNXF' },
            VPLEX: { label: "VPLEX", hwType: hwTypeKey_constants_1.HwTypeKey.VPLEX, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#VPLEX' },
            XTREMIO: { label: "XtremIO", hwType: hwTypeKey_constants_1.HwTypeKey.XTREMIO, helpUrl: 'https://xormon.com/EMC-PowerMax-VMAX-VNX-Unity-VPLEX-DataDomain-Isilon-XtremIO-CLARiiON-Celerra-monitoring.php#XTREMIO' }
        }
    },
    DOTHILL: {
        label: 'Dothill',
        helpUrl: 'https://xormon.com/DotHill-monitoring.php',
        devices: {
            ASSURED_SAN: { label: 'AssuredSAN', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL }
        }
    },
    FALCON_STOR: {
        label: 'FalconStor',
        helpUrl: 'https://xormon.com/FalconStor-FreeStor-monitoring.php',
        devices: {
            FREE_STOR: { label: 'FreeStor', hwType: hwTypeKey_constants_1.HwTypeKey.FALCONSTOR }
        }
    },
    FUJITSU: {
        label: 'Fujitsu',
        helpUrl: 'https://xormon.com/Fujitsu-ETERNUS-monitoring.php',
        devices: {
            ETERNUM: { label: 'Eternus', hwType: hwTypeKey_constants_1.HwTypeKey.ETERNUS }
        }
    },
    HITACHI: {
        label: 'Hitachi',
        helpUrl: 'https://xormon.com/Hitachi-VSPG-VSP-HUS-AMS-HNAS-monitoring.php',
        devices: {
            ASM: { label: 'ASM', hwType: hwTypeKey_constants_1.HwTypeKey.HUS, helpUrl: 'https://xormon.com/Hitachi-VSPG-VSP-HUS-AMS-HNAS-monitoring.php#HUS' },
            HCP: { label: 'HCP', hwType: hwTypeKey_constants_1.HwTypeKey.HCP, helpUrl: 'https://xormon.com/Hitachi-VSPG-VSP-HUS-AMS-HNAS-monitoring.php#HCP' },
            HNAS: { label: 'HNAS', hwType: hwTypeKey_constants_1.HwTypeKey.HNAS, helpUrl: 'https://xormon.com/Hitachi-VSPG-VSP-HUS-AMS-HNAS-monitoring.php#HNAS' },
            HUS: { label: 'HUS', hwType: hwTypeKey_constants_1.HwTypeKey.HUS, helpUrl: 'https://xormon.com/Hitachi-VSPG-VSP-HUS-AMS-HNAS-monitoring.php#HUS' },
            HUS_VM: { label: 'HUS-VM', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG },
            VSP_E: { label: 'VSP-E', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG },
            VSP_F: { label: 'VSP-F', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG },
            VSP_G: { label: 'VSP-G', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG },
            VSP: { label: 'VSP', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG },
            VSP_5K: { label: 'VSP 5000', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG }
        }
    },
    HPE: {
        label: 'HPE',
        helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php',
        devices: {
            ALLETRA_6K: { label: 'Alletra 6XXX', hwType: hwTypeKey_constants_1.HwTypeKey.NIMBLE, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#NIMBLE' },
            ALLETRA_9K: { label: 'Alletra 9XXX', hwType: hwTypeKey_constants_1.HwTypeKey._3PAR },
            LEFT_HAND: { label: 'LeftHand', hwType: hwTypeKey_constants_1.HwTypeKey.STOREVIRTUAL },
            MSA_P2K: { label: 'MSA', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#MSA-WBI' },
            NIMBLE: { label: 'Nimble', hwType: hwTypeKey_constants_1.HwTypeKey.NIMBLE, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#NIMBLE' },
            PRIMERA: { label: 'Primera', hwType: hwTypeKey_constants_1.HwTypeKey._3PAR },
            STORE_ONCE: { label: 'StoreOnce', hwType: hwTypeKey_constants_1.HwTypeKey.STOREONCE, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#STOREONCE' },
            STORE_VIRTUAL: { label: 'StoreVirtual', hwType: hwTypeKey_constants_1.HwTypeKey.STOREVIRTUAL, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#STOREVIRTUAL' },
            XP7: { label: 'XP7', hwType: hwTypeKey_constants_1.HwTypeKey.VSPG, helpUrl: 'https://xormon.com/HPE-3PAR-MSA-XP7-NIMBLE-StoreOnce-monitoring.php#XP7' },
            PAR3: { label: '3PAR', hwType: hwTypeKey_constants_1.HwTypeKey._3PAR }
        }
    },
    HUAWEI: {
        label: 'Huawei',
        helpUrl: 'https://xormon.com/Huawei-OceanStor-Dorado-monitoring.php',
        devices: {
            DORADO: { label: 'Dorado', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTOR },
            OCEAN_DISK: { label: 'OceanDisk', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTOR },
            OCEAN_PROTECT: { label: 'OceanProtect Backup Storage', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTOR },
            OCEAN_STOR: { label: 'OceanStor', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTOR },
            OCEAN_STOR_A_SERIES: { label: 'OceanStor A series', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTOR },
            OCEAN_STOR_PACIFIC_SERIES: { label: 'OceanStor Pacific Series', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTORPACIFIC },
            OCEAN_STOR_PACIFIC_SERIES_NAS: { label: 'OceanStor Pacific Series NAS', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTORPACIFICNAS },
            OCEAN_STOR_9000_V5_SCALE_NAS: { label: 'OceanStor 9000 V5 Scale-out NAS', hwType: hwTypeKey_constants_1.HwTypeKey.OCEANSTORNAS }
        }
    },
    IBM: {
        label: 'IBM',
        helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php',
        devices: {
            COSS: { label: 'Cloud Object Storage System', hwType: hwTypeKey_constants_1.HwTypeKey.IBMCOSS, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#COS' },
            DS_3_4_5_DSC_37: { label: 'DS3000/4000/5000 DSC3700', hwType: hwTypeKey_constants_1.HwTypeKey.ESERIES, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#ESERIES' },
            DS8K: { label: 'DS8000', hwType: hwTypeKey_constants_1.HwTypeKey.DS8K, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#DS8000' },
            FS_A9K: { label: 'FlashSystem A9000', hwType: hwTypeKey_constants_1.HwTypeKey.XIV, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#XIV' },
            FS_V9K: { label: 'FlashSystem V9000/V8400', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#IBMV9000' },
            FS_5K_7K_9K: { label: 'FlashSystem 5/7/9XXX', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#IBMV9000' },
            FS_900: { label: 'FlashSystem 900/840', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#IBMFLASH' },
            FS_9100: { label: 'FlashSystem 9100', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#IBMV9000' },
            FS_9K_7K_5K: { label: 'FlashSystem 9000, 7000, 5000', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#IBMV9000' },
            SPECTRUM_ACCELERATE: { label: 'Spectrum Accelerate (XIV)', hwType: hwTypeKey_constants_1.HwTypeKey.XIV, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#SPECTRUMSCALE' },
            SPECTRUM_VIRTUALIZE: { label: 'Spectrum Virtualize (SVC)', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#SPECTRUMSCALE' },
            STORWIZE_FAMILY: { label: 'Storwize family', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ },
            SPECTRUM_SCALE: { label: 'Spectrum Scale', hwType: hwTypeKey_constants_1.HwTypeKey.GPFS, helpUrl: 'https://xormon.com/IBM-SVC-Storwize-XIV-DS8000-monitoring.php#SPECTRUMSCALE' }
        }
    },
    INFINIDAT: {
        label: 'Infinidat',
        helpUrl: 'https://xormon.com/INFINIDAT-Infinibox-monitoring.php',
        devices: {
            INFINI_BOX: { label: 'InfiniBox', hwType: hwTypeKey_constants_1.HwTypeKey.INFINIBOX },
            INFINI_GUARD: { label: 'InfiniGuard', hwType: hwTypeKey_constants_1.HwTypeKey.INFINIGUARD, helpUrl: "https://xormon.com/INFINIDAT-Infinibox-monitoring.php#InfiniGuard" }
        }
    },
    INFORTREND: {
        label: 'Infortrend',
        helpUrl: 'https://xormon.com/Infortrend-monitoring.php',
        devices: {
            EONSTOR: { label: 'EonStor', hwType: hwTypeKey_constants_1.HwTypeKey.INFORTREND }
        }
    },
    INSPUR: {
        label: 'Inspur',
        helpUrl: 'https://xormon.com/Inspur-monitoring.php',
        devices: {
            AS_55_53_26_22: { label: 'AS5500/5300/2600/2200', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ }
        }
    },
    IXSYSTEMS: {
        label: 'iXsystems',
        helpUrl: 'https://xormon.com/FreeNAS-TrueNAS-monitoring.php',
        devices: {
            FREE_NAS: { label: 'FreeNAS', hwType: hwTypeKey_constants_1.HwTypeKey.FREENAS }
        }
    },
    LENOVO: {
        label: "Lenovo",
        helpUrl: 'https://xormon.com/Lenovo-Storwize-S3200-S2200-monitoring.php',
        devices: {
            STORAGE_S_SERIES: { label: 'Storage S Series (S2200/S3200)', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL, helpUrl: 'https://xormon.com/Lenovo-storage-monitoring.php#S2200-WBI' },
            STORAGE_V_SERIES: { label: 'Storage V Series (V5030/V3700)', hwType: hwTypeKey_constants_1.HwTypeKey.SWIZ },
            TS_DE_SERIES: { label: 'ThinkSystem DE series', hwType: hwTypeKey_constants_1.HwTypeKey.ESERIES, helpUrl: 'https://xormon.com/Lenovo-storage-monitoring.php#DEseries' },
            TS_DS_SERIES: { label: 'ThinkSystem DS Series', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL, helpUrl: 'https://xormon.com/Lenovo-storage-monitoring.php#DS-WBI' },
            TS_DM_SERIES: { label: 'ThinkSystem DM / DG Series', hwType: hwTypeKey_constants_1.HwTypeKey.NETAPP, helpUrl: 'https://xormon.com/Lenovo-storage-monitoring.php#DM-RESTAPI' }
        }
    },
    MACRO_SAN: {
        label: 'MacroSAN',
        helpUrl: 'https://xormon.com/MacroSAN-monitoring.php',
        devices: {
            MACRO_SAN: { label: 'MacroSAN', hwType: hwTypeKey_constants_1.HwTypeKey.MACROSAN }
        }
    },
    NETAPP: {
        label: 'NetApp',
        helpUrl: 'https://xormon.com/NetApp-monitoring.php',
        devices: {
            EF_SERIES: { label: 'E/EF series', hwType: hwTypeKey_constants_1.HwTypeKey.ESERIES, helpUrl: 'https://xormon.com/NetApp-monitoring.php#Eseries' },
            FAS_CDOT: { label: 'FAS CDOT', hwType: hwTypeKey_constants_1.HwTypeKey.NETAPP, helpUrl: 'https://xormon.com/NetApp-monitoring.php#NETAPP7' },
            ASA_ASERIES: { label: 'ASA A-series', hwType: hwTypeKey_constants_1.HwTypeKey.NETAPP },
            ONTAP_SELECT: { label: 'ONTAP Select', hwType: hwTypeKey_constants_1.HwTypeKey.NETAPP, helpUrl: 'https://xormon.com/NetApp-monitoring.php#ONTAPSelect' },
            SOLID_FIRE: { label: 'SolidFire', hwType: hwTypeKey_constants_1.HwTypeKey.SOLIDFIRE, helpUrl: 'https://xormon.com/NetApp-monitoring.php#SolidFire' },
            STORAGE_GRID: { label: 'StorageGrid', hwType: hwTypeKey_constants_1.HwTypeKey.STORAGEGRID, helpUrl: 'https://xormon.com/NetApp-monitoring.php#StorageGRID' },
            AFF_CSERIES: { label: 'AFF C-Series', hwType: hwTypeKey_constants_1.HwTypeKey.NETAPP, helpUrl: 'https://xormon.com/NetApp-monitoring.php#NETAPP7' }
        }
    },
    PROMISE_TECHNO: {
        label: 'Promise Technology',
        helpUrl: 'https://xormon.com/Promise-monitoring.php',
        devices: {
            VTRAK: { label: 'VTrak', hwType: hwTypeKey_constants_1.HwTypeKey.VTRAK }
        }
    },
    PURE_STORAGE: {
        label: 'Pure Storage',
        helpUrl: 'https://xormon.com/PureStorage-monitoring.php',
        devices: {
            FLASH_ARRAY: { label: 'FlashArray', hwType: hwTypeKey_constants_1.HwTypeKey.PURE },
            FLASH_BLADE: { label: 'FlashBlade', hwType: hwTypeKey_constants_1.HwTypeKey.PUREBLADE, helpUrl: 'https://xormon.com/PureStorage-monitoring.php#FlashBlade' }
        }
    },
    ORACLE: {
        label: 'Oracle',
        helpUrl: 'https://xormon.com/Oracle-ZFS-monitoring.php',
        devices: {
            ZFS: { label: 'ZFS', hwType: hwTypeKey_constants_1.HwTypeKey.ORACLEZFS }
        }
    },
    QNAP_SYSTEMS: {
        label: 'QNAP Systems',
        helpUrl: 'https://xormon.com/QNAP-monitoring.php',
        devices: {
            QNAP: { label: 'QNAP', hwType: hwTypeKey_constants_1.HwTypeKey.QNAP }
        }
    },
    QUANTUM: {
        label: 'Quantum',
        helpUrl: 'https://xormon.com/Quantum-StorNext-monitoring.php',
        devices: {
            STOR_NEXT: { label: 'StorNext', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL }
        }
    },
    QUMULO: {
        label: 'Qumulo',
        helpUrl: 'https://xormon.com/Qumulo-monitoring.php',
        devices: {
            QUMULO: { label: 'Qumulo', hwType: hwTypeKey_constants_1.HwTypeKey.QUMULO }
        }
    },
    RUBRIK: {
        label: 'Rubrik',
        helpUrl: 'https://xormon.com/Rubrik-monitoring.php',
        devices: {
            RUBRIK_CDM: { label: 'Cloud Data Management (CDM)', hwType: hwTypeKey_constants_1.HwTypeKey.RUBRIK }
        }
    },
    SEAGATE: {
        label: 'Seagate',
        helpUrl: 'https://xormon.com/Seagate-monitoring.php',
        devices: {
            EXOS_X: { label: 'Exos X', hwType: hwTypeKey_constants_1.HwTypeKey.DOTHILL }
        }
    },
    SYNOLOGY: {
        label: 'Synology Inc.',
        helpUrl: 'https://xormon.com/Synology-monitoring.php',
        devices: {
            SYNOLOGY: { label: 'Synology', hwType: hwTypeKey_constants_1.HwTypeKey.SYNOLOGY }
        }
    },
    VERITAS: {
        label: 'Veritas',
        helpUrl: 'https://xormon.com/Veritas-NetBackup-monitoring.php',
        devices: {
            NET_BACKUP: { label: 'NetBackup', hwType: hwTypeKey_constants_1.HwTypeKey.NETBACKUP }
        }
    },
});
//# sourceMappingURL=vendors.constants.js.map