"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomGroupFavoriteResponseDTO = exports.GroupCustomGroupFoldersDTO = exports.GroupCustomGroupFolder = exports.CustomGroupResponseDTO = exports.CustomGroupsResponseDTO = exports.CustomGroupFolderResponseDTO = exports.GroupCustomGroupFoldersTreeDTO = exports.CustomGroupFoldersResponseDTO = exports.GroupCustomGroupFolderTree = exports.CustomGroupItemGroup = exports.CustomGroup = exports.CreateCustomGroupFolder = exports.CustomGroupFolderTree = exports.CustomGroupFolder = exports.UpdateCustomGroupDTO = exports.CreateCustomGroupDTO = exports.CustomGroupItemDTO = exports.CustomGroupSearchDTO = exports.CustomGroupItemParent = exports.CustomGroupItem = exports.ParentRegex = exports.ParentTag = exports.SavedItemGroup = exports.ItemGroupWithLabels = exports.ItemGroupParents = exports.ItemGroupParentTag = exports.ItemGroupTag = exports.ItemGroup = exports.SavedItemStructure = exports.ItemStructure = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const menuResponse_dto_1 = require("./menuResponse.dto");
class ItemStructure {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: true, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: true, type: () => String }, groups: { required: true, type: () => [require("./customGroup.dto").ItemGroup] } };
    }
}
exports.ItemStructure = ItemStructure;
class SavedItemStructure extends ItemStructure {
    static _OPENAPI_METADATA_FACTORY() {
        return { groups: { required: true, type: () => [require("./customGroup.dto").SavedItemGroup] } };
    }
}
exports.SavedItemStructure = SavedItemStructure;
class ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_ids: { required: false, type: () => [String] }, regex: { required: false, type: () => [String] }, tags: { required: false, type: () => [String] }, parents: { required: false, type: () => ({ intersection: { required: true, type: () => Boolean }, tags: { required: false, type: () => [require("./customGroup.dto").ParentTag] }, item_ids: { required: false, type: () => [String] }, regex: { required: false, type: () => [require("./customGroup.dto").ParentRegex] } }) } };
    }
}
exports.ItemGroup = ItemGroup;
class ItemGroupTag {
    static _OPENAPI_METADATA_FACTORY() {
        return { tag_id: { required: true, type: () => String }, tag: { required: true, type: () => String } };
    }
}
exports.ItemGroupTag = ItemGroupTag;
class ItemGroupParentTag extends ItemGroupTag {
    static _OPENAPI_METADATA_FACTORY() {
        return { subsystem: { required: true, type: () => String } };
    }
}
exports.ItemGroupParentTag = ItemGroupParentTag;
class ItemGroupParents {
    static _OPENAPI_METADATA_FACTORY() {
        return { intersection: { required: true, type: () => Boolean }, items: { required: false, type: () => [require("./architecture.dto").Item] }, regex: { required: false, type: () => [require("./customGroup.dto").ParentRegex] }, tags: { required: false, type: () => [require("./customGroup.dto").ItemGroupParentTag] } };
    }
}
exports.ItemGroupParents = ItemGroupParents;
class ItemGroupWithLabels {
    static _OPENAPI_METADATA_FACTORY() {
        return { items: { required: false, type: () => [require("./architecture.dto").Item] }, regex: { required: false, type: () => [String] }, tags: { required: false, type: () => [require("./customGroup.dto").ItemGroupTag] }, parents: { required: false, type: () => require("./customGroup.dto").ItemGroupParents } };
    }
}
exports.ItemGroupWithLabels = ItemGroupWithLabels;
class SavedItemGroup extends ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_group_id: { required: true, type: () => String } };
    }
}
exports.SavedItemGroup = SavedItemGroup;
class ParentTag {
    static _OPENAPI_METADATA_FACTORY() {
        return { tag: { required: true, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.ParentTag = ParentTag;
class ParentRegex {
    static _OPENAPI_METADATA_FACTORY() {
        return { regex: { required: true, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.ParentRegex = ParentRegex;
class CustomGroupItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String }, parents: { required: false, type: () => [require("./customGroup.dto").CustomGroupItemParent] } };
    }
}
exports.CustomGroupItem = CustomGroupItem;
class CustomGroupItemParent {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String } };
    }
}
exports.CustomGroupItemParent = CustomGroupItemParent;
class CustomGroupSearchDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => Object } };
    }
}
exports.CustomGroupSearchDTO = CustomGroupSearchDTO;
class CustomGroupItemDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./customGroup.dto").CustomGroupItem] } };
    }
}
exports.CustomGroupItemDTO = CustomGroupItemDTO;
class CreateCustomGroupDTO extends ItemStructure {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, custom_group_folder_id: { required: true, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.CreateCustomGroupDTO = CreateCustomGroupDTO;
class UpdateCustomGroupDTO extends SavedItemStructure {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, custom_group_id: { required: true, type: () => String }, custom_group_folder_id: { required: true, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.UpdateCustomGroupDTO = UpdateCustomGroupDTO;
class CustomGroupFolder {
    static _OPENAPI_METADATA_FACTORY() {
        return { custom_group_folder_id: { required: false, type: () => String }, label: { required: true, type: () => String }, parent: { required: false, type: () => String }, path: { required: false, type: () => String } };
    }
}
exports.CustomGroupFolder = CustomGroupFolder;
class CustomGroupFolderTree {
    static _OPENAPI_METADATA_FACTORY() {
        return { custom_group_folder_id: { required: false, type: () => String }, label: { required: true, type: () => String }, children: { required: false, type: () => [require("./customGroup.dto").CustomGroupFolderTree] } };
    }
}
exports.CustomGroupFolderTree = CustomGroupFolderTree;
class CreateCustomGroupFolder {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, parent: { required: false, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.CreateCustomGroupFolder = CreateCustomGroupFolder;
class CustomGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { custom_group_id: { required: false, type: () => String }, class: { required: true, type: () => String }, label: { required: true, type: () => String }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, groups: { required: true, type: () => [require("./customGroup.dto").CustomGroupItemGroup] }, custom_group_folder_id: { required: false, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.CustomGroup = CustomGroup;
class CustomGroupItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { items: { required: false, type: () => [require("./architecture.dto").Item] }, regex: { required: false, type: () => [String] }, tags: { required: false }, parents: { required: true, type: () => ({ intersection: { required: true, type: () => Boolean }, items: { required: false, type: () => [require("./architecture.dto").Item] }, regex: { required: false, type: () => [require("./customGroup.dto").ParentRegex] }, tags: { required: false } }) } };
    }
}
exports.CustomGroupItemGroup = CustomGroupItemGroup;
class GroupCustomGroupFolderTree {
    static _OPENAPI_METADATA_FACTORY() {
        return { group_id: { required: true, type: () => Number }, label: { required: true, type: () => String }, children: { required: true, type: () => [require("./customGroup.dto").CustomGroupFolderTree] } };
    }
}
exports.GroupCustomGroupFolderTree = GroupCustomGroupFolderTree;
class CustomGroupFoldersResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./customGroup.dto").CustomGroupFolderTree] } };
    }
}
exports.CustomGroupFoldersResponseDTO = CustomGroupFoldersResponseDTO;
class GroupCustomGroupFoldersTreeDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./customGroup.dto").GroupCustomGroupFolderTree] } };
    }
}
exports.GroupCustomGroupFoldersTreeDTO = GroupCustomGroupFoldersTreeDTO;
class CustomGroupFolderResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./customGroup.dto").CustomGroupFolder } };
    }
}
exports.CustomGroupFolderResponseDTO = CustomGroupFolderResponseDTO;
class CustomGroupsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./customGroup.dto").CustomGroup] } };
    }
}
exports.CustomGroupsResponseDTO = CustomGroupsResponseDTO;
class CustomGroupResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./customGroup.dto").CustomGroup } };
    }
}
exports.CustomGroupResponseDTO = CustomGroupResponseDTO;
class GroupCustomGroupFolder extends menuResponse_dto_1.MenuItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { group_id: { required: true, type: () => Number } };
    }
}
exports.GroupCustomGroupFolder = GroupCustomGroupFolder;
class GroupCustomGroupFoldersDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./customGroup.dto").GroupCustomGroupFolder] } };
    }
}
exports.GroupCustomGroupFoldersDTO = GroupCustomGroupFoldersDTO;
class CustomGroupFavoriteResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => ({ favorite: { required: true, type: () => Boolean } }) } };
    }
}
exports.CustomGroupFavoriteResponseDTO = CustomGroupFavoriteResponseDTO;
//# sourceMappingURL=customGroup.dto.js.map