import { DASHBOARD_TYPE } from '@const/dashboard.constants';
import { BasicResponseDTO } from './basicResponse.dto';
import { MenuItem } from './menuResponse.dto';
import { GraphBase, GraphInterval } from './pageResponse.dto';
export type DashboardType = typeof DASHBOARD_TYPE[keyof typeof DASHBOARD_TYPE];
export declare class DashboardDTO {
    dashboard_id: string;
    label: string;
    type: DashboardType;
    groups: DashboardGroupDTO[];
    folder: string;
    default: boolean;
    width: number;
}
export declare class DefaultDashboard {
    dashboard: DashboardDTO;
    path: MenuItem[];
}
export declare class DefaultDashboardDTO extends BasicResponseDTO {
    data: DefaultDashboard;
}
export declare class DashboardGroupDTO {
    dashboard_group_id: string;
    dashboard_id?: string;
    label: string;
}
export declare class DashboardGroupsDTO extends BasicResponseDTO {
    data: DashboardGroupDTO[];
}
export declare class DashboardGraph extends GraphBase {
    static readonly DEFAULT_COORDINATE = 99;
    label: string;
    interval: GraphInterval;
    width: number;
    height: number;
    url: string;
    x: number;
    y: number;
    dashboard_graph_id: string;
    tab: string;
}
export declare class DashboardGroup {
    graphs: DashboardGraph[];
    label: string;
    width: number;
    height: number;
    x: number;
    y: number;
    dashboard_group_id: string;
}
export declare class DashboardFolder {
    dashboard_folder_id: string;
    label: string;
    type: DashboardType;
}
export declare class CreateDashboardGraphDTO {
    dashboard_group_id: string;
    url: string;
    tab: string;
    interval: GraphInterval;
}
export declare class FindDashboardGraphDTO {
    url: string;
    tab: string;
    interval?: GraphInterval;
}
export declare class CreateDTO {
    label: string;
    parent: string;
    group_id?: number;
}
export declare class UpdateDashboardDTO {
    label?: string;
    parent?: string;
    width?: number;
}
export declare class UpdateDashboardFolderDTO {
    label: string;
    parent: string;
    group_id?: number;
}
export declare class CreateResponseDTO extends BasicResponseDTO {
    data: {
        id: string;
        label?: string;
        parent?: string;
    };
}
export declare class FindGraph {
    interval: GraphInterval;
    dashboard_graph_id: string;
    dashboard_group: {
        label: string;
        dashboard_group_id: string;
    };
    dashboard: {
        label: string;
        dashboard_id: string;
    };
    group_id?: number;
}
export declare class FindGraphsDTO extends BasicResponseDTO {
    data: FindGraph[];
}
export declare class UpdateDashboardGraphDTO {
    width?: number;
    height?: number;
    url?: string;
    x?: number;
    y?: number;
    interval?: GraphInterval;
    tab?: string;
    dashboard_group_id: string;
    constructor(graph: DashboardGraph);
}
export declare class UpdateDashboardGroupDTO {
    width: number;
    height: number;
    x: number;
    y: number;
    label: string;
    dashboard_id: string;
    constructor(group: DashboardGroup);
}
export declare class GroupDashboardFolder extends MenuItem {
    group_id: number;
}
export declare class GroupDashboardFoldersDTO extends BasicResponseDTO {
    data: GroupDashboardFolder[];
}
