"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupDashboardFoldersDTO = exports.GroupDashboardFolder = exports.UpdateDashboardGroupDTO = exports.UpdateDashboardGraphDTO = exports.FindGraphsDTO = exports.FindGraph = exports.CreateResponseDTO = exports.UpdateDashboardFolderDTO = exports.UpdateDashboardDTO = exports.CreateDTO = exports.FindDashboardGraphDTO = exports.CreateDashboardGraphDTO = exports.DashboardFolder = exports.DashboardGroup = exports.DashboardGraph = exports.DashboardGroupsDTO = exports.DashboardGroupDTO = exports.DefaultDashboardDTO = exports.DefaultDashboard = exports.DashboardDTO = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const menuResponse_dto_1 = require("./menuResponse.dto");
const pageResponse_dto_1 = require("./pageResponse.dto");
class DashboardDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_id: { required: true, type: () => String }, label: { required: true, type: () => String }, type: { required: true, type: () => Object }, groups: { required: true, type: () => [require("./dashboard.dto").DashboardGroupDTO] }, folder: { required: true, type: () => String }, default: { required: true, type: () => Boolean }, width: { required: true, type: () => Number } };
    }
}
exports.DashboardDTO = DashboardDTO;
class DefaultDashboard {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard: { required: true, type: () => require("./dashboard.dto").DashboardDTO }, path: { required: true, type: () => [require("./menuResponse.dto").MenuItem] } };
    }
}
exports.DefaultDashboard = DefaultDashboard;
class DefaultDashboardDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./dashboard.dto").DefaultDashboard } };
    }
}
exports.DefaultDashboardDTO = DefaultDashboardDTO;
class DashboardGroupDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_group_id: { required: true, type: () => String }, dashboard_id: { required: false, type: () => String }, label: { required: true, type: () => String } };
    }
}
exports.DashboardGroupDTO = DashboardGroupDTO;
class DashboardGroupsDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./dashboard.dto").DashboardGroupDTO] } };
    }
}
exports.DashboardGroupsDTO = DashboardGroupsDTO;
class DashboardGraph extends pageResponse_dto_1.GraphBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, interval: { required: true, type: () => Object }, width: { required: true, type: () => Number }, height: { required: true, type: () => Number }, url: { required: true, type: () => String }, x: { required: true, type: () => Number }, y: { required: true, type: () => Number }, dashboard_graph_id: { required: true, type: () => String }, tab: { required: true, type: () => String } };
    }
}
exports.DashboardGraph = DashboardGraph;
DashboardGraph.DEFAULT_COORDINATE = 99;
class DashboardGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { graphs: { required: true, type: () => [require("./dashboard.dto").DashboardGraph] }, label: { required: true, type: () => String }, width: { required: true, type: () => Number }, height: { required: true, type: () => Number }, x: { required: true, type: () => Number }, y: { required: true, type: () => Number }, dashboard_group_id: { required: true, type: () => String } };
    }
}
exports.DashboardGroup = DashboardGroup;
class DashboardFolder {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_folder_id: { required: true, type: () => String }, label: { required: true, type: () => String }, type: { required: true, type: () => Object } };
    }
}
exports.DashboardFolder = DashboardFolder;
class CreateDashboardGraphDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_group_id: { required: true, type: () => String }, url: { required: true, type: () => String }, tab: { required: true, type: () => String }, interval: { required: true, type: () => Object } };
    }
}
exports.CreateDashboardGraphDTO = CreateDashboardGraphDTO;
class FindDashboardGraphDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { url: { required: true, type: () => String }, tab: { required: true, type: () => String }, interval: { required: false, type: () => Object } };
    }
}
exports.FindDashboardGraphDTO = FindDashboardGraphDTO;
class CreateDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, parent: { required: true, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.CreateDTO = CreateDTO;
class UpdateDashboardDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: false, type: () => String }, parent: { required: false, type: () => String }, width: { required: false, type: () => Number } };
    }
}
exports.UpdateDashboardDTO = UpdateDashboardDTO;
class UpdateDashboardFolderDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, parent: { required: true, type: () => String }, group_id: { required: false, type: () => Number } };
    }
}
exports.UpdateDashboardFolderDTO = UpdateDashboardFolderDTO;
class CreateResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => ({ id: { required: true, type: () => String }, label: { required: false, type: () => String }, parent: { required: false, type: () => String } }) } };
    }
}
exports.CreateResponseDTO = CreateResponseDTO;
class FindGraph {
    static _OPENAPI_METADATA_FACTORY() {
        return { interval: { required: true, type: () => Object }, dashboard_graph_id: { required: true, type: () => String }, dashboard_group: { required: true, type: () => ({ label: { required: true, type: () => String }, dashboard_group_id: { required: true, type: () => String } }) }, dashboard: { required: true, type: () => ({ label: { required: true, type: () => String }, dashboard_id: { required: true, type: () => String } }) }, group_id: { required: false, type: () => Number } };
    }
}
exports.FindGraph = FindGraph;
class FindGraphsDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./dashboard.dto").FindGraph] } };
    }
}
exports.FindGraphsDTO = FindGraphsDTO;
class UpdateDashboardGraphDTO {
    constructor(graph) {
        this.width = graph.width;
        this.height = graph.height;
        this.url = graph.url;
        this.x = graph.x;
        this.y = graph.y;
        this.interval = graph.interval;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { width: { required: false, type: () => Number }, height: { required: false, type: () => Number }, url: { required: false, type: () => String }, x: { required: false, type: () => Number }, y: { required: false, type: () => Number }, interval: { required: false, type: () => Object }, tab: { required: false, type: () => String }, dashboard_group_id: { required: true, type: () => String } };
    }
}
exports.UpdateDashboardGraphDTO = UpdateDashboardGraphDTO;
class UpdateDashboardGroupDTO {
    constructor(group) {
        this.width = group.width;
        this.height = group.height;
        this.x = group.x;
        this.y = group.y;
        this.label = group.label;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { width: { required: true, type: () => Number }, height: { required: true, type: () => Number }, x: { required: true, type: () => Number }, y: { required: true, type: () => Number }, label: { required: true, type: () => String }, dashboard_id: { required: true, type: () => String } };
    }
}
exports.UpdateDashboardGroupDTO = UpdateDashboardGroupDTO;
class GroupDashboardFolder extends menuResponse_dto_1.MenuItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { group_id: { required: true, type: () => Number } };
    }
}
exports.GroupDashboardFolder = GroupDashboardFolder;
class GroupDashboardFoldersDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./dashboard.dto").GroupDashboardFolder] } };
    }
}
exports.GroupDashboardFoldersDTO = GroupDashboardFoldersDTO;
//# sourceMappingURL=dashboard.dto.js.map