"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AzureDataDescription = exports.AzurePropsOld = exports.AzureProps = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
class AzureProps extends deviceProps_1.BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.client = undefined;
        this.secret = undefined;
        this.tenant = undefined;
        this.apiPort = undefined;
        this.subscriptions = [''];
        this.host = 'management.azure.com';
    }
}
exports.AzureProps = AzureProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AzureProps.prototype, "client", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AzureProps.prototype, "secret", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AzureProps.prototype, "tenant", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], AzureProps.prototype, "apiPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], AzureProps.prototype, "subscriptions", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], AzureProps.prototype, "host", void 0);
class AzurePropsOld extends deviceProps_1.OldDeviceProps {
    constructor() {
        super(...arguments);
        this.client = '';
        this.secret = '';
        this.tenant = '';
        this.subscriptions = [''];
        this.host = '';
    }
}
exports.AzurePropsOld = AzurePropsOld;
exports.AzureDataDescription = {
    client: {
        required: true,
        type: "string",
    },
    secret: {
        required: true,
        type: "string",
    },
    tenant: {
        required: true,
        type: "string",
    },
    subscriptions: {
        required: true,
        type: "string[]",
        description: "Array of sunscription ids managing your resources"
    },
    host: {
        required: false,
        type: "string",
        default: 'management.azure.com'
    },
    ...deviceProps_1.BaseDeviceDescription
};
//# sourceMappingURL=azure.data.js.map