"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnmpAuthProto = exports.SnmpPrivProto = exports.SnmpLevel = exports.SnmpVersion = exports.OldSp = exports.Sp = exports.DataGuardOld = exports.HostService = exports.Node = exports.PROTO = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
var PROTO;
(function (PROTO) {
    PROTO["HTTP"] = "http";
    PROTO["HTTPS"] = "https";
})(PROTO || (exports.PROTO = PROTO = {}));
class Node {
    constructor(alias, host) {
        this.alias = alias;
        this.host = host;
    }
}
exports.Node = Node;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Node.prototype, "alias", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Node.prototype, "host", void 0);
class HostService {
    constructor(host = '', service = '', pdbs = ['']) {
        this.host = undefined;
        this.service = undefined;
        this.pdbs = [''];
        this.host = host;
        this.service = service !== undefined ? service : "";
        this.pdbs = pdbs;
    }
}
exports.HostService = HostService;
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.Description)("Oracle RAC: Do not use SCAN IP in the configuration, add Virtual IP for each RAC node/instance separately. These instances should use the same listener service"),
    __metadata("design:type", String)
], HostService.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.Description)("Use listener service of an instance, can be obtained by running 'lsnrctl status'"),
    __metadata("design:type", String)
], HostService.prototype, "service", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], HostService.prototype, "pdbs", void 0);
class DataGuardOld {
    static getAsHostService(dg) {
        return new HostService(dg.hosts ? dg.hosts[0] : "", dg.instance ? dg.instance[0] : "", dg.pdbs ? dg.pdbs : [""]);
    }
}
exports.DataGuardOld = DataGuardOld;
class Sp {
    constructor() {
        this.host = undefined;
        this.sshPort = undefined;
        this.sshUsername = undefined;
        this.sshPassword = undefined;
        this.ftpUsername = undefined;
        this.ftpPassword = undefined;
        this.ftpPath = undefined;
    }
}
exports.Sp = Sp;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Sp.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], Sp.prototype, "sshPort", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], Sp.prototype, "sshUsername", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], Sp.prototype, "sshPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], Sp.prototype, "ftpUsername", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], Sp.prototype, "ftpPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], Sp.prototype, "ftpPath", void 0);
class OldSp {
    static portSp(old) {
        return {
            host: old.host,
            sshPort: parseInt(old.port),
            sshUsername: old.sshuser,
            sshPassword: old.sshpassword,
            ftpUsername: old.ftpuser,
            ftpPassword: old.ftppassword,
            ftpPath: old.ftppath
        };
    }
}
exports.OldSp = OldSp;
var SnmpVersion;
(function (SnmpVersion) {
    SnmpVersion["SNMPv1"] = "1";
    SnmpVersion["SNMPv2c"] = "2c";
    SnmpVersion["SNMPv3"] = "3";
})(SnmpVersion || (exports.SnmpVersion = SnmpVersion = {}));
var SnmpLevel;
(function (SnmpLevel) {
    SnmpLevel["NOAUTH_NOPRIV"] = "noAuthNoPriv";
    SnmpLevel["AUTH_NOPRIV"] = "authNoPriv";
    SnmpLevel["AUTH_PRIV"] = "authPriv";
})(SnmpLevel || (exports.SnmpLevel = SnmpLevel = {}));
var SnmpPrivProto;
(function (SnmpPrivProto) {
    SnmpPrivProto["AES"] = "AES";
    SnmpPrivProto["AES128"] = "AES128";
    SnmpPrivProto["AES256"] = "AES256";
})(SnmpPrivProto || (exports.SnmpPrivProto = SnmpPrivProto = {}));
var SnmpAuthProto;
(function (SnmpAuthProto) {
    SnmpAuthProto["MD5"] = "MD5";
    SnmpAuthProto["SHA"] = "SHA";
    SnmpAuthProto["SHA512"] = "SHA512";
})(SnmpAuthProto || (exports.SnmpAuthProto = SnmpAuthProto = {}));
//# sourceMappingURL=hostcfgData.types.js.map