"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenshiftDataDescription = exports.OpenshiftPropsOld = exports.OpenshiftProps = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
const hostcfgData_types_1 = require("./hostcfgData.types");
class OpenshiftProps extends deviceProps_1.BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.protocol = hostcfgData_types_1.PROTO.HTTPS;
        this.host = undefined;
        this.projectsAvailable = [];
        this.projectsSelected = [];
        this.skipContainer = undefined;
        this.token = undefined;
    }
}
exports.OpenshiftProps = OpenshiftProps;
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.PROTO.HTTPS),
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.PROTO),
    __metadata("design:type", String)
], OpenshiftProps.prototype, "protocol", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OpenshiftProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], OpenshiftProps.prototype, "projectsAvailable", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], OpenshiftProps.prototype, "projectsSelected", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], OpenshiftProps.prototype, "skipContainer", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OpenshiftProps.prototype, "token", void 0);
class OpenshiftPropsOld extends deviceProps_1.OldDeviceProps {
}
exports.OpenshiftPropsOld = OpenshiftPropsOld;
exports.OpenshiftDataDescription = {
    protocol: {
        required: true,
        type: "string",
        possibleValues: Object.keys(key => hostcfgData_types_1.PROTO[key])
    },
    host: {
        required: true,
        type: "string",
    },
    token: {
        required: true,
        type: "string",
    },
    container: {
        required: true,
        type: "string",
    },
    projectsSelected: {
        required: true,
        type: "string",
        description: "Array of selected project"
    },
    projectsAvailable: {
        required: false,
        type: "string",
        description: "Array of all projects, you can load these from the GUI device configuration"
    },
    ...deviceProps_1.BaseDeviceDescription
};
//# sourceMappingURL=openshift.data.js.map