"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracledbDataDescription = exports.OracledbPropsOld = exports.OracledbProps = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
const hostcfgData_types_1 = require("./hostcfgData.types");
var DbType;
(function (DbType) {
    DbType["Standalone"] = "Standalone";
    DbType["RAC"] = "RAC Standalone";
    DbType["Multitenant"] = "Multitenant";
    DbType["RACMultitenant"] = "RAC Multitenant";
})(DbType || (DbType = {}));
class OracledbProps {
    constructor() {
        this.vendor = undefined;
        this.device = undefined;
        this.created = Date.now();
        this.updated = null;
        this.description = undefined;
        this.managementUrl = undefined;
        this.instance = undefined;
        this.username = undefined;
        this.password = undefined;
        this.use_whitelist = false;
        this.dbs = [''];
        this.driver = undefined;
        this.port = null;
        this.type = undefined;
        this.hosts = [new hostcfgData_types_1.HostService()];
        this.dataguard = [new hostcfgData_types_1.HostService()];
        this.disabled = undefined;
        this.radio = undefined;
        this.main_group_id = undefined;
        this.sub_group_id = undefined;
        this.licType = undefined;
        this.sourceAddress = undefined;
    }
}
exports.OracledbProps = OracledbProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "vendor", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OracledbProps.prototype, "device", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], OracledbProps.prototype, "created", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], OracledbProps.prototype, "updated", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "description", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "managementUrl", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OracledbProps.prototype, "instance", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OracledbProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], OracledbProps.prototype, "password", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], OracledbProps.prototype, "use_whitelist", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Array)
], OracledbProps.prototype, "dbs", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.Description)("ORACLE_HOME variable, path to sqlplus('/usr/lib/oracle/19.6/client64')"),
    __metadata("design:type", String)
], OracledbProps.prototype, "driver", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Number)
], OracledbProps.prototype, "port", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.EnumType)(DbType),
    __metadata("design:type", String)
], OracledbProps.prototype, "type", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.ArrayItemType)(hostcfgData_types_1.HostService),
    __metadata("design:type", Array)
], OracledbProps.prototype, "hosts", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.ArrayItemType)(hostcfgData_types_1.HostService),
    __metadata("design:type", Array)
], OracledbProps.prototype, "dataguard", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], OracledbProps.prototype, "disabled", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "radio", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "main_group_id", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "sub_group_id", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "licType", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], OracledbProps.prototype, "sourceAddress", void 0);
class OracledbPropsOld extends deviceProps_1.AbstractOldDBProps {
}
exports.OracledbPropsOld = OracledbPropsOld;
exports.OracledbDataDescription = {
    ...deviceProps_1.AbstractDBDescription,
    driver: {
        required: true,
        type: "string",
    },
    port: {
        required: true,
        type: "number",
    },
    type: {
        required: true,
        type: "string",
        possibleValues: Object.keys(DbType).map(key => DbType[key])
    },
    hosts: {
        required: true,
        type: "format[]",
        description: "Array of hosts. Add multiple hosts only when using type RAC",
        format: {
            host: {
                required: true,
                type: "string",
            },
            service: {
                required: true,
                type: "string",
            },
            pdbs: {
                required: false,
                type: "string[]",
                description: "Array of pdb services, multitenant type only"
            }
        }
    },
    dataguard: {
        required: false,
        type: "format[]",
        description: "Array of dataguards. Add multiple hosts only when using type RAC",
        format: {
            host: {
                required: false,
                type: "string",
            },
            service: {
                required: false,
                type: "string",
            },
            pdbs: {
                required: false,
                type: "string[]",
                description: "Array of pdb services, multitenant type only"
            }
        }
    },
};
//# sourceMappingURL=oracledb.data.js.map