"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeatmapBox = exports.PortHealthStatusBox = exports.PortHealthStatusHwType = exports.PortHealthStatusLegend = exports.PORT_STATUS_TYPE = exports.PortHealthStatusLegendStatus = exports.PortHealthStatusDevice = exports.PortHealthStatusPort = exports.TopBox = exports.TopBoxTable = exports.Export = exports.TablePivotBox = exports.TableHeaderGroupBox = exports.TableGroupBox = exports.MirrorBox = exports.TableBox = exports.TableBase = exports.RegroupButtonBox = exports.RegroupGraph = exports.FourGraphBox = exports.Help = exports.PredictionGraphBox = exports.PredictionMetadata = exports.SingleGraphBox = exports.SingleTimeRangeGraphBox = exports.GraphBaseTimeRange = exports.GraphBaseInterval = exports.MultiGraphBox = exports.GraphTablePropertyItem = exports.GraphTableProperty = exports.GraphBaseParent = exports.GraphBase = exports.GraphTableSort = exports.StaticMetric = exports.SunburstBox = exports.SunburstItem = exports.DashboardBox = exports.HtmlTextBox = exports.TextBox = exports.TextStyled = exports.TableColumn = exports.TableGroup = exports.TableGroupHeader = exports.TableHeader = exports.CapacityTableBox = exports.CapacityTableColumn = exports.CapacityTableHeader = exports.TableHeaderBase = exports.CapacityTableBase = exports.Metric = void 0;
exports.HeatmapContent = exports.CustomTopResponseDTO = exports.OverviewResponseDTO = exports.TabResponseDTO = exports.PageResponseDTO = exports.Page = exports.MenuFormPage = exports.Tab = exports.TopologyBox = exports.TopologyRequestBox = exports.TopologyRequestItem = exports.TopologyRequest = exports.TopologyGroup = exports.TopologyItem = exports.TopologyConnection = exports.StorageHeatmapBox = exports.StorageHeatmapTiers = exports.StorageHeatmapTier = exports.StorageHeatmapItemMetric = exports.StorageHeatmapItem = exports.StorageHeatmapInterval = exports.CustomTopRequest = exports.CustomTopBox = exports.OverviewBox = exports.OverviewCategory = exports.OverviewItem = exports.OverviewRequest = void 0;
const openapi = require("@nestjs/swagger");
const pageResponse_constants_1 = require("./constants/pageResponse.constants");
const basicResponse_dto_1 = require("./basicResponse.dto");
const timeseriesRequest_dto_1 = require("./timeseriesRequest.dto");
class Metric {
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object }, stacked: { required: true, type: () => Boolean }, metric: { required: true, type: () => String }, order: { required: true, type: () => Number }, aggregate: { required: false, type: () => Object }, unit: { required: true, type: () => Object }, unitLabel: { required: false, type: () => String }, shortcut: { required: true, type: () => String }, label: { required: false, type: () => String }, color: { required: false, type: () => String }, defaultPrefix: { required: false, type: () => Object }, defaultPrecision: { required: false, type: () => Number }, minY: { required: false, type: () => Number }, legendTop: { required: false, type: () => Boolean, description: "Place metric in table above line separating items below" }, legendOnly: { required: false, type: () => Boolean, description: "Visible in table legend, not plotted" } };
    }
}
exports.Metric = Metric;
class CapacityTableBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { header: { required: true, type: () => [require("./pageResponse.dto").CapacityTableHeader] }, rows: { required: true, type: () => [[require("./pageResponse.dto").CapacityTableColumn]] }, summaryRow: { required: false, type: () => [require("./pageResponse.dto").CapacityTableColumn] }, export: { required: false, type: () => require("./pageResponse.dto").Export } };
    }
}
exports.CapacityTableBase = CapacityTableBase;
class TableHeaderBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { order: { required: true, type: () => Number }, value: { required: true, type: () => String }, prefix: { required: false, type: () => Object }, number: { required: false, type: () => Boolean }, decimal: { required: false, type: () => Number }, shortcut: { required: false, type: () => String } };
    }
}
exports.TableHeaderBase = TableHeaderBase;
class CapacityTableHeader extends TableHeaderBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { thermometer: { required: false, type: () => Boolean } };
    }
}
exports.CapacityTableHeader = CapacityTableHeader;
class CapacityTableColumn {
    static _OPENAPI_METADATA_FACTORY() {
        return { order: { required: true, type: () => Number }, value: { required: true, type: () => Object }, url: { required: false, type: () => String }, tooltip: { required: false, type: () => String } };
    }
}
exports.CapacityTableColumn = CapacityTableColumn;
class CapacityTableBox extends CapacityTableBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.CapacityTableBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.CapacityTableBox } };
    }
}
exports.CapacityTableBox = CapacityTableBox;
class TableHeader extends TableHeaderBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { unit: { required: false, type: () => Object }, multiplier: { required: false, type: () => Object }, shortcut: { required: false, type: () => String }, styleClass: { required: false, type: () => Object }, sort: { required: false, type: () => Object }, noWrap: { required: false, type: () => Boolean }, trim: { required: true, type: () => Boolean }, group: { required: false, type: () => String }, newLines: { required: false, type: () => Boolean }, linuxMpath: { required: false, type: () => Boolean }, trimLength: { required: false, type: () => Number }, disable: { required: false, type: () => ({ search: { required: false, type: () => Boolean }, sort: { required: false, type: () => Boolean } }) } };
    }
}
exports.TableHeader = TableHeader;
class TableGroupHeader {
    static _OPENAPI_METADATA_FACTORY() {
        return { order: { required: true, type: () => Number }, value: { required: true, type: () => String }, group: { required: true, type: () => String }, number: { required: false, type: () => Boolean } };
    }
}
exports.TableGroupHeader = TableGroupHeader;
class TableGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { group: { required: true, type: () => String }, unit: { required: false, type: () => Object }, shortcut: { required: false, type: () => String }, prefix: { required: false, type: () => Object }, number: { required: false, type: () => Boolean }, decimal: { required: false, type: () => Number }, styleClass: { required: false, type: () => Object }, multiplier: { required: false, type: () => Object }, trim: { required: true, type: () => Boolean } };
    }
}
exports.TableGroup = TableGroup;
class TableColumn {
    static _OPENAPI_METADATA_FACTORY() {
        return { order: { required: true, type: () => Number }, value: { required: true, type: () => [Object] }, styleClass: { required: false, type: () => Object }, bgStatus: { required: false, type: () => Object }, bgColor: { required: false, type: () => String }, url: { required: false, type: () => [String] }, tooltip: { required: false, type: () => String }, modal: { required: false, type: () => [Object] }, noTrim: { required: false, type: () => Boolean } };
    }
}
exports.TableColumn = TableColumn;
class TextStyled {
    static _OPENAPI_METADATA_FACTORY() {
        return { text: { required: true, type: () => String }, styleClass: { required: false, type: () => Object } };
    }
}
exports.TextStyled = TextStyled;
class TextBox extends TextStyled {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.TextBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TextBox } };
    }
}
exports.TextBox = TextBox;
class HtmlTextBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.HtmlTextBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.HtmlTextBox }, html: { required: true, type: () => String } };
    }
}
exports.HtmlTextBox = HtmlTextBox;
class DashboardBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.DashboardBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.DashboardBox }, groups: { required: true, type: () => [require("./dashboard.dto").DashboardGroup] }, width: { required: true, type: () => Number } };
    }
}
exports.DashboardBox = DashboardBox;
class SunburstItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String }, parent_id: { required: true, type: () => String }, parent_label: { required: true, type: () => String }, value: { required: true, type: () => Number } };
    }
}
exports.SunburstItem = SunburstItem;
class SunburstBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.SunburstBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.SunburstBox }, items: { required: true, type: () => [require("./pageResponse.dto").SunburstItem] } };
    }
}
exports.SunburstBox = SunburstBox;
class StaticMetric {
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object }, label: { required: true, type: () => String }, value: { required: true, type: () => Number }, unit: { required: true, type: () => Object }, shortcut: { required: true, type: () => String } };
    }
}
exports.StaticMetric = StaticMetric;
class GraphTableSort {
    static _OPENAPI_METADATA_FACTORY() {
        return { metric: { required: true, type: () => String }, order: { required: true, type: () => Object } };
    }
}
exports.GraphTableSort = GraphTableSort;
class GraphBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { aggregated: { required: false, type: () => Boolean }, label: { required: false, type: () => String }, graphLabel: { required: false, type: () => String }, parent: { required: false, type: () => require("./pageResponse.dto").GraphBaseParent }, metrics: { required: true, type: () => [require("./pageResponse.dto").Metric] }, minInterval: { required: false, type: () => Number }, peakMetric: { required: false, type: () => require("./pageResponse.dto").Metric }, properties: { required: false, type: () => [require("./pageResponse.dto").GraphTableProperty] }, sort: { required: false, type: () => require("./pageResponse.dto").GraphTableSort }, staticMetrics: { required: false, type: () => [require("./pageResponse.dto").StaticMetric] }, uuids: { required: true, type: () => [String] } };
    }
}
exports.GraphBase = GraphBase;
class GraphBaseParent {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.GraphBaseParent = GraphBaseParent;
class GraphTableProperty {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, search: { required: false, type: () => Boolean } };
    }
}
exports.GraphTableProperty = GraphTableProperty;
class GraphTablePropertyItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { value: { required: true, type: () => String }, url: { required: false, type: () => String } };
    }
}
exports.GraphTablePropertyItem = GraphTablePropertyItem;
class MultiGraphBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.MultiGraphBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.MultiGraphBox }, graphs: { required: true, type: () => [require("./pageResponse.dto").GraphBaseInterval] } };
    }
}
exports.MultiGraphBox = MultiGraphBox;
class GraphBaseInterval extends GraphBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { interval: { required: true, type: () => Object } };
    }
}
exports.GraphBaseInterval = GraphBaseInterval;
class GraphBaseTimeRange extends GraphBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { start: { required: true, type: () => Number }, end: { required: true, type: () => Number } };
    }
}
exports.GraphBaseTimeRange = GraphBaseTimeRange;
class SingleTimeRangeGraphBox extends GraphBaseTimeRange {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.SingleTimeRangeGraphBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.SingleTimeRangeGraphBox } };
    }
}
exports.SingleTimeRangeGraphBox = SingleTimeRangeGraphBox;
class SingleGraphBox extends GraphBaseInterval {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.SingleGraphBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.SingleGraphBox } };
    }
}
exports.SingleGraphBox = SingleGraphBox;
class PredictionMetadata {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, key: { required: true, type: () => String }, number: { required: true, type: () => Boolean } };
    }
}
exports.PredictionMetadata = PredictionMetadata;
class PredictionGraphBox extends timeseriesRequest_dto_1.PredictionBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.PredictionGraphBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.PredictionGraphBox }, graphLabel: { required: true, type: () => String }, metric: { required: true, type: () => require("./pageResponse.dto").Metric }, other_metrics: { required: true, type: () => [require("./pageResponse.dto").Metric] }, metadata: { required: true, type: () => [require("./pageResponse.dto").PredictionMetadata] }, lowerMax: { required: false, type: () => Number }, help: { required: false, type: () => require("./pageResponse.dto").Help } };
    }
}
exports.PredictionGraphBox = PredictionGraphBox;
class Help {
    static _OPENAPI_METADATA_FACTORY() {
        return { text: { required: true, type: () => String }, url: { required: true, type: () => String } };
    }
}
exports.Help = Help;
class FourGraphBox extends GraphBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.FourGraphBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.FourGraphBox } };
    }
}
exports.FourGraphBox = FourGraphBox;
class RegroupGraph extends GraphBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { url: { required: true, type: () => String }, tab: { required: true, type: () => String } };
    }
}
exports.RegroupGraph = RegroupGraph;
class RegroupButtonBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.RegroupButtonBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.RegroupButtonBox }, graphs: { required: true, type: () => [require("./pageResponse.dto").RegroupGraph] } };
    }
}
exports.RegroupButtonBox = RegroupButtonBox;
class TableBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { header: { required: true, type: () => [require("./pageResponse.dto").TableHeader] }, rows: { required: true, type: () => [[require("./pageResponse.dto").TableColumn]] }, fixedCols: { required: false, type: () => Number }, export: { required: false, type: () => require("./pageResponse.dto").Export }, headerNoWrap: { required: false, type: () => Boolean }, orientation: { required: true, type: () => Object }, headerNoUnit: { required: false, type: () => Boolean } };
    }
}
exports.TableBase = TableBase;
class TableBox extends TableBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.TableBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TableBox } };
    }
}
exports.TableBox = TableBox;
class MirrorBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.MirrorBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.MirrorBox } };
    }
}
exports.MirrorBox = MirrorBox;
class TableGroupBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.TableGroupBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TableGroupBox }, tables: { required: true, type: () => Object } };
    }
}
exports.TableGroupBox = TableGroupBox;
class TableHeaderGroupBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.TableHeaderGroupBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TableHeaderGroupBox }, header: { required: true, type: () => [require("./pageResponse.dto").TableGroupHeader] }, rows: { required: true, type: () => [[require("./pageResponse.dto").TableColumn]] }, groups: { required: true, type: () => [require("./pageResponse.dto").TableGroup] }, orientation: { required: true, type: () => Object } };
    }
}
exports.TableHeaderGroupBox = TableHeaderGroupBox;
class TablePivotBox extends TableBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.BOX_TYPE.TablePivotBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TablePivotBox } };
    }
}
exports.TablePivotBox = TablePivotBox;
class Export {
    static _OPENAPI_METADATA_FACTORY() {
        return { fileName: { required: false, type: () => String }, url: { required: true, type: () => String }, method: { required: true, type: () => Object }, body: { required: false, type: () => ({}) } };
    }
}
exports.Export = Export;
class TopBoxTable extends TableBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, export: { required: true, type: () => require("./pageResponse.dto").Export } };
    }
}
exports.TopBoxTable = TopBoxTable;
class TopBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.TableBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TableBox }, tables: { required: true, type: () => [require("./pageResponse.dto").TopBoxTable] } };
    }
}
exports.TopBox = TopBox;
class PortHealthStatusPort {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, url: { required: true, type: () => String }, operationalStatus: { required: true, type: () => String }, operationalStatusColor: { required: true, type: () => String }, physicalStatus: { required: false, type: () => String }, physicalStatusColor: { required: false, type: () => String }, adminStatus: { required: false, type: () => String }, adminStatusColor: { required: false, type: () => String }, operationalStatusReason: { required: false, type: () => String }, operationalStatusReasonColor: { required: false, type: () => String } };
    }
}
exports.PortHealthStatusPort = PortHealthStatusPort;
class PortHealthStatusDevice {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, ports: { required: true, type: () => [require("./pageResponse.dto").PortHealthStatusPort] } };
    }
}
exports.PortHealthStatusDevice = PortHealthStatusDevice;
class PortHealthStatusLegendStatus {
    static _OPENAPI_METADATA_FACTORY() {
        return { color: { required: true, type: () => String }, label: { required: true, type: () => String }, text: { required: false, type: () => String } };
    }
}
exports.PortHealthStatusLegendStatus = PortHealthStatusLegendStatus;
exports.PORT_STATUS_TYPE = ['operationalStatus', 'physicalStatus', 'adminStatus', 'operationalStatusReason'];
class PortHealthStatusLegend {
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object }, label: { required: true, type: () => String }, text: { required: false, type: () => String }, statuses: { required: true, type: () => [require("./pageResponse.dto").PortHealthStatusLegendStatus] } };
    }
}
exports.PortHealthStatusLegend = PortHealthStatusLegend;
class PortHealthStatusHwType {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, devices: { required: true, type: () => [require("./pageResponse.dto").PortHealthStatusDevice] }, legends: { required: true, type: () => [require("./pageResponse.dto").PortHealthStatusLegend] } };
    }
}
exports.PortHealthStatusHwType = PortHealthStatusHwType;
class PortHealthStatusBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.PortHealthStatusBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.PortHealthStatusBox }, hwTypes: { required: true, type: () => [require("./pageResponse.dto").PortHealthStatusHwType] }, tabs: { required: false } };
    }
}
exports.PortHealthStatusBox = PortHealthStatusBox;
class HeatmapBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.HeatmapBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.HeatmapBox }, metrics: { required: true, type: () => [Object] } };
    }
}
exports.HeatmapBox = HeatmapBox;
class OverviewRequest {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, start: { required: true, type: () => Number }, end: { required: true, type: () => Number } };
    }
}
exports.OverviewRequest = OverviewRequest;
class OverviewItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, item_id: { required: true, type: () => String } };
    }
}
exports.OverviewItem = OverviewItem;
class OverviewCategory {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, items: { required: true, type: () => [require("./pageResponse.dto").OverviewItem] } };
    }
}
exports.OverviewCategory = OverviewCategory;
class OverviewBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.OverviewBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.OverviewBox }, categories: { required: true, type: () => [require("./pageResponse.dto").OverviewCategory] } };
    }
}
exports.OverviewBox = OverviewBox;
class CustomTopBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.CustomTopBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.CustomTopBox }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, metrics: { required: true, type: () => [String] }, parentsSubsystem: { required: false, type: () => [String] }, pageLabel: { required: false, type: () => String } };
    }
}
exports.CustomTopBox = CustomTopBox;
class CustomTopRequest {
    static _OPENAPI_METADATA_FACTORY() {
        return { hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, type: { required: true, type: () => Object }, metrics: { required: true, type: () => [String] }, start: { required: true, type: () => Number }, end: { required: true, type: () => Number }, parentsSubsystem: { required: false, type: () => [String] }, pageLabel: { required: false, type: () => String } };
    }
}
exports.CustomTopRequest = CustomTopRequest;
class StorageHeatmapInterval {
    static _OPENAPI_METADATA_FACTORY() {
        return { color: { required: true, type: () => String }, limit: { required: true, type: () => Number } };
    }
}
exports.StorageHeatmapInterval = StorageHeatmapInterval;
class StorageHeatmapItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { device: { required: true, type: () => String }, label: { required: true, type: () => String }, item_id: { required: true, type: () => String }, read: { required: false, type: () => require("./pageResponse.dto").StorageHeatmapItemMetric }, write: { required: false, type: () => require("./pageResponse.dto").StorageHeatmapItemMetric }, total: { required: false, type: () => require("./pageResponse.dto").StorageHeatmapItemMetric }, url: { required: true, type: () => String }, sortValue: { required: false, type: () => Number } };
    }
}
exports.StorageHeatmapItem = StorageHeatmapItem;
class StorageHeatmapItemMetric {
    static _OPENAPI_METADATA_FACTORY() {
        return { line: { required: true, type: () => String }, color: { required: true, type: () => String }, value: { required: false, type: () => Number } };
    }
}
exports.StorageHeatmapItemMetric = StorageHeatmapItemMetric;
class StorageHeatmapTier {
    static _OPENAPI_METADATA_FACTORY() {
        return { items: { required: true, type: () => [require("./pageResponse.dto").StorageHeatmapItem] }, read_intervals: { required: true, type: () => [require("./pageResponse.dto").StorageHeatmapInterval] }, write_intervals: { required: true, type: () => [require("./pageResponse.dto").StorageHeatmapInterval] } };
    }
}
exports.StorageHeatmapTier = StorageHeatmapTier;
class StorageHeatmapTiers {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.StorageHeatmapTiers = StorageHeatmapTiers;
class StorageHeatmapBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.StorageHeatmapBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.StorageHeatmapBox }, tiers: { required: true, type: () => require("./pageResponse.dto").StorageHeatmapTiers } };
    }
}
exports.StorageHeatmapBox = StorageHeatmapBox;
class TopologyConnection {
    static _OPENAPI_METADATA_FACTORY() {
        return { sourceWwn: { required: true, type: () => String }, destinationWwn: { required: true, type: () => String }, sourceType: { required: true, type: () => String }, destinationType: { required: true, type: () => String }, percent: { required: true, type: () => Number }, text: { required: true, type: () => String } };
    }
}
exports.TopologyConnection = TopologyConnection;
class TopologyItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, id: { required: false, type: () => String }, wwn: { required: false, type: () => String }, url: { required: false, type: () => String }, children: { required: false, type: () => [require("./pageResponse.dto").TopologyItem] } };
    }
}
exports.TopologyItem = TopologyItem;
class TopologyGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, type: { required: true, type: () => Object }, children: { required: true, type: () => [require("./pageResponse.dto").TopologyItem] } };
    }
}
exports.TopologyGroup = TopologyGroup;
class TopologyRequest {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: false, type: () => String }, type: { required: true, type: () => Object }, hw_type: { required: false, type: () => String } };
    }
}
exports.TopologyRequest = TopologyRequest;
class TopologyRequestItem extends TopologyRequest {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String } };
    }
}
exports.TopologyRequestItem = TopologyRequestItem;
class TopologyRequestBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.TopologyRequestBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TopologyRequestBox }, topologies: { required: true, type: () => [require("./pageResponse.dto").TopologyRequestItem] } };
    }
}
exports.TopologyRequestBox = TopologyRequestBox;
class TopologyBox {
    constructor() {
        this.type = pageResponse_constants_1.BOX_TYPE.TopologyBox;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { type: { required: true, type: () => Object, default: pageResponse_constants_1.BOX_TYPE.TopologyBox }, connections: { required: false, type: () => [require("./pageResponse.dto").TopologyConnection] }, groups: { required: true, type: () => [require("./pageResponse.dto").TopologyGroup] } };
    }
}
exports.TopologyBox = TopologyBox;
class Tab {
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, content: { required: false }, lazyContent: { required: false, type: () => String }, export: { required: false, type: () => require("./pageResponse.dto").Export }, help: { required: false, type: () => require("./pageResponse.dto").Help }, subTabs: { required: false, type: () => [Object] } };
    }
}
exports.Tab = Tab;
class MenuFormPage {
    static _OPENAPI_METADATA_FACTORY() {
        return { hwTypes: { required: true, type: () => [Object] }, title: { required: true, type: () => String } };
    }
}
exports.MenuFormPage = MenuFormPage;
class Page {
    constructor(title, tabs, formPage) {
        this.title = title;
        this.tabs = tabs;
        this.formPage = formPage;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { title: { required: true, type: () => String }, tabs: { required: true }, formPage: { required: false, type: () => require("./pageResponse.dto").MenuFormPage } };
    }
}
exports.Page = Page;
class PageResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./pageResponse.dto").Page } };
    }
}
exports.PageResponseDTO = PageResponseDTO;
class TabResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true } };
    }
}
exports.TabResponseDTO = TabResponseDTO;
class OverviewResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true } };
    }
}
exports.OverviewResponseDTO = OverviewResponseDTO;
class CustomTopResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true } };
    }
}
exports.CustomTopResponseDTO = CustomTopResponseDTO;
class HeatmapContent {
    static _OPENAPI_METADATA_FACTORY() {
        return { heatmapBox: { required: true, type: () => Object }, textBox: { required: true, type: () => require("./pageResponse.dto").TextBox } };
    }
}
exports.HeatmapContent = HeatmapContent;
//# sourceMappingURL=pageResponse.dto.js.map