import type { MailFrequency } from '@const/report.constants';
import { BasicResponseDTO } from './basicResponse.dto';
import { RecurrenceElement as Recurrence } from './elements/report.elements';
import { SavedReportFile } from './reportFile.dto';
import { FullReportItem, NewReportItem, PlainReportItem, UpdateReportItem } from './reportItem.dto';
export { Recurrence };
export type { MailFrequency };
export declare class PlainReport {
    label: string;
    time_range?: TimeRange | null;
    report_items?: PlainReportItem[];
}
export declare class NewReport {
    user_id?: number;
    label: string;
    report_items?: NewReportItem[];
    disabled?: boolean;
    on_generate_create_report_file?: boolean;
    recurrence?: Recurrence | null;
    mail_group_ids?: number[];
}
export declare class UpdateReport extends NewReport {
    report_id?: string;
    report_items?: UpdateReportItem[];
}
export declare class SavedReport extends UpdateReport {
    report_id: string;
    disabled: boolean;
    on_generate_create_report_file: boolean;
    recurrence: Recurrence | null;
    last_run_at: Date | null;
    created_at: Date;
    updated_at: Date;
    report_items: FullReportItem[];
    report_files: SavedReportFile[];
    mail_group_ids?: number[];
}
export declare class SavedMailGroup {
    mail_group_id: number;
    label: string;
    mails: string[];
}
export declare class TimeRange {
    date_from: Date;
    date_to: Date;
}
export declare class GetReportsResponseDTO extends BasicResponseDTO {
    data: SavedReport[];
}
export declare class GetReportResponseDTO extends BasicResponseDTO {
    data: SavedReport;
}
export declare class SaveReportResponseDTO extends BasicResponseDTO {
    message: string;
    data: UpdateReport;
}
