"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Alerting = void 0;
const openapi = require("@nestjs/swagger");
const alerting_constants_1 = require("../common/constants/alerting.constants");
const typeorm_1 = require("typeorm");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const mailGroup_entity_1 = require("./mailGroup.entity");
const alertingLaunch_entity_1 = require("./alertingLaunch.entity");
const alert_elements_1 = require("../common/elements/alert.elements");
let Alerting = class Alerting {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_id: { required: true, type: () => String }, _alerting_group: { required: true, type: () => require("./alertingGroup.entity").AlertingGroup }, alerting_group_id: { required: true, type: () => String }, metric: { required: true, type: () => String }, limit: { required: true, type: () => Number }, peak: { required: true, type: () => Number }, repeat: { required: true, type: () => Number }, exclude_start: { required: true, type: () => Number }, exclude_end: { required: true, type: () => Number }, level: { required: true, type: () => String }, triggered: { required: true, type: () => Number }, integrations: { required: true, type: () => require("../common/elements/alert.elements").AlertIntegrations }, mail_groups: { required: true, type: () => [require("./mailGroup.entity").MailGroup] }, checked_until: { required: true, type: () => Date, nullable: true }, alerting_launches: { required: false, type: () => [require("./alertingLaunch.entity").AlertingLaunch] } };
    }
};
exports.Alerting = Alerting;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], Alerting.prototype, "alerting_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => alertingGroup_entity_1.AlertingGroup, (alertingGroup) => alertingGroup.alerts, { onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'alerting_group_id' }),
    __metadata("design:type", alertingGroup_entity_1.AlertingGroup)
], Alerting.prototype, "_alerting_group", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Alerting.prototype, "alerting_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Alerting.prototype, "metric", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'float4' }),
    __metadata("design:type", Number)
], Alerting.prototype, "limit", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Alerting.prototype, "peak", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Alerting.prototype, "repeat", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true,
    }),
    __metadata("design:type", Number)
], Alerting.prototype, "exclude_start", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true,
    }),
    __metadata("design:type", Number)
], Alerting.prototype, "exclude_end", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: alerting_constants_1.ALERT_LEVEL.undefined,
    }),
    __metadata("design:type", String)
], Alerting.prototype, "level", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true,
    }),
    __metadata("design:type", Number)
], Alerting.prototype, "triggered", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: false,
        type: 'jsonb',
        default: "'{}'::jsonb"
    }),
    __metadata("design:type", alert_elements_1.AlertIntegrations)
], Alerting.prototype, "integrations", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => mailGroup_entity_1.MailGroup),
    (0, typeorm_1.JoinTable)({
        name: 'alerting_mail_groups',
        joinColumn: {
            name: 'alerting_id',
            referencedColumnName: 'alerting_id',
        },
        inverseJoinColumn: {
            name: 'mail_group_id',
            referencedColumnName: 'mail_group_id',
        },
    }),
    __metadata("design:type", Array)
], Alerting.prototype, "mail_groups", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'timestamp with time zone',
        default: null,
        nullable: true
    }),
    __metadata("design:type", Date)
], Alerting.prototype, "checked_until", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingLaunch_entity_1.AlertingLaunch, (alertingLaunch) => alertingLaunch._alerting),
    __metadata("design:type", Array)
], Alerting.prototype, "alerting_launches", void 0);
exports.Alerting = Alerting = __decorate([
    (0, typeorm_1.Entity)({ name: 'alerting', synchronize: false })
], Alerting);
//# sourceMappingURL=alerting.entity.js.map