"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertingGroup = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const alerting_entity_1 = require("./alerting.entity");
const class_entity_1 = require("./class.entity");
const hwType_entity_1 = require("./hwType.entity");
const itemGroup_entity_1 = require("./itemGroup.entity");
const customGroup_entity_1 = require("./customGroup.entity");
const user_entity_1 = require("./user.entity");
const alertingHistory_entity_1 = require("./alertingHistory.entity");
const group_entity_1 = require("./group.entity");
let AlertingGroup = class AlertingGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_group_id: { required: true, type: () => String }, label: { required: true, type: () => String }, _class: { required: false, type: () => require("./class.entity").Class }, class: { required: true, type: () => String }, _hw_type: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, disabled: { required: true, type: () => Boolean }, _item_group: { required: false, type: () => require("./itemGroup.entity").ItemGroup }, item_group_id: { required: true, type: () => String }, _custom_group: { required: false, type: () => require("./customGroup.entity").CustomGroup }, custom_group_id: { required: true, type: () => String }, user_id: { required: true, type: () => Number }, alerts: { required: false, type: () => [require("./alerting.entity").Alerting] }, created_by: { required: false, type: () => require("./user.entity").User }, _history: { required: false, type: () => [require("./alertingHistory.entity").AlertingHistory] }, group_id: { required: true, type: () => Number }, _group: { required: false, type: () => require("./group.entity").Group } };
    }
};
exports.AlertingGroup = AlertingGroup;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], AlertingGroup.prototype, "alerting_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], AlertingGroup.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => class_entity_1.Class, (_class) => _class.alertingGroups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'class' }),
    __metadata("design:type", class_entity_1.Class)
], AlertingGroup.prototype, "_class", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], AlertingGroup.prototype, "class", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.alertingGroups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], AlertingGroup.prototype, "_hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], AlertingGroup.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], AlertingGroup.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], AlertingGroup.prototype, "disabled", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => itemGroup_entity_1.ItemGroup, (itemGroup) => itemGroup.alertingGroup, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'item_group_id' }),
    __metadata("design:type", itemGroup_entity_1.ItemGroup)
], AlertingGroup.prototype, "_item_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], AlertingGroup.prototype, "item_group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup.alertingGroups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'custom_group_id' }),
    __metadata("design:type", customGroup_entity_1.CustomGroup)
], AlertingGroup.prototype, "_custom_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], AlertingGroup.prototype, "custom_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], AlertingGroup.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alerting_entity_1.Alerting, (alerting) => alerting._alerting_group, { cascade: true }),
    __metadata("design:type", Array)
], AlertingGroup.prototype, "alerts", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_alerts, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], AlertingGroup.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingHistory_entity_1.AlertingHistory, (alertingHistory) => alertingHistory._alerting_group, { cascade: true }),
    __metadata("design:type", Array)
], AlertingGroup.prototype, "_history", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], AlertingGroup.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => group_entity_1.Group, (group) => group._alerting_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'group_id' }),
    __metadata("design:type", group_entity_1.Group)
], AlertingGroup.prototype, "_group", void 0);
exports.AlertingGroup = AlertingGroup = __decorate([
    (0, typeorm_1.Entity)({ name: 'alerting_groups', synchronize: false })
], AlertingGroup);
//# sourceMappingURL=alertingGroup.entity.js.map