"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomGroup = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const customGroupFolder_entity_1 = require("./customGroupFolder.entity");
const user_entity_1 = require("./user.entity");
const hwType_entity_1 = require("./hwType.entity");
const class_entity_1 = require("./class.entity");
const itemGroup_entity_1 = require("./itemGroup.entity");
const export_entity_1 = require("./export.entity");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const reportItem_entity_1 = require("./reportItem.entity");
const group_entity_1 = require("./group.entity");
const customGroupFavorite_entity_1 = require("./customGroupFavorite.entity");
let CustomGroup = class CustomGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { custom_group_id: { required: true, type: () => String }, internal: { required: true, type: () => Boolean }, label: { required: true, type: () => String }, _class: { required: false, type: () => require("./class.entity").Class }, class: { required: true, type: () => String }, _hw_type: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, custom_group_folder: { required: false, type: () => require("./customGroupFolder.entity").CustomGroupFolder }, custom_group_folder_id: { required: true, type: () => String }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User }, group_id: { required: true, type: () => Number }, _group: { required: false, type: () => require("./group.entity").Group }, groups: { required: false, type: () => [require("./itemGroup.entity").ItemGroup] }, exports: { required: false, type: () => [require("./export.entity").Export] }, alertingGroups: { required: false, type: () => [require("./alertingGroup.entity").AlertingGroup] }, report_items: { required: false, type: () => [require("./reportItem.entity").ReportItem] }, favorites: { required: false, type: () => [require("./customGroupFavorite.entity").CustomGroupFavorite] } };
    }
};
exports.CustomGroup = CustomGroup;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], CustomGroup.prototype, "custom_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], CustomGroup.prototype, "internal", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], CustomGroup.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => class_entity_1.Class, (_class) => _class.customGroups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'class' }),
    __metadata("design:type", class_entity_1.Class)
], CustomGroup.prototype, "_class", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], CustomGroup.prototype, "class", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.customGroups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], CustomGroup.prototype, "_hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], CustomGroup.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], CustomGroup.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => customGroupFolder_entity_1.CustomGroupFolder, (custom_group_folder) => custom_group_folder.custom_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'custom_group_folder_id' }),
    __metadata("design:type", customGroupFolder_entity_1.CustomGroupFolder)
], CustomGroup.prototype, "custom_group_folder", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], CustomGroup.prototype, "custom_group_folder_id", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], CustomGroup.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_custom_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], CustomGroup.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], CustomGroup.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => group_entity_1.Group, (group) => group._custom_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'group_id' }),
    __metadata("design:type", group_entity_1.Group)
], CustomGroup.prototype, "_group", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroup_entity_1.ItemGroup, (itemGroupItems) => itemGroupItems._custom_group),
    __metadata("design:type", Array)
], CustomGroup.prototype, "groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => export_entity_1.Export, (exporter) => exporter._custom_group),
    __metadata("design:type", Array)
], CustomGroup.prototype, "exports", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingGroup_entity_1.AlertingGroup, (alertingGroup) => alertingGroup._custom_group),
    __metadata("design:type", Array)
], CustomGroup.prototype, "alertingGroups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => reportItem_entity_1.ReportItem, (reportItem) => reportItem._custom_group),
    __metadata("design:type", Array)
], CustomGroup.prototype, "report_items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroupFavorite_entity_1.CustomGroupFavorite, (customGroupFavorite) => customGroupFavorite._custom_group),
    __metadata("design:type", Array)
], CustomGroup.prototype, "favorites", void 0);
exports.CustomGroup = CustomGroup = __decorate([
    (0, typeorm_1.Entity)({ name: 'custom_groups', synchronize: false })
], CustomGroup);
//# sourceMappingURL=customGroup.entity.js.map