"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashboardFolder = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const dashboard_entity_1 = require("./dashboard.entity");
const dashboard_constants_1 = require("../common/constants/dashboard.constants");
const user_entity_1 = require("./user.entity");
const group_entity_1 = require("./group.entity");
const enumsVersion = 'v' + 1;
let DashboardFolder = class DashboardFolder {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_folder_id: { required: true, type: () => String }, label: { required: true, type: () => String }, parent: { required: true, type: () => require("./dashboardFolder.entity").DashboardFolder }, children: { required: true, type: () => [require("./dashboardFolder.entity").DashboardFolder] }, type: { required: true, type: () => Object }, dashboards: { required: true, type: () => [require("./dashboard.entity").Dashboard] }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User }, group_id: { required: true, type: () => Number }, group: { required: false, type: () => require("./group.entity").Group } };
    }
};
exports.DashboardFolder = DashboardFolder;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], DashboardFolder.prototype, "dashboard_folder_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DashboardFolder.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.TreeParent)({
        onDelete: 'CASCADE',
    }),
    __metadata("design:type", DashboardFolder)
], DashboardFolder.prototype, "parent", void 0);
__decorate([
    (0, typeorm_1.TreeChildren)({
        cascade: true,
    }),
    __metadata("design:type", Array)
], DashboardFolder.prototype, "children", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: dashboard_constants_1.DASHBOARD_TYPE,
        default: dashboard_constants_1.DASHBOARD_TYPE.personal,
        enumName: `dashboard_type_${enumsVersion}`,
    }),
    __metadata("design:type", String)
], DashboardFolder.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => dashboard_entity_1.Dashboard, (dashboard) => dashboard.parent),
    __metadata("design:type", Array)
], DashboardFolder.prototype, "dashboards", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], DashboardFolder.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_dashboard_folders, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], DashboardFolder.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], DashboardFolder.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => group_entity_1.Group, (group) => group.group_id, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'group_id' }),
    __metadata("design:type", group_entity_1.Group)
], DashboardFolder.prototype, "group", void 0);
exports.DashboardFolder = DashboardFolder = __decorate([
    (0, typeorm_1.Entity)({ name: 'dashboard_folders', synchronize: false }),
    (0, typeorm_1.Tree)('materialized-path')
], DashboardFolder);
//# sourceMappingURL=dashboardFolder.entity.js.map