"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HwEventDeviceGroup = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const mailGroup_entity_1 = require("./mailGroup.entity");
const class_entity_1 = require("./class.entity");
const hwType_entity_1 = require("./hwType.entity");
const user_entity_1 = require("./user.entity");
const itemGroup_entity_1 = require("./itemGroup.entity");
const alert_elements_1 = require("../common/elements/alert.elements");
let HwEventDeviceGroup = class HwEventDeviceGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { device_group_id: { required: true, type: () => String }, label: { required: true, type: () => String }, class: { required: true, type: () => String }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, enabled: { required: true, type: () => Boolean }, user_id: { required: true, type: () => Number }, item_group_id: { required: true, type: () => String }, created_at: { required: true, type: () => Date }, integrations: { required: true, type: () => require("../common/elements/alert.elements").AlertIntegrations }, _user: { required: true, type: () => require("./user.entity").User }, _class: { required: true, type: () => require("./class.entity").Class }, _hw_type: { required: true, type: () => require("./hwType.entity").HwType }, _item_group: { required: false, type: () => require("./itemGroup.entity").ItemGroup }, mail_groups: { required: true, type: () => [require("./mailGroup.entity").MailGroup] } };
    }
};
exports.HwEventDeviceGroup = HwEventDeviceGroup;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "device_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "class", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: true }),
    __metadata("design:type", Boolean)
], HwEventDeviceGroup.prototype, "enabled", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], HwEventDeviceGroup.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HwEventDeviceGroup.prototype, "item_group_id", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], HwEventDeviceGroup.prototype, "created_at", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: false,
        type: 'jsonb',
        default: "'{}'::jsonb"
    }),
    __metadata("design:type", alert_elements_1.AlertIntegrations)
], HwEventDeviceGroup.prototype, "integrations", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => user_entity_1.User),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], HwEventDeviceGroup.prototype, "_user", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => class_entity_1.Class),
    (0, typeorm_1.JoinColumn)({ name: 'class' }),
    __metadata("design:type", class_entity_1.Class)
], HwEventDeviceGroup.prototype, "_class", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => hwType_entity_1.HwType, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], HwEventDeviceGroup.prototype, "_hw_type", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => itemGroup_entity_1.ItemGroup, (itemGroup) => itemGroup.deviceGroup),
    (0, typeorm_1.JoinColumn)({ name: 'item_group_id' }),
    __metadata("design:type", itemGroup_entity_1.ItemGroup)
], HwEventDeviceGroup.prototype, "_item_group", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => mailGroup_entity_1.MailGroup, (mailGroup) => mailGroup.hwEventDeviceGroups),
    (0, typeorm_1.JoinTable)({
        name: 'device_group_hw_alerting_mail_group',
        joinColumn: {
            name: 'device_group_id',
            referencedColumnName: 'device_group_id',
        },
        inverseJoinColumn: {
            name: 'mail_group_id',
            referencedColumnName: 'mail_group_id',
        },
    }),
    __metadata("design:type", Array)
], HwEventDeviceGroup.prototype, "mail_groups", void 0);
exports.HwEventDeviceGroup = HwEventDeviceGroup = __decorate([
    (0, typeorm_1.Entity)({ name: 'device_group_hw_alerting', synchronize: false })
], HwEventDeviceGroup);
//# sourceMappingURL=deviceGroupHwAlerting.entity.js.map