"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Export = void 0;
const openapi = require("@nestjs/swagger");
const exporter_dto_1 = require("../common/exporter.dto");
const typeorm_1 = require("typeorm");
const exporter_constants_1 = require("../common/constants/exporter.constants");
const user_entity_1 = require("./user.entity");
const class_entity_1 = require("./class.entity");
const hwType_entity_1 = require("./hwType.entity");
const customGroup_entity_1 = require("./customGroup.entity");
const itemGroup_entity_1 = require("./itemGroup.entity");
const exporterFormatEnumVersion = 'v' + 1;
const exporterTypeEnumVersion = 'v' + 2;
let Export = class Export {
    static _OPENAPI_METADATA_FACTORY() {
        return { export_id: { required: true, type: () => String }, label: { required: true, type: () => String }, format: { required: true, type: () => Object }, type: { required: true, type: () => Object }, _class: { required: false, type: () => require("./class.entity").Class }, class: { required: true, type: () => String }, _hw_type: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, _item_group: { required: false, type: () => require("./itemGroup.entity").ItemGroup }, item_group_id: { required: true, type: () => String }, _custom_group: { required: false, type: () => require("./customGroup.entity").CustomGroup }, custom_group_id: { required: true, type: () => String }, data: { required: true, type: () => Object }, recurrence: { required: false, type: () => require("../common/exporter.dto").Recurrence }, last_run: { required: false, type: () => String }, created: { required: false, type: () => Date }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User } };
    }
};
exports.Export = Export;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], Export.prototype, "export_id", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: 'unlabeled',
    }),
    __metadata("design:type", String)
], Export.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: exporter_constants_1.EXPORT_FORMAT,
        default: exporter_constants_1.EXPORT_FORMAT.csv,
        enumName: `export_format_${exporterFormatEnumVersion}`,
    }),
    __metadata("design:type", String)
], Export.prototype, "format", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: exporter_constants_1.EXPORT_TYPE,
        default: exporter_constants_1.EXPORT_TYPE.timeseries,
        enumName: `export_type_${exporterTypeEnumVersion}`,
    }),
    __metadata("design:type", String)
], Export.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => class_entity_1.Class, (_class) => _class.exports, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'class' }),
    __metadata("design:type", class_entity_1.Class)
], Export.prototype, "_class", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Export.prototype, "class", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.exports, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], Export.prototype, "_hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Export.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Export.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => itemGroup_entity_1.ItemGroup, (itemGroup) => itemGroup.export, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'item_group_id' }),
    __metadata("design:type", itemGroup_entity_1.ItemGroup)
], Export.prototype, "_item_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Export.prototype, "item_group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup.exports, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'custom_group_id' }),
    __metadata("design:type", customGroup_entity_1.CustomGroup)
], Export.prototype, "_custom_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Export.prototype, "custom_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'jsonb',
    }),
    __metadata("design:type", Object)
], Export.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'jsonb',
        nullable: true
    }),
    __metadata("design:type", exporter_dto_1.Recurrence)
], Export.prototype, "recurrence", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'timestamp with time zone', name: 'last_run', nullable: true }),
    __metadata("design:type", String)
], Export.prototype, "last_run", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'created' }),
    __metadata("design:type", Date)
], Export.prototype, "created", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Export.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_exports, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], Export.prototype, "created_by", void 0);
exports.Export = Export = __decorate([
    (0, typeorm_1.Entity)({ name: 'exports', synchronize: false })
], Export);
//# sourceMappingURL=export.entity.js.map