"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatus = exports.StatusPriority = exports.StatusType = exports.Status = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const objectItem_entity_1 = require("./objectItem.entity");
var Status;
(function (Status) {
    Status["OK"] = "ok";
    Status["WARNING"] = "warning";
    Status["ERROR"] = "error";
    Status["UNKNOWN"] = "unknown";
})(Status || (exports.Status = Status = {}));
var StatusType;
(function (StatusType) {
    StatusType["HEALTH"] = "health";
    StatusType["DATA"] = "data";
    StatusType["CONNECTION"] = "connection";
})(StatusType || (exports.StatusType = StatusType = {}));
class StatusPriority {
    constructor() {
        this.priority = {
            [Status.OK]: 1,
            [Status.WARNING]: 2,
            [Status.ERROR]: 3,
            [Status.UNKNOWN]: 1,
        };
        this.priority[Status.OK] = 1;
        this.priority[Status.WARNING] = 2;
        this.priority[Status.ERROR] = 3;
        this.priority[Status.UNKNOWN] = 1;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { priority: { required: true, type: () => Object, default: {
                    [Status.OK]: 1,
                    [Status.WARNING]: 2,
                    [Status.ERROR]: 3,
                    [Status.UNKNOWN]: 1,
                } } };
    }
}
exports.StatusPriority = StatusPriority;
const hsVersion = 'v' + 1;
let HealthStatus = class HealthStatus {
    static _OPENAPI_METADATA_FACTORY() {
        return { _item: { required: false, type: () => require("./objectItem.entity").ObjectItem }, item_id: { required: true, type: () => String }, type: { required: true, enum: require("./healthStatus.entity").StatusType }, status: { required: true, enum: require("./healthStatus.entity").Status }, createdAt: { required: false, type: () => Date }, updatedAt: { required: false, type: () => Date }, data: { required: false, type: () => String } };
    }
};
exports.HealthStatus = HealthStatus;
__decorate([
    (0, typeorm_1.OneToOne)(() => objectItem_entity_1.ObjectItem),
    (0, typeorm_1.JoinColumn)({ name: 'item_id' }),
    __metadata("design:type", objectItem_entity_1.ObjectItem)
], HealthStatus.prototype, "_item", void 0);
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], HealthStatus.prototype, "item_id", void 0);
__decorate([
    (0, typeorm_1.PrimaryColumn)({
        enum: StatusType,
        enumName: `status_type`,
        default: 'health',
    }),
    __metadata("design:type", String)
], HealthStatus.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: Status,
        enumName: `hs_${hsVersion}`,
        default: Status.UNKNOWN,
    }),
    __metadata("design:type", String)
], HealthStatus.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'created_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], HealthStatus.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ name: 'updated_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], HealthStatus.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], HealthStatus.prototype, "data", void 0);
exports.HealthStatus = HealthStatus = __decorate([
    (0, typeorm_1.Entity)({ name: 'health_status', synchronize: false })
], HealthStatus);
//# sourceMappingURL=healthStatus.entity.js.map