"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._3parVolume = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports._3parVolume = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_3par_volume',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        resp_t: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        r_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        w_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        capacity_used: {
            type: 'float4',
            nullable: true,
        },
        capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        capacity_total: {
            type: 'float4',
            nullable: true,
        },
        capacity_free: {
            type: 'float4',
            nullable: true,
        },
        sum_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        snapshot_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        sum_capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        sum_capacity_reserved: {
            type: 'float4',
            nullable: true,
        },
        capacity_reserved: {
            type: 'float4',
            nullable: true,
        },
        snapshot_capacity_reserved: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=3parVolume.entity.js.map