"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AzureVM = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.AzureVM = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_azure_vm',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_util: {
            type: 'float4',
            nullable: true,
        },
        read_bytes: {
            type: 'float4',
            nullable: true,
        },
        write_bytes: {
            type: 'float4',
            nullable: true,
        },
        read_ops: {
            type: 'float4',
            nullable: true,
        },
        write_ops: {
            type: 'float4',
            nullable: true,
        },
        received_bytes: {
            type: 'float4',
            nullable: true,
        },
        sent_bytes: {
            type: 'float4',
            nullable: true,
        },
        freeMemory: {
            type: 'float4',
            nullable: true,
        },
        usedMemory: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        capacity_free: {
            type: 'float4',
            nullable: true,
        },
        capacity_used: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=azureVM.entity.js.map