"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DockerContainer = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.DockerContainer = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_docker_container',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_usage: {
            type: 'int2',
            nullable: true,
        },
        cpu_cores_usage: {
            type: 'float4',
            nullable: true,
        },
        memory_used: {
            type: 'float4',
            nullable: true,
        },
        memory_free: {
            type: 'float4',
            nullable: true,
        },
        memory_available: {
            type: 'float4',
            nullable: true,
        },
        read_bytes: {
            type: 'float4',
            nullable: true,
        },
        write_bytes: {
            type: 'float4',
            nullable: true,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        tx_bytes: {
            type: 'float4',
            nullable: true,
        },
        rx_bytes: {
            type: 'float4',
            nullable: true,
        },
        size_rw: {
            type: 'float4',
            nullable: true,
        },
        size_root_fs: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=dockerContainer.entity.js.map