"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracledbInstance = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OracledbInstance = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oracledb_instance',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        GlobalCacheBlocksLost: {
            type: 'float4',
            nullable: true,
        },
        LogonsPerSec: {
            nullable: true,
            type: 'float4',
        },
        PGACacheHit: {
            nullable: true,
            type: 'float4',
        },
        ExecutionsPerSec: {
            nullable: true,
            type: 'float4',
        },
        free: {
            type: 'float4',
            nullable: true,
        },
        CPUUsagePerTxn: {
            nullable: true,
            type: 'float4',
        },
        HardParseCountPerSec: {
            nullable: true,
            type: 'int4',
        },
        gccrmultiblockrequest: {
            nullable: true,
            type: 'float4',
        },
        flashbacklogfilesync: {
            nullable: true,
            type: 'float4',
        },
        NetworkTrafficVolumePerSec: {
            type: 'float4',
            nullable: true,
        },
        GlobalCacheAverageCRGetTime: {
            nullable: true,
            type: 'float4',
        },
        CurrentLogonsCount: {
            type: 'float4',
            nullable: true,
        },
        IOMegabytesperSecond: {
            type: 'float4',
            nullable: true,
        },
        gccrgrant2way: {
            type: 'float4',
            nullable: true,
        },
        gccurrentblock2way: {
            nullable: true,
            type: 'float4',
        },
        gccrblock3way: {
            type: 'float4',
            nullable: true,
        },
        gccurrentgrant2way: {
            type: 'float4',
            nullable: true,
        },
        gccurrentgrantbusy: {
            nullable: true,
            type: 'float4',
        },
        BufferCacheHitRatio: {
            type: 'float4',
            nullable: true,
        },
        MemorySortsRatio: {
            nullable: true,
            type: 'float4',
        },
        PhysicalReadBytesPerSec: {
            nullable: true,
            type: 'float4',
        },
        used: {
            type: 'float4',
            nullable: true,
        },
        gccrblockcongested: {
            nullable: true,
            type: 'float4',
        },
        CellPhysicalIOInterconnectBytes: {
            type: 'float4',
            nullable: true,
        },
        SoftParseRatio: {
            type: 'float4',
            nullable: true,
        },
        GCAvgCRBlockreceivems: {
            type: 'float4',
            nullable: true,
        },
        GlobalCacheBlocksCorrupted: {
            type: 'float4',
            nullable: true,
        },
        gccrgrantcongested: {
            type: 'float4',
            nullable: true,
        },
        gccurrentblockcongested: {
            nullable: true,
            type: 'float4',
        },
        gccurrentretry: {
            type: 'float4',
            nullable: true,
        },
        gccrfailure: {
            type: 'float4',
            nullable: true,
        },
        dbfilesinglewrite: {
            type: 'float4',
            nullable: true,
        },
        UserTransactionPerSec: {
            nullable: true,
            type: 'float4',
        },
        gcbufferbusyrelease: {
            nullable: true,
            type: 'float4',
        },
        HostCPUUtilization: {
            type: 'float4',
            nullable: true,
        },
        LogicalReadsPerSec: {
            type: 'int4',
            nullable: true,
        },
        ActiveParallelSessions: {
            nullable: true,
            type: 'float4',
        },
        IORequestsperSecond: {
            nullable: true,
            type: 'float4',
        },
        RedoGeneratedPerSec: {
            type: 'float4',
            nullable: true,
        },
        PhysicalReadsPerSec: {
            nullable: true,
            type: 'float4',
        },
        AverageActiveSessions: {
            type: 'float4',
            nullable: true,
        },
        CurrentOpenCursorsCount: {
            nullable: true,
            type: 'float4',
        },
        logfilesync: {
            type: 'float4',
            nullable: true,
        },
        gcremaster: {
            nullable: true,
            type: 'float4',
        },
        GCCRBlockReceivedPerSecond: {
            nullable: true,
            type: 'float4',
        },
        DatabaseCPUTimeRatio: {
            type: 'float4',
            nullable: true,
        },
        DBBlockChangesPerSec: {
            type: 'float4',
            nullable: true,
        },
        logfilesinglewrite: {
            nullable: true,
            type: 'float4',
        },
        gccurrentblocklost: {
            type: 'float4',
            nullable: true,
        },
        dbfilescatteredread: {
            nullable: true,
            type: 'float4',
        },
        DatabaseWaitTimeRatio: {
            type: 'float4',
            nullable: true,
        },
        gccrblockbusy: {
            type: 'float4',
            nullable: true,
        },
        GCCurrentBlockReceivedPerSecond: {
            type: 'float4',
            nullable: true,
        },
        gccurrentsplit: {
            type: 'float4',
            nullable: true,
        },
        dbfilesequentialread: {
            type: 'float4',
            nullable: true,
        },
        PhysicalWriteBytesPerSec: {
            nullable: true,
            type: 'float4',
        },
        PhysicalWritesPerSec: {
            type: 'float4',
            nullable: true,
        },
        UserCommitsPerSec: {
            nullable: true,
            type: 'float4',
        },
        GCAvgCURBlockreceivems: {
            nullable: true,
            type: 'float4',
        },
        OpenCursorsPerSec: {
            type: 'float4',
            nullable: true,
        },
        gccurrentblockbusy: {
            nullable: true,
            type: 'float4',
        },
        gccurrentblock3way: {
            type: 'float4',
            nullable: true,
        },
        gccrdiskread: {
            nullable: true,
            type: 'float4',
        },
        gcbufferbusyacquire: {
            type: 'float4',
            nullable: true,
        },
        log_capacity: {
            nullable: true,
            type: 'float4',
        },
        dbfileparallelwrite: {
            nullable: true,
            type: 'float4',
        },
        gccrblock2way: {
            nullable: true,
            type: 'float4',
        },
        logfileparallelwrite: {
            nullable: true,
            type: 'float4',
        },
        gccrblocklost: {
            nullable: true,
            type: 'float4',
        },
        gccurrentgrantcongested: {
            type: 'float4',
            nullable: true,
        },
        ActiveSerialSessions: {
            type: 'float4',
            nullable: true,
        },
        gccurrentmultiblockrequest: {
            type: 'float4',
            nullable: true,
        },
        CPUUsagePerSec: {
            nullable: true,
            type: 'float4',
        },
        GlobalCacheAverageCurrentGetTime: {
            type: 'float4',
            nullable: true,
        },
        temp_files: {
            nullable: true,
            type: 'float4',
        },
        control_files: {
            type: 'float4',
            nullable: true,
        },
        ping: {
            type: 'float4',
            nullable: true,
        },
        recoveryused: {
            type: 'float4',
            nullable: true,
        },
        recoverysize: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oracledbInstance.entity.js.map