"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OraclezfsNode = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OraclezfsNode = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oraclezfs_node',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        iscsi_io_rate: {
            type: 'float4',
            nullable: true,
        },
        fc_io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        smb_data_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs_data_rate: {
            type: 'float4',
            nullable: true,
        },
        iscsi_resp_t: {
            type: 'float4',
            nullable: true,
        },
        iscsi_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        iscsi_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        fc_resp_t: {
            type: 'float4',
            nullable: true,
        },
        fc_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        fc_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        l1_hit_ratio: {
            type: 'float4',
            nullable: true,
        },
        l2_hit_miss: {
            type: 'float4',
            nullable: true,
        },
        l1_arc_size: {
            type: 'float4',
            nullable: true,
        },
        l2_arc_size: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oraclezfsNode.entity.js.map