"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxmoxVm = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.ProxmoxVm = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_proxmox_vm',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        maxcpu: {
            type: 'float4',
            nullable: true,
        },
        maxmem: {
            type: 'float4',
            nullable: true,
        },
        mem: {
            type: 'float4',
            nullable: true,
        },
        memfree: {
            type: 'float4',
            nullable: true,
        },
        diskread: {
            type: 'float4',
            nullable: true,
        },
        diskwrite: {
            type: 'float4',
            nullable: true,
        },
        netin: {
            type: 'float4',
            nullable: true,
        },
        netout: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=proxmoxVm.entity.js.map