"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SannavDevice = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.SannavDevice = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_sannav_device',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_system: {
            type: 'float4',
            nullable: true,
        },
        memory_used_percent: {
            type: 'float4',
            nullable: true,
        },
        data_out: {
            type: 'float4',
            nullable: true,
        },
        data_in: {
            type: 'float4',
            nullable: true,
        },
        frames_out: {
            type: 'float4',
            nullable: true,
        },
        frames_in: {
            type: 'float4',
            nullable: true,
        },
        bb_credits: {
            type: 'float4',
            nullable: true,
        },
        crc_errors: {
            type: 'float4',
            nullable: true,
        },
        link_fail: {
            type: 'float4',
            nullable: true,
        },
        loss_sync: {
            type: 'float4',
            nullable: true,
        },
        pcs_errors: {
            type: 'float4',
            nullable: true,
        },
        enc_out: {
            type: 'float4',
            nullable: true,
        },
        disc_c3: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=sannavDevice.entity.js.map