"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoragegridPort = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.StoragegridPort = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_storagegrid_node',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        s3_total: {
            type: 'float4',
            nullable: true,
        },
        s3_ingested: {
            type: 'float4',
            nullable: true,
        },
        s3_ops_failed: {
            type: 'float4',
            nullable: true,
        },
        s3_ops_successful: {
            type: 'float4',
            nullable: true,
        },
        s3_retrieved: {
            type: 'float4',
            nullable: true,
        },
        s3_ops_unauthorized: {
            type: 'float4',
            nullable: true,
        },
        network_rx: {
            type: 'float4',
            nullable: true,
        },
        network_tx: {
            type: 'float4',
            nullable: true,
        },
        network_rate: {
            type: 'float4',
            nullable: true,
        },
        read_error: {
            type: 'float4',
            nullable: true,
        },
        write_error: {
            type: 'float4',
            nullable: true,
        },
        error_rate: {
            type: 'float4',
            nullable: true,
        },
        metadata_capacity_total: {
            type: 'float4',
            nullable: true,
        },
        metadata_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        metadata_capacity_free: {
            type: 'float4',
            nullable: true,
        },
        capacity_total: {
            type: 'float4',
            nullable: true,
        },
        capacity_used: {
            type: 'float4',
            nullable: true,
        },
        capacity_free: {
            type: 'float4',
            nullable: true,
        },
        capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        ilm_queue_all: {
            type: 'float4',
            nullable: true,
        },
        ilm_queue_client: {
            type: 'float4',
            nullable: true,
        },
        ilm_queue_background: {
            type: 'float4',
            nullable: true,
        },
        ilm_scan_rate: {
            type: 'float4',
            nullable: true,
        },
        ilm_queue_eval_rate: {
            type: 'float4',
            nullable: true,
        },
        swift_ops_failed: {
            type: 'float4',
            nullable: true,
        },
        swift_ops_successful: {
            type: 'float4',
            nullable: true,
        },
        swift_ops_unauthorized: {
            type: 'float4',
            nullable: true,
        },
        swift_total: {
            type: 'float4',
            nullable: true,
        },
        swift_ingested: {
            type: 'float4',
            nullable: true,
        },
        swift_retrieved: {
            type: 'float4',
            nullable: true,
        },
        memory_used_percent: {
            type: 'float4',
            nullable: true,
        },
        memory_used: {
            type: 'float4',
            nullable: true,
        },
        memory_free: {
            type: 'float4',
            nullable: true,
        },
        memory_total: {
            type: 'float4',
            nullable: true,
        },
        cpu_busy: {
            type: 'float4',
            nullable: true,
        },
        cpu_system: {
            type: 'float4',
            nullable: true,
        },
        cpu_wait: {
            type: 'float4',
            nullable: true,
        },
        cpu_user: {
            type: 'float4',
            nullable: true,
        },
        cpu_steal: {
            type: 'float4',
            nullable: true,
        },
        cpu_softirq: {
            type: 'float4',
            nullable: true,
        },
        cpu_nice: {
            type: 'float4',
            nullable: true,
        },
        cpu_irq: {
            type: 'float4',
            nullable: true,
        },
        cpu_idle: {
            type: 'float4',
            nullable: true,
        },
        lb_total: {
            type: 'float4',
            nullable: true,
        },
        lb_rx: {
            type: 'float4',
            nullable: true,
        },
        lb_tx: {
            type: 'float4',
            nullable: true,
        },
        lb_request_rate: {
            type: 'float4',
            nullable: true,
        },
        lb_error_rate: {
            type: 'float4',
            nullable: true,
        },
        user_data_used: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=storagegridNode.entity.js.map