"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreonceCat = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.StoreonceCat = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_storeonce_cat',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        read_replication: {
            type: 'float4',
            nullable: true,
        },
        write_replication: {
            type: 'float4',
            nullable: true,
        },
        stream_rate: {
            type: 'float4',
            nullable: true,
        },
        dedupe_ratio: {
            type: 'float4',
            nullable: true,
        },
        stream_read_replication: {
            type: 'float4',
            nullable: true,
        },
        stream_write_replication: {
            type: 'float4',
            nullable: true,
        },
        user_capacity_used: {
            type: 'float4',
            nullable: true,
        },
        disk_size: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        stream_job_rate: {
            type: 'float4',
            nullable: true,
        },
        logical_data_read: {
            type: 'float4',
            nullable: true,
        },
        logical_data_write: {
            type: 'float4',
            nullable: true,
        },
        logical_data_rate: {
            type: 'float4',
            nullable: true,
        },
        logical_copy_job_read: {
            type: 'float4',
            nullable: true,
        },
        logical_copy_job_write: {
            type: 'float4',
            nullable: true,
        },
        logical_data_job_read: {
            type: 'float4',
            nullable: true,
        },
        logical_data_job_write: {
            type: 'float4',
            nullable: true,
        },
        copy_job_read: {
            type: 'float4',
            nullable: true,
        },
        copy_job_write: {
            type: 'float4',
            nullable: true,
        },
        data_job_read: {
            type: 'float4',
            nullable: true,
        },
        data_job_write: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=storeonceCat.entity.js.map