"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VmwareCluster = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.VmwareCluster = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_vmware_cluster',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_usage: {
            type: 'float4',
            nullable: true,
        },
        cpu_usage_proc: {
            type: 'float4',
            nullable: true
        },
        cpu_reserved: {
            type: 'float4',
            nullable: true,
        },
        cpu_total: {
            type: 'float4',
            nullable: true,
        },
        cluster_eff_cpu: {
            type: 'float4',
            nullable: true,
        },
        cluster_eff_mem: {
            type: 'float4',
            nullable: true,
        },
        memory_total: {
            type: 'float4',
            nullable: true,
        },
        memory_shared: {
            type: 'float4',
            nullable: true,
        },
        memory_zero: {
            type: 'float4',
            nullable: true,
        },
        memory_baloon: {
            type: 'float4',
            nullable: true,
        },
        memory_consumed: {
            type: 'float4',
            nullable: true,
        },
        memory_overhead: {
            type: 'float4',
            nullable: true,
        },
        memory_active: {
            type: 'float4',
            nullable: true,
        },
        memory_granted: {
            type: 'float4',
            nullable: true,
        },
        memory_compress: {
            type: 'float4',
            nullable: true,
        },
        memory_reserved: {
            type: 'float4',
            nullable: true,
        },
        memory_swap: {
            type: 'float4',
            nullable: true,
        },
        mem_cmprssion: {
            type: 'float4',
            nullable: true,
        },
        mem_dcompress: {
            type: 'float4',
            nullable: true,
        },
        memory_usage_proc: {
            type: 'int2',
            nullable: true,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        total_cluster_cores: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=vmwareCluster.entity.js.map