"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VmwareDatastore = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.VmwareDatastore = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_vmware_datastore',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        free_space: {
            type: 'float4',
            nullable: true,
        },
        disk_used: {
            type: 'float4',
            nullable: true,
        },
        disk_provisioned: {
            type: 'float4',
            nullable: true,
        },
        disk_capacity: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        read_avg: {
            type: 'float4',
            nullable: true,
        },
        write_avg: {
            type: 'float4',
            nullable: true,
        },
        read_latency: {
            type: 'float4',
            nullable: true,
        },
        write_latency: {
            type: 'float4',
            nullable: true,
        },
        max_depth: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=vmwareDatastore.entity.js.map