"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Microservice = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const hwType_entity_1 = require("./hwType.entity");
const microserviceData_entity_1 = require("./microserviceData.entity");
const microserviceJobs_entity_1 = require("./microserviceJobs.entity");
const microserviceJobsStatus_entity_1 = require("./microserviceJobsStatus.entity");
let Microservice = class Microservice {
    static _OPENAPI_METADATA_FACTORY() {
        return { microservice: { required: true, type: () => String }, label: { required: true, type: () => String }, script: { required: true, type: () => String }, host: { required: true, type: () => String }, port: { required: true, type: () => String }, hw_type_entity: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, onStartup: { required: true, type: () => Boolean }, needConf: { required: true, type: () => Boolean }, updatedAt: { required: false, type: () => Date }, data: { required: false, type: () => [require("./microserviceData.entity").MicroserviceData] }, jobs: { required: false, type: () => [require("./microserviceJobs.entity").MicroserviceJob] }, jobs_status: { required: false, type: () => [require("./microserviceJobsStatus.entity").MicroserviceJobStatus] } };
    }
};
exports.Microservice = Microservice;
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], Microservice.prototype, "microservice", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Microservice.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Microservice.prototype, "script", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Microservice.prototype, "host", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Microservice.prototype, "port", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.microservices, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], Microservice.prototype, "hw_type_entity", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Microservice.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'boolean', default: false }),
    __metadata("design:type", Boolean)
], Microservice.prototype, "onStartup", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'boolean', default: false }),
    __metadata("design:type", Boolean)
], Microservice.prototype, "needConf", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ name: 'updated_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], Microservice.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => microserviceData_entity_1.MicroserviceData, (microservicesData) => microservicesData._microservice),
    __metadata("design:type", Array)
], Microservice.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => microserviceJobs_entity_1.MicroserviceJob, (microservicesJobs) => microservicesJobs._microservice),
    __metadata("design:type", Array)
], Microservice.prototype, "jobs", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => microserviceJobsStatus_entity_1.MicroserviceJobStatus, (microservicesJobsStatus) => microservicesJobsStatus._microservice),
    __metadata("design:type", Array)
], Microservice.prototype, "jobs_status", void 0);
exports.Microservice = Microservice = __decorate([
    (0, typeorm_1.Entity)({ name: 'microservices', synchronize: false })
], Microservice);
//# sourceMappingURL=microservice.entity.js.map