import { Audit } from './audit.entity';
import { Group } from './group.entity';
import { Ldap } from './ldap.entity';
import { CustomGroup } from './customGroup.entity';
import { CustomGroupFolder } from './customGroupFolder.entity';
import { Export } from './export.entity';
import { Dashboard } from './dashboard.entity';
import { DashboardFolder } from './dashboardFolder.entity';
import { UserApiKey } from './userApiKey.entity';
import { Report } from './report.entity';
import { StorageGroup } from './storageGroup.entity';
import { MailGroup } from './mailGroup.entity';
import { RecentlySearched } from './recentlySearched.entity';
import { AlertingGroup } from './alertingGroup.entity';
import { Tag } from './tag.entity';
import { CustomGroupFavorite } from './customGroupFavorite.entity';
export interface UserConfiguration {
    top?: number;
    searchHistoryLimit?: number;
}
export declare class User {
    user_id: number;
    username: string;
    email: string;
    password: string;
    active: boolean;
    _ldap?: Ldap;
    ldap_id: string;
    groups: Group[];
    timezone: string;
    created?: string;
    updated?: string;
    logged: string;
    configuration: UserConfiguration;
    created_alerts: AlertingGroup[];
    created_custom_groups: CustomGroup[];
    created_custom_group_folders: CustomGroupFolder[];
    created_exports: Export[];
    created_reports: Report[];
    created_dashboards: Dashboard[];
    created_dashboard_folders: DashboardFolder[];
    created_storage_groups: StorageGroup[];
    created_server_groups: StorageGroup[];
    created_tags: Tag[];
    recently_searched: RecentlySearched[];
    audits: Audit[];
    apiKeys: UserApiKey[];
    mailGroups: MailGroup[];
    favoriteCustomGroups: CustomGroupFavorite[];
}
