"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AllExceptionsFilter = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const typeorm_1 = require("typeorm");
const xormon_exception_1 = require("./xormon.exception");
const Crypto_1 = require("../service/configuration/Crypto");
let AllExceptionsFilter = class AllExceptionsFilter extends core_1.BaseExceptionFilter {
    catch(exception, host) {
        const ctx = host.switchToHttp();
        const response = ctx.getResponse();
        const request = ctx.getRequest();
        let customResponse = exception.response
            ? exception.response
            : undefined;
        let printFullException = false;
        let message = exception.message
            ? exception.message
            : "Internal Server Error";
        let log = true;
        let httpStatus = typeof exception === 'object' && typeof exception['getStatus'] === 'function'
            ? exception.getStatus()
            : common_1.HttpStatus.INTERNAL_SERVER_ERROR;
        switch (exception.constructor) {
            case TypeError:
                break;
            case xormon_exception_1.XormonException:
                log = false;
                break;
            case common_1.UnauthorizedException:
                log = false;
                break;
            case common_1.ForbiddenException:
                log = false;
                break;
            case common_1.HttpException:
                break;
            case typeorm_1.QueryFailedError:
                printFullException = true;
                message = exception['detail'] ? `${exception['detail']}\n` : `${exception.message}\n`;
                break;
            case typeorm_1.EntityNotFoundError:
                message = exception.message;
                break;
        }
        if (log) {
            console.error("=== GlobalExceptionFilter ===");
            if (printFullException) {
                console.error(exception);
            }
            else {
                console.error(message, exception.stack);
            }
            console.error(`Request: ${request.method} ${request.url}\n Body: ${request.body
                ? typeof request.body === 'object'
                    ? JSON.stringify(Crypto_1.Crypto.hidePasswords(request.body))
                    : request.body
                : " - "}`);
        }
        response
            .status(httpStatus)
            .json(customResponse
            ? customResponse
            : {
                statusCode: httpStatus,
                message: message
            });
    }
};
exports.AllExceptionsFilter = AllExceptionsFilter;
exports.AllExceptionsFilter = AllExceptionsFilter = __decorate([
    (0, common_1.Catch)()
], AllExceptionsFilter);
//# sourceMappingURL=global.exception.js.map