"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagInterceptor = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const user_entity_1 = require("../entity/user.entity");
const ACLCheck_1 = require("../service/acl/ACLCheck");
const User_1 = require("../service/users/User");
const operators_1 = require("rxjs/operators");
const typeorm_2 = require("typeorm");
let TagInterceptor = class TagInterceptor {
    constructor(usersRepository) {
        this.usersRepository = usersRepository;
    }
    async intercept(context, next) {
        const request = context.switchToHttp().getRequest();
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user.groups.map(group => group.group_id);
        const isAdminGroup = groupIds.includes(1);
        let ret = next.handle();
        if (!isAdminGroup) {
            ret = ret.pipe((0, operators_1.map)(async (data) => {
                const items = data.data;
                const itemIds = items.map((item) => item.item_id);
                const filteredIds = await ACLCheck_1.ACLCheck.filterItemsByRulesTopDown(groupIds, itemIds);
                const filteredItems = items.filter((item) => filteredIds.includes(item.item_id));
                return {
                    statusCode: data.statusCode,
                    message: data.message,
                    data: filteredItems,
                };
            }));
        }
        return ret;
    }
};
exports.TagInterceptor = TagInterceptor;
exports.TagInterceptor = TagInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(user_entity_1.User)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], TagInterceptor);
//# sourceMappingURL=tag.interceptor.js.map