"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UuidRequestInterceptor = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const user_entity_1 = require("../entity/user.entity");
const ACLCheck_1 = require("../service/acl/ACLCheck");
const User_1 = require("../service/users/User");
const operators_1 = require("rxjs/operators");
const typeorm_2 = require("typeorm");
let UuidRequestInterceptor = class UuidRequestInterceptor {
    constructor(usersRepository) {
        this.usersRepository = usersRepository;
    }
    async intercept(context, next) {
        const request = context.switchToHttp().getRequest();
        const response = context.switchToHttp().getResponse();
        const caller = context.getHandler().name;
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user.groups.map(group => group.group_id);
        const url = response.req.url;
        let isRequestAllowed = true;
        if (!groupIds.includes(1)) {
            if (request.data && request.data.item_id) {
                const itemId = request.data.item_id;
                const filteredIds = await ACLCheck_1.ACLCheck.filterItemsByRulesTopDown(groupIds, [itemId]);
                if (filteredIds.length < 1) {
                    let isRequestAllowed = false;
                    throw new common_1.UnauthorizedException('Access denied');
                }
            }
        }
        return next
            .handle()
            .pipe((0, operators_1.map)(async (data) => {
            if (groupIds.includes(1)) {
                return data;
            }
            if (!isRequestAllowed) {
                return {
                    statusCode: common_1.HttpStatus.FORBIDDEN,
                    message: "Access denied",
                    error: 'Access denied'
                };
            }
            return data;
        }));
    }
};
exports.UuidRequestInterceptor = UuidRequestInterceptor;
exports.UuidRequestInterceptor = UuidRequestInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(user_entity_1.User)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], UuidRequestInterceptor);
//# sourceMappingURL=uuidRequest.interceptor.js.map