import { Architecture, DeleteArchitecture } from '@xormon/common/architecture.dto';
import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { ConfigurationService, ItemPropertyObject } from './configuration.service';
import { TargetHostCfgDTO } from '@xormon/common/hostCfgResponse.dto';
import { MetricsTableService } from '@xormon/service/metrics/metricsTable.service';
import { Request } from 'express';
export declare class ConfigurationController {
    private readonly configurationService;
    private readonly metricsTableService;
    private logger;
    constructor(configurationService: ConfigurationService, metricsTableService: MetricsTableService);
    saveConfigrationJSON(data: ItemPropertyObject): Promise<BasicResponseDTO>;
    saveConfigrationCSV(req: any): Promise<BasicResponseDTO>;
    saveArchitecture(architecture: Architecture[], agent?: number): Promise<BasicResponseDTO>;
    saveHostCfg(hostcfg: TargetHostCfgDTO, request: Request): Promise<any>;
    deleteArchitecture(architecture: DeleteArchitecture): Promise<BasicResponseDTO>;
}
