import { ConsistencyGroupMirrorMapDTO, HealthStatusMirrorDTO, HealthStatusMirrorRelDTO } from "@xormon/common/healthStatusMirror.dto";
import { ConsistencyGroup } from "@xormon/entity/consistencyGroup.entity";
import { HealthStatusMirror } from "@xormon/entity/healthStatusMirror.entity";
import { HealthStatusMirrorRel } from "@xormon/entity/healthStatusMirrorRel.entity";
import { EntityManager, Repository } from "typeorm";
export declare class HealthStatusMirrorService {
    private healthStatusMirrorRepository;
    private healthStatusMirrorRelRepository;
    private consistencyGroupRepository;
    private dataSource;
    constructor(healthStatusMirrorRepository: Repository<HealthStatusMirror>, healthStatusMirrorRelRepository: Repository<HealthStatusMirrorRel>, consistencyGroupRepository: Repository<ConsistencyGroup>, dataSource: EntityManager);
    getConsistencyGroup(id: string): Promise<ConsistencyGroup>;
    getMirrorsByConsistencyGroup(): Promise<ConsistencyGroupMirrorMapDTO>;
    insertConsistencyGroup(consistencyGroup: ConsistencyGroup): Promise<ConsistencyGroup>;
    updateHealthStatusMirror(healthStatusMirror: HealthStatusMirror): Promise<HealthStatusMirror>;
    getMirros(): Promise<HealthStatusMirrorDTO[]>;
    insertHealthStatusMirror(healthStatusMirror: HealthStatusMirrorRelDTO[], cgs: ConsistencyGroup[]): Promise<void>;
    deleteHealthStatusMirror(mirror: HealthStatusMirror): Promise<HealthStatusMirror>;
    deleteConsistencyGroup(id: string): Promise<boolean>;
}
