"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MappingController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const mapping_service_1 = require("./mapping.service");
let MappingController = class MappingController {
    constructor(mappingService) {
        this.mappingService = mappingService;
    }
    async searchItem(hw_type, id) {
        let vm = await this.mappingService.findVm(id);
        if (!vm) {
            vm = await this.mappingService.findVmwareVm(id);
        }
        return {
            statusCode: common_1.HttpStatus.OK,
            data: vm
        };
    }
    async searchPowerItem(serial, label) {
        const vm = await this.mappingService.findPowerVm(serial, label);
        return {
            statusCode: common_1.HttpStatus.OK,
            data: vm
        };
    }
};
exports.MappingController = MappingController;
__decorate([
    (0, common_1.Get)('v1/:hw_type/:id'),
    openapi.ApiResponse({ status: 200, type: require("../common/mapping.dto").ItemResponseDTO }),
    __param(0, (0, common_1.Param)('hw_type')),
    __param(1, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], MappingController.prototype, "searchItem", null);
__decorate([
    (0, common_1.Get)('v1/power/:serial/:label'),
    openapi.ApiResponse({ status: 200, type: require("../common/mapping.dto").ItemResponseDTO }),
    __param(0, (0, common_1.Param)('serial')),
    __param(1, (0, common_1.Param)('label')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], MappingController.prototype, "searchPowerItem", null);
exports.MappingController = MappingController = __decorate([
    (0, swagger_1.ApiTags)('Mapping'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/mapping'),
    __metadata("design:paramtypes", [mapping_service_1.MappingService])
], MappingController);
//# sourceMappingURL=mapping.controller.js.map