"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var RegenerateCookieMiddleware_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegenerateCookieMiddleware = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const dataSource_1 = require("../config/dataSource");
const user_entity_1 = require("../entity/user.entity");
const Settings_1 = require("../service/configuration/Settings");
const App_1 = require("../service/configuration/App");
let RegenerateCookieMiddleware = RegenerateCookieMiddleware_1 = class RegenerateCookieMiddleware {
    constructor(configService) {
        this.configService = configService;
        this.logger = new common_1.Logger(RegenerateCookieMiddleware_1.name);
        this.debug = configService.get('APP_DEBUG');
    }
    async use(req, res, next) {
        if (req.session['userId']) {
            next();
        }
        else {
            const jwt = require('jsonwebtoken');
            const secret = App_1.App.getSecret();
            if (req.cookies['xormon-token']) {
                const codedToken = req.cookies['xormon-token'];
                try {
                    const decoded = await jwt.verify(codedToken, secret);
                    if (req.cookies['xormon-token']) {
                        const settings = await Settings_1.Settings.get({ keys: ['GLOB_TOKEN_EXPIRATION'] });
                        const expiration = settings['GLOB_TOKEN_EXPIRATION'] && parseInt(settings['GLOB_TOKEN_EXPIRATION']) != 0 ? { expiresIn: settings['GLOB_TOKEN_EXPIRATION'] + "m" } : undefined;
                        const user = await (0, dataSource_1.getDataSource)().getRepository(user_entity_1.User).findOne({ where: { username: decoded.username }, relations: { groups: true } });
                        const regeneratedToken = await jwt.sign({
                            username: user.username,
                            email: user.email,
                            isAdmin: user.groups.find((group) => group.group_id === 1) ? true : false,
                            timezone: user.timezone,
                            configuration: user.configuration,
                            updated: user.updated,
                            groupLabels: user.groups.map(group => group.name)
                        }, secret, expiration);
                        res.cookie("xormon-token", regeneratedToken);
                    }
                    next();
                }
                catch (err) {
                    res.status(common_1.HttpStatus.UNAUTHORIZED).send({
                        statusCode: common_1.HttpStatus.UNAUTHORIZED,
                        error: 'Unauthorized access',
                        message: 'Bad token',
                    });
                }
            }
            else {
                next();
            }
        }
    }
};
exports.RegenerateCookieMiddleware = RegenerateCookieMiddleware;
exports.RegenerateCookieMiddleware = RegenerateCookieMiddleware = RegenerateCookieMiddleware_1 = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [config_1.ConfigService])
], RegenerateCookieMiddleware);
//# sourceMappingURL=regenerateCookie.middleware.js.map