"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LicenseLicType1718286552429 = void 0;
const hostcfg_entity_1 = require("../../entity/hostcfg.entity");
const typeorm_1 = require("typeorm");
class LicenseLicType1718286552429 {
    constructor() {
        this.name = 'LicenseLicType1718286552429';
    }
    async up(queryRunner) {
        const hostcfgs = await queryRunner.connection.getRepository(hostcfg_entity_1.HostCfg).findBy({
            hw_type: (0, typeorm_1.In)(['power', 'oracledb'])
        });
        for (const index in hostcfgs) {
            const hostcfg = hostcfgs[index];
            if (hostcfg.hw_type === 'power') {
                if (!hostcfg.data.type) {
                    hostcfg.data.type = 'HMC';
                    hostcfg.data.licType = 'HMC';
                }
            }
            else if (hostcfg.hw_type === 'oracledb') {
                if (hostcfg.data.type === 'Standalone' || hostcfg.data.type === 'Multitenant') {
                    hostcfg.data.licType = 'nonRAC';
                }
                else if (hostcfg.data.type === 'RAC' || hostcfg.data.type === 'RACMultitenant') {
                    hostcfg.data.licType = 'RAC';
                }
            }
        }
        await queryRunner.connection.getRepository(hostcfg_entity_1.HostCfg).save(hostcfgs);
    }
    async down(queryRunner) { }
}
exports.LicenseLicType1718286552429 = LicenseLicType1718286552429;
//# sourceMappingURL=1718286552429-LicenseLicType.migration.js.map