"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertingUser1717583929022 = void 0;
class AlertingUser1717583929022 {
    constructor() {
        this.name = 'AlertingUser1717583929022';
    }
    async up(queryRunner) {
        await queryRunner.query(`
    ALTER TABLE alerting_groups ADD COLUMN user_id int4;
    ALTER TABLE alerting_groups ADD CONSTRAINT "FK_alerting_groups_users" FOREIGN KEY (user_id) REFERENCES users ON DELETE CASCADE;

    UPDATE alerting_groups AS ag SET user_id = (SELECT a.user_id FROM alerting a WHERE a.alerting_group_id = ag.alerting_group_id LIMIT 1);

    DELETE FROM  alerting_groups WHERE user_id IS NULL;

    ALTER TABLE alerting_groups ALTER COLUMN user_id SET NOT NULL;

    ALTER TABLE alerting DROP COLUMN user_id;
    `);
    }
    async down(queryRunner) {
        await queryRunner.query(`
    ALTER TABLE alerting ADD COLUMN user_id int4;

    UPDATE alerting AS a SET user_id = (SELECT ag.user_id FROM alerting_groups ag WHERE a.alerting_group_id = ag.alerting_group_id LIMIT 1);

    ALTER TABLE alerting ALTER COLUMN user_id SET NOT NULL;

    ALTER TABLE alerting_groups DROP COLUMN user_id;
    `);
    }
}
exports.AlertingUser1717583929022 = AlertingUser1717583929022;
//# sourceMappingURL=1717583929022-AlertingUser.migration.js.map