"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const Upgrade_1 = require("./service/configuration/Upgrade");
const process_1 = require("process");
const dataSource_1 = require("./config/dataSource");
async function rollback() {
    const fs = require('fs');
    const FILES_PATH = (0, path_1.resolve)('./files');
    const previousVersion = fs.existsSync(FILES_PATH + '/previous-version.tar.gz') && FILES_PATH + '/previous-version.tar.gz';
    if (previousVersion) {
        console.log("Rollback to previous version...");
        if ((0, dataSource_1.getDataSource)() === undefined) {
            await (0, dataSource_1.createDataSource)();
        }
        const status = await Upgrade_1.Upgrade.install(previousVersion, true, true);
        if (status.success) {
            console.log("The rollback was successful");
        }
        else {
            console.log(status.message);
        }
    }
    else {
        console.error("Rollback failed. Version for rollback not found.");
        (0, process_1.exit)(1);
    }
}
rollback();
//# sourceMappingURL=rollback.js.map