import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ACL } from '@xormon/entity/acl.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Request } from 'express';
export declare class ACLCheck {
    private static maxLevel;
    static enabledSubsystems: {
        nutanix: string[];
        oraclevm: string[];
        ovirt: string[];
        power: string[];
        proxmox: string[];
        vmware: string[];
        linux: string[];
        docker: string[];
        kubernetes: string[];
        openshift: string[];
        isilon: string[];
        storeonce: string[];
        datadomain: string[];
        rubrik: string[];
        cohesity: string[];
        ibmcoss: string[];
        eseries: string[];
        vmax: string[];
        swiz: string[];
        xiv: string[];
        '3par': string[];
        oraclezfs: string[];
        compellent: string[];
        dothill: string[];
        infortrend: string[];
        nimble: string[];
        pure: string[];
        qnap: string[];
        powerflex: string[];
        vspg: string[];
        netapp: string[];
        infinibox: string[];
        oceanstor: string[];
        powerstore: string[];
        hcp: string[];
        ddnintelliflash: string[];
        ecs: string[];
        storagegrid: string[];
        oracledb: string[];
        postgres: string[];
        sqlserver: string[];
        db2: string[];
        lancisco: string[];
        lanothers: string[];
    };
    static getUserGroupsFromRequest(request: Request): Promise<any>;
    static getItemsChildren(itemIds: string[]): Promise<{
        [item_id: string]: string[];
    }>;
    static findParents2(item_ids: string[]): Promise<any>;
    static getItemWithParents(item_id: string): Promise<ObjectItem>;
    static getItemWithChildren(item_id: string): Promise<ObjectItem>;
    static findParents(uuid: string, level?: number): Promise<any>;
    static findChildren(uuid: string, level?: number): Promise<any>;
    static filterItemsByEnabledSubsys(itemIds: string[]): Promise<any[]>;
    static isEverythingGranted(groupIds: number[]): boolean;
    static filterItems2(groupIds: number[], itemIds: string[], hwType?: string, subsys?: string): Promise<any[]>;
    static isAnySubsysItemGranted(request: Request, subsys: string, hwType?: string, _class?: string, strict?: boolean): Promise<any>;
    static filterObjectItemsWithRequest(request: Request, items: ObjectItem[], hwType?: string, subsys?: string): Promise<ObjectItem[]>;
    static filterObjectItemsWithGroups(groupIds: number[], items: ObjectItem[], hwType?: string, subsys?: string): Promise<ObjectItem[]>;
    static filterItemsWithRequest(request: Request, itemIds: string[], hwType?: string, subsys?: string): Promise<any[]>;
    static filterItems(groupIds: number[], itemIds: string[], hwType?: string, subsys?: string): Promise<any[]>;
    static getItemClassification(itemId: string): Promise<{
        class: string;
        hwType: string;
        subsystem: string;
        itemId: string;
    }>;
    static parseLinkUrl(url: string): Promise<{
        class: any;
        hwType: string;
        subsystem: string;
        itemId: string;
    }>;
    static getClassStatus(groupIds: number[], _class: string, strict?: boolean): Promise<"partial" | "granted" | "denied">;
    static getHwTypeStatus(groupIds: number[], hwType: string, strict?: boolean): Promise<"partial" | "granted" | "denied">;
    static getSubsysStatus(groupIds: number[], hwType: string, subsys: string, parentIds?: string[], strict?: boolean): any;
    static getItemStatus(groupIds: number[], itemId: string, strict?: boolean): any;
    static getRules(groupIds: number[]): Promise<ACL[]>;
    static getObjectItems(itemIds: string[]): Promise<ObjectItem[]>;
    static filterClasses(groupIds: number[], classes: string[], strict?: boolean): Promise<any[]>;
    static filterHwTypes(groupIds: number[], hwTypes: string[], strict?: boolean): Promise<any[]>;
    static filterItemsById(groupIds: number[], itemIds: string[]): Promise<any[]>;
    static filterItemsBySubsys(groupIds: number[], itemIds: string[]): Promise<any[]>;
    static filterItemsByRulesTopDown(groupIds: number[], itemIds: string[], strict?: boolean): Promise<any[]>;
    static parseFolderUrl(url: string): Promise<{
        hwType: any;
        class: any;
        subsystem: any;
        itemId: any;
    }>;
    static filterMenuFolder(groupIds: number[], menuItems: MenuItem[], path: string, strict?: boolean): Promise<any[]>;
    static filterMenuItems(groupIds: number[], menuItems: MenuItem[], url?: string, strict?: boolean): Promise<any[]>;
    static getMenuFolderStatus(groupIds: number[], menuItem?: MenuItem, url?: string, strict?: boolean): Promise<any>;
    static getMenuItemStatus(groupIds: number[], menuItem: MenuItem, strict?: boolean): Promise<any>;
    static getStatus(menuItem: MenuItem, group_id: number, strict?: boolean): Promise<"partial" | "granted" | "denied">;
}
