"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApisController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const apisResponse_dto_1 = require("../../common/apisResponse.dto");
const HttpResponse_1 = require("../../dto/HttpResponse");
let ApisController = class ApisController {
    constructor() {
        this.registeredApis = {
            exporter: {
                v1: {
                    ip: 'localhost',
                    port: '3201',
                    type: 'api',
                    method: 'POST',
                    body: {
                        uuid: 'string[]',
                        start: 'timestamp',
                        end: 'timestamp',
                        metric: 'string',
                    },
                },
            },
        };
    }
    listApis() {
        let apis = [];
        for (const [name, item] of Object.entries(this.registeredApis)) {
            let registeredApi = item;
            let api = {
                name: name,
                versions: [],
            };
            for (const [version, value] of Object.entries(registeredApi)) {
                if (value.method === 'POST') {
                    api.versions.push({
                        version: version,
                        endpoint: '/apis/' + name + '/' + version,
                        method: value.method,
                        body: value.body,
                    });
                }
                else {
                    api.versions.push({
                        version: version,
                        endpoint: '/apis/' + name + '/' + version,
                        method: value.method,
                    });
                }
            }
            apis.push(api);
        }
        return {
            statusCode: 200,
            data: apis,
        };
    }
    async getApi(params, res) {
        if (this.registeredApis[params.api][params.version]) {
            let data = { test: 'test' };
            return HttpResponse_1.HttpResponse.prototype.json(res, data);
        }
        else {
            return HttpResponse_1.HttpResponse.prototype.error(res, 'bad request');
        }
    }
};
exports.ApisController = ApisController;
__decorate([
    (0, common_1.Get)(),
    openapi.ApiResponse({ status: 200, type: require("../../common/apisResponse.dto").ApisResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", apisResponse_dto_1.ApisResponseDTO)
], ApisController.prototype, "listApis", null);
__decorate([
    (0, common_1.Post)(':api/:version'),
    openapi.ApiResponse({ status: 201 }),
    __param(0, (0, common_1.Param)()),
    __param(1, (0, common_1.Response)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ApisController.prototype, "getApi", null);
exports.ApisController = ApisController = __decorate([
    (0, swagger_1.ApiTags)('External APIs'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('apis')
], ApisController);
//# sourceMappingURL=apis.controller.js.map