"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Crypto = void 0;
const App_1 = require("./App");
class Crypto {
    static async encrypt(text, secret) {
        let encrypted = null;
        if (text === null) {
            return encrypted;
        }
        try {
            encrypted = await this.CryptoJS.AES.encrypt(text, secret ? secret : App_1.App.getSecret()).toString();
        }
        catch (e) {
            console.error("Encrypt error: " + e);
        }
        return encrypted;
    }
    static async decrypt(ciphertext, secret) {
        let decrypted = null;
        if (ciphertext === null) {
            return decrypted;
        }
        try {
            const bytes = await this.CryptoJS.AES.decrypt(ciphertext, secret ? secret : App_1.App.getSecret());
            decrypted = bytes.toString(this.CryptoJS.enc.Utf8);
        }
        catch (e) {
            console.error("Decrypt error: " + e);
        }
        return decrypted;
    }
    static hidePasswords(params) {
        for (const key in params) {
            if (typeof params[key] === 'object' && params[key] !== null) {
                params[key] = this.findInObject(params[key]);
            }
            else if (this.passKeys.includes(key)) {
                params[key] = null;
            }
        }
        return params;
    }
    static findInObject(obj) {
        if (Object.keys(obj).length >= 1) {
            for (const key in obj) {
                if (typeof obj[key] === 'object' && obj[key] !== null) {
                    obj[key] = this.findInObject(obj[key]);
                }
                else if (this.passKeys.includes(key)) {
                    obj[key] = null;
                }
            }
        }
        return obj;
    }
}
exports.Crypto = Crypto;
Crypto.passKeys = ['password', 'Password', 'token', 'Token', 'secret', 'apiPassword', 'apiToken', 'snmpPrivPassword', 'snmpAuthPassword', 'sshPassword', 'cliPassword', 'ftpPassword', 'aws_secret_access_key'];
Crypto.CryptoJS = require('crypto-js');
//# sourceMappingURL=Crypto.js.map