import { MicroserviceJobDTO } from '@xormon/common/microserviceJob.dto';
import { SaveTargetDestination } from '@xormon/common/targetDestination.dto';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { HostcfgRelation } from '@xormon/entity/hostcfgRelation.entity';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { MailGroup } from '@xormon/entity/mailGroup.entity';
import { MicroserviceJobStatus } from '@xormon/entity/microserviceJobsStatus.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { AgentMapping } from '@xormon/entity/agentMapping.entity';
import { StorageMapping } from '@xormon/entity/storageMapping.entity';
import { TargetDestination } from '@xormon/entity/targetDestination.entity';
import { TargetDestinationHostcfg } from '@xormon/entity/targetDestinationHostcfg.entity';
import { IHwType, ISubsystem } from '@xormon/service/architecture/Architecture';
import { Repository } from 'typeorm';
import { StorageGroupDevice } from '@xormon/entity/storageGroupDevice.entity';
import { Heatmap } from '@xormon/entity/heatmap.entity';
import { Top } from '@xormon/entity/top.entity';
import { AgentStatus } from '@xormon/common/osAgent.dto';
import { Request } from 'express';
export declare class ConfigurationService {
    private itemPropertiesRepository;
    private hostCfgRepository;
    private hostCfgRelationsRepository;
    private microservicesJobsStatusRepository;
    private objectItemsRepository;
    private itemRelationsRepository;
    private agentMappingRepository;
    private storageMappingRepository;
    private targetDestinationRepository;
    private targetDestinationHostcfgRepository;
    private storageGroupRepository;
    private topRepository;
    private heatmapRepository;
    private mailGroupsRepository;
    constructor(itemPropertiesRepository: Repository<ItemProperty>, hostCfgRepository: Repository<HostCfg>, hostCfgRelationsRepository: Repository<HostcfgRelation>, microservicesJobsStatusRepository: Repository<MicroserviceJobStatus>, objectItemsRepository: Repository<ObjectItem>, itemRelationsRepository: Repository<ItemRelation>, agentMappingRepository: Repository<AgentMapping>, storageMappingRepository: Repository<StorageMapping>, targetDestinationRepository: Repository<TargetDestination>, targetDestinationHostcfgRepository: Repository<TargetDestinationHostcfg>, storageGroupRepository: Repository<StorageGroupDevice>, topRepository: Repository<Top>, heatmapRepository: Repository<Heatmap>, mailGroupsRepository: Repository<MailGroup>);
    saveItemProperties(items: ItemProperty[]): Promise<number>;
    saveMicroservicesJobStatus(items: MicroserviceJobDTO): Promise<number>;
    getMicroservicesJobStatus(microservice: string, job: string, identification: string, pid: number): Promise<MicroserviceJobStatus>;
    getMicroservicesJobsStatus(microservice?: string): Promise<MicroserviceJobStatus[]>;
    getMicroserviceJobStatus(ms: string, job: string, identification: string, pid: number): Promise<MicroserviceJobStatus[]>;
    saveMicroserviceJobStatus(data: MicroserviceJobStatus): Promise<boolean>;
    getItemProperties(uuid: string, property_name: string): Promise<ItemProperty[]>;
    getItemsProperties(uuids: string[], properties: string[]): Promise<ItemProperty[]>;
    getPropertiesKey(uuid: string[]): Promise<string[]>;
    checkObjectItemsByHWType(hw_type?: string): Promise<ObjectItem>;
    saveArchitecture(objectItems: ObjectItem[]): Promise<number>;
    saveAgentMapping(agentMapping: AgentMapping[]): Promise<number>;
    saveStorageMapping(storageMapping: StorageMapping[]): Promise<number>;
    saveArchitectureAgent(objectItems: ObjectItem[]): Promise<number>;
    saveItemRelations(itemRelations: ItemRelation[]): Promise<number>;
    getClasses(active?: boolean): Promise<import("@xormon/service/architecture/Architecture").IClass[]>;
    getHwTypes(active?: boolean): Promise<IHwType[]>;
    getSubsystems(hw_type?: string): Promise<ISubsystem[]>;
    getHwType(hw_type: string): Promise<IHwType>;
    getItemIds(): Promise<string[]>;
    getTargetDestinations(): Promise<TargetDestination[]>;
    joinDestinationDevices(destination: SaveTargetDestination | string): Promise<string>;
    getTargetDestination(target_destination_id: string): Promise<TargetDestination>;
    saveTargetDestination(destination: SaveTargetDestination): Promise<TargetDestination>;
    updateTargetDestination(target_destination_id: string, destination: SaveTargetDestination): Promise<TargetDestination>;
    deleteTargetDestination(target_destination_id: string): Promise<boolean>;
    getOSAgentStatus(request: Request): Promise<AgentStatus[]>;
}
