"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MailGroupService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const mailGroup_entity_1 = require("../../entity/mailGroup.entity");
const typeorm_2 = require("typeorm");
let MailGroupService = class MailGroupService {
    constructor(mailGroupsRepository) {
        this.mailGroupsRepository = mailGroupsRepository;
    }
    async getMailGroups(userId) {
        return this.mailGroupsRepository.find({
            where: userId ? {
                user_id: userId
            } : undefined,
            order: { label: 'ASC' }
        });
    }
    async saveMailGroup(mail, userId) {
        return this.mailGroupsRepository.save({ ...mail, user_id: userId ? userId : null });
    }
    async deleteMailGroup(mail_group_id) {
        const deleted = await this.mailGroupsRepository.delete({ mail_group_id: mail_group_id });
        return deleted.affected === 1 ? true : false;
    }
    async updateMailGroup(mail_group_id, mail) {
        const update = await this.mailGroupsRepository
            .createQueryBuilder()
            .update(mailGroup_entity_1.MailGroup)
            .set({ label: mail.label, mails: mail.mails })
            .where('mail_group_id = :id', { id: mail_group_id })
            .execute();
        return update.affected === 1 ? true : false;
    }
    async checkMailGroupOwner(mail_group_id, user_id) {
        return this.mailGroupsRepository.findOneBy({ mail_group_id: mail_group_id, user_id: user_id }) !== null;
    }
};
exports.MailGroupService = MailGroupService;
exports.MailGroupService = MailGroupService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mailGroup_entity_1.MailGroup)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], MailGroupService);
//# sourceMappingURL=mailgroup.service.js.map