import { MicroserviceVariableDTO } from "@xormon/common/microserviceVariables.dto";
import { MicroserviceVariables } from "@xormon/entity/microserviceVariables.entity";
import { Repository } from "typeorm";
export declare class MicroserviceVariablesService {
    private microserviceVariablesRepository;
    constructor(microserviceVariablesRepository: Repository<MicroserviceVariables>);
    getByTypeOrConfig(hw_type?: string, hostcfg_id?: string): Promise<MicroserviceVariables[]>;
    createMicroserviceVariable(microserviceVariableDTO: MicroserviceVariableDTO): Promise<MicroserviceVariables>;
    private findByKey;
    findById(microservice_variables_id: string): Promise<MicroserviceVariables>;
    private getWhereOptions;
    private getWhereOptionsUpdate;
    checkIfKeyExistsForTypeOrConf(microserviceVariableDTO: MicroserviceVariableDTO): Promise<boolean>;
    canUpdateMicroserviceVariable(microserviceVariableDTO: MicroserviceVariableDTO, microservice_variables_id: string): Promise<boolean>;
    updateMicroserviceVariable(microservice_variables_id: string, microserviceVariableDTO: MicroserviceVariableDTO): Promise<MicroserviceVariables>;
    deleteById(ids: string[]): Promise<boolean>;
    getByIds(ids: string[]): Promise<MicroserviceVariables[]>;
    auditLog(): (variable: MicroserviceVariableDTO) => Promise<string>;
}
