import { Item } from "@xormon/common/architecture.dto";
import { ExportCapacityRequestDTO, ExportConfigurationRequestDTO, ExportFormat, ExportMappingRequestDTO, ExportTimeseriesRequestDTO, ExportValuesRequestDTO, MailFrequency } from "@xormon/common/exporter.dto";
import { IMetricItem } from "../metrics/MetricsWrapper";
import { Request, Response } from 'express';
export interface ExporterTimeseriesData {
    items: Item[];
    metricsItems: IMetricItem;
}
export interface ExporterConfigurationData {
    items: Item[];
    headers: string[];
    configurationItems: IConfigurationItem;
}
export interface StartEnd {
    start: number;
    end: number;
}
export interface IConfigurationItem {
    [item_id: string]: {
        [property_name: string]: string;
    };
}
export declare class Exporter {
    private static LIMIT_1M;
    private static LIMIT_5M;
    private static LIMIT_1H;
    private static LIMIT_6H;
    private static LIMIT_1D;
    private static loadItems;
    private static addRootParent;
    private static applyFilter;
    static mapping(exportRequest: ExportMappingRequestDTO, request: Request, format: ExportFormat, res: Response): Promise<string | {
        item_id: string;
        label: string;
        device: string;
        volumes: string[];
    }[]>;
    static timeseries(exportRequest: ExportTimeseriesRequestDTO, request?: Request): Promise<ExporterTimeseriesData>;
    static configuration(exportRequest: ExportConfigurationRequestDTO, request: Request, format: ExportFormat, res: Response): Promise<string | any[]>;
    static capacity(exportRequest: ExportCapacityRequestDTO, request: Request, format: ExportFormat, res: Response): Promise<string | any[]>;
    static valuesToCsv(exportRequest: ExportValuesRequestDTO, request?: Request): Promise<string>;
    static isValid(request: ExportTimeseriesRequestDTO): boolean;
    static getTimeseriesInterval(data: ExportTimeseriesRequestDTO, freq: MailFrequency): StartEnd;
}
