import { OnModuleInit } from '@nestjs/common';
import { StatusHostCfgBase, StatusHostCfgExtended } from '@xormon/common/healthStatus.dto';
import { HealthStatus, Status } from '@xormon/entity/healthStatus.entity';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { HostcfgRelation } from '@xormon/entity/hostcfgRelation.entity';
import { HwType } from '@xormon/entity/hwType.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Repository } from 'typeorm';
import { PM2Message } from '../configuration/PM2';
import { EventEmitter2 } from '@nestjs/event-emitter';
export declare class HealthStatusService implements OnModuleInit {
    private objectItemsRepository;
    private hostCfgRepository;
    private hostCfgRelationsRepository;
    private hwTypesRepository;
    private healthStatusRepository;
    private eventEmitter;
    static LAST_DATA_UPDATE_LIMIT: number;
    private LAST_DATA_UPDATE_LIMIT;
    constructor(objectItemsRepository: Repository<ObjectItem>, hostCfgRepository: Repository<HostCfg>, hostCfgRelationsRepository: Repository<HostcfgRelation>, hwTypesRepository: Repository<HwType>, healthStatusRepository: Repository<HealthStatus>, eventEmitter: EventEmitter2);
    onModuleInit(): void;
    reloadHealthStatus(data: PM2Message): void;
    getHostCfg(uuid: string): Promise<HostCfg>;
    getHostsCfg(ignored: boolean, blacklist?: string[]): Promise<HostCfg[]>;
    getHostCfgStatus(includeIgnored: boolean, specificIds?: string[], blacklist?: string[]): Promise<HostCfg[]>;
    getHostCfgByHWType(hw_type?: string): Promise<HostCfg[]>;
    getHealthStatuses(): Promise<HealthStatus[]>;
    getHealthStatus(item_id: string[], status: Status): Promise<HealthStatus[]>;
    getHostcfgRelations(hostcfg_id: string): Promise<HostcfgRelation[]>;
    getHostcfgRelationsAll(): Promise<HostcfgRelation[]>;
    getItem(item_id: string): Promise<ObjectItem>;
    getItemsByHwType(hw_type: string): Promise<ObjectItem[]>;
    saveHealthStatus(healthStatus: HealthStatus[]): Promise<number>;
    getHwTypes(active?: boolean): Promise<HwType[]>;
    getHwType(hw_type: string): Promise<HwType>;
    getDeviceHS(hostcfgs: HostCfg[], byStatus: Status, groupIds?: any): Promise<StatusHostCfgExtended[]>;
    getStatus(hostcfg_entity: HostCfg, type: string): StatusHostCfgBase;
    setStatusBySeverity(currentStatus: string, status: string): string;
    getStatusPriority(status: any): any;
    getArrayFromResponse(response: any, elmntType: any): any[];
}
