"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImportController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const import_dto_1 = require("../../common/import.dto");
const import_1 = require("./import");
const xormon_exception_1 = require("../../exception/xormon.exception");
const metricsTable_service_1 = require("../metrics/metricsTable.service");
const Audit_1 = require("../configuration/Audit");
const auditEvent_entity_1 = require("../../entity/auditEvent.entity");
let ImportController = class ImportController {
    constructor(metricsTableService) {
        this.metricsTableService = metricsTableService;
    }
    async importDevices(request, lparStorAuth) {
        const { lparAuth, storAuth } = lparStorAuth;
        const deviceImporter = new import_1.DeviceImporter();
        try {
            await deviceImporter.init(this.metricsTableService);
            const importResult = await deviceImporter.startFromREST(lparAuth, storAuth);
            Audit_1.Audit.log(request, auditEvent_entity_1.auditEventId.IMPORTED_DEVICES, "Imported " + importResult.insertedDevices.length + " devices.");
            return {
                message: "Successfuly imported devices",
                statusCode: common_1.HttpStatus.OK,
                data: importResult
            };
        }
        catch (error) {
            if (error.response) {
                throw new xormon_exception_1.XormonException(error.response.error, error.response.statusCode);
            }
            else {
                throw new xormon_exception_1.XormonException(error, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
            }
        }
    }
};
exports.ImportController = ImportController;
__decorate([
    (0, common_1.Post)("v1/import"),
    openapi.ApiResponse({ status: 201, type: require("../../common/import.dto").ImportResultRespnse }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, import_dto_1.LparStorImportAuth]),
    __metadata("design:returntype", Promise)
], ImportController.prototype, "importDevices", null);
exports.ImportController = ImportController = __decorate([
    (0, swagger_1.ApiTags)('Import'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/import'),
    __metadata("design:paramtypes", [metricsTable_service_1.MetricsTableService])
], ImportController);
//# sourceMappingURL=import.controller.js.map