"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MappingService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const itemProperty_entity_1 = require("../../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const config = {
    powerSerialPropertyName: 'SerialNumber',
    vmwareOsUuidPropertyName: 'os_uuid',
};
let MappingService = class MappingService {
    constructor(objectItemsRepository, itemPropertiesRepository, itemRelationsRepository) {
        this.objectItemsRepository = objectItemsRepository;
        this.itemPropertiesRepository = itemPropertiesRepository;
        this.itemRelationsRepository = itemRelationsRepository;
    }
    async findVm(id, label) {
        const vm = await this.objectItemsRepository.findOne({
            where: [
                { item_id: id.toLowerCase() },
                { item_id: id.toUpperCase() }
            ]
        });
        if (vm) {
            return vm;
        }
        else {
            return null;
        }
    }
    async findVmwareVmByOsUuid(id) {
        const vm = await this.itemPropertiesRepository.findOneBy({ property_name: config.vmwareOsUuidPropertyName, property_value: id.toUpperCase() });
        return vm ? vm.item_id : null;
    }
    async findVmwareVm(id, label) {
        const vmId = await this.findVmwareVmByOsUuid(id);
        if (!vmId) {
            return null;
        }
        const vm = await this.objectItemsRepository.findOneBy({ item_id: vmId });
        if (vm) {
            return vm;
        }
        else {
            return null;
        }
    }
    async findPowerServerBySerial(serial) {
        const server = await this.itemPropertiesRepository.findOneBy({ property_name: config.powerSerialPropertyName, property_value: serial });
        return server ? server.item_id : null;
    }
    async findPowerVm(serverSerial, vmLabel) {
        const vms = await this.objectItemsRepository.findBy({ hw_type: 'power', subsystem: 'vm', label: vmLabel });
        if (vms.length === 0) {
            return null;
        }
        else if (vms.length === 1) {
            return vms[0];
        }
        const serverId = await this.findPowerServerBySerial(serverSerial);
        if (!serverId) {
            return null;
        }
        const children = await this.itemRelationsRepository.findBy({
            parent: serverId,
            child: (0, typeorm_2.In)(vms.map((vm) => {
                return vm.item_id;
            })),
        });
        if (children.length === 1) {
            return vms.find((vm) => vm.item_id === children[0].child);
        }
        else {
            return null;
        }
    }
};
exports.MappingService = MappingService;
exports.MappingService = MappingService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __param(1, (0, typeorm_1.InjectRepository)(itemProperty_entity_1.ItemProperty)),
    __param(2, (0, typeorm_1.InjectRepository)(itemRelation_entity_1.ItemRelation)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], MappingService);
//# sourceMappingURL=mapping.service.js.map