import { MenuResponseDTO } from '@xormon/common/menuResponse.dto';
import { CustomTopRequest, CustomTopResponseDTO, OverviewRequest, OverviewResponseDTO, PageResponseDTO, TabResponseDTO, TopologyRequest } from '@xormon/common/pageResponse.dto';
import { StorageGroupService } from '@xormon/service/storage_group/storage_group.service';
import { MenuService } from './menu.service';
import { Request } from 'express';
import { ServerGroupService } from '../server_group/serverGroup.service';
import { GroupStorageGroupsResponseDTO } from '@xormon/common/storageGroups.dto';
export declare class MenuController {
    private readonly menuService;
    private readonly storageGroupService;
    private readonly serverGroupService;
    constructor(menuService: MenuService, storageGroupService: StorageGroupService, serverGroupService: ServerGroupService);
    getPage(request: Request, hw_type: string, type: string, item_id?: string): Promise<PageResponseDTO>;
    getTab(request: Request, hw_type: string, type: string, tab: string, item_id?: string): Promise<TabResponseDTO>;
    getRoot(request: Request, technology_class?: string): Promise<MenuResponseDTO>;
    getHwType(request: Request, hw_type: string): Promise<MenuResponseDTO>;
    getStorageGroups(request: Request): Promise<MenuResponseDTO>;
    getGroupStorageGroups(request: Request): Promise<GroupStorageGroupsResponseDTO>;
    getStorageGroup(request: Request, storage_group_id: string): Promise<MenuResponseDTO>;
    getServerGroups(request: Request): Promise<MenuResponseDTO>;
    getStorages(request: Request): Promise<MenuResponseDTO>;
    getSubsystem(request: Request, hw_type: string, subsystemOrFolderType: string, itemIds?: string): Promise<MenuResponseDTO>;
    getPath(request: Request, hw_type: string, type: string, item_id?: string, sgroup_id?: string): Promise<MenuResponseDTO>;
    getPathSgroup(request: Request, hw_type: string, type: string, item_id?: string, sgroup_id?: string): Promise<MenuResponseDTO>;
    getOverviewData(request: OverviewRequest, req: Request): Promise<OverviewResponseDTO>;
    getCustomTopData(req: Request, request: CustomTopRequest): Promise<CustomTopResponseDTO>;
    getTopologyData(request: Request, topologyRequest: TopologyRequest): Promise<OverviewResponseDTO>;
}
