import { MenuFolder, Newable } from "@xormon/common/menuResponse.dto";
import { ChartType, MetricAggregate, Page, Tab } from "@xormon/common/pageResponse.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
import { TabFactory } from "./TabFactory";
export declare class AzureFolder extends AbstractFolder {
    hwType: string;
}
export declare class AzurePage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare class AzureSubsystemFolder extends AzureFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare abstract class AzureSingleItemPage extends AzurePage {
    subsystem: string;
}
export declare class AzureRootFolder extends AzureFolder {
    _get(): Promise<MenuFolder[]>;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<MenuFolder[]>;
}
export declare class AzureConfigurationPage extends AzurePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class AzureMgroupFolder extends AzureSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class AzureSubscriptionFolder extends AzureSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class AzureRgroupFolder extends AzureSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class AzureVmFolder extends AzureSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class AzureAccountFolder extends AzureSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class AzureMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            getAggrGraph(type: ChartType, stacked?: boolean, order?: number, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class AzureVmPage extends AzureSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class AzureAccountfolderFolder extends AzureSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class AbstractAzureAccountPage extends AzureSingleItemPage {
    subsystem: string;
    subPart: string;
    item: ObjectItem;
    withItemId: boolean;
    protected tabFactory: TabFactory;
    getTabs(): Promise<Tab<import("@xormon/common/pageResponse.dto").Box>[]>;
}
export declare class AzureAccountPage extends AbstractAzureAccountPage {
    subPart: string;
    getPage(): Promise<Page>;
}
export declare class AzureBlobPage extends AbstractAzureAccountPage {
    subPart: string;
    getPage(): Promise<Page>;
}
export declare class AzureFilePage extends AbstractAzureAccountPage {
    subPart: string;
    getPage(): Promise<Page>;
}
export declare class AzureQueuePage extends AbstractAzureAccountPage {
    subPart: string;
    getPage(): Promise<Page>;
}
export declare class AzureTablePage extends AbstractAzureAccountPage {
    subPart: string;
    getPage(): Promise<Page>;
}
export declare class AzureVmtotalsPage extends AzureSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class AzureVmmgrouptotalsPage extends AzureSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AzureVmsubscriptiontotalsPage extends AzureSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AzureVmrgrouptotalsPage extends AzureSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class AzureStatusesPage extends AzurePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class AzureHeatmapPage extends AzurePage {
    title: string;
    getPage(): Promise<Page>;
}
