import { CapacityTableBox, CapacityTableColumn, CapacityTableHeader } from "@xormon/common/pageResponse.dto";
export declare class GenerateRow {
    order: number;
    value?: number | string;
    url?: string;
    metric?: string;
    itemId?: string;
}
export declare class CapacityTable {
    private header;
    private rows;
    private generatedRows;
    private lastIndex;
    private itemIds;
    private metrics;
    private summaryRow;
    constructor();
    addHeader(header: Partial<CapacityTableHeader>): this;
    addHeaders(headers: Partial<CapacityTableHeader>[]): this;
    addRow(columns: CapacityTableColumn[]): this;
    addRows(rows: CapacityTableColumn[][]): this;
    addGenerateRows(columns: GenerateRow[]): this;
    addSummaryRow(row: CapacityTableColumn[]): void;
    generateRows(): Promise<this>;
    sortByIndex(i: number, rev?: boolean, isString?: boolean): void;
    generateBox(): CapacityTableBox;
    static createSimpleCapacityTable(itemIds: string[], metrics: string[], hwType: string, subsystem: string): Promise<CapacityTableBox>;
}
