import { CapacityTableBox, HtmlTextBox, PredictionGraphBox, TextBox } from "@xormon/common/pageResponse.dto";
import { Request } from 'express';
import { User as UserEntity } from "@xormon/entity/user.entity";
import { StorageGroup } from "@xormon/entity/storageGroup.entity";
interface CustomCapTableHeader {
    label: string;
    valuesByItemId: {
        [item_id: string]: string | number;
    };
}
type UsedMetrics = {
    used: string;
    total: string;
};
export declare class CapacityTableBuilder {
    #private;
    constructor(subsystem: string, request: Request);
    addMetric(metric: string, label?: string, thermometer?: boolean): this;
    addDefaultMetrics(): this;
    addUsed(metricsToUse?: UsedMetrics): this;
    addPrediction(withoutPerPool?: boolean, metric?: string, maxMetric?: string): this;
    addUrl(): this;
    addItems(itemIds: string[]): this;
    setItemLabel(label: string): this;
    setUser(user: UserEntity): this;
    addTotal(): this;
    addCustomHeader(header: CustomCapTableHeader): this;
    generateData(): Promise<this>;
    generateBox(): Promise<CapacityTableBox>;
    setStorageGroups(storageGroups: StorageGroup[]): this;
    generateStorageGroupBox(): Promise<CapacityTableBox>;
    generateContentWithPredictions(): Promise<(CapacityTableBox | TextBox | HtmlTextBox | PredictionGraphBox)[]>;
    private addPredictionMetrics;
    private generateTable;
}
export {};
