import { Status } from "@dto/healthStatus.dto";
import { Status as StatusEntity } from '@xormon/entity/healthStatus.entity';
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { HwTypeKey } from '@xormon/common/constants/hwTypeKey.constants';
import { ClassKey } from '@xormon/common/constants/class.constants';
import { URL } from './URL';
import { Request } from "express";
import { MirrorBox, Page, TableBox } from "@xormon/common/pageResponse.dto";
import { User as UserEntity } from "@xormon/entity/user.entity";
type DeviceStatusBody = {
    id: string;
    health: Status;
    connection: Status;
    data: Status;
    healthUpdatedAt?: Date;
    connectionUpdatedAt?: Date;
    dataUpdatedAt?: Date;
    name: string;
    class: string;
    hwTypeLabel: string;
    hwType: string;
    reason?: string;
    parent: string;
    url?: URL;
    link: string;
};
export declare class HealthStatus {
    private objectItemsRepository;
    private hostcfgRepository;
    private healthstatusRepository;
    static LAST_DATA_UPDATE_LIMIT: number;
    private LAST_DATA_UPDATE_LIMIT;
    private request;
    protected deviceAliasColumn: boolean;
    protected linkToItem: boolean;
    protected clickableAlias: boolean;
    getStorageGlobal(): Promise<TableBox>;
    getStatusByIds(deviceIds: string[], itemColumnLabel?: string): Promise<TableBox>;
    getStatusByParameters(subsystem: string, _class: string, itemName: string, hw_type?: string): Promise<TableBox>;
    hsQueryFrame(whereClause: any): Promise<ObjectItem[]>;
    generateBasicTable(devices: ObjectItem[], itemName: string, user?: UserEntity, path?: string): Promise<TableBox>;
    getDeviceSubsystems(device_id: string, subsystems?: string[]): Promise<TableBox>;
    getHistory(_class: ClassKey, subsystem: string, hwType?: HwTypeKey, itemLabel?: string): Promise<TableBox>;
    getMirrors(): MirrorBox;
    getGlobalStatus(_class?: string, _hwType?: string, statusSubsystems?: string[]): Promise<DeviceStatusBody[]>;
    getGlobalStatusTable(type: 'all' | 'Health' | 'Connection' | 'Data', deviceStatuses: DeviceStatusBody[]): TableBox;
    getCustomStatusTable(_class: string, _hwType: string, _subsystem: string): Promise<TableBox>;
    getGlobalStatusPage(): Promise<Page>;
    isLastUpdateOld(timestamp: any): boolean | 1;
    transformEntityStatus(status: StatusEntity): Status;
    static getScoreForSorting(): {
        undefined: number;
        ignored: number;
        unknown: number;
        ok: number;
        warning: number;
        error: number;
    };
    setAcl(request: Request): this;
    useDeviceAliasColumn(deviceAliasColumn: boolean): this;
    useLinkToItem(linkToItem: boolean): this;
    useClickableAlias(clickableAlias: boolean): this;
}
export {};
