"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KubernetesMetrics = exports.KubernetesPodoverviewPage = exports.KubernetesTopPage = exports.KubernetesHeatmapPage = exports.KubernetesContainerPage = exports.KubernetesPodPage = exports.KubernetesNamespacePage = exports.KubernetesNodePage = exports.KubernetesClusterpodsaggregatedPage = exports.KubernetesClusternamespacetotalsPage = exports.KubernetesClusternodetotalsPage = exports.KubernetesConfigurationPage = exports.KubernetesItemPage = exports.KubernetesPage = exports.KubernetesPodFolder = exports.KubernetesNamespaceFolder = exports.KubernetesNamespacesFolder = exports.KubernetesNodeFolder = exports.KubernetesClusterFolder = exports.KubernetesRootFolder = exports.KubernetesSubsystemFolder = exports.KubernetesFolder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Heatmap_1 = require("./Heatmap");
const Top_1 = require("./Top");
const ConfigurationTable_1 = require("./ConfigurationTable");
const Table_1 = require("./Table");
const URL_1 = require("./URL");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const ACLCheck_1 = require("../../acl/ACLCheck");
const Color_1 = require("../../metrics/Color");
const AbstractMenu_1 = require("./AbstractMenu");
class KubernetesFolder extends AbstractMenu_1.AbstractFolder {
    constructor() {
        super(...arguments);
        this.hwType = 'kubernetes';
    }
}
exports.KubernetesFolder = KubernetesFolder;
class KubernetesSubsystemFolder extends KubernetesFolder {
    constructor(itemId) {
        super();
        if (itemId !== null) {
            this.itemId = itemId;
        }
    }
}
exports.KubernetesSubsystemFolder = KubernetesSubsystemFolder;
class KubernetesRootFolder extends KubernetesFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', this.hwType + '/heatmap', 'heatmap'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration', 'configuration'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Pods TOP', this.hwType + '/top', 'top'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Pods Overview', this.hwType + '/pod-overview', 'pod-overview'));
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, KubernetesClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, KubernetesClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesRootFolder = KubernetesRootFolder;
class KubernetesClusterFolder extends KubernetesSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'cluster';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Node Totals', this.hwType + '/' + this.subsystem + '-node-totals' + '?item_id=' + this.itemId, 'node-totals', undefined, true));
        menuItems.push(new menuResponse_dto_1.MenuLink('Namespace Totals', this.hwType + '/' + this.subsystem + '-namespace-totals' + '?item_id=' + this.itemId, 'namespace-totals'));
        const checkPod = await this.objectItemsRepository.findOne({
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'pod',
                hw_type: 'kubernetes'
            }, relations: {
                parents: true
            }
        });
        if (checkPod) {
            menuItems.push(new menuResponse_dto_1.MenuLink('Pods Aggregated', this.hwType + '/' + this.subsystem + '-pods-aggregated' + '?item_id=' + this.itemId, 'pods-aggregated'));
        }
        const subsystems = [{
                subsystem: "Node",
                folder: KubernetesNodeFolder,
            }, {
                subsystem: "Namespace",
                folder: KubernetesNamespacesFolder,
            }];
        for (let childSubsystem of subsystems) {
            let childSubsystemItem = await this.objectItemsRepository.findOneBy({
                hw_type: this.hwType,
                subsystem: childSubsystem.subsystem.toLowerCase(),
            });
            if (childSubsystemItem) {
                let childSubsystemPath = childSubsystem.subsystem === 'Namespace' ? "Namespaces" : childSubsystem.subsystem;
                let path = this.hwType + '/' + childSubsystemPath.toLowerCase() + (this.itemId !== null ? '?ids=' + this.itemId : '');
                menuItems.push(new menuResponse_dto_1.MenuFolder(childSubsystem.subsystem, path, this.hwType, childSubsystemPath.toLowerCase(), this.itemId, childSubsystem.folder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let namespaces = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: 'namespace',
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (const namespace of namespaces) {
            let path = this.hwType + '/namespace?item_id=' + namespace.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(namespace.label, path, 'namespace', namespace.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesClusterFolder = KubernetesClusterFolder;
class KubernetesNodeFolder extends KubernetesSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
    }
    async getChildren() {
        let menuItems = [];
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (const node of nodes) {
            let path = this.hwType + '/' + this.subsystem + '?item_id=' + node.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(node.label, path, this.subsystem, node.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesNodeFolder = KubernetesNodeFolder;
class KubernetesNamespacesFolder extends KubernetesSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'namespace';
    }
    async getChildren() {
        let menuItems = [];
        const onlyNamespaces = false;
        let namespaces = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        for (const namespace of namespaces) {
            if (onlyNamespaces) {
                let path = this.hwType + '/' + this.subsystem + '?item_id=' + namespace.item_id;
                menuItems.push(new menuResponse_dto_1.MenuLink(namespace.label, path, this.subsystem, namespace.item_id));
            }
            else {
                let path = this.hwType + '/' + this.subsystem + '?ids=' + namespace.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(namespace.label, path, this.hwType, this.subsystem, namespace.item_id, KubernetesNamespaceFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesNamespacesFolder = KubernetesNamespacesFolder;
class KubernetesNamespaceFolder extends KubernetesSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
    }
    async getChildren() {
        let menuItems = [];
        const onlyPods = false;
        let pods = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        let path = this.hwType + '/namespace?item_id=' + this.itemId.toString();
        menuItems.push(new menuResponse_dto_1.MenuLink("Totals", path, this.subsystem, this.itemId.toString(), true));
        for (const pod of pods) {
            if (onlyPods) {
                let path = this.hwType + '/' + this.subsystem + '?item_id=' + pod.item_id;
                menuItems.push(new menuResponse_dto_1.MenuLink(pod.label, path, this.subsystem, this.itemId));
            }
            else {
                let path = this.hwType + '/' + this.subsystem + '?ids=' + pod.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(pod.label, path, this.hwType, this.subsystem, pod.item_id, KubernetesPodFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesNamespaceFolder = KubernetesNamespaceFolder;
class KubernetesPodFolder extends KubernetesSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'container';
    }
    async getChildren() {
        let menuItems = [];
        let containers = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId.toString()
                }
            },
            relations: {
                parents: true
            }
        });
        let path = this.hwType + '/pod?item_id=' + this.itemId.toString();
        menuItems.push(new menuResponse_dto_1.MenuLink('Totals', path, 'pod', this.itemId.toString(), true));
        for (const container of containers) {
            let path = this.hwType + '/' + this.subsystem + '?item_id=' + container.item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink(container.label, path, this.subsystem, container.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.KubernetesPodFolder = KubernetesPodFolder;
class KubernetesPage extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.hwType = 'kubernetes';
        this.rootFolder = KubernetesRootFolder;
    }
}
exports.KubernetesPage = KubernetesPage;
class KubernetesItemPage extends KubernetesPage {
    constructor(itemId, request) {
        super(itemId, request);
        this.itemId = itemId;
        this.request = request;
    }
}
exports.KubernetesItemPage = KubernetesItemPage;
class KubernetesConfigurationPage extends KubernetesPage {
    constructor() {
        super(...arguments);
        this.title = 'Configuration';
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: 'kubernetes',
                subsystem: 'node'
            }
        });
        const configurationNodeTable = new ConfigurationTable_1.ConfigurationTable(nodes.map(node => node.item_id), ['kubeletVersion', 'containerRuntimeVersion', 'architecture', 'osImage'], ['cluster']);
        configurationNodeTable.setItemLabel("Node");
        configurationNodeTable.sortByColumn(0, 'desc');
        configurationNodeTable.setAcl(this.request);
        tabs.push({
            title: 'Node',
            content: [await configurationNodeTable.generate()],
        });
        let pods = await this.objectItemsRepository.find({
            where: {
                hw_type: 'kubernetes',
                subsystem: 'pod'
            }
        });
        const configurationPodTable = new ConfigurationTable_1.ConfigurationTable(pods.map(pod => pod.item_id), ['status', 'podIP'], ['cluster', 'namespace']);
        configurationPodTable.setItemLabel("Pod");
        configurationNodeTable.sortByColumn(0, 'desc');
        configurationPodTable.setAcl(this.request);
        tabs.push({
            title: 'Pod',
            content: [await configurationPodTable.generate()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesConfigurationPage = KubernetesConfigurationPage;
class KubernetesClusternodetotalsPage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
        this.withItemId = true;
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Node Totals';
        let tabs = [];
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'cpu_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'memory_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Pods',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'pods').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('node', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('node', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_read_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1),
                        new KubernetesMetrics.Metric('node', 'container_fs_write_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('node', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        tabs.push({
            title: 'Containers Size',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_usage_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true),
                    ],
                    aggregated: true,
                    uuids: itemIds,
                    label: 'Node'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesClusternodetotalsPage = KubernetesClusternodetotalsPage;
class KubernetesClusternamespacetotalsPage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'namespace';
        this.withItemId = true;
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Namespace Totals';
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('namespace', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('namespace', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('namespace', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    label: 'Namespace'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesClusternamespacetotalsPage = KubernetesClusternamespacetotalsPage;
class KubernetesClusterpodsaggregatedPage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
        this.withItemId = true;
    }
    async getPage() {
        let items = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: this.subsystem,
                parents: {
                    parent: this.itemId
                }
            }, relations: {
                parents: true
            }
        });
        const itemIds = items.map(item => item.item_id);
        let title = 'Pods Aggregated';
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('pod', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('pod', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                        new KubernetesMetrics.Metric('pod', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                    ],
                    uuids: itemIds,
                    aggregated: true,
                    parent: {
                        label: 'Namespace',
                        subsystem: 'namespace'
                    },
                    label: 'Pod'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesClusterpodsaggregatedPage = KubernetesClusterpodsaggregatedPage;
class KubernetesNodePage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'node';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Node ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'cpu_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('node', 'cpu_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'memory_usage').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('node', 'memory_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Pods',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'pods').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('node', 'pods_capacity').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('node', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('node', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_read_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('node', 'container_fs_write_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('node', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Size',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('node', 'container_fs_usage_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesNodePage = KubernetesNodePage;
class KubernetesNamespacePage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'namespace';
        this.withItemId = true;
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Namespace ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const pods = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                subsystem: 'pod',
                parents: {
                    parent: this.itemId
                }
            }
        });
        tabs.push({
            title: 'Pods CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Pods Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Pods Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                    ],
                    uuids: pods.map(pod => pod.item_id),
                    aggregated: true,
                    label: 'Pod'
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('namespace', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('namespace', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('namespace', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('namespace', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const containers = await this.objectItemsRepository.find({
            where: {
                subsystem: 'container',
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                parents: true
            }
        });
        if (containers.length >= 1) {
            tabs.push({
                title: 'Containers IO Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new KubernetesMetrics.Metric('container', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1, Color_1.Color.metric.read),
                            new KubernetesMetrics.Metric('container', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.metric.write),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
            tabs.push({
                title: 'Containers Data Aggr',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new KubernetesMetrics.Metric('container', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1, Color_1.Color.metric.read),
                            new KubernetesMetrics.Metric('container', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.metric.write),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesNamespacePage = KubernetesNamespacePage;
class KubernetesPodPage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'pod';
        this.withItemId = true;
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Pod ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('pod', 'cpu_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('pod', 'memory_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Processes',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_processes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('pod', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('pod', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'container_network_receive_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('pod', 'container_network_transmit_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        const containers = await this.objectItemsRepository.find({
            where: {
                subsystem: 'container',
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                parents: true
            }
        });
        if (containers.length >= 1) {
            tabs.push({
                title: 'Containers IO Aggr.',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new KubernetesMetrics.Metric('container', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new KubernetesMetrics.Metric('container', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
            tabs.push({
                title: 'Containers Data Aggr.',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new KubernetesMetrics.Metric('container', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, -1),
                            new KubernetesMetrics.Metric('container', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0),
                        ],
                        uuids: containers.map(item => item.item_id),
                        aggregated: true,
                        parent: {
                            label: 'Pod',
                            subsystem: 'pod'
                        },
                        label: 'Container'
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesPodPage = KubernetesPodPage;
class KubernetesContainerPage extends KubernetesItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'container';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Container ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'cpu').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('pod', 'cpu_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('pod', 'memory').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.used),
                        new KubernetesMetrics.Metric('pod', 'memory_limit').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.metric.total)
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('container', 'container_fs_reads').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('container', 'container_fs_writes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('container', 'container_fs_reads_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('container', 'container_fs_writes_bytes').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        tabs.push({
            title: 'Containers Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new KubernetesMetrics.Metric('container', 'container_fs_read_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, -1, Color_1.Color.metric.read),
                        new KubernetesMetrics.Metric('container', 'container_fs_write_latency').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.write),
                    ],
                    uuids: [this.itemId]
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesContainerPage = KubernetesContainerPage;
class KubernetesHeatmapPage extends KubernetesPage {
    constructor() {
        super(...arguments);
        this.title = 'Heatmap';
    }
    async getPage() {
        let title = 'Heatmap';
        let tabs = [];
        tabs.push({
            title: 'Node Heatmap',
            content: Object.values(await new Heatmap_1.Heatmap(this.hwType, "node", true)
                .computedHeatmapBox(class_constants_1.ClassKey.CONTAINER, this.request)),
        });
        let nodeTable = new Table_1.Table()
            .addHeader({ value: 'Node' })
            .addHeader({ value: 'CPU', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true })
            .addHeader({ value: 'Memory', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true });
        let nodes = await this.objectItemsRepository.find({
            where: {
                hw_type: this.hwType,
                subsystem: 'node',
            },
            relations: {
                heatmaps: true,
            }
        });
        if (this.request) {
            const ids = await ACLCheck_1.ACLCheck.filterItemsWithRequest(this.request, nodes.map(item => item.item_id));
            nodes = nodes.filter(item => ids.includes(item.item_id));
        }
        for (const node of nodes) {
            const cpu = node.heatmaps.find(heatmap => heatmap.metric === 'cpu_usage');
            const memory = node.heatmaps.find(heatmap => heatmap.metric === 'memory_usage');
            nodeTable.addRow([
                { order: 1, value: node.label, url: URL_1.URL.generate(this.hwType, 'node', node.item_id) },
                { order: 2, value: cpu ? cpu.value : null },
                { order: 3, value: memory ? memory.value : null }
            ]);
        }
        nodeTable.sortByIndex(1);
        nodeTable.setBoxExport("kubernetes-heatmap");
        tabs.push({
            title: 'Node table',
            content: [nodeTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.KubernetesHeatmapPage = KubernetesHeatmapPage;
class KubernetesTopPage extends KubernetesPage {
    constructor() {
        super(...arguments);
        this.title = 'POD TOP';
    }
    async getPage() {
        const top = new Top_1.Top();
        top.setSubsystem('kubernetes', 'pod');
        top.setParentSubsystem('namespace');
        const tabs = await top.genTabs();
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.KubernetesTopPage = KubernetesTopPage;
class KubernetesPodoverviewPage extends KubernetesPage {
    constructor() {
        super(...arguments);
        this.title = 'POD Overview';
    }
    async getPage() {
        const tabs = [];
        const clusters = await this.objectItemsRepository.findBy({
            hw_type: 'kubernetes',
            subsystem: 'cluster'
        });
        let overview = new Table_1.Table()
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'Running' })
            .addHeader({ value: 'Pending' })
            .addHeader({ value: 'Succeeded' })
            .addHeader({ value: 'Failed' });
        const pods = await this.objectItemsRepository.find({
            relations: {
                properties: true,
                parents: {
                    _parent: true
                }
            },
            where: {
                hw_type: 'kubernetes',
                subsystem: 'pod'
            }
        });
        for (const cluster of clusters) {
            const clusterPods = pods.filter(pod => pod.parents.find(parent => parent.parent === cluster.item_id) !== undefined);
            overview.addRow([
                {
                    order: 0,
                    value: cluster.label
                },
                {
                    order: 1,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Running') !== undefined).length
                },
                {
                    order: 2,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Pending') !== undefined).length
                },
                {
                    order: 3,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Succeeded') !== undefined).length
                },
                {
                    order: 4,
                    value: clusterPods.filter(pod => pod.properties.find(property => property.property_name === 'status' && property.property_value === 'Failed') !== undefined).length
                }
            ]);
        }
        overview.sortByIndex(0, false, true);
        let podTable = new Table_1.Table()
            .addHeader({ value: 'Pod' })
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'Namespace' })
            .addHeader({ value: 'Status' });
        for (const pod of pods) {
            const cluster = pod.parents.find(parent => parent._parent.subsystem === 'cluster');
            const namespace = pod.parents.find(parent => parent._parent.subsystem === 'namespace');
            const status = pod.properties.find(property => property.property_name === 'status');
            podTable.addRow([
                {
                    order: 0,
                    value: pod.label,
                    url: new URL_1.URL().generateFromObject(pod)
                },
                {
                    order: 1,
                    value: cluster ? cluster._parent.label : '',
                    url: cluster ? new URL_1.URL().generateFromObject(cluster._parent) : undefined
                },
                {
                    order: 2,
                    value: namespace ? namespace._parent.label : '',
                    url: namespace ? new URL_1.URL().generateFromObject(namespace._parent) : undefined
                },
                {
                    order: 3,
                    value: status ? status.property_value : ''
                }
            ]);
        }
        podTable.sortByIndex(0, false, true);
        tabs.push({
            title: 'Overview',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                    text: "Overview"
                },
                overview.generateBox(),
                {
                    type: pageResponse_constants_1.BOX_TYPE.TextBox,
                    styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                    text: "All Pods"
                },
                podTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.KubernetesPodoverviewPage = KubernetesPodoverviewPage;
class KubernetesMetrics {
}
exports.KubernetesMetrics = KubernetesMetrics;
KubernetesMetrics.Metric = class extends pageResponse_dto_1.Metric {
    constructor(subsystem, metric) {
        super();
        this.metric = metric;
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.CONTAINER, hwTypeKey_constants_1.HwTypeKey.KUBERNETES, subsystem, metric);
        if (definition) {
            Object.assign(this, definition);
        }
    }
    getGraph(type, stacked, order, color) {
        this.type = type;
        this.stacked = stacked ? stacked : false;
        this.order = order ? order : 0;
        this.color = color ? color : undefined;
        return this;
    }
};
//# sourceMappingURL=Kubernetes.js.map