"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LanGroupFolder = exports.LanGroupconfigurationPage = exports.LanConfigurationPage = exports.LanHealthstatusPage = exports.LanMetrics = exports.LanGroupportchanneltotalPage = exports.LanGroupvlantotalPage = exports.LanGroupcpumemoryPage = exports.LanGrouppacketPage = exports.LanGroupdataPage = exports.LanPortchanneltotalPage = exports.LanVlantotalPage = exports.LanCpumemoryPage = exports.LanPacketPage = exports.LanDataPage = exports.LanGrouptotalsPage = exports.LanHeatmapPage = exports.LanTotalsPage = exports.LanItemPage = exports.LanSingleItemPage = exports.LanAbstractSingleItemPage = exports.LanPage = exports.LanSimplePage = exports.LanSubsystemItemsFolder = exports.LanDeviceFolder = exports.LanRootFolder = exports.LanSubsystemFolder = exports.LanFolder = exports.lanGlobalPages = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const Classes_1 = require("../../metrics/Classes");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const typeorm_1 = require("typeorm");
const HealthStatus_1 = require("./HealthStatus");
const ConfigurationTable_1 = require("./ConfigurationTable");
const AbstractMenu_1 = require("./AbstractMenu");
const TabFactory_1 = require("./TabFactory");
const URL_1 = require("./URL");
const Table_1 = require("./Table");
const serverGroup_entity_1 = require("../../../entity/serverGroup.entity");
const serverGroupItems_entity_1 = require("../../../entity/serverGroupItems.entity");
const User_1 = require("../../users/User");
const Heatmap_1 = require("./Heatmap");
const common_1 = require("@nestjs/common");
const lanGlobalPages = () => {
    let menuItems = [];
    menuItems.push(new menuResponse_dto_1.MenuLink('Data', 'lan/data', 'data', undefined, true));
    menuItems.push(new menuResponse_dto_1.MenuLink('Packet', 'lan/packet', 'packet'));
    menuItems.push(new menuResponse_dto_1.MenuLink('System', 'lan/cpumemory', 'cpu'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', 'lan/heatmap', 'heatmap'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', 'lan/health-status', 'healthstatus'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', 'lan/configuration', 'configuration'));
    menuItems.push(new menuResponse_dto_1.MenuLink('Groups Configuration', 'lan/groupconfiguration', 'configuration'));
    return menuItems;
};
exports.lanGlobalPages = lanGlobalPages;
class LanFolder extends AbstractMenu_1.StorUniversalGroupAbstractFolder {
    constructor() {
        super(...arguments);
        this.serverGroupsRepository = (0, dataSource_1.getDataSource)().getRepository(serverGroup_entity_1.ServerGroup);
        this.serverGroupItemsRepository = (0, dataSource_1.getDataSource)().getRepository(serverGroupItems_entity_1.ServerGroupItems);
    }
}
exports.LanFolder = LanFolder;
class LanSubsystemFolder extends LanFolder {
    constructor(hwType, subsystem, itemId) {
        super(hwType, subsystem, "");
        if (itemId !== null) {
            if (Array.isArray(itemId)) {
                if (itemId.length === 1) {
                    this.itemId = itemId[0];
                }
                else {
                    this.itemIds = itemId;
                }
            }
            else {
                this.itemId = itemId;
            }
        }
        if (subsystem !== null) {
            this.subsystem = subsystem.toString();
        }
    }
}
exports.LanSubsystemFolder = LanSubsystemFolder;
class LanRootFolder extends LanFolder {
    constructor(hw_type, sus, request) {
        super(hw_type, "", null, request);
        this.request = request;
    }
    async getChildren() {
        let menuItems = [];
        const user = this.request && this.request.session ? await User_1.User.getUserByRequest(this.request) : null;
        const sgItems = user
            ? (await this.serverGroupItemsRepository.find({
                where: {
                    _server_group: {
                        user_id: user.user_id,
                        class: "lan",
                    },
                    isPrimary: true
                },
                relations: {
                    _server_group: true,
                }
            })).map(sg => sg.item_id)
            : [];
        let devices = await this.objectItemsRepository.find({
            relations: {
                hw_type_entity: true,
                parents: {
                    _parent: true
                }
            },
            where: {
                subsystem: 'device',
                hw_type_entity: {
                    class: 'lan'
                },
                item_id: user ? (0, typeorm_1.Not)((0, typeorm_1.In)(sgItems)) : undefined
            }
        });
        devices.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        if (devices.length > 0 || sgItems.length > 0) {
            menuItems = (0, exports.lanGlobalPages)();
        }
        if (user) {
            let serverGroups = await this.serverGroupsRepository.find({
                where: { user_id: user.user_id, class: "lan" },
                relations: { server_group_items: true }
            });
            if (serverGroups.length) {
                for (const group of serverGroups.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }))) {
                    if (group && group?.server_group_items.length) {
                        let path = 'lancisco/group?ids=' + group.server_group_id;
                        menuItems.push(new menuResponse_dto_1.MenuFolder(group.label, path, "lancisco", 'group', group.server_group_id, LanGroupFolder));
                    }
                }
            }
        }
        for (const device of devices) {
            let path = device.hw_type.toLowerCase() + '/device?ids=' + device.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(device.label, path, device.hw_type.toLowerCase(), 'device', device.item_id, LanDeviceFolder));
        }
        return menuItems;
    }
}
exports.LanRootFolder = LanRootFolder;
class LanDeviceFolder extends LanSubsystemFolder {
    constructor(hwType, subsystem, itemId) {
        super(hwType, subsystem, itemId);
        this.subsystem = 'device';
        const split = itemId.split(":::");
        if (split.length > 1) {
            this.itemId = split[0];
            this.groupId = split[1];
        }
        else {
            this.groupId = null;
        }
        this.hwType = hwType;
    }
    async getChildren() {
        if (!Classes_1.Lan.technology[this.hwType]) {
            return [];
        }
        const groupedItemId = this.groupId ? this.itemId + ":::" + this.groupId : this.itemId;
        const countableSubsys = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: (0, typeorm_1.In)(["vlan", "memory", "portchannel"])
            }
        });
        const subsysCount = {
            vlan: 0,
            memory: 0,
            portchannel: 0
        };
        for (const item of countableSubsys) {
            subsysCount[item.subsystem]++;
        }
        let menuItems = [
            new menuResponse_dto_1.MenuLink('Data', this.hwType + '/data?item_id=' + groupedItemId, 'data', groupedItemId, true),
            new menuResponse_dto_1.MenuLink('Packet', this.hwType + '/packet?item_id=' + groupedItemId, 'packet', groupedItemId),
        ];
        if (this.hwType === "lancisco") {
            menuItems.push(new menuResponse_dto_1.MenuLink('System', this.hwType + '/cpumemory?item_id=' + groupedItemId, 'cpu', groupedItemId));
        }
        if (subsysCount.vlan) {
            menuItems.push(new menuResponse_dto_1.MenuLink('VLAN', this.hwType + '/vlan-total?item_id=' + groupedItemId, 'vlan', this.itemId));
        }
        if (subsysCount.portchannel) {
            menuItems.push(new menuResponse_dto_1.MenuLink('Port Channel', this.hwType + '/portchannel-total?item_id=' + groupedItemId, 'portchannel', this.itemId));
        }
        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status?item_id=' + groupedItemId, 'healthstatus', this.itemId));
        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration?item_id=' + groupedItemId, 'configuration', this.itemId));
        const partialPath = (subsystem) => this.hwType + '/' + subsystem + '-items' + (groupedItemId !== null ? '?ids=' + groupedItemId : '');
        menuItems.push(new menuResponse_dto_1.MenuFolder('Port', partialPath("physical"), this.hwType, "physical", this.itemId, LanSubsystemItemsFolder));
        if (subsysCount.vlan) {
            menuItems.push(new menuResponse_dto_1.MenuFolder('VLAN', partialPath("vlan"), this.hwType, "vlan", this.itemId, LanSubsystemItemsFolder));
        }
        if (subsysCount.portchannel) {
            menuItems.push(new menuResponse_dto_1.MenuFolder('Port Channel', partialPath("portchannel"), this.hwType, "portchannel", this.itemId, LanSubsystemItemsFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.LanDeviceFolder = LanDeviceFolder;
class LanSubsystemItemsFolder extends LanSubsystemFolder {
    constructor(hwType, subsystem, itemId) {
        super(hwType, subsystem, itemId);
        const split = itemId.split(":::");
        if (split.length > 1) {
            this.itemId = split[0];
            this.groupId = split[1];
        }
        else {
            this.groupId = null;
        }
        this.subsystem = subsystem.toString();
    }
    async getChildren() {
        let menuItems = [];
        const groupedItemId = this.groupId ? this.itemId + ":::" + this.groupId : this.itemId;
        if (Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem] ||
            Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem.replace('-items', '').replace('items', '')]) {
            if (this.subsystem.includes('items')) {
                const subsys = this.subsystem.replace('-items', '').replace('items', '');
                let parentChildren = await this.itemRelationsRepository.find({
                    relations: {
                        _child: {
                            properties: true
                        }
                    },
                    where: {
                        parent: this.itemId.toString(),
                        _child: {
                            hw_type: this.hwType,
                            subsystem: subsys
                        }
                    }
                });
                let items = [];
                let unusedItems = [];
                for (const child of parentChildren) {
                    if (subsys === 'physical' && child._child.properties.find(property => property.property_name === 'working_state' && property.property_value === 'unused')) {
                        unusedItems.push(child._child);
                    }
                    else {
                        items.push(child._child);
                    }
                }
                items.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
                for (let item of items) {
                    let groupedId = this.groupId ? item.item_id + ":::" + this.groupId : item.item_id;
                    let path = this.hwType.toLowerCase() + '/' + subsys + '?item_id=' + groupedId;
                    menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, subsys, item.item_id));
                }
                if (unusedItems.length >= 1) {
                    let path = this.hwType.toLowerCase() + '/unused-ports?ids=' + groupedItemId;
                    menuItems.push(new menuResponse_dto_1.MenuFolder('Unused', path, this.hwType.toLowerCase(), 'unused-ports', this.itemId, LanSubsystemItemsFolder));
                }
                this.children = menuItems;
            }
            else {
                let i = 0;
                for (const page in Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['totals']) {
                    const item = Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['totals'][page];
                    menuItems.push(new menuResponse_dto_1.MenuLink(item['label'], this.hwType + '/' + this.subsystem + '-' + page + '?item_id=' + groupedItemId, this.subsystem + '-totals', undefined, i === 0 ? true : undefined));
                    i++;
                }
            }
        }
        else if (this.subsystem === 'unused-ports') {
            let parentChildren = await this.itemRelationsRepository.find({
                relations: {
                    _child: {
                        properties: true
                    }
                },
                where: {
                    parent: this.itemId.toString(),
                    _child: {
                        hw_type: this.hwType,
                        subsystem: 'physical',
                        properties: {
                            property_name: 'working_state',
                            property_value: 'unused'
                        }
                    }
                }
            });
            let items = [];
            for (const child of parentChildren) {
                items.push(child._child);
            }
            items.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
            for (let item of items) {
                let groupedId = this.groupId ? item.item_id + ":::" + this.groupId : item.item_id;
                let path = this.hwType.toLowerCase() + '/physical?item_id=' + groupedId;
                menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, 'physical', item.item_id));
            }
        }
        return menuItems;
    }
}
exports.LanSubsystemItemsFolder = LanSubsystemItemsFolder;
class LanSimplePage extends AbstractMenu_1.UniversalGroupAbstractPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.rootFolder = LanRootFolder;
    }
}
exports.LanSimplePage = LanSimplePage;
class LanPage extends AbstractMenu_1.UniversalGroupStorAbstractPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.rootFolder = LanRootFolder;
    }
}
exports.LanPage = LanPage;
class LanAbstractSingleItemPage extends AbstractMenu_1.UniversalGroupStorAbstractPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.rootFolder = LanRootFolder;
    }
}
exports.LanAbstractSingleItemPage = LanAbstractSingleItemPage;
class LanSingleItemPage extends LanAbstractSingleItemPage {
    constructor() {
        super(...arguments);
        this.parentSubsystem = 'device';
        this.withItemId = true;
    }
}
exports.LanSingleItemPage = LanSingleItemPage;
class LanItemPage extends LanSingleItemPage {
    constructor(hwType, pageType, itemId, request) {
        super(hwType, pageType, itemId, request);
        this.withItemId = true;
        this.pageType = pageType;
        const split = itemId.split(":::");
        if (split.length > 1) {
            this.itemId = split[0];
            this.groupId = split[1];
        }
        else {
            this.groupId = null;
        }
    }
    async getPage() {
        this.subsystem = this.pageType.split('-')[0];
        this.pageType = this.pageType.split('-')[1];
        let lanItems = [];
        let tabs = [];
        let title;
        if (this.pageType) {
            let items = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: this.subsystem,
            });
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    lanItems.push(item.item_id);
                }
            }
            title = this.subsystem + ' totals';
            for (const tabIndex in Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['totals'][this.pageType]['tabs']) {
                const tab = Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['totals'][this.pageType]['tabs'][tabIndex];
                tabs.push({
                    title: tab.label,
                    content: [
                        {
                            type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                            metrics: tab.metrics,
                            uuids: lanItems,
                            aggregated: true,
                        },
                    ],
                });
            }
        }
        else {
            let item = await this.objectItemsRepository.findOneBy({
                item_id: this.itemId,
            });
            lanItems.push(item.item_id);
            if (Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['single']) {
                for (const tabIndex in Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['single']) {
                    const tab = Classes_1.Lan.technology[this.hwType]['subsystems'][this.subsystem]['single'][tabIndex];
                    if (!tab) {
                        console.error("Cannot find tab definition for " + tabIndex);
                        continue;
                    }
                    tabs.push({
                        title: tab.label ? tab.label : 'unlabeled',
                        content: [
                            {
                                type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                                metrics: tab.metrics,
                                uuids: lanItems,
                                aggregated: false,
                            },
                        ],
                    });
                }
            }
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanItemPage = LanItemPage;
class LanTotalsPage extends LanSimplePage {
    constructor(pageType, itemId, request, group) {
        super(itemId, request);
        this.title = 'Data';
        this.withItemId = true;
        this.type = pageType;
        if (itemId) {
            const split = itemId.split(":::");
            if (split.length > 1) {
                this.itemId = split[0];
                this.groupId = split[1];
            }
            else {
                this.groupId = null;
            }
        }
    }
    async getPage() {
        let title = 'Data';
        let tabs = [];
        let subsys = "device";
        let options = {
            relations: {
                hw_type_entity: true
            },
            where: {
                subsystem: 'device',
                hw_type_entity: {
                    class: 'lan'
                }
            }
        };
        if (this.itemId) {
            options.relations = {
                hw_type_entity: undefined,
                parents: true
            };
            if (this.type === "data" || this.type === "packet") {
                subsys = "physical";
                options.where = {
                    subsystem: subsys,
                    parents: {
                        parent: this.itemId
                    }
                };
            }
            else if (this.type === "vlan") {
                subsys = "vlan";
                options.relations = {
                    hw_type_entity: true,
                    properties: true
                };
                options.where = {
                    subsystem: subsys,
                    parents: {
                        parent: this.itemId
                    },
                    properties: true
                };
            }
            else if (this.type === "portchannel") {
                subsys = "portchannel";
                options.where = {
                    subsystem: subsys,
                    parents: {
                        parent: this.itemId
                    }
                };
            }
        }
        if (this.type === "cpumemory") {
            subsys = "cpu";
            options.where = {
                subsystem: subsys,
                hw_type: 'lancisco',
                parents: {
                    parent: this.itemId ? this.itemId : undefined
                }
            };
        }
        const devices = await this.objectItemsRepository.find(options);
        const devicesIds = devices.map((device) => device.item_id);
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.LAN, hwTypeKey_constants_1.HwTypeKey.LANCISCO, subsys, devicesIds);
        if (this.type === 'data') {
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
            if (this.itemId) {
                tabs.push(tabFactory.createTab("In %", { metric: "utilization_in", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Out %", { metric: "utilization_out", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true));
            }
        }
        else if (this.type === 'packet') {
            tabs.push(tabFactory.createTab("In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        else if (this.type === 'cpumemory') {
            tabs.push(tabFactory.createTab("CPU", { metric: "cpu_system", default: TabFactory_1.MPDefault.LINE }, undefined, { label: 'Switch', subsystem: 'device' }, true));
            subsys = "memory";
            options.where = {
                subsystem: subsys,
                parents: {
                    parent: this.itemId ? this.itemId : undefined
                }
            };
            const memoryIds = (await this.objectItemsRepository.find(options)).map((device) => device.item_id);
            if (memoryIds && memoryIds.length) {
                tabFactory.setItems(memoryIds);
                tabFactory.setSubsystem(subsys);
                tabs.push(tabFactory.createTab("Memory", { metric: "memory_used_percent", default: TabFactory_1.MPDefault.LINE }, undefined, { label: 'Switch', subsystem: 'device' }, true));
            }
        }
        else if (this.type === 'portchannel') {
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("In %", { metric: "utilization_in", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Out %", { metric: "utilization_out", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Packets In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Packets Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        else if (this.type === 'vlan') {
            const routed = devices.filter(d => d.properties.find(prop => prop.property_value === "routed")).map(i => i.item_id);
            const unrouted = devices.filter(d => d.properties.find(prop => prop.property_value === "unrouted")).map(i => i.item_id);
            tabFactory.setItems(routed);
            tabs.push(tabFactory.createTab("Routed In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Routed Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
            tabFactory.setItems(unrouted);
            tabs.push(tabFactory.createTab("Unrouted In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Unrouted Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
            tabFactory.setItems(devicesIds);
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("In %", { metric: "utilization_in", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Out %", { metric: "utilization_out", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Packets In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Packets Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanTotalsPage = LanTotalsPage;
class LanHeatmapPage extends LanSimplePage {
    constructor() {
        super(...arguments);
        this.title = 'Heatmap';
    }
    async getTab(tab) {
        if (tab === 'in') {
            const heatmap = new Heatmap_1.HeatmapLan(this.request);
            const heatmapBox = await heatmap.gen();
            const dataIn = heatmapBox.heatmapBox.metrics.find(m => m.metric === 'data_in_util');
            return {
                title: 'LAN In',
                content: [],
                subTabs: [
                    {
                        title: 'Heatmap',
                        content: [{
                                type: pageResponse_constants_1.BOX_TYPE.HeatmapBox,
                                metrics: dataIn ? [dataIn] : []
                            }, heatmapBox.textBox]
                    }, {
                        title: 'Table',
                        content: dataIn ? [await heatmap.table("data_in_util")] : []
                    }
                ]
            };
        }
        else if (tab === 'out') {
            const heatmap = new Heatmap_1.HeatmapLan(this.request);
            const heatmapBox = await heatmap.gen();
            const dataOut = heatmapBox.heatmapBox.metrics.find(m => m.metric === 'data_out_util');
            return {
                title: 'LAN Out',
                content: [],
                subTabs: [
                    {
                        title: 'Heatmap',
                        content: [{
                                type: pageResponse_constants_1.BOX_TYPE.HeatmapBox,
                                metrics: dataOut ? [dataOut] : []
                            }, heatmapBox.textBox]
                    }, {
                        title: 'Table',
                        content: dataOut ? [await heatmap.table("data_out_util")] : []
                    }
                ]
            };
        }
        else {
            throw new common_1.NotFoundException();
        }
    }
    async getPage() {
        let title = 'Heatmap';
        let tabs = [];
        const heatmap = new Heatmap_1.HeatmapLan(this.request);
        tabs.push({
            title: 'Heatmap',
            content: Object.values(await heatmap.gen()),
        });
        tabs.push({
            title: 'Ports',
            content: [
                await heatmap.table()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanHeatmapPage = LanHeatmapPage;
class LanGrouptotalsPage extends LanSimplePage {
    constructor(pageType, itemId, request, group) {
        super(itemId, request);
        this.title = 'Data';
        this.withItemId = true;
        this.type = pageType;
    }
    async getPage() {
        let title = 'Data';
        let tabs = [];
        let subsys = "device";
        let options = {
            relations: {
                hw_type_entity: true,
                parents: true
            },
            where: {
                subsystem: 'device',
                hw_type_entity: {
                    class: 'lan'
                },
                parents: {
                    parent: this.itemId
                }
            }
        };
        if (this.type === "cpumemory") {
            const tmpDevices = await this.objectItemsRepository.find(options);
            subsys = "cpu";
            options.where = {
                subsystem: subsys,
                hw_type: 'lancisco',
                parents: {
                    parent: tmpDevices ? (0, typeorm_1.In)(tmpDevices.map(d => d.item_id)) : undefined
                }
            };
        }
        const devices = await this.objectItemsRepository.find(options);
        const devicesIds = devices.map((device) => device.item_id);
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.LAN, hwTypeKey_constants_1.HwTypeKey.LANCISCO, subsys, devicesIds);
        if (this.type === 'data') {
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        else if (this.type === 'packet') {
            tabs.push(tabFactory.createTab("In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        else if (this.type === 'cpumemory') {
            tabs.push(tabFactory.createTab("CPU", { metric: "cpu_system", default: TabFactory_1.MPDefault.LINE }, undefined, { label: 'Switch', subsystem: 'device' }, true));
            subsys = "memory";
            const tmpDevices = await this.objectItemsRepository.find(options);
            options.where = {
                subsystem: subsys,
                hw_type: 'lancisco',
                parents: {
                    parent: tmpDevices ? (0, typeorm_1.In)(tmpDevices.map(d => d.item_id)) : undefined
                }
            };
            const memoryIds = (await this.objectItemsRepository.find(options)).map((device) => device.item_id);
            if (memoryIds && memoryIds.length) {
                tabFactory.setItems(memoryIds);
                tabFactory.setSubsystem(subsys);
                tabs.push(tabFactory.createTab("Memory", { metric: "memory_used_percent", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true));
            }
        }
        else if (this.type === 'portchannel') {
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("In %", { metric: "utilization_in", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Out %", { metric: "utilization_out", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Packets In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Packets Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        else if (this.type === 'vlan') {
            const routed = devices.filter(d => d.properties.find(prop => prop.property_value === "routed")).map(i => i.item_id);
            const unrouted = devices.filter(d => d.properties.find(prop => prop.property_value === "unrouted")).map(i => i.item_id);
            tabFactory.setItems(routed);
            tabs.push(tabFactory.createTab("Routed In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Routed Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
            tabFactory.setItems(unrouted);
            tabs.push(tabFactory.createTab("Unrouted In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Unrouted Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
            tabFactory.setItems(devicesIds);
            tabs.push(tabFactory.createTab("In", { metric: "data_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Out", { metric: "data_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("In %", { metric: "utilization_in", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Out %", { metric: "utilization_out", default: TabFactory_1.MPDefault.LINE }, undefined, undefined, true), tabFactory.createTab("Packets In", { metric: "unicast_pkts_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Packets Out", { metric: "unicast_pkts_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors In", { metric: "error_in", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true), tabFactory.createTab("Errors Out", { metric: "error_out", default: TabFactory_1.MPDefault.AREA_STACKED }, undefined, undefined, true));
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanGrouptotalsPage = LanGrouptotalsPage;
class LanDataPage extends LanTotalsPage {
    constructor(itemId, request) {
        super('data', itemId, request);
    }
}
exports.LanDataPage = LanDataPage;
class LanPacketPage extends LanTotalsPage {
    constructor(itemId, request) {
        super('packet', itemId, request);
    }
}
exports.LanPacketPage = LanPacketPage;
class LanCpumemoryPage extends LanTotalsPage {
    constructor(itemId, request) {
        super('cpumemory', itemId, request);
    }
}
exports.LanCpumemoryPage = LanCpumemoryPage;
class LanVlantotalPage extends LanTotalsPage {
    constructor(itemId, request) {
        super('vlan', itemId, request);
    }
}
exports.LanVlantotalPage = LanVlantotalPage;
class LanPortchanneltotalPage extends LanTotalsPage {
    constructor(itemId, request) {
        super('portchannel', itemId, request);
    }
}
exports.LanPortchanneltotalPage = LanPortchanneltotalPage;
class LanGroupdataPage extends LanGrouptotalsPage {
    constructor(itemId, request) {
        super('data', itemId, request);
    }
}
exports.LanGroupdataPage = LanGroupdataPage;
class LanGrouppacketPage extends LanGrouptotalsPage {
    constructor(itemId, request) {
        super('packet', itemId, request);
    }
}
exports.LanGrouppacketPage = LanGrouppacketPage;
class LanGroupcpumemoryPage extends LanGrouptotalsPage {
    constructor(itemId, request) {
        super('cpumemory', itemId, request);
    }
}
exports.LanGroupcpumemoryPage = LanGroupcpumemoryPage;
class LanGroupvlantotalPage extends LanGrouptotalsPage {
    constructor(itemId, request) {
        super('vlan', itemId, request);
    }
}
exports.LanGroupvlantotalPage = LanGroupvlantotalPage;
class LanGroupportchanneltotalPage extends LanGrouptotalsPage {
    constructor(itemId, request) {
        super('portchannel', itemId, request);
    }
}
exports.LanGroupportchanneltotalPage = LanGroupportchanneltotalPage;
class LanMetrics {
}
exports.LanMetrics = LanMetrics;
LanMetrics.Metric = class extends pageResponse_dto_1.Metric {
    constructor(metric) {
        super();
        this.metric = metric;
        if (Classes_1.Lan.metrics[metric]) {
            const definition = Classes_1.Lan.metrics[metric];
            this.unit = definition.unit;
            this.shortcut = definition.shortcut;
            this.label = definition.label;
            this.defaultPrecision = definition.defaultPrecision ? definition.defaultPrecision : undefined;
            this.defaultPrefix = definition.defaultPrefix ? definition.defaultPrefix : undefined;
        }
    }
    getGraph(type, stacked, order, color) {
        this.type = type;
        this.stacked = stacked ? stacked : false;
        this.order = order ? order : 0;
        this.color = color ? color : undefined;
        return this;
    }
};
class LanHealthstatusPage extends LanSimplePage {
    constructor(itemId, request) {
        super(itemId, request);
        this.title = 'Heatlh status';
        if (itemId) {
            const split = itemId.split(":::");
            if (split.length > 1) {
                this.itemId = split[0];
                this.groupId = split[1];
            }
            else {
                this.groupId = null;
            }
        }
    }
    async getPage() {
        let title = 'Heatlh status';
        let tabs = [];
        let portHealthStatus = {
            type: pageResponse_constants_1.BOX_TYPE.PortHealthStatusBox,
            hwTypes: []
        };
        const user = await User_1.User.getUserByRequest(this.request);
        const hsColors = {
            ['yellow']: 'yellow',
            ['green']: 'green',
            ['red']: 'red',
            ['gray']: 'gray'
        };
        let colorMapping = {
            ['up']: hsColors.green,
            ['notPresent']: hsColors.gray,
            ['unknown']: hsColors.gray,
            ['down']: hsColors.yellow,
            ['testing']: hsColors.yellow,
            ['dormant']: hsColors.yellow,
            ['lowerLayerDown']: hsColors.red,
        };
        const legends = {
            'lancisco': [
                {
                    'type': 'adminStatus',
                    'label': "Admin status",
                    "text": "The desired state of the interface.",
                    'statuses': [
                        { 'color': colorMapping['up'], 'label': 'up', 'text': '' },
                        { 'color': colorMapping['down'], 'label': 'down', 'text': '' },
                        { 'color': colorMapping['testing'], 'label': 'testing', 'text': '' },
                    ]
                },
                {
                    'type': 'operationalStatus',
                    'label': "Operational status",
                    "text": "The current operational state of the interface.",
                    'statuses': [
                        { 'color': colorMapping['up'], 'label': 'up' },
                        { 'color': colorMapping['notPresent'], 'label': 'notPresent' },
                        { 'color': colorMapping['unknown'], 'label': 'unknown' },
                        { 'color': colorMapping['down'], 'label': 'down' },
                        { 'color': colorMapping['testing'], 'label': 'testing' },
                        { 'color': colorMapping['dormant'], 'label': 'dormant' },
                        { 'color': colorMapping['lowerLayerDown'], 'label': 'lowerLayerDown' },
                    ]
                }
            ],
            'lanothers': [
                {
                    'type': 'adminStatus',
                    'label': "Admin status",
                    "text": "The desired state of the interface.",
                    'statuses': [
                        { 'color': colorMapping['up'], 'label': 'up' },
                        { 'color': colorMapping['down'], 'label': 'down' },
                        { 'color': colorMapping['testing'], 'label': 'testing' },
                    ]
                },
                {
                    'type': 'operationalStatus',
                    'label': "Operational status",
                    "text": "The current operational state of the interface.",
                    'statuses': [
                        { 'color': colorMapping['up'], 'label': 'up' },
                        { 'color': colorMapping['notPresent'], 'label': 'notPresent' },
                        { 'color': colorMapping['unknown'], 'label': 'unknown' },
                        { 'color': colorMapping['down'], 'label': 'down' },
                        { 'color': colorMapping['testing'], 'label': 'testing' },
                        { 'color': colorMapping['dormant'], 'label': 'dormant' },
                        { 'color': colorMapping['lowerLayerDown'], 'label': 'lowerLayerDown' },
                    ]
                },
            ]
        };
        let devices = [];
        if (this.itemId) {
            devices = await this.objectItemsRepository.find({
                relations: {
                    children: {
                        _child: {
                            properties: true,
                            server_group_items: {
                                _server_group: true
                            }
                        }
                    },
                    server_group_items: {
                        _server_group: true
                    }
                },
                where: {
                    item_id: this.itemId,
                    children: {
                        _child: {
                            subsystem: 'physical',
                            properties: {
                                property_name: (0, typeorm_1.In)(['operational_status', 'admin_status'])
                            },
                        }
                    }
                }
            });
        }
        else {
            devices = await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true,
                    children: {
                        _child: {
                            properties: true,
                            server_group_items: {
                                _server_group: true
                            }
                        }
                    },
                    health_status: true,
                    hostcfg_relations: {
                        _hostcfg: true
                    },
                    server_group_items: {
                        _server_group: true
                    }
                },
                where: {
                    hw_type_entity: {
                        class: 'lan'
                    },
                    subsystem: 'device',
                    children: {
                        _child: {
                            subsystem: 'physical',
                            properties: {
                                property_name: (0, typeorm_1.In)(['operational_status', 'admin_status'])
                            },
                        }
                    }
                }
            });
            let healthStatus = new HealthStatus_1.HealthStatus().setAcl(this.request).generateBasicTable(devices, "Switch", user, this.groupId);
            tabs.push({
                title: 'Health Status',
                content: [await healthStatus],
            });
        }
        let lancisco = {
            label: 'Cisco LAN switches',
            devices: [],
            legends: legends['lancisco']
        };
        let lanothers = {
            label: 'Other LAN switches',
            devices: [],
            legends: legends['lanothers']
        };
        const url = new URL_1.URL();
        for (const device of devices) {
            let ports = [];
            for (const port of device.children) {
                if (port._child.properties.length >= 2) {
                    let propertiesMap = {};
                    for (const property of port._child.properties) {
                        propertiesMap[property.property_name] = property.property_value;
                    }
                    ports.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
                    ports.push({
                        label: port._child.label,
                        url: url.generateFromObject(port._child, undefined, this.groupId, user),
                        adminStatus: propertiesMap['admin_status'] ? propertiesMap['admin_status'] : undefined,
                        adminStatusColor: propertiesMap['admin_status'] ? colorMapping[propertiesMap['admin_status']] : undefined,
                        operationalStatus: propertiesMap['operational_status'] ? propertiesMap['operational_status'] : undefined,
                        operationalStatusColor: propertiesMap['operational_status'] ? colorMapping[propertiesMap['operational_status']] : undefined,
                    });
                }
            }
            if (device.hw_type === 'lancisco') {
                lancisco['devices'].push({
                    label: device.label,
                    ports: ports
                });
            }
            else if (device.hw_type === 'lanothers') {
                lanothers['devices'].push({
                    label: device.label,
                    ports: ports
                });
            }
        }
        if (lancisco.devices.length >= 1) {
            portHealthStatus.hwTypes.push(lancisco);
        }
        if (lanothers.devices.length >= 1) {
            portHealthStatus.hwTypes.push(lanothers);
        }
        tabs.push({
            title: 'Details',
            content: [portHealthStatus],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanHealthstatusPage = LanHealthstatusPage;
class LanConfigurationPage extends LanSimplePage {
    constructor(itemId, request) {
        super(itemId, request);
        this.title = 'Configuration';
        if (itemId) {
            this.itemId = itemId;
            const split = itemId.split(":::");
            if (split.length > 1) {
                this.itemId = split[0];
                this.groupId = split[1];
            }
            else {
                this.groupId = null;
            }
        }
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        if (this.itemId) {
            const device = await this.objectItemsRepository.findOneBy({
                item_id: this.itemId
            });
            const physicalports = await this.objectItemsRepository.findBy({
                subsystem: 'physical',
                parents: {
                    parent: this.itemId
                }
            });
            const portchannelports = await this.objectItemsRepository.findBy({
                subsystem: 'portchannel',
                parents: {
                    parent: this.itemId
                }
            });
            const vlanports = await this.objectItemsRepository.findBy({
                subsystem: 'vlan',
                parents: {
                    parent: this.itemId
                }
            });
            const vlancfgports = await this.objectItemsRepository.findBy({
                subsystem: 'vlancfg',
                parents: {
                    parent: this.itemId
                }
            });
            const stackcfgports = await this.objectItemsRepository.findBy({
                subsystem: 'stackcfg',
                parents: {
                    parent: this.itemId
                }
            });
            const fexcfgports = await this.objectItemsRepository.findBy({
                subsystem: 'fexcfg',
                parents: {
                    parent: this.itemId
                }
            });
            const vsscfgports = await this.objectItemsRepository.findBy({
                subsystem: 'vsscfg',
                parents: {
                    parent: this.itemId
                }
            });
            if (device.hw_type === 'lancisco' || device.hw_type === 'lanothers') {
                let tab_content = [];
                const switchesTable = new ConfigurationTable_1.ConfigurationTable([device.item_id], ["ip", "sysLocation", "model", "version", "up_time", "serial", "total_ports", "isl_ports", "unused_ports"]).setAcl(this.request).setGroup(this.groupId);
                switchesTable.setItemLabel('Switch Name');
                tab_content.push(await switchesTable.generate());
                if (vlancfgports.length > 0) {
                    const vlancfgportsTable = new ConfigurationTable_1.ConfigurationTable(vlancfgports.map(port => port.item_id), ["index", "unrouted_interface", "unrouted_ifalias", "unrouted_cfgalias", "routed_interface", "routed_ifalias", "routed_cfgalias"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    vlancfgportsTable.setItemLabel('VLAN');
                    vlancfgportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'VLAN configuration'
                    }, await vlancfgportsTable.generate());
                }
                if (stackcfgports.length > 0) {
                    const stackcfgportsTable = new ConfigurationTable_1.ConfigurationTable(stackcfgports.map(port => port.item_id), ["role", "state", "serial_number", "model_number", "stackport1", "stackport1_status", "stackport2", "stackport2_status"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    stackcfgportsTable.setItemLabel('Stack');
                    stackcfgportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'STACK configuration'
                    }, await stackcfgportsTable.generate());
                }
                if (fexcfgports.length > 0) {
                    const fexcfgportsTable = new ConfigurationTable_1.ConfigurationTable(fexcfgports.map(port => port.item_id), ["fex_serial", "fex_model", "fex_connection"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    fexcfgportsTable.setItemLabel('FEX');
                    fexcfgportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'FEX configuration'
                    }, await fexcfgportsTable.generate());
                }
                if (vsscfgports.length > 0) {
                    const vsscfgportsTable = new ConfigurationTable_1.ConfigurationTable(vsscfgports.map(port => port.item_id), ["vss_role", "vss_serial_number", "vss_uptime", "vss_vsl", "vss_vsl_status"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    vsscfgportsTable.setItemLabel('VSS');
                    vsscfgportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'Virtual Switch System'
                    }, await vsscfgportsTable.generate());
                }
                if (physicalports.length > 0) {
                    const physicalportsTable = new ConfigurationTable_1.ConfigurationTable(physicalports.map(port => port.item_id), ["alias", "vlan_id_list", "speed", "working_state", "operational_status", "admin_status", "isl", "macs"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    physicalportsTable.setItemLabel('Port');
                    physicalportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'Physical Ports'
                    }, await physicalportsTable.generate());
                }
                if (portchannelports.length > 0) {
                    const portchannelportsTable = new ConfigurationTable_1.ConfigurationTable(portchannelports.map(port => port.item_id), ["alias", "vlan_id_list", "speed", "working_state", "operational_status", "admin_status", "isl", "macs", "port_channel_members"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    portchannelportsTable.setItemLabel('Port');
                    portchannelportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'Portchannel Ports'
                    }, await portchannelportsTable.generate());
                }
                if (vlanports.length > 0) {
                    const vlanportsTable = new ConfigurationTable_1.ConfigurationTable(vlanports.map(port => port.item_id), ["alias", "vlan_id_list", "speed", "working_state", "operational_status", "admin_status", "isl", "macs"], ["device"]).setAcl(this.request).setGroup(this.groupId);
                    vlanportsTable.setItemLabel('Port');
                    vlanportsTable.sortByColumn(0, 'desc', true);
                    tab_content.push({
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: 'VLAN Ports'
                    }, await vlanportsTable.generate());
                }
                tabs.push({
                    title: 'Switch',
                    content: tab_content,
                });
            }
        }
        else {
            let switchesTable = new Table_1.Table()
                .addHeader({ value: 'Switch Name' })
                .addHeader({ value: 'IP Address' })
                .addHeader({ value: 'Group', trim: true, trimLength: 25 })
                .addHeader({ value: 'Location' })
                .addHeader({ value: 'Model' })
                .addHeader({ value: 'OS version' })
                .addHeader({ value: 'Days up' })
                .addHeader({ value: 'Serial number' })
                .addHeader({ value: 'Total ports' })
                .addHeader({ value: 'ISL ports' })
                .addHeader({ value: 'Unused ports' });
            const devicesWithProperties = await this.objectItemsRepository.find({
                relations: {
                    hw_type_entity: true,
                    properties: true,
                    server_group_items: {
                        _server_group: true
                    }
                },
                where: {
                    subsystem: 'device',
                    hw_type_entity: {
                        class: 'lan'
                    }
                }
            });
            let user = null;
            if (this.request) {
                user = await User_1.User.getUserByRequest(this.request);
            }
            for (const device of devicesWithProperties) {
                let props = {};
                for (const property of device.properties) {
                    props[property.property_name] = property.property_value;
                }
                const groupLabels = device.server_group_items ? device.server_group_items.filter(sg => sg._server_group.user_id === user.user_id).map(sg => sg._server_group.label).join(", ") : ' ';
                switchesTable.addRow([
                    { order: 1, value: device.label, url: new URL_1.URL().generateFromObject(device, null, this.groupId, user) },
                    { order: 2, value: props['ip'] ? props['ip'] : ' ' },
                    { order: 3, value: groupLabels },
                    { order: 4, value: props['sysLocation'] ? props['sysLocation'] : ' ' },
                    { order: 5, value: props['model'] ? props['model'] : ' ' },
                    { order: 6, value: props['version'] ? props['version'] : ' ' },
                    { order: 6, value: props['up_time'] ? props['up_time'] : ' ' },
                    { order: 7, value: props['serial'] ? props['serial'] : ' ' },
                    { order: 8, value: props['total_ports'] ? props['total_ports'] : ' ' },
                    { order: 9, value: props['isl_ports'] ? props['isl_ports'] : ' ' },
                    { order: 10, value: props['unused_ports'] ? props['unused_ports'] : ' ' },
                ]);
            }
            switchesTable.addExport(devicesWithProperties.map(i => i.item_id), ["ip", "group", "sysLocation", "model", "version", "up_time", "serial", "total_ports", "isl_ports", "unused_ports"]);
            tabs.push({
                title: 'Configuration',
                content: [switchesTable.generateBox()],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.LanConfigurationPage = LanConfigurationPage;
class LanGroupconfigurationPage extends LanSimplePage {
    async getPage() {
        const hwTypes = [
            {
                hwType: "lancisco",
                subsystem: "device",
                class: class_constants_1.ClassKey.LAN
            },
            {
                hwType: "lanothers",
                subsystem: "device",
                class: class_constants_1.ClassKey.LAN
            },
        ];
        this.page = new pageResponse_dto_1.Page("LAN Groups Configuration", [], { title: "LAN", hwTypes: hwTypes });
        return this.page;
    }
}
exports.LanGroupconfigurationPage = LanGroupconfigurationPage;
class LanGroupFolder extends LanSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = "group";
    }
    async getChildren(request, useFirst) {
        let menuItems = [];
        let user = null;
        if (this.request) {
            user = await User_1.User.getUserByRequest(this.request);
        }
        else if (request) {
            user = await User_1.User.getUserByRequest(request);
        }
        const sGroup = await this.serverGroupsRepository.findOne({
            where: {
                server_group_id: this.itemId,
                server_group_items: {
                    isPrimary: true
                },
                user_id: user ? user.user_id : undefined
            },
            relations: {
                server_group_items: {
                    _item: true
                }
            }
        });
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', 'lan/group-data?item_id=' + this.itemId, 'data', undefined, true));
        menuItems.push(new menuResponse_dto_1.MenuLink('Packet', 'lan/group-packet?item_id=' + this.itemId, 'packet'));
        menuItems.push(new menuResponse_dto_1.MenuLink('System', 'lan/group-cpumemory?item_id=' + this.itemId, 'cpu'));
        if (sGroup) {
            for (const { _item: item } of sGroup.server_group_items) {
                menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, item.hw_type + "/device?ids=" + (useFirst ? item.item_id : item.item_id + ":::" + this.itemId), item.hw_type, "device", item.item_id, LanDeviceFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.LanGroupFolder = LanGroupFolder;
//# sourceMappingURL=Lan.js.map