"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.NutanixHealthstatusPage = exports.NutanixStoragepoolPage = exports.NutanixStoragecontainerPage = exports.NutanixVdiskPage = exports.NutanixDiskPage = exports.NutanixStoragePage = exports.NutanixHostPage = exports.NutanixVmPage = exports.NutanixSingleItemPage = exports.NutanixClusterstoragetotalsPage = exports.NutanixClusterhosttotalsPage = exports.NutanixClustervmtotalsPage = exports.NutanixClusterTotalsPage = exports.NutanixOverviewPage = exports.NutanixVmtopPage = exports.NutanixConfigurationPage = exports.NutanixTopPage = exports.NutanixHeatmapPage = exports.NutanixTotalsPage = exports.NutanixPage = exports.NutanixMetrics = exports.NutanixStorageFolder = exports.NutanixPhysicaldiskFolder = exports.NutanixVirtualdiskFolder = exports.NutanixStoragecontainerFolder = exports.NutanixStoragepoolFolder = exports.NutanixVmFolder = exports.NutanixHostFolder = exports.NutanixChildSubsystemFolder = exports.NutanixClusterFolder = exports.NutanixRootFolder = exports.NutanixSubsystemFolder = exports.NutanixFolder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const Color_1 = require("../../metrics/Color");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const typeorm_1 = require("typeorm");
const Heatmap_1 = require("./Heatmap");
const Overview_1 = require("./Overview");
const Table_1 = require("./Table");
const Top_1 = require("./Top");
const URL_1 = require("./URL");
const HealthStatus_1 = require("./HealthStatus");
const ACLCheck_1 = require("../../acl/ACLCheck");
const ConfigurationTable_1 = require("./ConfigurationTable");
const Prediction_1 = require("../../metrics/Prediction");
const AbstractMenu_1 = require("./AbstractMenu");
const cpu_peak_help = {
    url: "https://xormon.com/max_vrs_average.php",
    text: "How it works?",
};
class NutanixFolder extends AbstractMenu_1.AbstractFolder {
    constructor() {
        super(...arguments);
        this.hwType = 'nutanix';
    }
}
exports.NutanixFolder = NutanixFolder;
class NutanixSubsystemFolder extends NutanixFolder {
    constructor(itemId) {
        super();
        if (itemId !== null) {
            this.itemId = itemId;
        }
    }
}
exports.NutanixSubsystemFolder = NutanixSubsystemFolder;
class NutanixRootFolder extends NutanixFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Heatmap', this.hwType + '/heatmap', 'heatmap'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration', 'configuration'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status', 'health-status'));
        menuItems.push(new menuResponse_dto_1.MenuLink('VM TOP', this.hwType + '/top', 'top'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview', 'overview'));
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        clusters.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, NutanixClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let subsystem_cluster = 'cluster';
        let clusters = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: subsystem_cluster,
        });
        for (let item of clusters) {
            let path = this.hwType + '/' + subsystem_cluster + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, subsystem_cluster, item.item_id, NutanixClusterFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.NutanixRootFolder = NutanixRootFolder;
class NutanixClusterFolder extends NutanixSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'cluster';
    }
    async getChildren() {
        let menuItems = [];
        let subsystems = ['Host', 'VM'];
        let subsystemClasses = {
            "Host": NutanixHostFolder,
            "VM": NutanixVmFolder
        };
        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status?item_id=' + this.itemId, 'health-status', this.itemId));
        for (let childSubsystem of subsystems) {
            menuItems.push(new menuResponse_dto_1.MenuLink(childSubsystem + ' Totals', this.hwType + '/' + this.subsystem + '-' + childSubsystem.toLowerCase() + '-totals' + '?item_id=' + this.itemId, childSubsystem.toLowerCase() + '-totals', this.itemId, childSubsystem === 'Host' ? true : undefined));
        }
        menuItems.push(new menuResponse_dto_1.MenuLink('Storage Totals', this.hwType + '/' + this.subsystem + '-storage-totals' + '?item_id=' + this.itemId, 'storage-totals', this.itemId));
        for (let childSubsystem of subsystems) {
            let childSubsystemItems = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: childSubsystem,
            });
            if (childSubsystemItems !== null) {
                let path = this.hwType + '/' + childSubsystem.toLowerCase() + (this.itemId !== null ? '?ids=' + this.itemId : '');
                menuItems.push(new menuResponse_dto_1.MenuFolder(childSubsystem, path, this.hwType, childSubsystem.toLowerCase(), this.itemId, subsystemClasses[childSubsystem]));
            }
        }
        menuItems.push(new menuResponse_dto_1.MenuFolder('Storage', this.hwType + '/storage?ids=' + this.itemId, this.hwType, 'storage', this.itemId, NutanixStorageFolder));
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let childSubsystem = 'VM';
        let childSubsystemItems = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: childSubsystem.toLowerCase(),
        });
        if (childSubsystemItems !== null) {
            let path = this.hwType + '/' + childSubsystem.toLowerCase() + (this.itemId !== null ? '?ids=' + this.itemId : '');
            menuItems.push(new menuResponse_dto_1.MenuFolder(childSubsystem, path, this.hwType, childSubsystem.toLowerCase(), this.itemId, NutanixVmFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.NutanixClusterFolder = NutanixClusterFolder;
class NutanixChildSubsystemFolder extends NutanixSubsystemFolder {
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        items.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, this.subsystem, item.item_id));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
    async getChildrenAcl() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, this.subsystem, item.item_id));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.NutanixChildSubsystemFolder = NutanixChildSubsystemFolder;
class NutanixHostFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
    }
}
exports.NutanixHostFolder = NutanixHostFolder;
class NutanixVmFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
    }
}
exports.NutanixVmFolder = NutanixVmFolder;
class NutanixStoragepoolFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'storage_pool';
    }
}
exports.NutanixStoragepoolFolder = NutanixStoragepoolFolder;
class NutanixStoragecontainerFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'storage_container';
    }
}
exports.NutanixStoragecontainerFolder = NutanixStoragecontainerFolder;
class NutanixVirtualdiskFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'vdisk';
    }
}
exports.NutanixVirtualdiskFolder = NutanixVirtualdiskFolder;
class NutanixPhysicaldiskFolder extends NutanixChildSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'disk';
    }
}
exports.NutanixPhysicaldiskFolder = NutanixPhysicaldiskFolder;
class NutanixStorageFolder extends NutanixSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'storage';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuFolder('Storage pools', this.hwType + '/storage-pool?ids=' + this.itemId, this.hwType, 'storage-pool', this.itemId, NutanixStoragepoolFolder));
        menuItems.push(new menuResponse_dto_1.MenuFolder('Storage containers', this.hwType + '/storage-container?ids=' + this.itemId, this.hwType, 'storage-container', this.itemId, NutanixStoragecontainerFolder));
        menuItems.push(new menuResponse_dto_1.MenuFolder('Virtual disks', this.hwType + '/virtual-disk?ids=' + this.itemId, this.hwType, 'virtual-disk', this.itemId, NutanixVirtualdiskFolder));
        menuItems.push(new menuResponse_dto_1.MenuFolder('Physical disks', this.hwType + '/physical-disk?ids=' + this.itemId, this.hwType, 'physical-disk', this.itemId, NutanixPhysicaldiskFolder));
        return menuItems;
    }
}
exports.NutanixStorageFolder = NutanixStorageFolder;
class NutanixMetrics {
}
exports.NutanixMetrics = NutanixMetrics;
_a = NutanixMetrics;
NutanixMetrics.Metric = class extends pageResponse_dto_1.Metric {
    init() {
        const metric = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.VIRTUALIZATION, hwTypeKey_constants_1.HwTypeKey.NUTANIX, this.subsystem, this.metric);
        if (metric) {
            Object.assign(this, metric);
        }
        return this;
    }
};
NutanixMetrics.AggrMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
    }
};
NutanixMetrics.VmCpuCoresMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_cores';
        this.order = 1;
        this.color = Color_1.Color.metric.total;
    }
};
NutanixMetrics.VmCpuCoresUsageMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_cores';
        this.order = 0;
        this.color = Color_1.Color.metric.used;
    }
};
NutanixMetrics.VmCpuCoresUsageAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'cpu_utilization_cores';
        this.order = 0;
    }
};
NutanixMetrics.VmCpuPercentMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent';
        this.order = 0;
        this.color = Color_1.Color.metric.used;
    }
};
NutanixMetrics.VmCpuPercentPeakMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent_max';
        this.order = 1;
        this.color = Color_1.Color.pallete.blueDark;
    }
};
NutanixMetrics.VmCpuPercentAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent';
        this.order = 0;
    }
};
NutanixMetrics.VmMemoryTotalMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'memory_total';
        this.order = 2;
        this.color = Color_1.Color.pallete.black;
    }
};
NutanixMetrics.VmMemoryUsageBytesMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_used';
        this.order = 0;
        this.color = Color_1.Color.pallete.red;
    }
};
NutanixMetrics.VmMemoryUsageBytesAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_used';
        this.order = 0;
    }
};
NutanixMetrics.VmMemoryFreeBytesMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_free';
        this.order = 1;
        this.color = Color_1.Color.pallete.green;
    }
};
NutanixMetrics.VmMemoryFreeBytesAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_free';
        this.order = 0;
    }
};
NutanixMetrics.VmDataMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'total_io_bandwidth';
        this.order = 0;
        this.color = Color_1.Color.metric.used;
    }
};
NutanixMetrics.VmDataAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'total_io_bandwidth';
        this.order = 0;
    }
};
NutanixMetrics.VmIopsReadMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'read_io';
        this.order = -1;
        this.color = Color_1.Color.metric.read;
    }
};
NutanixMetrics.VmIopsReadAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'read_io';
        this.order = -1;
    }
};
NutanixMetrics.VmIopsWriteMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'write_io';
        this.order = 0;
        this.color = Color_1.Color.metric.write;
    }
};
NutanixMetrics.VmIopsWriteAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'write_io';
        this.order = 0;
    }
};
NutanixMetrics.VmLatencyReadMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'read_io_latency';
        this.order = -1;
        this.color = Color_1.Color.metric.read;
    }
};
NutanixMetrics.VmLatencyReadAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'read_io_latency';
        this.order = -1;
    }
};
NutanixMetrics.VmLatencyWriteMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'write_io_latency';
        this.order = 0;
        this.color = Color_1.Color.metric.write;
    }
};
NutanixMetrics.VmLatencyWriteAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'write_io_latency';
        this.order = 0;
    }
};
NutanixMetrics.VmReceivedMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'received';
        this.order = -1;
        this.color = Color_1.Color.metric.read;
    }
};
NutanixMetrics.VmReceivedAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'received';
        this.order = -1;
    }
};
NutanixMetrics.VmTransmittedMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'transmitted';
        this.order = 0;
        this.color = Color_1.Color.metric.write;
    }
};
NutanixMetrics.VmTransmittedAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'transmitted';
        this.order = 0;
    }
};
NutanixMetrics.HostCpuCoresUsageMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_cores';
        this.order = 0;
        this.color = Color_1.Color.metric.used;
    }
};
NutanixMetrics.HostCpuCoresUsageAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'cpu_utilization_cores';
        this.order = 0;
    }
};
NutanixMetrics.HostCpuCoresMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_cores';
        this.order = 1;
        this.color = Color_1.Color.metric.total;
    }
};
NutanixMetrics.HostCpuUsageMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent';
        this.order = 0;
        this.color = Color_1.Color.pallete.redDark;
    }
};
NutanixMetrics.HostCpuUsagePeakMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent_max';
        this.order = 1;
        this.color = Color_1.Color.pallete.blueDark;
    }
};
NutanixMetrics.HostCpuUsageAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'cpu_utilization_percent';
        this.order = 0;
    }
};
NutanixMetrics.HostMemoryUsageMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_used';
        this.order = 0;
        this.color = Color_1.Color.pallete.red;
    }
};
NutanixMetrics.HostMemoryUsageAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_used';
        this.order = 0;
    }
};
NutanixMetrics.HostMemoryFreeMetric = class extends _a.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_free';
        this.order = 1;
        this.color = Color_1.Color.pallete.green;
    }
};
NutanixMetrics.HostMemoryFreeAggrMetric = class extends _a.AggrMetric {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
        this.metric = 'memory_free';
        this.order = 0;
    }
};
NutanixMetrics.StorageWriteMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'write_io_bandwidth';
        this.order = 0;
        this.color = Color_1.Color.metric.write;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageWriteMetric = class extends _a.StorageWriteMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageWriteMetricAggr = class extends _a.StorageWriteMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageReadMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'read_io_bandwidth';
        this.order = -1;
        this.color = Color_1.Color.metric.read;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageReadMetric = class extends _a.StorageReadMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageReadMetricAggr = class extends _a.StorageReadMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageTotalIoLatencyMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'total_io_latency';
        this.order = 0;
        this.color = Color_1.Color.pallete.redDark;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageTotalIoLatencyMetric = class extends _a.StorageTotalIoLatencyMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageTotalIoLatencyMetricAggr = class extends _a.StorageTotalIoLatencyMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageReadIoMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'read_io';
        this.order = -1;
        this.color = Color_1.Color.metric.read;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageReadIoMetric = class extends _a.StorageReadIoMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageReadIoMetricAggr = class extends _a.StorageReadIoMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageWriteIoMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'write_io';
        this.order = 0;
        this.color = Color_1.Color.metric.write;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageWriteIoMetric = class extends _a.StorageWriteIoMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageWriteIoMetricAggr = class extends _a.StorageWriteIoMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageTotalIoMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'total_io';
        this.order = 0;
        this.color = Color_1.Color.pallete.redDark;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageTotalIoMetric = class extends _a.StorageTotalIoMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageTotalIoMetricAggr = class extends _a.StorageTotalIoMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
NutanixMetrics.StorageLatencyMetricBase = class extends _a.Metric {
    constructor(subsystem) {
        super();
        this.metric = 'total_io_latency';
        this.order = 0;
        this.color = Color_1.Color.pallete.redDark;
        this.subsystem = subsystem;
    }
};
NutanixMetrics.StorageLatencyMetric = class extends _a.StorageLatencyMetricBase {
    constructor() {
        super(...arguments);
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
    }
};
NutanixMetrics.StorageLatencyMetricAggr = class extends _a.StorageLatencyMetricBase {
    constructor() {
        super(...arguments);
        this.aggregate = pageResponse_constants_1.METRIC_AGGREGATE.items;
        this.type = pageResponse_constants_1.CHART_TYPE.area;
        this.stacked = true;
    }
};
class NutanixPage extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.hwType = 'nutanix';
        this.rootFolder = NutanixRootFolder;
    }
}
exports.NutanixPage = NutanixPage;
class NutanixTotalsPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
    }
}
exports.NutanixTotalsPage = NutanixTotalsPage;
class NutanixHeatmapPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'Heatmap';
    }
    async getPage() {
        let title = 'Heatmap';
        let tabs = [];
        tabs.push({
            title: 'VM',
            content: Object.values(await new Heatmap_1.Heatmap('nutanix', 'vm', true)
                .virtHeatmapBox(this.request)),
        });
        let vmTable = new Table_1.Table()
            .addHeader({ value: 'VM' })
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'Host' })
            .addHeader({ value: 'CPU', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true })
            .addHeader({ value: 'Memory', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true });
        let vms = await this.objectItemsRepository.find({
            where: {
                hw_type: 'nutanix',
                subsystem: 'vm'
            },
            relations: {
                heatmaps: true,
                parents: {
                    _parent: true
                }
            }
        });
        vms = await ACLCheck_1.ACLCheck.filterObjectItemsWithRequest(this.request, vms);
        for (const vm of vms) {
            const cluster = vm.parents.find(parent => parent._parent.subsystem === 'cluster');
            const host = vm.parents.find(parent => parent._parent.subsystem === 'host');
            const cpu = vm.heatmaps.find(heatmap => heatmap.metric === 'cpu_utilization_percent');
            const memory = vm.heatmaps.find(heatmap => heatmap.metric === 'memory_usage');
            vmTable.addRow([
                { order: 0, value: vm.label, url: URL_1.URL.generate('nutanix', 'vm', vm.item_id) },
                { order: 1, value: cluster ? cluster._parent.label : 'undefined' },
                { order: 2, value: host ? host._parent.label : 'undefined', url: host ? URL_1.URL.generate('nutanix', 'host', host.parent) : undefined },
                { order: 3, value: cpu ? cpu.value : null },
                { order: 4, value: memory ? memory.value : null },
            ]);
        }
        vmTable.sortByIndex(3);
        vmTable.setBoxExport("nutanix-vm-heatmap");
        tabs.push({
            title: 'VM table',
            content: [vmTable.generateBox()],
        });
        tabs.push({
            title: 'Host',
            content: Object.values(await new Heatmap_1.Heatmap('nutanix', 'host', true)
                .virtHeatmapBox(this.request)),
        });
        let hostTable = new Table_1.Table()
            .addHeader({ value: 'Host' })
            .addHeader({ value: 'Cluster' })
            .addHeader({ value: 'CPU', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true })
            .addHeader({ value: 'Memory', unit: subsystemMetricsResponse_constants_1.UNIT.percent, number: true });
        let hosts = await this.objectItemsRepository.find({
            where: {
                hw_type: 'nutanix',
                subsystem: 'host'
            },
            relations: {
                heatmaps: true,
                parents: {
                    _parent: true
                }
            }
        });
        hosts = await ACLCheck_1.ACLCheck.filterObjectItemsWithRequest(this.request, hosts);
        for (const host of hosts) {
            const cluster = host.parents.find(parent => parent._parent.subsystem === 'cluster');
            const cpu = host.heatmaps.find(heatmap => heatmap.metric === 'cpu_utilization_percent');
            const memory = host.heatmaps.find(heatmap => heatmap.metric === 'memory_usage');
            hostTable.addRow([
                { order: 0, value: host.label, url: URL_1.URL.generate('nutanix', 'host', host.item_id) },
                { order: 1, value: cluster ? cluster._parent.label : 'undefined' },
                { order: 2, value: cpu ? cpu.value : null },
                { order: 3, value: memory ? memory.value : null },
            ]);
        }
        hostTable.sortByIndex(2);
        hostTable.setBoxExport("nutanix-host-heatmap");
        tabs.push({
            title: 'Host table',
            content: [hostTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixHeatmapPage = NutanixHeatmapPage;
class NutanixTopPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'VM TOP';
    }
    async getPage() {
        const top = new Top_1.Top();
        top.setSubsystem('nutanix', 'vm');
        top.setParentSubsystem('cluster');
        top.setAcl(this.request);
        const tabs = await top.genTabs();
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.NutanixTopPage = NutanixTopPage;
class NutanixConfigurationPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'Configuration';
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        let hostTable = new Table_1.Table()
            .addHeader({ value: 'Host', property: 'name', url: '{{this}}' })
            .addHeader({ value: 'Address', property: 'address' })
            .addHeader({ value: 'Memory', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, property: 'memory', prefix: pageResponse_constants_1.UNIT_PREFIX.giga, multiplier: 1024 })
            .addHeader({ value: 'CPU', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.cpu, property: 'cpu_count' })
            .addHeader({ value: 'Socket', number: true, property: 'socket_count' })
            .addHeader({ value: 'CPU model', property: 'cpu_model' })
            .addHeader({ value: 'Version', property: 'version' });
        let hosts = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'host' });
        hosts = await ACLCheck_1.ACLCheck.filterObjectItemsWithRequest(this.request, hosts);
        await hostTable.addPropertiesItems(hosts.map(item => item.item_id));
        tabs.push({
            title: 'Host',
            content: [hostTable.generateBox()],
        });
        let vms = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'vm' });
        const vmConfigurationTable = new ConfigurationTable_1.ConfigurationTable(vms.map(vm => vm.item_id), ['cpu_count', 'memory', 'os'], ['cluster', 'host']);
        vmConfigurationTable.setAcl(this.request);
        vmConfigurationTable.setItemLabel("VM");
        tabs.push({
            title: 'VM',
            content: [await vmConfigurationTable.generate()],
        });
        let disks = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'disk' });
        const diskConfigurationTable = new ConfigurationTable_1.ConfigurationTable(disks.map(item => item.item_id), ['type', 'physical_size'], ['cluster', 'host']);
        diskConfigurationTable.setAcl(this.request);
        diskConfigurationTable.setItemLabel("Disk");
        tabs.push({
            title: 'Physical Disk',
            content: [await diskConfigurationTable.generate()],
        });
        let vdisks = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'vdisk' });
        const vdiskConfigurationTable = new ConfigurationTable_1.ConfigurationTable(vdisks.map(item => item.item_id), ['capacity'], ['cluster', 'storage_container', 'vm']);
        vdiskConfigurationTable.setAcl(this.request);
        vdiskConfigurationTable.setItemLabel("Disk");
        tabs.push({
            title: 'Virtual Disk',
            content: [await vdiskConfigurationTable.generate()],
        });
        let storageContainers = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'storage_container' });
        const storageContainerConfigurationTable = new ConfigurationTable_1.ConfigurationTable(storageContainers.map(item => item.item_id), ['capacity_size', 'capacity_used', 'capacity_free', 'compression_enabled', 'is_nutanix_managed'], ['cluster']);
        storageContainerConfigurationTable.setAcl(this.request);
        storageContainerConfigurationTable.setItemLabel("Storage Container");
        tabs.push({
            title: 'Storage Container',
            content: [await storageContainerConfigurationTable.generate()],
        });
        let storagePools = await this.objectItemsRepository.findBy({ hw_type: 'nutanix', subsystem: 'storage_pool' });
        const storagePoolsConfigurationTable = new ConfigurationTable_1.ConfigurationTable(storagePools.map(item => item.item_id), ['capacity_size', 'capacity_used', 'capacity_free'], ['cluster']);
        storagePoolsConfigurationTable.setAcl(this.request);
        storagePoolsConfigurationTable.setItemLabel("Storage Pool");
        tabs.push({
            title: 'Storage Pool',
            content: [await storagePoolsConfigurationTable.generate()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixConfigurationPage = NutanixConfigurationPage;
class NutanixVmtopPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'VM Top';
    }
}
exports.NutanixVmtopPage = NutanixVmtopPage;
class NutanixOverviewPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'Overview';
    }
    async getPage() {
        let title = 'Overview';
        let tabs = [];
        const overview = new Overview_1.Overview('nutanix');
        let hosts = await this.objectItemsRepository.findBy({ hw_type: hwTypeKey_constants_1.HwTypeKey.NUTANIX, subsystem: 'host' });
        hosts = await ACLCheck_1.ACLCheck.filterObjectItemsWithRequest(this.request, hosts);
        overview.addCategory('Host', hosts.map(item => {
            return {
                label: item.label,
                item_id: item.item_id
            };
        }));
        tabs.push({
            title: 'Host',
            content: [
                overview.form()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixOverviewPage = NutanixOverviewPage;
class NutanixClusterTotalsPage extends NutanixTotalsPage {
    constructor() {
        super(...arguments);
        this.withItemId = true;
        this.subsystem = 'cluster';
    }
}
exports.NutanixClusterTotalsPage = NutanixClusterTotalsPage;
class NutanixClustervmtotalsPage extends NutanixClusterTotalsPage {
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'VM Totals ' + (item !== null ? item.label : this.itemId);
        let child_vms = [];
        let vms = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: 'vm' });
        for (let vm of vms) {
            child_vms.push(vm.item_id);
        }
        let items = [];
        let itemRelations = await this.itemRelationsRepository.findBy({ parent: this.itemId, child: (0, typeorm_1.In)(child_vms) });
        for (let relation of itemRelations) {
            items.push(relation.child);
        }
        const parent = MetricsWrapper_1.MetricsWrapper.getParent(class_constants_1.ClassKey.VIRTUALIZATION, hwTypeKey_constants_1.HwTypeKey.NUTANIX, 'vm');
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmCpuCoresUsageAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent
                        ? {
                            subsystem: parent.subsystem,
                            label: parent.label
                        } : undefined,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmCpuPercentAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'Memory used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmMemoryUsageBytesAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'Memory free',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmMemoryFreeBytesAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmDataAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmIopsReadAggrMetric().init(), await new NutanixMetrics.VmIopsWriteAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmLatencyReadAggrMetric().init(), await new NutanixMetrics.VmLatencyWriteAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        tabs.push({
            title: 'LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmReceivedAggrMetric().init(), await new NutanixMetrics.VmTransmittedAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'VM'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixClustervmtotalsPage = NutanixClustervmtotalsPage;
class NutanixClusterhosttotalsPage extends NutanixClusterTotalsPage {
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Host Totals ' + (item !== null ? item.label : this.itemId);
        let child_hosts = [];
        let hosts = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: 'host' });
        for (let host of hosts) {
            child_hosts.push(host.item_id);
        }
        let items = [];
        let itemRelations = await this.itemRelationsRepository.findBy({ parent: this.itemId, child: (0, typeorm_1.In)(child_hosts) });
        for (let relation of itemRelations) {
            items.push(relation.child);
        }
        const parent = MetricsWrapper_1.MetricsWrapper.getParent(class_constants_1.ClassKey.VIRTUALIZATION, hwTypeKey_constants_1.HwTypeKey.NUTANIX, 'host');
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostCpuCoresUsageAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent
                        ? {
                            label: parent.label,
                            subsystem: parent.subsystem
                        } : undefined,
                    label: 'Host'
                },
            ],
        });
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostCpuUsageAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'Host'
                },
            ],
        });
        tabs.push({
            title: 'Memory used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostMemoryUsageAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'Host'
                },
            ],
        });
        tabs.push({
            title: 'Memory free',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostMemoryFreeAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                    parent: parent,
                    label: 'Host'
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixClusterhosttotalsPage = NutanixClusterhosttotalsPage;
class NutanixClusterstoragetotalsPage extends NutanixClusterTotalsPage {
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'Storage Totals ' + (item !== null ? item.label : this.itemId);
        let storages = [
            {
                label: "Pool",
                subsystem: "storage_pool"
            },
            {
                label: "SC",
                subsystem: "storage_container"
            },
            {
                label: "VDisk",
                subsystem: "vdisk"
            },
            {
                label: "Disk",
                subsystem: "disk"
            }
        ];
        let children = await this.itemRelationsRepository.find({ where: { parent: this.itemId, _child: { subsystem: (0, typeorm_1.In)(['vdisk', 'disk', 'storage_pool', 'storage_container']) } }, relations: { _child: true } });
        let tabs = [];
        for (const storage of storages) {
            const itemIds = (children.filter((obj) => {
                return obj._child.subsystem === storage.subsystem;
            })).map(item => item.child);
            const parent = MetricsWrapper_1.MetricsWrapper.getParent(class_constants_1.ClassKey.VIRTUALIZATION, hwTypeKey_constants_1.HwTypeKey.NUTANIX, storage.subsystem);
            tabs.push({
                title: storage.label + " Data",
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new NutanixMetrics.StorageReadMetricAggr(storage.subsystem).init(),
                            new NutanixMetrics.StorageWriteMetricAggr(storage.subsystem).init()
                        ],
                        uuids: itemIds,
                        aggregated: true,
                        parent: parent
                            ? {
                                label: parent.label,
                                subsystem: parent.subsystem
                            } : undefined,
                        label: storage.label
                    },
                ],
            });
            tabs.push({
                title: storage.label + " IO",
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new NutanixMetrics.StorageReadIoMetricAggr(storage.subsystem).init(),
                            new NutanixMetrics.StorageWriteIoMetricAggr(storage.subsystem).init()
                        ],
                        uuids: itemIds,
                        aggregated: true,
                        parent: parent,
                        label: storage.label
                    },
                ],
            });
            tabs.push({
                title: storage.label + " Latency",
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new NutanixMetrics.StorageLatencyMetricAggr(storage.subsystem).init()
                        ],
                        uuids: itemIds,
                        aggregated: true,
                        parent: parent,
                        label: storage.label
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixClusterstoragetotalsPage = NutanixClusterstoragetotalsPage;
class NutanixSingleItemPage extends NutanixPage {
}
exports.NutanixSingleItemPage = NutanixSingleItemPage;
class NutanixVmPage extends NutanixSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'vm';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let title = 'VM ' + (item !== null ? item.label : this.itemId);
        const metricsWrapper = await (new MetricsWrapper_1.MetricsWrapper(['cpu_cores'], [this.itemId])).getLastDailyValuesFromTable();
        const maxCpuCores = metricsWrapper[this.itemId]?.['cpu_cores'];
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmCpuCoresUsageMetric().init(), await new NutanixMetrics.VmCpuCoresMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
                await Prediction_1.Prediction.generatePredictionBox({
                    item_id: this.itemId,
                    metric: new NutanixMetrics.VmCpuCoresUsageMetric().init(),
                    other_metrics: [],
                    frequency: '5m',
                    command: 'predict_vm',
                    interval: 'month',
                    max: maxCpuCores
                }),
                await Prediction_1.Prediction.generatePredictionBox({
                    item_id: this.itemId,
                    metric: new NutanixMetrics.VmCpuCoresUsageMetric().init(),
                    other_metrics: [],
                    frequency: '6h',
                    command: 'predict_vm',
                    interval: 'year',
                    max: maxCpuCores
                }),
            ],
        });
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        await new NutanixMetrics.VmCpuPercentMetric().init(),
                        await new NutanixMetrics.VmCpuPercentPeakMetric().init()
                    ],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
            help: cpu_peak_help,
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        await new NutanixMetrics.VmMemoryUsageBytesMetric().init(),
                        await new NutanixMetrics.VmMemoryFreeBytesMetric().init(),
                        await new NutanixMetrics.VmMemoryTotalMetric().init(),
                    ],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmDataMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmIopsReadMetric().init(), await new NutanixMetrics.VmIopsWriteMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmLatencyReadMetric().init(), await new NutanixMetrics.VmLatencyWriteMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LAN',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmReceivedMetric().init(), await new NutanixMetrics.VmTransmittedMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixVmPage = NutanixVmPage;
class NutanixHostPage extends NutanixSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'host';
    }
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let child_vms = [];
        let vms = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: 'vm' });
        for (let vm of vms) {
            child_vms.push(vm.item_id);
        }
        let items = [];
        let itemRelations = await this.itemRelationsRepository.findBy({ parent: this.itemId, child: (0, typeorm_1.In)(child_vms) });
        for (let relation of itemRelations) {
            items.push(relation.child);
        }
        let title = 'Host ' + (item !== null ? item.label : this.itemId);
        const metricsWrapper = await (new MetricsWrapper_1.MetricsWrapper(['cpu_cores'], [this.itemId])).getLastDailyValuesFromTable();
        const maxCpuCores = metricsWrapper[this.itemId]?.['cpu_cores'];
        let tabs = [];
        tabs.push({
            title: 'CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostCpuCoresUsageMetric().init(), await new NutanixMetrics.HostCpuCoresMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
                await Prediction_1.Prediction.generatePredictionBox({
                    item_id: this.itemId,
                    metric: new NutanixMetrics.HostCpuCoresUsageMetric().init(),
                    other_metrics: [],
                    frequency: '5m',
                    command: 'predict_cpu',
                    interval: 'month',
                    max: maxCpuCores
                }),
                await Prediction_1.Prediction.generatePredictionBox({
                    item_id: this.itemId,
                    metric: new NutanixMetrics.HostCpuCoresUsageMetric().init(),
                    other_metrics: [],
                    frequency: '6h',
                    command: 'predict_cpu',
                    interval: 'year',
                    max: maxCpuCores
                }),
            ],
        });
        tabs.push({
            title: 'CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        await new NutanixMetrics.HostCpuUsageMetric().init(),
                        await new NutanixMetrics.HostCpuUsagePeakMetric().init()
                    ],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
            help: cpu_peak_help,
        });
        tabs.push({
            title: 'VM CPU',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmCpuCoresUsageAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'VM CPU%',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmCpuPercentAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.HostMemoryUsageMetric().init(), await new NutanixMetrics.HostMemoryFreeMetric().init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'VM memory used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmMemoryUsageBytesAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'VM memory free',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [await new NutanixMetrics.VmMemoryFreeBytesAggrMetric().init()],
                    uuids: items,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixHostPage = NutanixHostPage;
class NutanixStoragePage extends NutanixSingleItemPage {
    async getPage() {
        let item = await this.objectItemsRepository.findOneBy({
            hw_type: this.hwType,
            subsystem: this.subsystem,
            item_id: this.itemId,
        });
        let child_items = [];
        let oItems = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        for (let item of oItems) {
            child_items.push(item.item_id);
        }
        let items = [];
        let itemRelations = await this.itemRelationsRepository.findBy({ parent: this.itemId, child: (0, typeorm_1.In)(child_items) });
        for (let relation of itemRelations) {
            items.push(relation.child);
        }
        let title = this.subsystem + ' ' + (item !== null ? item.label : this.itemId);
        let tabs = [];
        tabs.push({
            title: 'Data',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new NutanixMetrics.StorageReadMetric(this.subsystem).init(),
                        new NutanixMetrics.StorageWriteMetric(this.subsystem).init()
                    ],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new NutanixMetrics.StorageReadIoMetric(this.subsystem).init(),
                        new NutanixMetrics.StorageWriteIoMetric(this.subsystem).init()
                    ],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Total IO',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new NutanixMetrics.StorageTotalIoMetric(this.subsystem).init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Latency',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new NutanixMetrics.StorageLatencyMetric(this.subsystem).init()],
                    uuids: [this.itemId],
                    aggregated: false,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixStoragePage = NutanixStoragePage;
class NutanixDiskPage extends NutanixStoragePage {
    constructor() {
        super(...arguments);
        this.subsystem = "disk";
    }
}
exports.NutanixDiskPage = NutanixDiskPage;
class NutanixVdiskPage extends NutanixStoragePage {
    constructor() {
        super(...arguments);
        this.subsystem = "vdisk";
    }
}
exports.NutanixVdiskPage = NutanixVdiskPage;
class NutanixStoragecontainerPage extends NutanixStoragePage {
    constructor() {
        super(...arguments);
        this.subsystem = "storage_container";
    }
}
exports.NutanixStoragecontainerPage = NutanixStoragecontainerPage;
class NutanixStoragepoolPage extends NutanixStoragePage {
    constructor() {
        super(...arguments);
        this.subsystem = "storage_pool";
    }
}
exports.NutanixStoragepoolPage = NutanixStoragepoolPage;
class NutanixHealthstatusPage extends NutanixPage {
    constructor() {
        super(...arguments);
        this.title = 'Health Status';
    }
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatus = this.itemId
            ? new HealthStatus_1.HealthStatus().getStatusByIds([this.itemId])
            : new HealthStatus_1.HealthStatus().getStatusByParameters("cluster", "virtualization", "Cluster", "nutanix");
        let ids = [];
        const itemProperties = await this.itemPropertiesRepository.find({
            where: {
                item_id: this.itemId ? this.itemId : undefined,
                property_name: (0, typeorm_1.In)(['hs', 'events', 'alerts']),
                _item: {
                    hw_type: hwTypeKey_constants_1.HwTypeKey.NUTANIX,
                    subsystem: 'cluster'
                }
            }, relations: {
                _item: true
            }
        });
        const errors = [];
        const hs = itemProperties.find(property => property.property_name === 'hs');
        let hsRows = hs ? JSON.parse(hs.property_value) : {};
        const types = [{
                key: 'clusters',
                label: 'Cluster'
            }, {
                key: 'hosts',
                label: 'Host'
            }];
        for (const type of types) {
            for (const clusterId in hsRows[type.key]) {
                for (const errorId in hsRows[type.key][clusterId]['errors']) {
                    const errrorRow = hsRows[type.key][clusterId]['errors'][errorId];
                    ids.push(clusterId);
                    errors.push({
                        type: type.label,
                        item_id: clusterId,
                        severity: errrorRow['status'],
                        id: +errorId,
                        error: errrorRow['name'],
                        description: errrorRow['description']
                    });
                }
            }
            ;
        }
        const items = await this.objectItemsRepository.findBy({
            item_id: (0, typeorm_1.In)(ids)
        });
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Error' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'ID' });
        for (const error of errors) {
            const item = items.find(item => item.item_id === error.item_id);
            hsTable.addRow([
                { order: 0, value: error.severity },
                { order: 1, value: error.type },
                { order: 2, value: item ? item.label : error.item_id, url: item ? URL_1.URL.generate('nutanix', error.type.toLocaleLowerCase(), item.item_id) : undefined },
                { order: 3, value: error.error },
                { order: 4, value: error.description },
                { order: 5, value: error.id },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                await healthStatus,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NutanixHealthstatusPage = NutanixHealthstatusPage;
//# sourceMappingURL=Nutanix.js.map