"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracledbLatencytotalPage = exports.OracledbRatiototalPage = exports.OracledbNetworktotalPage = exports.OracledbSqlquerytotalPage = exports.OracledbSessiontotalPage = exports.OracledbSgadatatotalPage = exports.OracledbDatatotalPage = exports.OracledbIototalPage = exports.OracledbCputotalPage = exports.OracledbHosttotalPage = exports.OracledbLatencyPage = exports.OracledbRatioPage = exports.OracledbNetworkPage = exports.OracledbSqlqueryPage = exports.OracledbSessionPage = exports.OracledbSgadataPage = exports.OracledbDataPage = exports.OracledbIoPage = exports.OracledbCpuPage = exports.OracledbHostPage = exports.OracledbCapacityPage = exports.OracledbViewfivePage = exports.OracledbViewfourPage = exports.OracledbViewthreePage = exports.OracledbViewtwoPage = exports.OracledbViewonePage = exports.OracledbGlobalcachePage = exports.OracledbOverviewPage = exports.OracledbMetrics = exports.OracledbDatafilesPage = exports.OracledbConfigurationPage = exports.OracledbHealthstatusPage = exports.OracledbTotalconfigurationPage = exports.OracledbTopPage = exports.OracledbSingleItemPage = exports.OracledbPage = exports.OracledbInstanceFolder = exports.OracledbGlobalcacheFolder = exports.OracledbPdbsFolder = exports.OracledbTotalsFolder = exports.OracledbInstancesFolder = exports.OracledbChildSubsystemFolder = exports.OracledbOdbfolderFolder = exports.OracledbSubmenugroupFolder = exports.OracledbGroupFolder = exports.OracledbHostitemsFolder = exports.OracledbHostsFolder = exports.OracledbRootFolder = exports.OracledbSubsystemFolder = exports.OracledbFolder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const itemProperty_entity_1 = require("../../../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../../entity/objectItem.entity");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const typeorm_1 = require("typeorm");
const HealthStatus_1 = require("./HealthStatus");
const Table_1 = require("./Table");
const Top_1 = require("./Top");
const AbstractMenu_1 = require("./AbstractMenu");
const Color_1 = require("../../metrics/Color");
const TabFactory_1 = require("./TabFactory");
class OracledbFolder extends AbstractMenu_1.AbstractFolder {
    constructor() {
        super(...arguments);
        this.hwType = 'oracledb';
    }
}
exports.OracledbFolder = OracledbFolder;
class OracledbSubsystemFolder extends OracledbFolder {
    constructor(itemId) {
        super();
        if (itemId !== null) {
            this.itemId = itemId;
        }
    }
}
exports.OracledbSubsystemFolder = OracledbSubsystemFolder;
class OracledbRootFolder extends OracledbFolder {
    async getChildrenAcl() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: "instance",
        });
        for (let item of items) {
            let path = this.hwType + '/' + "instance" + '?ids=' + item.item_id;
            const menuLink = new menuResponse_dto_1.MenuLink(item.label, path, "instance", item.item_id);
            menuLink.subsystem = "instance";
            menuItems.push(menuLink);
        }
        return menuItems;
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Total', this.hwType + '/totalconfiguration', 'totalconfiguration'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Health Status', this.hwType + '/health-status', 'health-status'));
        menuItems.push(new menuResponse_dto_1.MenuLink('DB TOP', this.hwType + '/top', 'top'));
        let path = this.hwType + '/hosts';
        menuItems.push(new menuResponse_dto_1.MenuFolder("Hosts", path, this.hwType, "hosts", "true", OracledbHostsFolder));
        let menugroups = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: "menugroup",
        });
        menugroups.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let item of menugroups) {
            let path = this.hwType + '/' + "group" + '?ids=' + item.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, "group", item.item_id, OracledbGroupFolder));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbRootFolder = OracledbRootFolder;
class OracledbHostsFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'odbfolder';
    }
    async getChildren() {
        let menuItems = [];
        let subsystems = ['instance'];
        menuItems.push(new menuResponse_dto_1.MenuLink('Total', this.hwType + '/hosttotal', 'total'));
        let path = this.hwType + '/hostitems';
        menuItems.push(new menuResponse_dto_1.MenuFolder("Items", path, this.hwType, "hostitems", "true", OracledbHostitemsFolder));
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbHostsFolder = OracledbHostsFolder;
class OracledbHostitemsFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'odbfolder';
    }
    async getChildren() {
        let menuItems = [];
        let hosts = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: "host",
        });
        for (const host of hosts) {
            menuItems.push(new menuResponse_dto_1.MenuLink(host.label, this.hwType + '/host?item_id=' + host.item_id, 'host', host.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbHostitemsFolder = OracledbHostitemsFolder;
class OracledbGroupFolder extends OracledbSubsystemFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + this.itemId, 'overview', undefined, true));
        let itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
        let itemRelations = await itemRelationsRepository.find({ where: { parent: this.itemId }, relations: { _child: true } });
        for (const relation of itemRelations) {
            if (relation._child.subsystem === "odbfolder") {
                let path = this.hwType + '/' + "odbfolder" + '?ids=' + relation._child.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(relation._child.label, path, this.hwType, "odbfolder", relation._child.item_id, OracledbOdbfolderFolder));
            }
            else if (relation._child.subsystem === "submenugroup") {
                let path = this.hwType + '/' + "submenugroup" + '?ids=' + relation._child.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(relation._child.label, path, this.hwType, "submenugroup", relation._child.item_id, OracledbSubmenugroupFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbGroupFolder = OracledbGroupFolder;
class OracledbSubmenugroupFolder extends OracledbSubsystemFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + this.itemId, 'overview', undefined, true));
        let itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
        let itemRelations = await itemRelationsRepository.find({ where: { parent: this.itemId }, relations: { _child: true } });
        for (const relation of itemRelations) {
            if (relation._child.subsystem === "odbfolder") {
                let path = this.hwType + '/' + "odbfolder" + '?ids=' + relation._child.item_id;
                menuItems.push(new menuResponse_dto_1.MenuFolder(relation._child.label, path, this.hwType, "odbfolder", relation._child.item_id, OracledbOdbfolderFolder));
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbSubmenugroupFolder = OracledbSubmenugroupFolder;
class OracledbOdbfolderFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'odbfolder';
    }
    async isStandalone() {
        const manager = (0, dataSource_1.getDataSource)();
        let tableRes = await manager.query("SELECT * FROM hostcfg hcfg INNER JOIN hostcfg_relations cr on hcfg.hostcfg_id = cr.hostcfg_id WHERE cr.item_id ='" + this.itemId + "' ORDER BY hcfg.hostcfg_id DESC LIMIT 1;");
        if (tableRes && 'data' in tableRes && tableRes.data.type.toLowerCase() === 'standalone') {
            return true;
        }
        else {
            return false;
        }
    }
    async getChildren() {
        let menuItems = [];
        let subsystems = ['instance'];
        let tableRes = await (0, dataSource_1.getDataSource)()
            .createQueryBuilder()
            .select('*')
            .from('hostcfg', 'hcfg')
            .innerJoin('hostcfg_relations', 'cr', 'hcfg.hostcfg_id = cr.hostcfg_id')
            .where('cr.item_id = :item_id', { item_id: this.itemId })
            .getRawOne();
        if (tableRes && 'data' in tableRes && (tableRes.data.type).toLowerCase() === 'standalone') {
            let instances = await this.objectItemsRepository.find({
                where: {
                    subsystem: "instance",
                    parents: {
                        _parent: {
                            item_id: this.itemId
                        }
                    }
                },
                relations: {
                    parents: true
                }
            });
            let item_id = instances[0].item_id;
            menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + item_id, 'overview', undefined, true));
            menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration?item_id=' + item_id, 'configuration'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Datafiles', this.hwType + '/datafiles?item_id=' + item_id, 'datafiles'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/capacity?item_id=' + item_id, 'capacity'));
            menuItems.push(new menuResponse_dto_1.MenuLink('CPU', this.hwType + '/cpu?item_id=' + item_id, 'cpu'));
            menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/io?item_id=' + item_id, 'io'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/data?item_id=' + item_id, 'data'));
            menuItems.push(new menuResponse_dto_1.MenuLink('SGA data', this.hwType + '/sga-data?item_id=' + item_id, 'sga-data'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Session', this.hwType + '/session?item_id=' + item_id, 'session'));
            menuItems.push(new menuResponse_dto_1.MenuLink('SQL query', this.hwType + '/sql-query?item_id=' + item_id, 'sql-query'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/network?item_id=' + item_id, 'network'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Ratio', this.hwType + '/ratio?item_id=' + item_id, 'ratio'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/latency?item_id=' + item_id, 'latency'));
        }
        else {
            menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + this.itemId, 'overview'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Configuration', this.hwType + '/configuration?item_id=' + this.itemId, 'configuration'));
            menuItems.push(new menuResponse_dto_1.MenuLink('Datafiles', this.hwType + '/datafiles?item_id=' + this.itemId, 'datafiles'));
        }
        for (let childSubsystem of subsystems) {
            let childSubsystemItems = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: childSubsystem,
            });
            if (childSubsystemItems !== null) {
                let path = '';
                if (tableRes && 'data' in tableRes && tableRes.data.type !== 'Standalone' && tableRes.data.type !== 'Multitenant') {
                    path = this.hwType + '/Globalcache' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                    menuItems.push(new menuResponse_dto_1.MenuFolder('Global Cache', path, this.hwType, childSubsystem, this.itemId, OracledbGlobalcacheFolder));
                }
                if (tableRes && 'data' in tableRes && tableRes.data.type !== 'Standalone') {
                    path = this.hwType + '/totals' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                    menuItems.push(new menuResponse_dto_1.MenuFolder('Total', path, this.hwType, childSubsystem, this.itemId, OracledbTotalsFolder));
                    path = this.hwType + '/instances' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                    menuItems.push(new menuResponse_dto_1.MenuFolder('Instances', path, this.hwType, childSubsystem, this.itemId, OracledbInstancesFolder));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbOdbfolderFolder = OracledbOdbfolderFolder;
class OracledbChildSubsystemFolder extends OracledbSubsystemFolder {
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuLink(item.label, path, this.subsystem, item.item_id));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbChildSubsystemFolder = OracledbChildSubsystemFolder;
class OracledbInstancesFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?ids=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, this.subsystem, this.itemId, OracledbInstanceFolder));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbInstancesFolder = OracledbInstancesFolder;
class OracledbTotalsFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('CPU', this.hwType + '/cputotal?item_id=' + this.itemId, 'cputotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/iototal?item_id=' + this.itemId, 'iototal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/datatotal?item_id=' + this.itemId, 'datatotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SGA data', this.hwType + '/sga-datatotal?item_id=' + this.itemId, 'sga-datatotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Session', this.hwType + '/sessiontotal?item_id=' + this.itemId, 'sessiontotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SQL query', this.hwType + '/sql-querytotal?item_id=' + this.itemId, 'sql-querytotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/networktotal?item_id=' + this.itemId, 'networktotal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Ratio', this.hwType + '/ratiototal?item_id=' + this.itemId, 'ratiototal'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/latencytotal?item_id=' + this.itemId, 'latencytotal'));
        return menuItems;
    }
}
exports.OracledbTotalsFolder = OracledbTotalsFolder;
class OracledbPdbsFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getChildren() {
        let menuItems = [];
        let items = await this.objectItemsRepository.findBy({ hw_type: this.hwType, subsystem: this.subsystem });
        if (this.itemId) {
            let parentChildren = await this.itemRelationsRepository.find({ where: { parent: this.itemId.toString() } });
            let childrenIds = parentChildren.map((relation) => relation.child);
            for (let item of items) {
                if (childrenIds.includes(item.item_id)) {
                    let path = this.hwType + '/' + this.subsystem + '?ids=' + item.item_id;
                    menuItems.push(new menuResponse_dto_1.MenuFolder(item.label, path, this.hwType, this.subsystem, this.itemId, OracledbInstanceFolder));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbPdbsFolder = OracledbPdbsFolder;
class OracledbGlobalcacheFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Global cache', this.hwType + '/global-cache?item_id=' + this.itemId, 'global-cache'));
        menuItems.push(new menuResponse_dto_1.MenuLink('View one', this.hwType + '/viewone?item_id=' + this.itemId, 'viewone'));
        menuItems.push(new menuResponse_dto_1.MenuLink('View two', this.hwType + '/viewtwo?item_id=' + this.itemId, 'viewtwo'));
        menuItems.push(new menuResponse_dto_1.MenuLink('View three', this.hwType + '/viewthree?item_id=' + this.itemId, 'viewthree'));
        menuItems.push(new menuResponse_dto_1.MenuLink('View four', this.hwType + '/viewfour?item_id=' + this.itemId, 'viewfour'));
        menuItems.push(new menuResponse_dto_1.MenuLink('View five', this.hwType + '/viewfive?item_id=' + this.itemId, 'viewfive'));
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbGlobalcacheFolder = OracledbGlobalcacheFolder;
class OracledbInstanceFolder extends OracledbSubsystemFolder {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getChildren() {
        let menuItems = [];
        let subsystems = ['instance'];
        menuItems.push(new menuResponse_dto_1.MenuLink('Overview', this.hwType + '/overview?item_id=' + this.itemId, 'overview'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/capacity?item_id=' + this.itemId, 'capacity'));
        menuItems.push(new menuResponse_dto_1.MenuLink('CPU', this.hwType + '/cpu?item_id=' + this.itemId, 'cpu', this.itemId));
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/io?item_id=' + this.itemId, 'io'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/data?item_id=' + this.itemId, 'data'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SGA data', this.hwType + '/sga-data?item_id=' + this.itemId, 'sga-data'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Session', this.hwType + '/session?item_id=' + this.itemId, 'session'));
        menuItems.push(new menuResponse_dto_1.MenuLink('SQL query', this.hwType + '/sql-query?item_id=' + this.itemId, 'sql-query'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/network?item_id=' + this.itemId, 'network'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Ratio', this.hwType + '/ratio?item_id=' + this.itemId, 'ratio'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/latency?item_id=' + this.itemId, 'latency'));
        for (let childSubsystem of subsystems) {
            let childSubsystemItems = await this.objectItemsRepository.findBy({
                hw_type: this.hwType,
                subsystem: childSubsystem,
            });
            if (childSubsystemItems !== undefined) {
                let path = '';
                let childId = await (0, dataSource_1.getDataSource)()
                    .createQueryBuilder()
                    .select('child')
                    .from('item_relations', 'ItemRelations')
                    .where('parent = :parent', { parent: this.itemId })
                    .getRawOne();
                if (childId !== undefined) {
                    path = this.hwType + '/pdbs' + (this.itemId !== null ? '?ids=' + this.itemId : '');
                    menuItems.push(new menuResponse_dto_1.MenuFolder('PDBs', path, this.hwType, childSubsystem, this.itemId, OracledbPdbsFolder));
                }
            }
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.OracledbInstanceFolder = OracledbInstanceFolder;
class OracledbPage extends AbstractMenu_1.AbstractPage {
    constructor() {
        super(...arguments);
        this.hwType = 'oracledb';
        this.rootFolder = OracledbRootFolder;
    }
}
exports.OracledbPage = OracledbPage;
class OracledbSingleItemPage extends OracledbPage {
    constructor() {
        super(...arguments);
        this.parentSubsystem = 'odbfolder';
    }
}
exports.OracledbSingleItemPage = OracledbSingleItemPage;
class OracledbTopPage extends OracledbPage {
    constructor() {
        super(...arguments);
        this.title = 'DB TOP';
    }
    async getPage() {
        const top = new Top_1.Top();
        top.setSubsystem('oracledb', 'instance');
        top.setParentSubsystem('odbfolder');
        top.setAcl(this.request);
        const tabs = await top.genTabs();
        this.page = new pageResponse_dto_1.Page(this.title, tabs);
        return this.page;
    }
}
exports.OracledbTopPage = OracledbTopPage;
class OracledbTotalconfigurationPage extends OracledbPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Configuration';
    }
    async getPage() {
        let title = 'Configuration';
        let tabs = [];
        let uuids = await getAllDbs(this.subsystem, this.hwType, 'all');
        let content = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('CPU', [
            { metric: 'CPUUsagePerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], undefined, undefined, true);
        tabFactory.addTab('Block Changes', [
            { metric: 'DBBlockChangesPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, true);
        tabFactory.addTab('Logical Read', [
            { metric: 'LogicalReadsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, true);
        tabFactory.addTab('Used', [
            { metric: 'used', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], undefined, undefined, true);
        tabFactory.addTab('Free', [
            { metric: 'free', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], undefined, undefined, true);
        tabFactory.addTab('Log size', [
            { metric: 'log_capacity', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], undefined, undefined, true);
        let serverTable = await gen_table('Main info', uuids[0], {
            'DB name': 'DB name',
            'Unique name': 'Unique name',
            'Instance name': 'Instance name',
            'Version': 'Version',
            'Host name': 'Host name',
            'Status': 'Status',
            'Open mode': 'Open mode',
            'Startup': 'Startup',
            'Archive mode': 'Archive mode',
            'Flashback activate': 'Flashback activate',
            'Logins': 'Logins',
            'Force logging': 'Force logging',
            'Instance role': 'Instance role',
            'RAM_GB': 'Memory total\n[GiB]',
            'CPUS': 'CPUs',
            'CDB': 'CDB',
            'Edition': 'Edition',
            'Platform': 'Platform',
            'DBID': 'DBID',
        });
        if (serverTable) {
            content.push(serverTable.generateBox());
        }
        tabs.push({
            title: 'Main',
            content: content,
        });
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbTotalconfigurationPage = OracledbTotalconfigurationPage;
class OracledbHealthstatusPage extends OracledbPage {
    constructor() {
        super(...arguments);
        this.title = 'Health Status';
    }
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatus = await new HealthStatus_1.HealthStatus().setAcl(this.request).useDeviceAliasColumn(true).useClickableAlias(false).useLinkToItem(true).getStatusByParameters("instance", "database", "Database", "oracledb");
        tabs.push({
            title: 'Health Status',
            content: [healthStatus],
        });
        tabs.push({
            title: 'Alert History',
            content: [],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OracledbHealthstatusPage = OracledbHealthstatusPage;
class OracledbConfigurationPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Configuration';
    }
    async getPage() {
        let id = this.itemId;
        let title = 'Configuration';
        let tabs = [];
        let serverTable = await gen_table('Main info', id, {
            'DB name': 'DB name',
            'Unique name': 'Unique name',
            'Instance name': 'Instance name',
            'Version': 'Version',
            'Host name': 'Host name',
            'Status': 'Status',
            'Open mode': 'Open mode',
            'Startup': 'Startup',
            'Archive mode': 'Archive mode',
            'Flashback activate': 'Flashback activate',
            'Logins': 'Logins',
            'Force logging': 'Force logging',
            'Instance role': 'Instance role',
            'RAM_GB': 'Memory total\n[GiB]',
            'CPUS': 'CPUs',
            'CDB': 'CDB',
            'Edition': 'Edition',
            'Platform': 'Platform',
            'DBID': 'DBID',
        });
        tabs.push({
            title: 'Main',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('SGA info', id, {
            'Instance': 'Instance',
            'Pool name': 'Pool name',
            'Pool size MB': 'Pool size\n[MiB]'
        });
        tabs.push({
            title: 'SGA',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('Installed DB components', id, { 'Component': 'Component', 'DATE': 'Date', 'VERSION': 'Version', 'STATUS': 'Status' });
        tabs.push({
            title: 'Installed DB components',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('Upgrade, Downgrade info', id, { 'ID': 'ID', 'DATE': 'Date', 'VERSION': 'Version', 'STATUS': 'Status' });
        tabs.push({
            title: 'Upgrade, Downgrade info',
            content: [serverTable.generateBox()],
        });
        serverTable = await gen_table('PSU, patches info', id, { 'Date': 'Date', 'ID': 'ID', 'NAMESPACE': 'Namespace', 'ACTION': 'Action', 'VERSION': 'Version', 'COMMENTS': 'Comments' });
        tabs.push({
            title: 'PSU, patches info',
            content: [serverTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OracledbConfigurationPage = OracledbConfigurationPage;
class OracledbDatafilesPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.title = 'Datafiles';
    }
    async getPage() {
        let id = this.itemId;
        let title = 'Datafiles';
        let tabs = [];
        let serverTable = await genTable('IO Read Write per datafile', id, [
            'Datafile',
            'Physical Reads',
            'Physical Writes',
            'Avg write wait ms',
            'Avg read wait ms',
            'Read/Write %',
        ]);
        tabs.push({
            title: 'Datafiles',
            content: [serverTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OracledbDatafilesPage = OracledbDatafilesPage;
class OracledbMetrics {
}
exports.OracledbMetrics = OracledbMetrics;
OracledbMetrics.Metric = class extends pageResponse_dto_1.Metric {
    async init() {
        const metric = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, this.subsystem, this.metric);
        if (metric) {
            Object.assign(this, metric);
        }
        return this;
    }
};
OracledbMetrics.BasicDbMetric = class extends OracledbMetrics.Metric {
    constructor(metric, type, subsystem, stacked, order, color) {
        super();
        this.metric = metric;
        this.type = type;
        this.subsystem = subsystem;
        this.stacked = stacked;
        this.order = order;
        this.color = color;
    }
};
OracledbMetrics.CheckpointMetric = class extends OracledbMetrics.Metric {
    constructor() {
        super(...arguments);
        this.subsystem = 'DB';
        this.type = pageResponse_constants_1.CHART_TYPE.line;
        this.stacked = false;
        this.metric = 'buffers_checkpoint';
        this.order = 0;
    }
};
class OracledbOverviewPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Overview';
        this.withItemId = true;
    }
    async getPage() {
        let title = 'Overview';
        let tabs = [];
        let uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        if (uuids == undefined) {
            uuids[0] = this.itemId;
        }
        tabs.push({
            title: 'Overview',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                    graphs: [
                        {
                            metrics: [await new OracledbMetrics.BasicDbMetric('CPUUsagePerSec', pageResponse_constants_1.CHART_TYPE.area, this.subsystem, false, 0).init()],
                            uuids: uuids,
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new OracledbMetrics.BasicDbMetric('CurrentLogonsCount', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('LogonsPerSec', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('ActiveSerialSessions', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('AverageActiveSessions', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('ActiveParallelSessions', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                            ],
                            uuids: uuids,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new OracledbMetrics.BasicDbMetric('dbfilescatteredread', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('dbfilesequentialread', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init(),
                            ],
                            uuids: uuids,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [
                                await new OracledbMetrics.BasicDbMetric('logfilesync', pageResponse_constants_1.CHART_TYPE.line, 'instance', false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('logfilesinglewrite', pageResponse_constants_1.CHART_TYPE.line, 'instance', false, 0).init(),
                                await new OracledbMetrics.BasicDbMetric('logfileparallelwrite', pageResponse_constants_1.CHART_TYPE.line, 'instance', false, 0).init(),
                            ],
                            uuids: uuids,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [await new OracledbMetrics.BasicDbMetric('IORequestsperSecond', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()],
                            uuids: uuids,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                        {
                            type: pageResponse_constants_1.BOX_TYPE.MultiGraphBox,
                            metrics: [await new OracledbMetrics.BasicDbMetric('IOMegabytesperSecond', pageResponse_constants_1.CHART_TYPE.line, this.subsystem, false, 0).init()],
                            uuids: uuids,
                            parent: {
                                label: "Alias",
                                subsystem: "odbfolder"
                            },
                            interval: pageResponse_constants_1.GRAPH_INTERVAL.day,
                            aggregated: true,
                        },
                    ],
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OracledbOverviewPage = OracledbOverviewPage;
class OracledbGlobalcachePage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Global cache';
    }
    async getPage() {
        let title = 'Global cache';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('Avg get time', [
            { metric: 'GlobalCacheAverageCRGetTime', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'GlobalCacheAverageCurrentGetTime', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        tabFactory.addTab('Blocks recieved', [
            { metric: 'GCCRBlockReceivedPerSecond', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'GCCurrentBlockReceivedPerSecond', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbGlobalcachePage = OracledbGlobalcachePage;
class OracledbViewonePage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'View one';
    }
    async getPage() {
        let title = 'View one';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('View one', [
            { metric: 'gccrblock2way', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentblock2way', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrblock3way', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentblock3way', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbViewonePage = OracledbViewonePage;
class OracledbViewtwoPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'View two';
    }
    async getPage() {
        let title = 'View two';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('View two', [
            { metric: 'gccrblockbusy', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrblockcongested', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrgrant2way', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrgrantcongested', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentblockbusy', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentblockcongested', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentgrant2way', color: Color_1.Color.pallete.purpleDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentgrantcongested', color: Color_1.Color.pallete.black, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbViewtwoPage = OracledbViewtwoPage;
class OracledbViewthreePage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'View three';
    }
    async getPage() {
        let title = 'View three';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('View three', [
            { metric: 'gccrblocklost', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentblocklost', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'GlobalCacheBlocksLost', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'GlobalCacheBlocksCorrupted', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrfailure', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentretry', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbViewthreePage = OracledbViewthreePage;
class OracledbViewfourPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'View four';
    }
    async getPage() {
        let title = 'View four';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('View four', [
            { metric: 'gccurrentsplit', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentmultiblockrequest', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccurrentgrantbusy', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrdiskread', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gccrmultiblockrequest', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gcbufferbusyacquire', color: Color_1.Color.pallete.brownDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'gcbufferbusyrelease', color: Color_1.Color.pallete.purpleDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbViewfourPage = OracledbViewfourPage;
class OracledbViewfivePage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'View five';
    }
    async getPage() {
        let title = 'View five';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('View five', [
            { metric: 'gcremaster', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ]);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbViewfivePage = OracledbViewfivePage;
class OracledbCapacityPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Capacity';
    }
    async getPage() {
        let title = 'Capacity';
        let tabs = [];
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", [this.itemId]);
        tabFactory.addTab('Used', [
            { metric: 'used', color: Color_1.Color.pallete.red, default: TabFactory_1.MPDefault.AREA },
            { metric: 'log_capacity', color: Color_1.Color.pallete.blue, default: TabFactory_1.MPDefault.AREA },
            { metric: 'temp_files', color: Color_1.Color.pallete.green, default: TabFactory_1.MPDefault.AREA },
            { metric: 'control_files', color: Color_1.Color.pallete.orange, default: TabFactory_1.MPDefault.AREA },
            { metric: 'free', color: Color_1.Color.pallete.yellow, default: TabFactory_1.MPDefault.AREA },
        ]);
        tabFactory.addTab('Recovery file destination', [
            { metric: 'recoverysize', color: Color_1.Color.pallete.black, default: TabFactory_1.MPDefault.LINE },
            { metric: 'recoveryused', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.AREA },
        ]);
        let serverTable = await gen_table('Online Redo Logs', this.itemId, {
            'Group': 'Group',
            'Thread': 'Thread',
            'Group number': 'Group number',
            'Member': 'Member',
            'Size in MiB': 'Size in MiB',
            'Status': 'Status',
            'Archived': 'Archived',
            'Type': 'Type',
            'RDF': 'RDF',
            'Sequence': 'Sequence',
        });
        tabs.push({
            title: 'Online Redo Logs',
            content: [serverTable.generateBox()],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbCapacityPage = OracledbCapacityPage;
class OracledbHostPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getPage() {
        let title = 'Overview';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getHosts(this.hwType, "host");
        }
        else {
            uuids = await getHosts(this.hwType, "host", this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('CPU %', [
            { metric: 'HostCPUUtilization', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('CPU', [
            { metric: 'CPUUsagePerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('Block changes', [
            { metric: 'DBBlockChangesPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('LogicalReadsPerSec', [
            { metric: 'LogicalReadsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('Used', [
            { metric: 'used', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('Free', [
            { metric: 'free', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        tabFactory.addTab('Log size', [
            { metric: 'log_capacity', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA_STACKED },
        ], "Instance", { label: 'Host', subsystem: 'host' }, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbHostPage = OracledbHostPage;
class OracledbCpuPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
    }
    async getPage() {
        let title = 'CPU';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('CPU %', [
            { metric: 'HostCPUUtilization', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('CPU', [
            { metric: 'CPUUsagePerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.AREA },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('CPU Usage/Txn', [
            { metric: 'CPUUsagePerTxn', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbCpuPage = OracledbCpuPage;
class OracledbIoPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'IO';
    }
    async getPage() {
        let title = 'IO';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Total', [
            { metric: 'IORequestsperSecond', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Physical', [
            { metric: 'PhysicalReadsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'PhysicalWritesPerSec', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbIoPage = OracledbIoPage;
class OracledbDataPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Data';
    }
    async getPage() {
        let title = 'Data';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Total', [
            { metric: 'IOMegabytesperSecond', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Redo', [
            { metric: 'RedoGeneratedPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Physical Data', [
            { metric: 'PhysicalReadBytesPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'PhysicalWriteBytesPerSec', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbDataPage = OracledbDataPage;
class OracledbSgadataPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'SGA data';
    }
    async getPage() {
        let title = 'SGA data';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Block Changes', [
            { metric: 'DBBlockChangesPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Logical Reads', [
            { metric: 'LogicalReadsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbSgadataPage = OracledbSgadataPage;
class OracledbSessionPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Session';
    }
    async getPage() {
        let title = 'Session';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Session', [
            { metric: 'CurrentLogonsCount', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'AverageActiveSessions', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ActiveSerialSessions', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'ActiveParallelSessions', color: Color_1.Color.pallete.orangeDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'LogonsPerSec', color: Color_1.Color.pallete.yellowDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbSessionPage = OracledbSessionPage;
class OracledbSqlqueryPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'SQL query';
    }
    async getPage() {
        let title = 'SQL query';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('User', [
            { metric: 'UserTransactionPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'UserCommitsPerSec', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Cursors', [
            { metric: 'OpenCursorsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'CurrentOpenCursorsCount', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Hard parse', [
            { metric: 'HardParseCountPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Executions', [
            { metric: 'ExecutionsPerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbSqlqueryPage = OracledbSqlqueryPage;
class OracledbNetworkPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Network';
    }
    async getPage() {
        let title = 'Network';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Network', [
            { metric: 'NetworkTrafficVolumePerSec', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbNetworkPage = OracledbNetworkPage;
class OracledbRatioPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Ratio';
    }
    async getPage() {
        let title = 'Ratio';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('Buffer Cache Hit', [
            { metric: 'BufferCacheHitRatio', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('PGA Cache Hit', [
            { metric: 'PGACacheHit', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Memory Sorts', [
            { metric: 'MemorySortsRatio', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Soft Parse', [
            { metric: 'SoftParseRatio', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('CPU Time', [
            { metric: 'DatabaseCPUTimeRatio', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Wait Time', [
            { metric: 'DatabaseWaitTimeRatio', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbRatioPage = OracledbRatioPage;
class OracledbLatencyPage extends OracledbSingleItemPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.title = 'Latency';
    }
    async getPage() {
        let title = 'Latency';
        let tabs = [];
        let uuids = [this.itemId];
        let aggregated = this.total;
        if (this.total === true) {
            uuids = await getAllDbs(this.subsystem, this.hwType, this.itemId);
        }
        const tabFactory = new TabFactory_1.TabFactory(class_constants_1.ClassKey.DATABASE, hwTypeKey_constants_1.HwTypeKey.ORACLEDB, "instance", uuids);
        tabFactory.addTab('DB files read', [
            { metric: 'dbfilescatteredread', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'dbfilesequentialread', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        tabFactory.addTab('DB files write', [
            { metric: 'dbfilesinglewrite', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'dbfileparallelwrite', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        tabFactory.addTab('LOG files write', [
            { metric: 'logfilesync', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'logfilesinglewrite', color: Color_1.Color.pallete.blueDark, default: TabFactory_1.MPDefault.LINE },
            { metric: 'logfileparallelwrite', color: Color_1.Color.pallete.greenDark, default: TabFactory_1.MPDefault.LINE }
        ], undefined, undefined, aggregated);
        tabFactory.addTab('Flashback latency', [
            { metric: 'flashbacklogfilesync', color: Color_1.Color.pallete.redDark, default: TabFactory_1.MPDefault.LINE },
        ], undefined, undefined, aggregated);
        this.page = new pageResponse_dto_1.Page(title, tabs.concat(...tabFactory.getTabs()));
        return this.page;
    }
}
exports.OracledbLatencyPage = OracledbLatencyPage;
class OracledbHosttotalPage extends OracledbHostPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbHosttotalPage = OracledbHosttotalPage;
class OracledbCputotalPage extends OracledbCpuPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbCputotalPage = OracledbCputotalPage;
class OracledbIototalPage extends OracledbIoPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbIototalPage = OracledbIototalPage;
class OracledbDatatotalPage extends OracledbDataPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbDatatotalPage = OracledbDatatotalPage;
class OracledbSgadatatotalPage extends OracledbSgadataPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbSgadatatotalPage = OracledbSgadatatotalPage;
class OracledbSessiontotalPage extends OracledbSessionPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbSessiontotalPage = OracledbSessiontotalPage;
class OracledbSqlquerytotalPage extends OracledbSqlqueryPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbSqlquerytotalPage = OracledbSqlquerytotalPage;
class OracledbNetworktotalPage extends OracledbNetworkPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbNetworktotalPage = OracledbNetworktotalPage;
class OracledbRatiototalPage extends OracledbRatioPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbRatiototalPage = OracledbRatiototalPage;
class OracledbLatencytotalPage extends OracledbLatencyPage {
    constructor() {
        super(...arguments);
        this.subsystem = 'instance';
        this.total = true;
        this.withItemId = true;
    }
}
exports.OracledbLatencytotalPage = OracledbLatencytotalPage;
async function genTable(tableType, id, dict) {
    const itemsPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    let skipFirstColumn = 0;
    if (tableType === 'Main info') {
        skipFirstColumn = 1;
    }
    let serverTable = new Table_1.Table();
    for (let i = skipFirstColumn; i < dict.length; i++) {
        let value = dict[i] !== "m_name" ? dict[i] : "";
        serverTable.addHeader({ value: value, property: value, number: isMetricNumber(value), trim: false });
    }
    let tableRes = await itemsPropertiesRepository.findOneBy({ item_id: id, property_name: tableType });
    if (tableRes) {
        for (const item of JSON.parse(tableRes.property_value)) {
            let row = [];
            for (const [key, value] of Object.entries(item)) {
                let orderI = (dict.findIndex((d) => d === key) - skipFirstColumn);
                if (orderI >= 0) {
                    row.push({
                        order: orderI,
                        value: value,
                    });
                }
            }
            row.sort((a, b) => a['order'] - b['order']);
            serverTable.addRow(row);
        }
    }
    return serverTable;
}
function isMetricNumber(metric) {
    const numberMetrics = [
        'Physical Reads',
        'Physical Writes',
        'Avg write wait ms',
        'Avg read wait ms',
        'Read/Write %',
    ];
    return numberMetrics.includes(metric);
}
async function gen_table(tableType, id, dict) {
    const itemsPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    let serverTable = new Table_1.Table();
    for (const item in dict) {
        let value = dict[item];
        let properties = {};
        if (value.includes("[GiB]")) {
            value = value.replace('\n[GiB]', '');
            properties = {
                prefix: "Gi",
                unit: "bytes",
                shortcut: "GiB",
                number: true,
            };
        }
        serverTable.addHeader({ property: value, value: value, ...properties });
    }
    let rawProperties = Object.keys(dict);
    let tableRes = await itemsPropertiesRepository.findOneBy({ item_id: id, property_name: tableType });
    if (tableRes) {
        let wholeStuff = JSON.parse(tableRes.property_value);
        for (const dbRow of wholeStuff) {
            let row = [];
            for (const rawHeader of rawProperties) {
                let value = dbRow[rawHeader] ? dbRow[rawHeader] : "";
                if (dict[rawHeader].includes("[GiB]")) {
                    value = value * 1024 * 1024 * 1024;
                }
                row.push({
                    value: value,
                });
            }
            serverTable.addRow(row);
        }
        return serverTable;
    }
    else {
        let row = [];
        row.push({
            order: 1,
            value: "value",
        });
        return serverTable.addRow(row);
    }
}
async function getAllDbs(subsystem, hw_type, item_id) {
    let itemsTotal = [];
    let child_vms = [];
    let objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
    let itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
    let vms = await objectItemsRepository.findBy({ hw_type: hw_type, subsystem: subsystem });
    for (let vm of vms) {
        child_vms.push(vm.item_id);
    }
    if (item_id === 'all') {
        return child_vms;
    }
    let items = [];
    let itemRelations = await itemRelationsRepository.findBy({ parent: item_id, child: (0, typeorm_1.In)(child_vms) });
    for (let relation of itemRelations) {
        items.push(relation.child);
    }
    if (!(items.length >= 1)) {
        items.push(item_id);
    }
    return items;
}
async function getHosts(hw_type, subsystem, item_id = undefined) {
    let child_vms = [];
    let objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
    let hosts = await objectItemsRepository.find({ where: { hw_type: hw_type, subsystem: subsystem, item_id: item_id }, relations: { children: true } });
    for (let host of hosts) {
        for (let child of host.children) {
            child_vms.push(child.child);
        }
    }
    return child_vms;
}
//# sourceMappingURL=Oracledb.js.map