import { MenuItem, Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
export declare class OraclevmFolder extends AbstractFolder {
    hwType: string;
}
export declare class OraclevmSubsystemFolder extends OraclevmFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class OraclevmPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class OraclevmSingleItemPage extends OraclevmPage {
    subsystem: string;
}
export declare class OraclevmHeatmapPage extends OraclevmPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OraclevmTopPage extends OraclevmPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OraclevmConfigurationPage extends OraclevmPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OraclevmRootFolder extends OraclevmFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OraclevmManagerFolder extends OraclevmSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OraclevmServerpoolFolder extends OraclevmSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<MenuItem[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OraclevmServerFolder extends OraclevmSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OraclevmVmFolder extends OraclevmSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OraclevmManagertotalsPage extends OraclevmSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class OraclevmServerpooltotalsPage extends OraclevmSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class OraclevmServerPage extends OraclevmSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OraclevmVmPage extends OraclevmSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OraclevmMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            getAggrGraph(type: ChartType, stacked?: boolean, order?: number, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
