import { MenuItem, Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
export declare class OvirtFolder extends AbstractFolder {
    hwType: string;
}
export declare class OvirtSubsystemFolder extends OvirtFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class OvirtPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class OvirtSingleItemPage extends OvirtPage {
    subsystem: string;
    withItemId: boolean;
}
export declare class OvirtHeatmapPage extends OvirtPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OvirtTopPage extends OvirtPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OvirtConfigurationPage extends OvirtPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OvirtOverviewPage extends OvirtPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class OvirtRootFolder extends OvirtFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OvirtDatacenterFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OvirtClusterFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<MenuItem[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OvirtHostFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OvirtHostnicFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OvirtHostnicitemsFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OvirtVmFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class OvirtStoragedomainFolder extends OvirtSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class OvirtStoragedomainitemFolder extends OvirtSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class OvirtClustertotalsPage extends OvirtSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class OvirtHostPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtHostnictotalsPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtHostnicPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtVmPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtStoragedomaintotalsPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtStoragedomainPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtDiskPage extends OvirtSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class OvirtMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            getAggrGraph(type: ChartType, stacked?: boolean, order?: number, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
