import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class PostgresFolder extends AbstractFolder {
    hwType: string;
}
export declare class PostgresSubsystemFolder extends PostgresFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class PostgresRootFolder extends PostgresFolder {
    getChildren(): Promise<any[]>;
}
export declare class PostgresDbfoldersFolder extends PostgresSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class PostgresDbsFolder extends PostgresSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PostgresDbFolder extends PostgresSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class PostgresPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class PostgresSingleItemPage extends PostgresPage {
    subsystem: string;
    parentSubsystem: string;
    parentId: string;
    withItemId: boolean;
}
export declare class PostgresOverviewPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresConfigurationPage extends PostgresSingleItemPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresBgwriterPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresSizePage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresThroughputPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresSessionsPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresLocksPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresSqlqueryPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresWaiteventsPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresTopPage extends PostgresPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresHealthstatusPage extends PostgresPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresRatioPage extends PostgresSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PostgresMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): Promise<any>;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static BasicDbMetric: {
        new (metric: string, type: ChartType, subsystem: string, stacked: boolean, order: number, color?: string): {
            metric: string;
            type: ChartType;
            subsystem: string;
            stacked: boolean;
            order: number;
            color?: string;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CheckpointMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
