import { MenuItem, Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { Request } from 'express';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class PowerPage extends AbstractPage {
    itemId: string;
    request: Request;
    hwType: string;
    page: Page;
    withItemId: boolean;
    rootFolder: Newable<AbstractFolder>;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
}
export declare class PowerFolder extends AbstractFolder {
    itemId: string;
    request: Request;
    hwType: string;
    children?: Array<MenuItem>;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
    getChildren(): Promise<Array<MenuItem>>;
}
export declare class PowerRootFolder extends PowerFolder {
    subRootFolders: Newable<AbstractFolder>[];
    getChildren(): Promise<any[]>;
}
export declare class PowerCmcFolder extends PowerFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerCmcconsoleFolder extends PowerFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerCmcconsolepoolFolder extends PowerFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerCmcconsoleserverFolder extends PowerFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerCmcserverPage extends PowerPage {
    subsystem: string;
    title: string;
    itemId: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerCmcpoolPage extends PowerPage {
    subsystem: string;
    title: string;
    itemId: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerServerFolder extends PowerFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerChildSubsystemFolder extends PowerFolder {
    subsystem: string;
    itemId: string;
    subsystemClass: Newable<any>;
    getChildren(): Promise<any[]>;
}
export declare class PowerTotalFolder extends PowerFolder {
    getChildren(): Promise<any[]>;
}
export declare class PowerChildSubsystemItemsFolder extends PowerChildSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class PowerVmFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerPoolFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerMempoolFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerSeaFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerHeaFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerFiberFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerGenericFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerGenericvFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerGenericvirtualFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerGenericphysicalFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerSharedstoragepoolFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerVirtualethernetFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerSriovlogicalFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerSriovphysicalFolder extends PowerChildSubsystemFolder {
    subsystemClass: Newable<any>;
    subsystem: string;
}
export declare class PowerVmitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerPoolitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerMempoolitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerSeaitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerHeaitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerFiberitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerGenericitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerGenericvitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerGenericvirtualitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerGenericphysicalitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerSharedstoragepoolitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerVirtualethernetitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerSriovlogicalitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare class PowerSriovphysicalitemsFolder extends PowerChildSubsystemItemsFolder {
    subsystem: string;
}
export declare abstract class PowerServerTotalsPage extends PowerPage {
    subsystem: string;
    withItemId: boolean;
}
export declare class PowerSantopologyPage extends PowerPage {
    getPage(): Promise<Page>;
}
export declare class PowerTopPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare abstract class PowerSingleItemPage extends PowerPage {
    subsystem: string;
    parentSubsystem: string;
    parentId: string;
}
export declare class PowerOverviewPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerHeatmapPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerConfigurationPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerRmccheckPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerTotalPage extends PowerPage {
    getPath(): Promise<MenuItem[]>;
}
export declare class PowerServertotalPage extends PowerTotalPage {
    title: string;
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerVmtotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export type LsDiskLineT = {
    disk_size: string;
    path_prop: string;
    label?: string;
    path_info: string;
    path_stat: string;
    status: string;
    statusColor?: string;
};
export type Multilin = {
    wwid: string;
    alias?: string;
    attributes: string;
    paths: string;
    status: string;
    statusColor?: string;
};
export declare class PowerMultipathPage extends PowerTotalPage {
    title: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class PowerPooltotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerSeatotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerFibertotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerGenerictotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerGenericvtotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerGenericvirtualtotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerGenericphysicaltotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerHeatotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerSharedstoragepooltotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerVirtualethernettotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerSriovlogicaltotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerSriovphysicaltotalPage extends PowerTotalPage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerHealthstatusPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerEstimatorPage extends PowerPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerServerPage extends PowerPage {
    subsystem: string;
    title: string;
    itemId: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerServermemoryPage extends PowerPage {
    subsystem: string;
    title: string;
    itemId: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerCmcinstallPage extends PowerPage {
    title: string;
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class PowerCmcconfigurationPage extends PowerPage {
    title: string;
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class PowerCmctotalPage extends PowerPage {
    title: string;
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class PowerCmcconsoleconfigurationPage extends PowerPage {
    title: string;
    subsystem: string;
    itemId: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerServerconfigurationPage extends PowerPage {
    title: string;
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerVmPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerServervmtotalsPage extends PowerServerTotalsPage {
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerServerpooltotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServerseatotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServerfibertotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServergenericvirtualtotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServergenericphysicaltotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServergenerictotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServergenericvtotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServerheatotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServersharedstoragepooltotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServervirtualethernettotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServersriovlogicaltotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerServersriovphysicaltotalsPage extends PowerServerTotalsPage {
    getPage(): Promise<Page>;
}
export declare class PowerPoolPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerMempoolPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class PowerSeaPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerSriovlogicalPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerSriovphysicalPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerVirtualethernetPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerHeaPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerGenericPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerGenericvPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerFiberPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerSharedstoragepoolPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerGenericvirtualPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerGenericphysicalPage extends PowerSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class PowerMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static AggrMetric: {
        new (): {
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static AggrMetricPercent: {
        new (): {
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static AggrSumMetric: {
        new (): {
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerAggrMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerAggrMetricPercent: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerutilizedProcUnitsAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerutilizedProcUnitsMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Servercpu_utilization_coresAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Servercpu_utilization_coresMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Servercpu_utilization_percentAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Servercpu_utilization_percentMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerutilizedProcUnitsPhysicalProcessorAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerpowerReadingAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmAggrMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmAggrPercentMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmAggrSumMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmutilizedProcUnitsAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmutilizedProcUnitsMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmutilizedProcUnitsPercentAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLogicalMemAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmAssignedMemAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmBackedPhysicalMemAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Vmcpu_utilization_coresAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Vmcpu_utilization_coresMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static Vmcpu_utilization_percentAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPacketsAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPacketsAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReadBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static WriteBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static NumofreadsAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static NumofwritesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPhysicalBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPhysicalBytesAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPhysicalPacketsAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPhysicalPacketsAggrMetric: {
        new (): {
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            subsystem: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeasentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeareceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeasentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeareceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FiberwriteBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FiberreadBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FibernumOfReadsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FibernumOfWritesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualwriteBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualreadBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualnumOfReadsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualnumOfWritesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalwriteBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalreadBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalnumOfReadsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalnumOfWritesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericsentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericreceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericsentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericreceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvsentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvreceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvsentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvreceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeasentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeareceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeasentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeareceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolwriteBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolreadBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolnumOfReadsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolnumOfWritesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPhysicalBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPhysicalBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPhysicalPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPhysicalPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalsentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalreceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalsentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalreceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalsentBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalreceivedBytesAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalsentPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalreceivedPacketsAggrMetric: {
        new (): {
            subsystem: string;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPacketsMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPacketsMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPhysicalBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPhysicalBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReceivedPhysicalPacketsMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SentPhysicalPacketsMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ReadBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static WriteBytesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static NumOfReadsMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static NumOfWritesMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            subsystem: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cpu_physical_cores: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cpu_physical_cores_max: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerCpu_utilization_coresMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerCpu_utilization_coresMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerCpu_utilization_percentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerCpu_utilization_percentMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServertotalProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServertotalProcUnitsPercentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServertotalProcUnitsPercentMetricMax: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerconfigurableProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerassignedProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServeravailableProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerassignedProcUnitsPhysicalProcessorMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerutilizedProcUnitsPhysicalProcessorMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerconfiguredProcUnitsPhysicalProcessorMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerborrowedProcUnitsPhysicalProcessorMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServeravailableProcUnitsPhysicalProcessorMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerpowerreadingMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerassignedMinusBorrowedMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            color: string;
            init(): any;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static utilizedProcUnits: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static baseAnyOS: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServercpuInstalled: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseMemory: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerMemoryTotal: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerInstalledMemory: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationLinux: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseLinuxvios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerUtilizationSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcServerBaseSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolbaseAnyOS: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolcpuInstalled: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CmcPoolcpuUtilization: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutes: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMemoryMinutes: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMemoryTotal: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesAix: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesIbmi: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationLinux: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseLinuxvios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesLinux: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesLinux: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesLinuxVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesVios: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesRhel: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesRhcos: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolUtilizationSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolBaseSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredCoreMinutesSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static cmcPoolMeteredMemoryMinutesSles: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmUtilizedProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpu_utilization_coresMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpu_utilization_percentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpu_utilization_coresMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpu_utilization_percentMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmUtilizedProcUnitsMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmEntitledProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMaxVirtualProcessorsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCurrentVirtualProcessorsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmEntitledProcUnitsPercentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmTotalProcUnitsPercentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmTotalProcUnitsPercentMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmBackedPhysicalMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLogicalMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmUtilizedMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmAssignedMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmVirtualpersistentMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerconfigurableMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServerassignedMemToLparsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServeravailableMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServertotalMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static ServersystemFirmwareUtilAssignedMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolassignedProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolutilizedProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolutilizedProcUnitsMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolavailableProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolconfiguredProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolborrowedProcUnitsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PooltotalUtilizedProcUnitsPercentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PooltotalUtilizedProcUnitsPercentMaxMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolAggrPercentMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolAggrMetric: {
        new (): {
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolutilizedProcUnitsAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolutilizedProcUnitsMaxAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static PoolutilizedProcUnitsPercentAggrMetric: {
        new (): {
            metric: string;
            subsystem: string;
            aggregate: MetricAggregate;
            type: ChartType;
            stacked: boolean;
            init(): any;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static MempoolmappedIOMemToLparsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static MempooltotalMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static MempooltotalIOMemMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static MempoolassignedMemToLparsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static MempoolassignedMemToSysFirmwareMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeasentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeareceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeasentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SeareceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalsentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalreceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalsentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovlogicalreceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalsentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalreceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalsentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SriovphysicalreceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeasentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeareceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeasentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HeareceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericsentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericreceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericsentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericreceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvsentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvreceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvsentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvreceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPhysicalBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPhysicalBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetsentPhysicalPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VirtualethernetreceivedPhysicalPacketsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FiberwriteBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FiberreadBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FibernumOfReadsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static FibernumOfWritesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolwriteBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolreadBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolnumOfReadsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static SharedstoragepoolnumOfWritesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualwriteBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualreadBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualnumOfReadsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericvirtualnumOfWritesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalwriteBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalreadBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalnumOfReadsMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static GenericphysicalnumOfWritesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
