"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PowerflexMetrics = exports.PowerflexSystemFolder = exports.PowerflexSystemrebalancePage = exports.PowerflexSystemrebuildPage = exports.PowerflexSystemcapacityPage = exports.PowerflexSystemreplicationPage = exports.PowerflexSystemcachePage = exports.PowerflexSystemlatencyPage = exports.PowerflexSystemdataPage = exports.PowerflexSystemioPage = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const Color_1 = require("../../metrics/Color");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Stor_1 = require("./Stor");
class PowerflexSystemioPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System IO';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System IO';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Total',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'read_io')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.read),
                            new PowerflexMetrics.Metric('system', 'write_io')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.write)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Read',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'read_io')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Write',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'write_io')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemioPage = PowerflexSystemioPage;
class PowerflexSystemdataPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Data';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Data';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Total',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'read')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.read),
                            new PowerflexMetrics.Metric('system', 'write')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.write)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Read',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'read')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Write',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'write')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemdataPage = PowerflexSystemdataPage;
class PowerflexSystemlatencyPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Latency';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Latency';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Total',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'resp_t_r')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.read),
                            new PowerflexMetrics.Metric('system', 'resp_t_w')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.write)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Read',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'resp_t_r')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Write',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'resp_t_w')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemlatencyPage = PowerflexSystemlatencyPage;
class PowerflexSystemcachePage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Cache';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Cache';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Cache Read hit',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'r_cache_hit')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemcachePage = PowerflexSystemcachePage;
class PowerflexSystemreplicationPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Replication';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Replication';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Total',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_in')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.read),
                            new PowerflexMetrics.Metric('system', 'replication_out')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.write)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'RX',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_in')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'TX',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_out')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Apply latency',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_app_resp_t')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'RX latency',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_in_resp_t')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'TX latency',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_out_resp_t')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Journal capacity',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'replication_journal_used')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 1, Color_1.Color.pallete.red),
                            new PowerflexMetrics.Metric('system', 'replication_journal_total')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.metric.total),
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemreplicationPage = PowerflexSystemreplicationPage;
class PowerflexSystemcapacityPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Capacity';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Capacity';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'LAN used',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'capacity_used')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.metric.used)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'LAN capacity',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'capacity_used')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                            new PowerflexMetrics.Metric('system', 'capacity_free')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Net used %',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'capacity_used_percent')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.metric.used)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Raw used',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'raw_capacity_used')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Raw capacity',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'raw_capacity_used')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                            new PowerflexMetrics.Metric('system', 'raw_capacity_free')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemcapacityPage = PowerflexSystemcapacityPage;
class PowerflexSystemrebuildPage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Rebuild';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Rebuild';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Rebuild rate',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'rebuild_rate')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Rebuild pending',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'rebuild_pending')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemrebuildPage = PowerflexSystemrebuildPage;
class PowerflexSystemrebalancePage extends Stor_1.StorPage {
    constructor(itemId) {
        console.log(itemId);
        super('powerflex');
        this.title = 'System Rebalance';
        this.itemId = itemId;
    }
    async getPage() {
        let title = 'System Rebalance';
        let tabs = [];
        if (this.itemId) {
            tabs.push({
                title: 'Rebalance rate',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'rebalance_rate')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
            tabs.push({
                title: 'Rebalance pending',
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [
                            new PowerflexMetrics.Metric('system', 'rebalance_pending')
                                .getGraph(pageResponse_constants_1.CHART_TYPE.area, false, 0, Color_1.Color.pallete.red)
                        ],
                        uuids: [this.itemId],
                        aggregated: false,
                    }
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexSystemrebalancePage = PowerflexSystemrebalancePage;
class PowerflexSystemFolder extends Stor_1.StorSubsystemFolder {
    constructor(itemId) {
        super('powerflex', 'system', itemId);
    }
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/' + this.subsystem + '-io?item_id=' + this.itemId, 'io'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/' + this.subsystem + '-data?item_id=' + this.itemId, 'data'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/' + this.subsystem + '-latency?item_id=' + this.itemId, 'Latency'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Cache', this.hwType + '/' + this.subsystem + '-cache?item_id=' + this.itemId, 'cache'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Replication', this.hwType + '/' + this.subsystem + '-replication?item_id=' + this.itemId, 'replication'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/' + this.subsystem + '-capacity?item_id=' + this.itemId, 'capacity'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Rebalance', this.hwType + '/' + this.subsystem + '-rebalance?item_id=' + this.itemId, 'rebalance'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Rebuild', this.hwType + '/' + this.subsystem + '-rebuild?item_id=' + this.itemId, 'rebuild'));
        return menuItems;
    }
}
exports.PowerflexSystemFolder = PowerflexSystemFolder;
class PowerflexMetrics {
}
exports.PowerflexMetrics = PowerflexMetrics;
PowerflexMetrics.Metric = class extends pageResponse_dto_1.Metric {
    constructor(subsystem, metric) {
        super();
        this.metric = metric;
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.STORAGE, hwTypeKey_constants_1.HwTypeKey.POWERFLEX, subsystem, metric);
        if (definition) {
            Object.assign(this, definition);
        }
    }
    getGraph(type, stacked, order, color) {
        this.type = type;
        this.stacked = stacked ? stacked : false;
        this.order = order ? order : 0;
        this.color = color ? color : undefined;
        return this;
    }
};
//# sourceMappingURL=Powerflex.js.map