import { Newable } from "@xormon/common/menuResponse.dto";
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
import { Page } from "@xormon/common/pageResponse.dto";
export declare namespace Solaris {
    class Folder extends AbstractFolder {
        hwType: string;
    }
    class SPage extends AbstractPage {
        hwType: string;
        withItemId: boolean;
        rootFolder: Newable<AbstractFolder>;
    }
    class RootFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    class LdomFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<any[]>;
    }
    class StandaloneFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<any[]>;
    }
    class ZoneFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    class CdomFolder extends LdomFolder {
        subsystem: string;
    }
    class CdomPage extends SPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    class LdomtotalsPage extends SPage {
        getPage(): Promise<Page>;
    }
    class LdomPage extends SPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    class StandalonePage extends SPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    class ZonePage extends SPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    class CdomtopPage extends SPage {
        title: string;
        subsystem: string;
        withItemId: boolean;
        getPage(): Promise<Page>;
    }
    class LdomtopPage extends CdomtopPage {
        title: string;
        subsystem: string;
    }
    class HeatmapPage extends SPage {
        title: string;
        getPage(): Promise<Page>;
    }
}
