import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class SqlserverFolder extends AbstractFolder {
    hwType: string;
}
export declare class SqlserverSubsystemFolder extends SqlserverFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class SqlserverRootFolder extends SqlserverFolder {
    getChildren(): Promise<any[]>;
}
export declare class SqlserverSqlsfolderFolder extends SqlserverSubsystemFolder {
    subsystem: string;
    parentID: string;
    getChildren(): Promise<any[]>;
}
export declare class SqlserverChildSubsystemFolder extends SqlserverSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class SqlserverDbsFolder extends SqlserverSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class SqlserverDbFolder extends SqlserverSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class SqlserverPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class SqlserverSingleItemPage extends SqlserverPage {
    subsystem: string;
    itemId: string;
    parentSubsystem: string;
    parentId: string;
    withItemId: boolean;
}
export declare class SqlserverOverviewPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverConfigurationPage extends SqlserverSingleItemPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverMemoryPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverBuffersPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverSessionsPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverLatchesPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverWaiteventsPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverCapacityPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverIoPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverDataPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverTopPage extends SqlserverPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverHealthstatusPage extends SqlserverPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverLatencyPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverSqlqueryPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverLocksPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverRatioPage extends SqlserverSingleItemPage {
    subsystem: string;
    title: string;
    getPage(): Promise<Page>;
}
export declare class SqlserverMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): Promise<any>;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static BasicDbMetric: {
        new (metric: string, type: ChartType, subsystem: string, stacked: boolean, order: number, color?: string): {
            metric: string;
            type: ChartType;
            subsystem: string;
            stacked: boolean;
            order: number;
            color?: string;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static CheckpointMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            init(): Promise<any>;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
