import { MenuItem } from "@xormon/common/menuResponse.dto";
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from "@xormon/entity/itemRelation.entity";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
export declare class StoragegridFolder {
    hwType: string;
    children?: Array<MenuItem>;
    itemId: string;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    constructor(itemId?: string);
}
export declare class StoragegridSiteFolder extends StoragegridFolder {
    getChildren(): Promise<any[]>;
    getPath(): Promise<void>;
}
export declare class StoragegridSiteitemFolder extends StoragegridFolder {
    getChildren(): Promise<any[]>;
}
export declare class StoragegridDriveFolder extends StoragegridFolder {
    getChildren(): Promise<any[]>;
}
export declare class StoragegridNodeFolder extends StoragegridFolder {
    getChildren(): Promise<any[]>;
}
export declare class StoragegridPortFolder extends StoragegridFolder {
    getChildren(): Promise<any[]>;
}
export declare class StoragegridSubsystemItemsFolder extends StoragegridFolder {
    subsystem: string;
    constructor(itemId: string, subsystem: string);
    getChildren(): Promise<any[]>;
}
export declare class StoragegridPortitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId: string);
}
export declare class StoragegridDriveitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId: string);
}
export declare class StoragegridNodeitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId: string);
}
export declare class StoragegridPage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<MenuItem[]>;
}
export declare class StoragegridSiteTotalPage extends StoragegridPage {
    itemId: string;
    constructor(itemId: string);
    getPath(): Promise<MenuItem[]>;
}
export declare abstract class StoragegridSingleItemPage extends StoragegridPage {
    subsystem: string;
    itemId: string;
    constructor(itemId: string);
    getPath(subsystem?: string, items?: boolean): Promise<MenuItem[]>;
}
export declare abstract class StoragegridSiteItemPage extends StoragegridSingleItemPage {
    subsystem: string;
    constructor(itemId: string, subsystem: string);
    getPath(subsystem?: string, items?: boolean): Promise<MenuItem[]>;
}
export declare class StoragegridSitePage extends StoragegridSingleItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodecpuPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodecapacitygraphPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodememoryPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodenetworkPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodes3Page extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodeswiftPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodeilmPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodeloadbalancerPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridNodePage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
    getPath(): Promise<MenuItem[]>;
}
export declare class StoragegridDriveioPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridDrivedataPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridDrivelatencyPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridPortdataPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridPorterrorPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridPortdropPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridDrivePage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
    getPath(): Promise<MenuItem[]>;
}
export declare class StoragegridPortPage extends StoragegridSiteItemPage {
    constructor(itemId: string);
    getPage(): Promise<Page>;
    getPath(): Promise<MenuItem[]>;
}
export declare class StoragegridCpuPage extends StoragegridSiteTotalPage {
    title: string;
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class StoragegridCapacitygraphPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridMemoryPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridNetworkPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridS3Page extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridSwiftPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridIlmPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridLoadbalancerPage extends StoragegridSiteTotalPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class StoragegridCapacityPage extends StoragegridPage {
    getPage(): Promise<Page>;
}
export declare class StoragegridMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
