"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoragegridMetrics = exports.StoragegridCapacityPage = exports.StoragegridLoadbalancerPage = exports.StoragegridIlmPage = exports.StoragegridSwiftPage = exports.StoragegridS3Page = exports.StoragegridNetworkPage = exports.StoragegridMemoryPage = exports.StoragegridCapacitygraphPage = exports.StoragegridCpuPage = exports.StoragegridPortPage = exports.StoragegridDrivePage = exports.StoragegridPortdropPage = exports.StoragegridPorterrorPage = exports.StoragegridPortdataPage = exports.StoragegridDrivelatencyPage = exports.StoragegridDrivedataPage = exports.StoragegridDriveioPage = exports.StoragegridNodePage = exports.StoragegridNodeloadbalancerPage = exports.StoragegridNodeilmPage = exports.StoragegridNodeswiftPage = exports.StoragegridNodes3Page = exports.StoragegridNodenetworkPage = exports.StoragegridNodememoryPage = exports.StoragegridNodecapacitygraphPage = exports.StoragegridNodecpuPage = exports.StoragegridSitePage = exports.StoragegridSiteItemPage = exports.StoragegridSingleItemPage = exports.StoragegridSiteTotalPage = exports.StoragegridPage = exports.StoragegridNodeitemsFolder = exports.StoragegridDriveitemsFolder = exports.StoragegridPortitemsFolder = exports.StoragegridSubsystemItemsFolder = exports.StoragegridPortFolder = exports.StoragegridNodeFolder = exports.StoragegridDriveFolder = exports.StoragegridSiteitemFolder = exports.StoragegridSiteFolder = exports.StoragegridFolder = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const itemRelation_entity_1 = require("../../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../../entity/objectItem.entity");
const Color_1 = require("../../metrics/Color");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const class_constants_1 = require("../../../common/constants/class.constants");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Menu = require("./Menu");
const Stor_1 = require("./Stor");
const CapacityTableBuilder_1 = require("./CapacityTableBuilder");
class StoragegridFolder {
    constructor(itemId) {
        this.hwType = hwTypeKey_constants_1.HwTypeKey.STORAGEGRID;
        this.objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
        this.itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
        if (itemId !== null) {
            this.itemId = itemId.toString();
        }
    }
}
exports.StoragegridFolder = StoragegridFolder;
class StoragegridSiteFolder extends StoragegridFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('CPU', this.hwType + '/cpu?item_id=' + this.itemId, 'cpu'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/capacity-graph?item_id=' + this.itemId, 'capacity-graph'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Memory', this.hwType + '/memory?item_id=' + this.itemId, 'memory'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/network?item_id=' + this.itemId, 'network'));
        menuItems.push(new menuResponse_dto_1.MenuLink('S3', this.hwType + '/s3?item_id=' + this.itemId, 's3'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Swift', this.hwType + '/swift?item_id=' + this.itemId, 'swift'));
        menuItems.push(new menuResponse_dto_1.MenuLink('ILM', this.hwType + '/ilm?item_id=' + this.itemId, 'ilm'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Load balancer', this.hwType + '/load-balancer?item_id=' + this.itemId, 'load-balancer'));
        let sites = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: 'site',
        });
        sites.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let site of sites) {
            let path = this.hwType + '/site-item?ids=' + site.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(site.label, path, this.hwType, 'site-item', site.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
    async getPath() {
    }
}
exports.StoragegridSiteFolder = StoragegridSiteFolder;
class StoragegridSiteitemFolder extends StoragegridFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Totals', this.hwType + '/site?item_id=' + this.itemId, 'site'));
        const subsystems = ['Node', 'Drive', 'Port'];
        for (let subsystem of subsystems) {
            let path = this.hwType + '/' + subsystem + '?ids=' + this.itemId;
            menuItems.push(new menuResponse_dto_1.MenuFolder(subsystem, path, this.hwType, subsystem.toLowerCase(), this.itemId));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.StoragegridSiteitemFolder = StoragegridSiteitemFolder;
class StoragegridDriveFolder extends StoragegridFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('IO', this.hwType + '/drive-io?item_id=' + this.itemId, 'drive-io'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/drive-data?item_id=' + this.itemId, 'drive-data'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Latency', this.hwType + '/drive-latency?item_id=' + this.itemId, 'drive-latency'));
        let path = this.hwType + '/drive-items?ids=' + this.itemId;
        menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, 'drive', this.itemId));
        this.children = menuItems;
        return menuItems;
    }
}
exports.StoragegridDriveFolder = StoragegridDriveFolder;
class StoragegridNodeFolder extends StoragegridFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('CPU', this.hwType + '/node-cpu?item_id=' + this.itemId, 'node-cpu'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Capacity', this.hwType + '/node-capacity-graph?item_id=' + this.itemId, 'node-capacity-graph'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Memory', this.hwType + '/node-memory?item_id=' + this.itemId, 'node-memory'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Network', this.hwType + '/node-network?item_id=' + this.itemId, 'node-network'));
        menuItems.push(new menuResponse_dto_1.MenuLink('S3', this.hwType + '/node-s3?item_id=' + this.itemId, 's3'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Swift', this.hwType + '/node-swift?item_id=' + this.itemId, 'node-swift'));
        menuItems.push(new menuResponse_dto_1.MenuLink('ILM', this.hwType + '/node-ilm?item_id=' + this.itemId, 'node-ilm'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Load balancer', this.hwType + '/node-load-balancer?item_id=' + this.itemId, 'node-load-balancer'));
        let path = this.hwType + '/node-items?ids=' + this.itemId;
        menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, 'node', this.itemId));
        this.children = menuItems;
        return menuItems;
    }
}
exports.StoragegridNodeFolder = StoragegridNodeFolder;
class StoragegridPortFolder extends StoragegridFolder {
    async getChildren() {
        let menuItems = [];
        menuItems.push(new menuResponse_dto_1.MenuLink('Data', this.hwType + '/port-data?item_id=' + this.itemId, 'port-data'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Error', this.hwType + '/port-error?item_id=' + this.itemId, 'port-error'));
        menuItems.push(new menuResponse_dto_1.MenuLink('Drop', this.hwType + '/port-drop?item_id=' + this.itemId, 'port-drop'));
        let path = this.hwType + '/port-items?ids=' + this.itemId;
        menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, 'port', this.itemId));
        this.children = menuItems;
        return menuItems;
    }
}
exports.StoragegridPortFolder = StoragegridPortFolder;
class StoragegridSubsystemItemsFolder extends StoragegridFolder {
    constructor(itemId, subsystem) {
        super(itemId);
        this.subsystem = subsystem;
    }
    async getChildren() {
        let menuItems = [];
        const items = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: this.subsystem
            }
        });
        for (let item of items) {
            menuItems.push(new menuResponse_dto_1.MenuLink(item.label, this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id, item.subsystem));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.StoragegridSubsystemItemsFolder = StoragegridSubsystemItemsFolder;
class StoragegridPortitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId) {
        super(itemId, 'port');
    }
}
exports.StoragegridPortitemsFolder = StoragegridPortitemsFolder;
class StoragegridDriveitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId) {
        super(itemId, 'drive');
    }
}
exports.StoragegridDriveitemsFolder = StoragegridDriveitemsFolder;
class StoragegridNodeitemsFolder extends StoragegridSubsystemItemsFolder {
    constructor(itemId) {
        super(itemId, 'node');
    }
}
exports.StoragegridNodeitemsFolder = StoragegridNodeitemsFolder;
class StoragegridPage {
    constructor() {
        this.hwType = hwTypeKey_constants_1.HwTypeKey.STORAGEGRID;
        this.objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
        this.itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
    }
    async getPath() {
        let root = new Stor_1.StorRootFolder(this.hwType);
        let menuItems = await root.getChildren();
        for (const menuItem of menuItems) {
            if (menuItem.subsystem === 'device') {
                const deviceFolder = new Stor_1.StorDeviceFolder(this.hwType, 'device', menuItem.itemId);
                menuItem.children = await deviceFolder.getChildren();
            }
        }
        return menuItems;
    }
}
exports.StoragegridPage = StoragegridPage;
class StoragegridSiteTotalPage extends StoragegridPage {
    constructor(itemId) {
        super();
        this.itemId = itemId;
    }
    async getPath() {
        let menuItems = await super.getPath();
        for (const menuItem of menuItems) {
            if (menuItem.subsystem === 'device' && menuItem.itemId === this.itemId) {
                for (const deviceItem of menuItem.children) {
                    if (deviceItem.subsystem === 'site') {
                        const site = new StoragegridSiteFolder(this.itemId);
                        deviceItem.children = await site.getChildren();
                    }
                }
            }
        }
        return menuItems;
    }
}
exports.StoragegridSiteTotalPage = StoragegridSiteTotalPage;
class StoragegridSingleItemPage extends StoragegridPage {
    constructor(itemId) {
        super();
        this.itemId = itemId;
    }
    async getPath(subsystem, items) {
        let root = new Stor_1.StorRootFolder(this.hwType);
        let menuItems = await root.getChildren();
        const item = await this.objectItemsRepository.findOne({
            where: {
                item_id: this.itemId
            },
            relations: {
                parents: {
                    _parent: true
                }
            }
        });
        const device = item.parents.find(parent => parent._parent.subsystem === 'device');
        const siteId = item.subsystem === 'site' ? this.itemId : item.parents.find(parent => parent._parent.subsystem === 'site')._parent.item_id;
        for (const menuItem of menuItems) {
            if (device) {
                if (menuItem.subsystem === 'device' && menuItem.itemId === device._parent.item_id) {
                    const deviceFolder = new Stor_1.StorDeviceFolder(this.hwType, 'device', device._parent.item_id);
                    menuItem.children = await deviceFolder.getChildren();
                    for (const deviceItem of menuItem.children) {
                        if (deviceItem.subsystem === 'site') {
                            const siteFolder = new StoragegridSiteFolder(device._parent.item_id);
                            deviceItem.children = await siteFolder.getChildren();
                            for (const siteItem of deviceItem.children) {
                                if (siteItem.subsystem === 'site-item' && siteItem.itemId === siteId) {
                                    const siteItemFolder = new StoragegridSiteitemFolder(siteId);
                                    siteItem.children = await siteItemFolder.getChildren();
                                    if (subsystem) {
                                        for (const subsystemItem of siteItem.children) {
                                            if (subsystemItem.subsystem === subsystem) {
                                                const subsystemLabel = subsystem.charAt(0).toUpperCase() + subsystem.slice(1);
                                                const subsystemFolder = new Menu['Storagegrid' + subsystemLabel + 'Folder'](siteId);
                                                subsystemItem.children = await subsystemFolder.getChildren();
                                                if (items) {
                                                    for (const subsytemChild of subsystemItem.children) {
                                                        if (subsytemChild.title === 'Items') {
                                                            const itemsFolder = new Menu['Storagegrid' + subsystemLabel + 'itemsFolder'](siteId);
                                                            subsytemChild.children = await itemsFolder.getChildren();
                                                            break;
                                                        }
                                                    }
                                                }
                                                break;
                                            }
                                        }
                                    }
                                    else {
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return menuItems;
    }
}
exports.StoragegridSingleItemPage = StoragegridSingleItemPage;
class StoragegridSiteItemPage extends StoragegridSingleItemPage {
    constructor(itemId, subsystem) {
        super(itemId);
        this.subsystem = subsystem;
    }
    async getPath(subsystem, items) {
        console.log(this.subsystem);
        return await super.getPath(this.subsystem ? this.subsystem : subsystem, items);
    }
}
exports.StoragegridSiteItemPage = StoragegridSiteItemPage;
class StoragegridSitePage extends StoragegridSingleItemPage {
    constructor(itemId) {
        super(itemId);
    }
    async getPage() {
        const site = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        let title = site.label;
        let tabs = [];
        tabs.push({
            title: 'Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('site', 'capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'capacity_total')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.pallete.greenDark, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Metadata Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('site', 'metadata_capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'metadata_capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'metadata_capacity_total')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.pallete.black, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'CPU %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'cpu_busy').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'memory_used_percent').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LAN In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'network_rx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LAN Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'network_tx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'S3 Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'S3 Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'S3 Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'S3 Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'S3 Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Swift Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Swift Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Swift Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Swift Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'Swift Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'ILM Queue All',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_all').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'ILM Queue Client',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_client').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'ILM Queue Background',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_background').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'ILM Eval Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_eval_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'ILM Scan Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_scan_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LB In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_rx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LB Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_tx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LB request rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_request_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        tabs.push({
            title: 'LB error rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [site.item_id],
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridSitePage = StoragegridSitePage;
class StoragegridNodecpuPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Cpu';
        let tabs = [];
        tabs.push({
            title: 'CPU %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'cpu_busy').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodecpuPage = StoragegridNodecpuPage;
class StoragegridNodecapacitygraphPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Capacity';
        let tabs = [];
        tabs.push({
            title: 'Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('node', 'capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: nodeIds,
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'capacity_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Metadata Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'metadata_capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('node', 'metadata_capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: nodeIds,
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Metadata Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'metadata_capacity_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Data Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'user_data_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodecapacitygraphPage = StoragegridNodecapacitygraphPage;
class StoragegridNodememoryPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Memory';
        let tabs = [];
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'memory_used_percent').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodememoryPage = StoragegridNodememoryPage;
class StoragegridNodenetworkPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Network';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'network_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'network_rx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'network_tx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Error',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Error Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'read_error').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Error In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'write_error').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodenetworkPage = StoragegridNodenetworkPage;
class StoragegridNodes3Page extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node S3';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodes3Page = StoragegridNodes3Page;
class StoragegridNodeswiftPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Swift';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodeswiftPage = StoragegridNodeswiftPage;
class StoragegridNodeilmPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Ilm';
        let tabs = [];
        tabs.push({
            title: 'Queue All',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_all').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Queue Client',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_client').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Queue Background',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_background').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Eval Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_eval_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Scan Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_scan_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodeilmPage = StoragegridNodeilmPage;
class StoragegridNodeloadbalancerPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const nodeIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'node',
            }, relations: {
                parents: true
            }
        })).map(node => node.item_id);
        let title = 'Node Load balancer';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_rx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_tx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Request Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_request_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Error Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: nodeIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNodeloadbalancerPage = StoragegridNodeloadbalancerPage;
class StoragegridNodePage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'node');
    }
    async getPage() {
        const node = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        let title = node.label;
        let tabs = [];
        tabs.push({
            title: 'Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                        new StoragegridMetrics.Metric('node', 'capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green),
                        new StoragegridMetrics.Metric('node', 'capacity_total')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.pallete.black),
                    ],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Metadata Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'metadata_capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                        new StoragegridMetrics.Metric('node', 'metadata_capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green),
                        new StoragegridMetrics.Metric('node', 'metadata_capacity_total')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 2, Color_1.Color.pallete.black),
                    ],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'CPU %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'cpu_busy').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'CPU Detail',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'cpu_system')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                        new StoragegridMetrics.Metric('node', 'cpu_user')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.blue),
                        new StoragegridMetrics.Metric('node', 'cpu_wait')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 2, Color_1.Color.pallete.green),
                        new StoragegridMetrics.Metric('node', 'cpu_steal')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 3, Color_1.Color.pallete.brown),
                        new StoragegridMetrics.Metric('node', 'cpu_softirq')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 4, Color_1.Color.pallete.orange),
                        new StoragegridMetrics.Metric('node', 'cpu_nice')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 5, Color_1.Color.pallete.purple),
                    ],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'memory_used_percent').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Memory',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('node', 'memory_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red),
                        new StoragegridMetrics.Metric('node', 'memory_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green),
                    ],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LAN In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'network_rx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LAN Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'network_tx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LAN In err',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'read_error').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LAN Out err',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'write_error').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'S3 Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'S3 Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'S3 Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'S3 Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'S3 Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 's3_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Swift Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Swift Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Swift Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Swift Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Swift Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'swift_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'ILM queue all',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_all').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'ILM queue client',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_client').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'ILM queue background',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_background').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'ILM eval rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_queue_eval_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'ILM scan rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'ilm_scan_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LB In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_rx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LB Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_tx').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LB request rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_request_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'LB error rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('node', 'lb_error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [node.item_id],
                    aggregated: false,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
    async getPath() {
        return await super.getPath('node', true);
    }
}
exports.StoragegridNodePage = StoragegridNodePage;
class StoragegridDriveioPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'drive');
    }
    async getPage() {
        const driveIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'drive',
            }, relations: {
                parents: true
            }
        })).map(drive => drive.item_id);
        let title = 'Drive Io';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'io_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'read_io').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'write_io').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridDriveioPage = StoragegridDriveioPage;
class StoragegridDrivedataPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'drive');
    }
    async getPage() {
        const driveIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'drive',
            }, relations: {
                parents: true
            }
        })).map(drive => drive.item_id);
        let title = 'Drive Data';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'data_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'read').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'write').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridDrivedataPage = StoragegridDrivedataPage;
class StoragegridDrivelatencyPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'drive');
    }
    async getPage() {
        const driveIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'drive',
            }, relations: {
                parents: true
            }
        })).map(drive => drive.item_id);
        let title = 'Drive Latency';
        let tabs = [];
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'resp_t_r').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'resp_t_w').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: driveIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridDrivelatencyPage = StoragegridDrivelatencyPage;
class StoragegridPortdataPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'port');
    }
    async getPage() {
        const portIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'port',
            }, relations: {
                parents: true
            }
        })).map(port => port.item_id);
        let title = 'Port Data';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'data_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridPortdataPage = StoragegridPortdataPage;
class StoragegridPorterrorPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'port');
    }
    async getPage() {
        const portIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'port',
            }, relations: {
                parents: true
            }
        })).map(port => port.item_id);
        let title = 'Port Error';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read_error').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write_error').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridPorterrorPage = StoragegridPorterrorPage;
class StoragegridPortdropPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'port');
    }
    async getPage() {
        const portIds = (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: 'port',
            }, relations: {
                parents: true
            }
        })).map(port => port.item_id);
        let title = 'Port Drop';
        let tabs = [];
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'drop_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read_drop').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write_drop').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: portIds,
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridPortdropPage = StoragegridPortdropPage;
class StoragegridDrivePage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'drive');
    }
    async getPage() {
        const drive = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        let title = drive.label;
        let tabs = [];
        tabs.push({
            title: 'IO Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'read_io').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'IO Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'write_io').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'read').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'write').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Latency Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'resp_t_r').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Latency Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('drive', 'resp_t_w').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [drive.item_id],
                    aggregated: false,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
    async getPath() {
        return await super.getPath('drive', true);
    }
}
exports.StoragegridDrivePage = StoragegridDrivePage;
class StoragegridPortPage extends StoragegridSiteItemPage {
    constructor(itemId) {
        super(itemId, 'port');
    }
    async getPage() {
        const port = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        let title = port.label;
        let tabs = [];
        tabs.push({
            title: 'Read',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Write',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Read error',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read_error').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Write error',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write_error').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Read drop',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'read_drop').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Write drop',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('port', 'write_drop').getGraph(pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.redDark)],
                    uuids: [port.item_id],
                    aggregated: false,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
    async getPath() {
        return await super.getPath('port', true);
    }
}
exports.StoragegridPortPage = StoragegridPortPage;
class StoragegridCpuPage extends StoragegridSiteTotalPage {
    constructor(itemId) {
        super(itemId);
        this.title = 'CPU';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'CPU %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'cpu_busy').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridCpuPage = StoragegridCpuPage;
class StoragegridCapacitygraphPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'Capacity';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('site', 'capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: sites.map(item => item.item_id),
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'capacity_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Metadata Capacity',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [
                        new StoragegridMetrics.Metric('site', 'metadata_capacity_used')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                        new StoragegridMetrics.Metric('site', 'metadata_capacity_free')
                            .getGraph(pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum),
                    ],
                    uuids: sites.map(item => item.item_id),
                    aggregated: false,
                },
            ],
        });
        tabs.push({
            title: 'Metadata Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'metadata_capacity_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Data Used',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'user_data_used').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridCapacitygraphPage = StoragegridCapacitygraphPage;
class StoragegridMemoryPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'Memory';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Memory %',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'memory_used_percent').getGraph(pageResponse_constants_1.CHART_TYPE.line, false)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridMemoryPage = StoragegridMemoryPage;
class StoragegridNetworkPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'Network';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'network_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'network_rx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'network_tx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridNetworkPage = StoragegridNetworkPage;
class StoragegridS3Page extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'S3';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 's3_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridS3Page = StoragegridS3Page;
class StoragegridSwiftPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'Swift';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Ingest',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ingested').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Retrieve',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_retrieved').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Successful',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_successful').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Failed',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_failed').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Unauthorized',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'swift_ops_unauthorized').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridSwiftPage = StoragegridSwiftPage;
class StoragegridIlmPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'ILM';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Queue All',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_all').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Queue Client',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_client').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Queue Background',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_background').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Eval Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_queue_eval_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Scan Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'ilm_scan_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridIlmPage = StoragegridIlmPage;
class StoragegridLoadbalancerPage extends StoragegridSiteTotalPage {
    constructor() {
        super(...arguments);
        this.title = 'Load balancer';
    }
    async getPage() {
        let title = this.title;
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: 'site'
            }
        });
        tabs.push({
            title: 'Total',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_total').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'In',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_rx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Out',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_tx').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Request Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_request_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        tabs.push({
            title: 'Error Rate',
            content: [
                {
                    type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                    metrics: [new StoragegridMetrics.Metric('site', 'lb_error_rate').getGraph(pageResponse_constants_1.CHART_TYPE.area, true)],
                    uuids: sites.map(item => item.item_id),
                    aggregated: true,
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridLoadbalancerPage = StoragegridLoadbalancerPage;
class StoragegridCapacityPage extends StoragegridPage {
    async getPage() {
        let tabs = [];
        const sites = await this.objectItemsRepository.find({
            where: {
                subsystem: 'site',
                hw_type: hwTypeKey_constants_1.HwTypeKey.STORAGEGRID,
            }
        });
        tabs.push({
            title: 'Capacity',
            content: [
                await new CapacityTableBuilder_1.CapacityTableBuilder("site", null)
                    .setItemLabel("Site")
                    .addItems(sites.map(it => it.item_id))
                    .addDefaultMetrics()
                    .addUsed()
                    .addTotal()
                    .generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page("Capacity", tabs);
        return this.page;
    }
}
exports.StoragegridCapacityPage = StoragegridCapacityPage;
class StoragegridMetrics {
}
exports.StoragegridMetrics = StoragegridMetrics;
StoragegridMetrics.Metric = class extends pageResponse_dto_1.Metric {
    constructor(subsystem, metric) {
        super();
        this.metric = metric;
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.STORAGE, hwTypeKey_constants_1.HwTypeKey.STORAGEGRID, subsystem, metric);
        if (definition) {
            Object.assign(this, definition);
        }
    }
    getGraph(type, stacked, order, color, aggregate) {
        this.type = type;
        this.stacked = stacked ? stacked : false;
        this.order = order ? order : 0;
        this.color = color ? color : undefined;
        this.aggregate = aggregate ? aggregate : undefined;
        return this;
    }
};
//# sourceMappingURL=Storagegrid.js.map