import { Metric, GraphBaseParent, Tab } from "@xormon/common/pageResponse.dto";
import { HwTypeKey } from '@xormon/common/constants/hwTypeKey.constants';
import { ClassKey } from '@xormon/common/constants/class.constants';
type MetricWithDefault = Partial<Metric> & {
    default?: string;
};
type MetricParamsDefault = Partial<MetricWithDefault>;
export declare enum MPDefault {
    AREA = "area",
    LINE = "line",
    AREA_STACKED = "area_stacked",
    LINE_STACKED = "line_stacked",
    READ_LINE_AGGR = "r_line_aggr",
    WRITE_LINE_AGGR = "w_line_aggr",
    READ_LINE = "r_line",
    WRITE_LINE = "w_line",
    LINE_AGGR = "line_aggr",
    AREA_AGGR = "area_aggr"
}
export declare const defaultPicker: {
    [key in MPDefault]: MetricParamsDefault;
};
export declare class TabFactory {
    private _class;
    private hwType;
    private subsystem;
    private itemIds;
    private tabs;
    constructor(_class: ClassKey, hwType: HwTypeKey, subsystem: string, itemIds: string[]);
    createTab: (title: string, mp: MetricWithDefault[] | MetricWithDefault, label?: string, parent?: GraphBaseParent, setAggregated?: boolean) => {
        title: string;
        content: import("@xormon/common/pageResponse.dto").FourGraphBox[];
    };
    addTab(title: string, mp: MetricWithDefault[] | MetricWithDefault, label?: string, parent?: GraphBaseParent, setAggregated?: boolean): void;
    getTabs(): Tab<import("@xormon/common/pageResponse.dto").Box>[];
    private setDefaults;
    setItems(itemIds: string[]): void;
    setSubsystem(subsystem: string): void;
}
export {};
