import { MenuItem } from '@xormon/common/menuResponse.dto';
import { Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
declare class XormonFolder {
    children?: Array<MenuItem>;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
}
export declare class ApplicationFolder extends XormonFolder {
    hwType: string;
}
export declare class DatabaseFolder extends XormonFolder {
    hwType: string;
}
export declare class ApplicationRootFolder extends ApplicationFolder {
    getChildren(): Promise<any[]>;
}
export declare class DatabaseRootFolder extends DatabaseFolder {
    getChildren(): Promise<any[]>;
}
export declare class DatabaseTechnologiesFolder extends DatabaseFolder {
    getChildren(): Promise<any[]>;
}
export declare class DatabasePage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<any[]>;
}
export declare class DatabaseTotalPage extends DatabasePage {
    getPage(): Promise<Page>;
}
export declare class DatabaseHwtypePage extends DatabasePage {
    itemId: string;
    constructor(itemId: string);
    getPage(): Promise<Page>;
}
export declare class ApplicationPage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<any[]>;
}
export declare class ApplicationTasksPage extends ApplicationPage {
    getPage(): Promise<Page>;
}
export {};
