import { TimeseriesItem } from "@xormon/common/timeseriesResponse.dto";
import { IMetricItem } from './MetricsWrapper';
import { Request } from "express";
interface PreparedMetricData {
    start: number;
    end: number;
    interval: number;
    timeseries: number[];
}
interface PreparedMetric {
    [metric: string]: PreparedMetricData;
}
interface PreparedItem {
    [item_id: string]: PreparedMetric;
}
interface WeightedItem {
    value: number;
    weight: number;
}
export declare class MetricsHelper {
    static prepareTable(metricsItem: object, metadata: object, uuids: string[], interval: number, objectItemsById: object, parentsById?: object, metric?: string, path?: string, request?: Request): Promise<TimeseriesItem[]>;
    static prepareData(metrics: IMetricItem): PreparedItem;
    static calculateWeightedAverage(data: WeightedItem[][]): number[];
    static handleWeightedAverage(metricsItem: any, metric: string, start: number, end: number): Promise<TimeseriesItem[]>;
}
export {};
