import { EntityMetadata } from "typeorm";
export interface Interval {
    label: string;
    interval: string;
    start_offset: string;
    end_offset: string;
    schedule_interval: string;
    retention_policy: string;
    chunk_interval: string;
    compress_after?: string;
    materialized?: boolean;
    minValues?: number;
}
interface MaxMetric {
    [hw_type: string]: {
        [subsystem: string]: string[];
    };
}
export declare class TableGenerator {
    static rawDataInterval: Partial<Interval>;
    private static withoutMinValues;
    static intervals: Interval[];
    private static winstonLogger;
    private static sumMetrics;
    static getMaxMetricsByClass(): MaxMetric;
    static getMaxMetrics(): Promise<MaxMetric>;
    static createPerformanceTableFromEntity(entity: EntityMetadata): Promise<void>;
    private static getInitialTime;
}
export {};
