"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetricsController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const basicResponse_dto_1 = require("../../common/basicResponse.dto");
const timeseriesRequest_contants_1 = require("../../common/constants/timeseriesRequest.contants");
const timeseriesRequest_dto_1 = require("../../common/timeseriesRequest.dto");
const URL_1 = require("../menu/menu/URL");
const rawbody = require("raw-body");
const Color_1 = require("./Color");
;
;
const Metric_1 = require("./Metric");
const MetricsHelper_1 = require("./MetricsHelper");
const MetricsTransform_1 = require("./MetricsTransform");
const MetricsWrapper_1 = require("./MetricsWrapper");
const metrics_service_1 = require("./metrics.service");
const timeserie_interceptor_1 = require("../../interceptor/timeserie.interceptor");
const uuidRequest_interceptor_1 = require("../../interceptor/uuidRequest.interceptor");
const Prediction_1 = require("./Prediction");
const User_1 = require("../users/User");
let MetricsController = class MetricsController {
    constructor(metricsService) {
        this.metricsService = metricsService;
    }
    async saveMetrics(res, data, hw_type, subsystem) {
        var metrics = [];
        for (var item in data) {
            for (var time in data[item]) {
                let datetime = new Date(parseInt(time) * 1000).toISOString();
                for (const metric of data[item][time]) {
                    if (!data[item][time][time][metric] || data[item][time][metric].length == 0) {
                        delete data[item][time][metric];
                    }
                }
                let metric = {
                    time: datetime,
                    item_id: item,
                    data: data[item][time],
                };
                metrics.push(metric);
            }
        }
        let inserted = 0;
        if (hw_type && subsystem) {
            inserted = await this.metricsService.saveMetrics(metrics, hw_type, subsystem);
        }
        else {
            inserted = await this.metricsService.saveMetrics(metrics);
        }
        res.status(common_1.HttpStatus.CREATED);
        return {
            statusCode: common_1.HttpStatus.CREATED,
            message: 'saved ' + inserted + ' rows',
        };
    }
    async saveMetrics2(res, data) {
        let metrics = [];
        let inserted = 0;
        for (const hwType in data) {
            for (const subsystem in data[hwType]) {
                for (const item_id in data[hwType][subsystem]) {
                    for (const time in data[hwType][subsystem][item_id]) {
                        for (const metric in data[hwType][subsystem][item_id][time]) {
                            if (data[hwType][subsystem][item_id][time][metric] === undefined ||
                                data[hwType][subsystem][item_id][time][metric] === null ||
                                data[hwType][subsystem][item_id][time][metric].length == 0) {
                                delete data[hwType][subsystem][item_id][time][metric];
                            }
                        }
                        let metric = {
                            time: new Date(parseInt(time) * 1000).toISOString(),
                            item_id: item_id,
                            data: data[hwType][subsystem][item_id][time],
                        };
                        metrics.push(metric);
                    }
                }
                inserted += await this.metricsService.saveMetrics(metrics, hwType, subsystem);
                metrics = [];
            }
        }
        res.status(common_1.HttpStatus.CREATED);
        return {
            statusCode: common_1.HttpStatus.CREATED,
            message: 'saved ' + inserted + ' rows',
        };
    }
    async saveMetricsCSV(req, hw_type, subsystem) {
        if (req.readable) {
            let metrics = [];
            const raw = await rawbody(req);
            const csv = raw.toString().trim().split('\n');
            const legend = csv[0].split(';');
            for (let i = 1; i < csv.length; i++) {
                if (csv[i].charAt(0) == " ") {
                    csv[i] = csv[i].substring(1);
                }
                const sublines = csv[i].split('|');
                if (sublines.length >= 2) {
                    const m_line = csv[i].split(';');
                    const item_id = m_line[0];
                    for (let sub_index = 0; sub_index < sublines.length; sub_index++) {
                        const subline = sublines[sub_index];
                        const line = subline.split(';');
                        const l_offset = sub_index == 0 ? 0 : 1;
                        const d_offset = sub_index == 0 ? 1 : 0;
                        const datetime = new Date(parseInt(line[d_offset]) * 1000).toISOString();
                        let data = {};
                        for (let x = 1 + d_offset; x < line.length; x++) {
                            if (!legend[x + l_offset] || legend[x + l_offset].length === 0) {
                                continue;
                            }
                            let value = line[x] && line[x].length >= 1 ? this.metricsService.checkValue(line[x]) : null;
                            if (value) {
                                data[legend[x + l_offset]] = value;
                            }
                        }
                        if (Object.keys(data).length >= 1) {
                            let metric = {
                                time: datetime,
                                item_id: item_id,
                                data: data,
                            };
                            metrics.push(metric);
                        }
                    }
                }
                else {
                    const line = csv[i].split(';');
                    const datetime = new Date(parseInt(line[1]) * 1000).toISOString();
                    let data = {};
                    for (let x = 2; x < line.length; x++) {
                        if (!legend[x] || legend[x].length === 0) {
                            continue;
                        }
                        let value = line[x] ? this.metricsService.checkValue(line[x]) : null;
                        if (value) {
                            data[legend[x]] = value;
                        }
                    }
                    if (Object.keys(data).length >= 1) {
                        let metric = {
                            time: datetime,
                            item_id: line[0],
                            data: data,
                        };
                        metrics.push(metric);
                    }
                }
            }
            let inserted = 0;
            if (hw_type && subsystem) {
                inserted = await this.metricsService.saveMetrics(metrics, hw_type, subsystem);
            }
            else {
                inserted = await this.metricsService.saveMetrics(metrics);
            }
            return {
                statusCode: common_1.HttpStatus.CREATED,
                message: 'saved ' + inserted + ' rows',
            };
        }
        else {
            throw new common_1.HttpException({
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                error: 'bad request',
            }, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getPrediction(request, predictionRequest) {
        let data = {
            metadata: {
                command: predictionRequest.command,
                frequency: predictionRequest.frequency,
                item_id: predictionRequest.item_id,
                metric: predictionRequest.metric
            },
            models: {},
            real: {}
        };
        const handleDays = (days, max) => {
            if (days >= max) {
                return `${max}+`;
            }
            else {
                return Math.round(days);
            }
        };
        let originalDataInMin;
        switch (predictionRequest.frequency) {
            case '5m':
                originalDataInMin = 5;
                break;
            case '1h':
                originalDataInMin = 60;
                break;
            case '6h':
                originalDataInMin = 360;
                break;
            case '1d':
                originalDataInMin = 1440;
                break;
            default:
                originalDataInMin = 1440;
                break;
        }
        const item = await this.metricsService.getItem(predictionRequest.item_id);
        const predictionData = await Prediction_1.Prediction.predict({
            itemId: item.item_id,
            hwType: item.hw_type,
            subsystem: item.subsystem,
            metric: predictionRequest.metric,
            max: predictionRequest.max
        }, predictionRequest.command, predictionRequest.frequency);
        let firstData;
        const models = Object.keys(predictionData);
        const isAnyDisplayed = models.find(model => predictionData[model].display === true) !== undefined;
        for (const predictionType in predictionData) {
            if (Prediction_1.Prediction.TO_SKIP.includes(predictionType)) {
                continue;
            }
            let timeseries = predictionData[predictionType].prediction;
            const startTime = predictionData[predictionType].start_time;
            if (!firstData || startTime < firstData) {
                firstData = startTime;
            }
            const modelData = {
                metadata: {
                    label: predictionData[predictionType].name
                        ? predictionData[predictionType].name
                        : predictionType,
                    start: startTime,
                    end: startTime + ((timeseries.length * originalDataInMin) * 60),
                    interval: originalDataInMin,
                    display: predictionData[predictionType].display !== true
                        ? Prediction_1.Prediction.isDefaultDisplayed(predictionType, !isAnyDisplayed)
                        : true,
                    description: predictionData[predictionType].description,
                    days_to_100_percent_fill: handleDays(predictionData[predictionType].days_to_100_percent_fill, originalDataInMin == 5 ? 31 : 365),
                    days_to_90_percent_fill: predictionRequest.command === 'predict_capacity'
                        ? handleDays(predictionData[predictionType].days_to_90_percent_fill, originalDataInMin == 5 ? 31 : 365)
                        : undefined,
                    days_to_70_percent_fill: predictionRequest.command === 'predict_cpu' || predictionRequest.command === 'predict_vm'
                        ? handleDays(predictionData[predictionType].days_to_70_percent_fill, originalDataInMin == 5 ? 31 : 365)
                        : undefined,
                    slope: predictionData[predictionType].slope,
                    std: predictionData[predictionType].std,
                    max_dif: predictionData[predictionType].max_dif,
                    min_dif: predictionData[predictionType].min_dif
                },
                timeseries: timeseries
            };
            data.models[predictionType] = modelData;
        }
        firstData = Date.now() / 1000;
        const originalMetrics = predictionRequest.other_metrics.concat([predictionRequest.metric]);
        const startTimeOriginal = predictionRequest.interval === 'month'
            ? firstData - (30 * 24 * 60 * 60)
            : firstData - (365 * 24 * 60 * 60);
        const originalData = await this.getMetrics(request, {
            uuid: [predictionRequest.item_id],
            metrics: originalMetrics,
            start: startTimeOriginal,
            end: firstData
        }, undefined, undefined, undefined, undefined, originalDataInMin);
        if (originalData.statusCode === 200) {
            for (const metric in originalData.data.metrics) {
                if (originalData.data.metrics[metric].length === 1) {
                    data.real[metric] = originalData.data.metrics[metric][0];
                    data.real[metric].metadata.description = data.real[metric].metadata.interval === 5
                        ? "5-minute averages"
                        : data.real[metric].metadata.interval === 360
                            ? "6-hour averages"
                            : data.real[metric].metadata.interval === 1440
                                ? "Daily averages"
                                : null;
                }
            }
        }
        return {
            statusCode: common_1.HttpStatus.OK,
            data: data
        };
    }
    async getMetrics(request, timeseriesRequest, top, order, fixedUIDs, parent, overrideInterval) {
        let data = {
            metadata: {
                start: timeseriesRequest.start,
                end: timeseriesRequest.end,
            },
            metrics: {},
        };
        const user = await User_1.User.getUserByRequest(request);
        if (timeseriesRequest.uuid.length === 0) {
            return {
                statusCode: common_1.HttpStatus.OK,
                data: data,
            };
        }
        let items = {};
        let transform = undefined;
        if (await MetricsTransform_1.MetricsTransform.checkId(timeseriesRequest.uuid[0])) {
            transform = new MetricsTransform_1.MetricsTransform(timeseriesRequest.uuid);
            await transform.transformIds();
            timeseriesRequest.uuid = transform.getIdsTransformed();
        }
        let interval = Metric_1.Metric.getInterval(timeseriesRequest.start, timeseriesRequest.end);
        const metricsWrapper = new MetricsWrapper_1.MetricsWrapper(timeseriesRequest.metrics, timeseriesRequest.uuid);
        await metricsWrapper.init();
        let metricsData = await metricsWrapper.getDataFromTable(timeseriesRequest.start, timeseriesRequest.end, true, true, overrideInterval);
        const min5minutesInterval = await MetricsWrapper_1.MetricsWrapper.getMin5MinutesInterval();
        const hwTypes = metricsWrapper.getHwTypes();
        if (hwTypes[0] && interval === Metric_1.Metric.INTERVAL_1_M && min5minutesInterval.includes(hwTypes[0])) {
            interval = Metric_1.Metric.INTERVAL_5_M;
        }
        if (overrideInterval !== undefined) {
            interval = overrideInterval;
        }
        let metricsItem = {};
        let metricsMetadata = {};
        let itemIds = Object.keys(metricsData);
        for (const itemId in metricsData) {
            for (const metric in metricsData[itemId]) {
                if (!metricsItem[metric]) {
                    metricsItem[metric] = {};
                }
                metricsItem[metric][itemId] = {
                    timeseries: [],
                    metadata: {},
                };
                if (!metricsMetadata[itemId]) {
                    metricsMetadata[itemId] = {
                        start: Object.keys(metricsData[itemId][metric])[0]
                            ? new Date(Object.keys(metricsData[itemId][metric])[0]).getTime()
                            : null,
                        end: Object.keys(metricsData[itemId][metric])[0]
                            ? new Date(Object.keys(metricsData[itemId][metric])[Object.keys(metricsData[itemId][metric]).length - 1]).getTime()
                            : null
                    };
                }
                for (const time in metricsData[itemId][metric]) {
                    metricsItem[metric][itemId].timeseries.push(metricsData[itemId][metric][time]);
                }
            }
        }
        if (transform) {
            for (const metric in metricsItem) {
                data.metrics[metric] = await transform.transformData(metricsItem[metric], metricsMetadata, interval);
            }
            return {
                statusCode: common_1.HttpStatus.OK,
                data: data
            };
        }
        let parentsById = {};
        let objectItemsById = {};
        let parentType = undefined;
        let switchParent = false;
        if (parent !== undefined && hwTypes.length > 1) {
            parentType = {
                subsystem: parent.toLowerCase(),
                hasPage: false,
                label: parent.charAt(0).toUpperCase() + parent.slice(1)
            };
        }
        else if (parent !== undefined) {
            if (hwTypes[0] === 'vmware' && parent.toLowerCase() === 'datastore') {
                parent = 'vm';
                switchParent = true;
            }
            parentType = MetricsWrapper_1.MetricsWrapper.getParentInfo(metricsWrapper.getClass(), hwTypes[0], parent.toLowerCase());
        }
        const objectItems = await this.metricsService.getItems(itemIds, parentType ? parentType.subsystem : undefined);
        for (const objectItem of objectItems) {
            objectItemsById[objectItem.item_id] = objectItem;
            if (objectItem.parents && objectItem.parents[0]) {
                parentsById[objectItem.item_id] = {
                    'label': objectItem.parents[0]._parent.label,
                    'url': parentType.hasPage ? new URL_1.URL().generateFromObject(objectItem.parents[0]._parent, undefined, timeseriesRequest.path, user, objectItem) : undefined
                };
            }
        }
        for (const metric in metricsItem) {
            items[metric] = await MetricsHelper_1.MetricsHelper.prepareTable(metricsItem[metric], metricsMetadata, timeseriesRequest.uuid, interval, objectItemsById, parentsById, metric, timeseriesRequest.path, request);
        }
        if (switchParent) {
            for (const metric in items) {
                for (const item of items[metric]) {
                    if (item.metadata.parent && item.metadata.parent.label) {
                        const originalLabel = item.metadata.name;
                        item.metadata = {
                            ...item.metadata,
                            name: item.metadata.parent.label,
                            url: item.metadata.parent.url,
                            parent: {
                                label: originalLabel,
                                url: null
                            }
                        };
                    }
                }
            }
        }
        let topItems = 0;
        if (top) {
            topItems = +top;
        }
        if (topItems !== 0 && topItems < itemIds.length) {
            const firstMetric = Object.keys(items)[0];
            switch (order) {
                case timeseriesRequest_contants_1.TIMESERIES_TOP_ORDER.avg:
                    items[firstMetric].sort((a, b) => (a.metadata.avg > b.metadata.avg ? -1 : 1));
                    break;
                case timeseriesRequest_contants_1.TIMESERIES_TOP_ORDER.max:
                    items[firstMetric].sort((a, b) => (a.metadata.max > b.metadata.max ? -1 : 1));
                    break;
                default:
                    break;
            }
            const fixedItems = {};
            const unfixedItems = {};
            if (fixedUIDs && fixedUIDs.length && fixedUIDs.length <= topItems) {
                for (const metric in items) {
                    fixedItems[metric] = items[metric].filter(i => fixedUIDs.includes(i.metadata.uuid));
                    unfixedItems[metric] = items[metric].filter(i => !fixedItems[metric].includes(i));
                }
            }
            else {
                for (const metric in items) {
                    fixedItems[metric] = [];
                    unfixedItems[metric] = items[metric];
                }
            }
            const others = unfixedItems[firstMetric].slice(topItems - fixedItems[firstMetric].length);
            const othersIds = others.map(other => other.metadata.uuid);
            for (const metric in items) {
                const skipOthers = MetricsWrapper_1.MetricsWrapper.skipOthers(metricsWrapper.getClass(), objectItems[0].hw_type, objectItems[0].subsystem, metric);
                const otherItems = items[metric].filter(i => othersIds.includes(i.metadata.uuid));
                const timeseries = otherItems.map(i => i.timeseries);
                const reducedTimeseries = timeseries.reduce((r, a) => a.map((b, i) => (r[i] || 0) + b), []);
                items[metric] = [...fixedItems[metric], ...unfixedItems[metric].filter(i => !othersIds.includes(i.metadata.uuid))];
                if (skipOthers) {
                    continue;
                }
                let sum, avg, max, min;
                const filtered = reducedTimeseries.filter((e) => { return e !== null; });
                sum = reducedTimeseries.reduce((a, b) => a + b, 0);
                avg = +Number(sum / filtered.length).toPrecision(5) || 0;
                max = Math.max(...filtered);
                items[metric].push({
                    metadata: {
                        uuid: null,
                        name: 'Others',
                        start: items[metric][0]['metadata']['start'],
                        end: items[metric][0]['metadata']['end'],
                        interval: interval,
                        avg: avg,
                        max: max,
                        url: null,
                    },
                    timeseries: reducedTimeseries,
                });
            }
        }
        else {
            for (const metric in items) {
                items[metric].sort((a, b) => (a.metadata.uuid > b.metadata.uuid ? 1 : -1));
            }
        }
        data.metrics = items;
        return {
            statusCode: common_1.HttpStatus.OK,
            data: data,
        };
    }
    async metricsDefinitionByHWType(hw_type) {
        let metrics = await this.metricsService.getSubsystemMetrics(hw_type);
        return {
            statusCode: common_1.HttpStatus.OK,
            data: metrics,
        };
    }
    async saveMetricsDefinitions(subsystemMetrics) {
        const inserted = this.metricsService.saveMetricsDefinitions(subsystemMetrics);
        return {
            statusCode: common_1.HttpStatus.OK,
            message: 'inserted ' + inserted + ' metrics definitions',
        };
    }
    async metricsDefinitionBySubsystem(hw_type, subsystem) {
        let metrics = await this.metricsService.getSubsystemMetrics(hw_type, subsystem);
        return {
            statusCode: common_1.HttpStatus.OK,
            data: metrics,
        };
    }
    getColorPallete() {
        return {
            statusCode: common_1.HttpStatus.OK,
            data: Color_1.Color.colors,
        };
    }
};
exports.MetricsController = MetricsController;
__decorate([
    openapi.ApiOperation({ description: "stores metrics data from JSON format" }),
    (0, swagger_1.ApiBody)({
        schema: {
            type: 'object',
            example: {
                'f6969d67-453d-4337-970c-ccc72f5d8c43': {
                    '1618822147': {
                        cpu: '1.76',
                        mem_free: '2.56',
                        mem_used: '5.44',
                    },
                },
            },
        },
    }),
    (0, common_1.Post)('v1/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Res)({ passthrough: true })),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.Query)('hw_type')),
    __param(3, (0, common_1.Query)('subsystem')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, String, String]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "saveMetrics", null);
__decorate([
    openapi.ApiOperation({ description: "stores metrics data from JSON format" }),
    (0, swagger_1.ApiBody)({
        schema: {
            type: 'object',
            example: {
                'f6969d67-453d-4337-970c-ccc72f5d8c43': {
                    '1618822147': {
                        cpu: '1.76',
                        mem_free: '2.56',
                        mem_used: '5.44',
                    },
                },
            },
        },
    }),
    (0, common_1.Post)('v3/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Res)({ passthrough: true })),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "saveMetrics2", null);
__decorate([
    openapi.ApiOperation({ description: "stores metrics data from CSV format" }),
    (0, swagger_1.ApiHeader)({ name: 'Content-Type', description: 'text/plain' }),
    (0, common_1.Post)('v2/data/store'),
    openapi.ApiResponse({ status: 201, type: require("../../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Query)('hw_type')),
    __param(2, (0, common_1.Query)('subsystem')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, String]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "saveMetricsCSV", null);
__decorate([
    (0, common_1.UseInterceptors)(uuidRequest_interceptor_1.UuidRequestInterceptor),
    (0, common_1.Post)('v1/data/prediction'),
    openapi.ApiResponse({ status: 201, type: require("../../common/timeseriesResponse.dto").PredictionResponseDTO }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, timeseriesRequest_dto_1.PredictionRequestDTO]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "getPrediction", null);
__decorate([
    openapi.ApiOperation({ description: "returns metric data" }),
    (0, common_1.Post)('v1/data/timeseries'),
    (0, common_1.UseInterceptors)(timeserie_interceptor_1.TimeseriesInterceptor),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: require("../../common/timeseriesResponse.dto").TimeseriesResponseDTO }),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.Query)('top')),
    __param(3, (0, common_1.Query)('order')),
    __param(4, (0, common_1.Query)('fixed')),
    __param(5, (0, common_1.Query)('parent')),
    __param(6, (0, common_1.Query)('interval')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, timeseriesRequest_dto_1.TimeseriesRequestDTO, Number, String, Array, String, Number]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "getMetrics", null);
__decorate([
    openapi.ApiOperation({ description: "metrics definitions for hw_type" }),
    (0, common_1.Get)('v1/definitions/:hw_type'),
    openapi.ApiResponse({ status: 200, type: require("../../common/subsystemMetricsResponse.dto").SubsystemMetricsResponseDTO }),
    __param(0, (0, common_1.Param)('hw_type')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "metricsDefinitionByHWType", null);
__decorate([
    openapi.ApiOperation({ description: "save metrics definitions for hw_type" }),
    (0, common_1.Post)('v1/definitions'),
    openapi.ApiResponse({ status: 201, type: require("../../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "saveMetricsDefinitions", null);
__decorate([
    openapi.ApiOperation({ description: "metrics definitions for hw_type/subsystem" }),
    (0, common_1.Get)('v1/definitions/:hw_type/:subsystem'),
    openapi.ApiResponse({ status: 200, type: require("../../common/subsystemMetricsResponse.dto").SubsystemMetricsResponseDTO }),
    __param(0, (0, common_1.Param)('hw_type')),
    __param(1, (0, common_1.Param)('subsystem')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], MetricsController.prototype, "metricsDefinitionBySubsystem", null);
__decorate([
    openapi.ApiOperation({ description: "colors pallete" }),
    (0, common_1.Get)('v1/pallete'),
    openapi.ApiResponse({ status: 200, type: require("../../common/basicResponse.dto").ArrayResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", basicResponse_dto_1.ArrayResponseDTO)
], MetricsController.prototype, "getColorPallete", null);
exports.MetricsController = MetricsController = __decorate([
    (0, swagger_1.ApiTags)('Metrics'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/metrics'),
    __metadata("design:paramtypes", [metrics_service_1.MetricsService])
], MetricsController);
//# sourceMappingURL=metrics.controller.js.map