import { ConfigService } from '@nestjs/config';
import { Aggregation } from '@xormon/entity/aggregation.entity';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { EntityManager, Repository } from 'typeorm';
export declare class MetricsService {
    private configService;
    private itemPropertiesRepository;
    private objectItemsRepository;
    private aggregationRepository;
    private dataSource;
    private logger;
    private compressedLimit;
    private _5minAggregationLimit;
    constructor(configService: ConfigService, itemPropertiesRepository: Repository<ItemProperty>, objectItemsRepository: Repository<ObjectItem>, aggregationRepository: Repository<Aggregation>, dataSource: EntityManager);
    saveMetrics(metrics: any[], hw_type?: string, subsystem?: string): Promise<number>;
    getMetricsGapFill(uuid: any, metric: any, start: any, end: any, interval: any, func: any): Promise<any>;
    getMetricsGapFill2(uuids: any, metric: any, start: any, end: any, interval: any, func: any): Promise<any>;
    getValue(id: string, name: string): Promise<ItemProperty>;
    getItem(id: string): Promise<ObjectItem>;
    getItems(itemIds: string[], parentType?: string): Promise<ObjectItem[]>;
    getSubsystemMetrics(hw_type: string, subsystem?: string): Promise<[]>;
    saveMetricsDefinitions(definitions: any): Promise<number>;
    calculate(statistics: any, value: any): any;
    toIso(datetime: number): string;
    toTimestamp(datetime: string, precision: number): number;
    checkValue(value: any): number;
    noExponents(number: any): number;
}
