import { Microservice as MicroserviceEntity } from '@xormon/entity/microservice.entity';
interface IMicroservice {
    label: string;
    microservice: string;
    script: string;
    host: string;
    port: string;
    hw_type: string;
    needConf: boolean;
    onStartup?: boolean;
}
export declare class Microservice {
    label: string;
    microservice: string;
    script: string;
    hw_type: string;
    host: string;
    port: number;
    needConf: boolean;
    private registered;
    private active;
    private available;
    pid: number;
    version: string;
    monitor: {
        memory_byte: number;
        cpu_percent: number;
    };
    private microservicesRepository;
    constructor();
    init(microservice: string): Promise<void>;
    isRegistered(): boolean;
    isActive(): boolean;
    isAvailable(): boolean;
    needsConf(): boolean;
    getData(): {
        label: string;
        microservice: string;
        host: string;
        port: number;
        script: string;
        pid: number;
        version: string;
        active: boolean;
        monitor: {
            memory_byte: number;
            cpu_percent: number;
        };
    };
    reloadData(): Promise<void>;
    getMicroserviceDB(microservice: string): Promise<MicroserviceEntity>;
    getMicroservicePM2(name: string): Promise<unknown>;
    start(): Promise<void>;
    changeOnStartup(onStartup: boolean): Promise<void>;
    stop(): Promise<void>;
    register(data: JSON): Promise<void>;
    registerService(data: JSON): Promise<unknown>;
    sendData(data: string): Promise<unknown>;
    static checkAndStart(ms: string): Promise<void>;
    static getCoreServices(): string[];
    static list(): IMicroservice[];
    static jobs(): {
        microservice: string;
        job: string;
        interval: number;
    }[];
}
export {};
