import 'reflect-metadata';
import { HwTypeKey } from "@xormon/common/constants/hwTypeKey.constants";
import { HostcfgDefinition } from "@xormon/common/hostCfgResponse.dto";
export type HwTypeVendorMap = {
    [key in HwTypeKey]?: {
        vendors: {
            [key: string]: {
                label: string;
            };
        };
        labels: {
            [key: string]: string;
        };
    };
};
export declare function createVendorMapFromObject(): HwTypeVendorMap;
export declare function getVendorKeys(): string[];
export declare function getVendorDevice(_vendor: string): string[];
export declare function getClassMetadata(target: any): HostcfgDefinition;
export declare function getHwTypeByVendorDevice(device: string): [HostcfgDefinition | Record<string, HostcfgDefinition>, string];
export declare function describeMetaData(hwType?: HwTypeKey): HostcfgDefinition | Record<string, HostcfgDefinition>;
