import { PlainReport, TimeRange } from "@xormon/common/report.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { Report as ReportEntity } from "@xormon/entity/report.entity";
import { ReportFile } from "@xormon/entity/reportFile.entity";
import * as winston from 'winston';
import { Request } from 'express';
export declare class Reporter {
    private static EXPORT_PATH;
    private static LOGS_PATH;
    private static aclGroups;
    private static user;
    static ensureExportPath(): Promise<string>;
    static getReportFilePath(reportFile: ReportFile): string;
    static getReportTmpPath(): string;
    static winstonLogger: winston.Logger;
    private static sanitizeFileName;
    private static generateReportPdfMakeContent;
    static generateReport(report: PlainReport | ReportEntity, request?: Request): Promise<ReportFile>;
    static getIds(_item_group_id: string, _custom_group_id: string): Promise<{
        ids: string[];
        items: ObjectItem[];
    }>;
    static getStartAndEnd(timeRange?: TimeRange | null, interval?: string | null, endDate?: Date): {
        start: number;
        end: number;
    };
    static makeTimeNumberFromDate(date?: Date): number;
    static secondsInTimeInterval(interval: string): number;
    static setAclGroups(): void;
    static setUser(request: Request, userId: number): Promise<void>;
    static getUserTimezone(): string;
}
