import { NewReport, UpdateReport } from "@xormon/common/report.dto";
import { PlainReportItem } from "@xormon/common/reportItem.dto";
import { MailGroup } from "@xormon/entity/mailGroup.entity";
import { Report } from "@xormon/entity/report.entity";
import { ReportFile } from "@xormon/entity/reportFile.entity";
import { ReportItem } from "@xormon/entity/reportItem.entity";
import { Repository } from "typeorm";
import { ItemGroup } from "@xormon/entity/itemGroup.entity";
export declare class ReporterService {
    private reportRepository;
    private reportFileRepository;
    private reportItemRepository;
    private mailGroupRepository;
    private itemGroupRepository;
    constructor(reportRepository: Repository<Report>, reportFileRepository: Repository<ReportFile>, reportItemRepository: Repository<ReportItem>, mailGroupRepository: Repository<MailGroup>, itemGroupRepository: Repository<ItemGroup>);
    private reduceMailGroupsToIds;
    private removeUserId;
    getReportsWithRelations(user_id: number): Promise<Report[]>;
    getReportWithRelations(report_id: string, includeFiles?: boolean): Promise<Report>;
    getReportWithItems(report_id: string): Promise<Report>;
    getReportWithFiles(report_id: string): Promise<Report>;
    getReportOnly(report_id: string): Promise<Report>;
    getReportsOnly(user_id: number): Promise<Report[]>;
    private processReportItem;
    private handleMailGroups;
    private processReportItems;
    private deleteRemovedReportItems;
    saveReport(report: UpdateReport | NewReport, oldReport?: Report): Promise<(NewReport | UpdateReport) & Report>;
    transformReportItem(reportItems: ReportItem[]): (PlainReportItem & ReportItem)[];
    updateReportLastRunAt(report: Report, lastRunAt: Date): Promise<import("typeorm").UpdateResult>;
    removeReport(report: Report): Promise<Report>;
    getReportFile(report_file_id: string): Promise<ReportFile>;
    saveReportFile(reportFile: ReportFile): Promise<ReportFile>;
    removeReportFile(reportFile: ReportFile): Promise<ReportFile>;
    removeFilesFromReport(report: Report): Promise<ReportFile[]>;
    getMailGroups(): Promise<MailGroup[]>;
    getUserId(request: any): Promise<any>;
}
