import { ConfigService } from '@nestjs/config';
import { EventEmitter2 } from '@nestjs/event-emitter';
import { TokenRefreshRequestDTO, TokenRequestDTO } from '@xormon/common/tokenRequest.dto';
import { UsersService } from '@xormon/service/users/users.service';
import { Request, Response } from 'express';
import { TokenResponseDTO, TokenResponseMetricsPort } from '../../common/tokenResponse.dto';
import { LdapService } from '../ldap/ldap.service';
export declare class TokenController {
    private configService;
    private readonly usersService;
    private readonly ldapService;
    private eventEmitter;
    private readonly logger;
    private readonly debug;
    constructor(configService: ConfigService, usersService: UsersService, ldapService: LdapService, eventEmitter: EventEmitter2);
    logout(req: Request, response: Response): Promise<void>;
    generateToken(request: Request, res: Response, tokenRequest: TokenRequestDTO): Promise<TokenResponseDTO>;
    proxyGenerate(request: Request, tokenRequestDTO: TokenRequestDTO): Promise<TokenResponseMetricsPort>;
    refresh(tokenRequest: TokenRefreshRequestDTO): Promise<TokenResponseDTO>;
}
