"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LdapSubscriber = void 0;
const ldap_entity_1 = require("../entity/ldap.entity");
const Crypto_1 = require("../service/configuration/Crypto");
const typeorm_1 = require("typeorm");
let LdapSubscriber = class LdapSubscriber {
    listenTo() {
        return ldap_entity_1.Ldap;
    }
    async afterLoad(entity) {
        if (entity['password']) {
            entity['password'] = await Crypto_1.Crypto.decrypt(entity['password']);
        }
    }
    async beforeInsert(event) {
    }
    async beforeUpdate(event) {
        if (event.entity.password) {
            event.entity.password = await Crypto_1.Crypto.encrypt(event.entity.password);
        }
    }
};
exports.LdapSubscriber = LdapSubscriber;
exports.LdapSubscriber = LdapSubscriber = __decorate([
    (0, typeorm_1.EventSubscriber)()
], LdapSubscriber);
//# sourceMappingURL=ldap.subscriber.js.map