import { OnApplicationShutdown } from '@nestjs/common';
import { Alerting } from '@xormon/entity/alerting.entity';
import { AlertingGroup } from '@xormon/entity/alertingGroup.entity';
import { AlertingLaunch } from '@xormon/entity/alertingLaunch.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { MailService } from '@xormon/mail/mail.service';
import { Repository } from 'typeorm';
import { SnmpHandler } from './snmp.handler';
import { ServiceNowHandler } from './serviceNow.handler';
import { SettingsItem } from '@xormon/common/settings.dto';
import { AlertingHistory } from '@xormon/entity/alertingHistory.entity';
import { AlertingHistoryItem } from '@xormon/entity/alertingHistoryItem.entity';
interface IValuePerId {
    [id: string]: number;
}
export declare class AlertHandler implements OnApplicationShutdown {
    private alertingRepository;
    private alertingLaunchRepository;
    private alertingGroupRepository;
    private alertingHistoryRepository;
    private alertingHistoryItemsRepository;
    private objectItemsRepository;
    private mailService;
    private snmpHandler;
    private serviceNowHandler;
    private settings;
    private winstonLogger;
    constructor(alertingRepository: Repository<Alerting>, alertingLaunchRepository: Repository<AlertingLaunch>, alertingGroupRepository: Repository<AlertingGroup>, alertingHistoryRepository: Repository<AlertingHistory>, alertingHistoryItemsRepository: Repository<AlertingHistoryItem>, objectItemsRepository: Repository<ObjectItem>, mailService: MailService, snmpHandler: SnmpHandler, serviceNowHandler: ServiceNowHandler);
    onApplicationShutdown(signal?: string): void;
    private loadAlertingGroupItems;
    private getAlertingGroups;
    private getDefaultRepeat;
    private getDefaultScanningLength;
    private getMaximumLookBackTime;
    private findLastCompleteDataPoint;
    private getItemsMetricsMap;
    private filterOutRecentlyTriggering;
    private scanForLaunch;
    private roundToWholeMinutes;
    private computeDate;
    private computeTimeInSeconds;
    private computeInterval;
    private saveTriggeredAlert;
    private gatherTriggeringItems;
    private sendSnmpTraps;
    private serviceNow;
    private processAlerting;
    private processAlertingGroup;
    checkAlerts(checkUntil: Date): Promise<void[][]>;
    setSettings(settings: any): this;
}
export declare class EmailAlert implements OnApplicationShutdown {
    private winstonLogger;
    private settings;
    private APP_PORT;
    private alert;
    private alertingGroup;
    private mailService;
    constructor(mailService: MailService, settíngs: SettingsItem, alert: Alerting, alertingGroup: AlertingGroup);
    onApplicationShutdown(signal?: string): void;
    private makeGraphFile;
    private makeItemsList;
    private createURL;
    private makeEmailBody;
    makeAndSendEmail(checkUntil: Date, items: ObjectItem[], source: string, valuePerId: IValuePerId, debugInfo?: any): Promise<void>;
    makePresentable(text: string): string;
    createSubsystemsInfo(objectItem: ObjectItem): {
        first: string;
        second: string;
    };
    setAppPort(newAppPort: any): this;
    getAppPort(): number;
}
export {};
