"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskServerModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const schedule_1 = require("@nestjs/schedule");
const typeorm_1 = require("@nestjs/typeorm");
const architecture_dto_1 = require("../common/architecture.dto");
const bucket_config_1 = require("../config/bucket.config");
const db_config_1 = require("../config/db.config");
const alerting_entity_1 = require("../entity/alerting.entity");
const alertingGroup_entity_1 = require("../entity/alertingGroup.entity");
const alertingHwEmail_entity_1 = require("../entity/alertingHwEmail.entity");
const alertingLaunch_entity_1 = require("../entity/alertingLaunch.entity");
const backend_entity_1 = require("../entity/backend.entity");
const customGroup_entity_1 = require("../entity/customGroup.entity");
const customGroupFolder_entity_1 = require("../entity/customGroupFolder.entity");
const healthStatus_entity_1 = require("../entity/healthStatus.entity");
const healthStatusHistory_entity_1 = require("../entity/healthStatusHistory.entity");
const healthStatusMirror_entity_1 = require("../entity/healthStatusMirror.entity");
const heatmap_entity_1 = require("../entity/heatmap.entity");
const heatmapTier_entity_1 = require("../entity/heatmapTier.entity");
const heatmapTierItem_entity_1 = require("../entity/heatmapTierItem.entity");
const hostcfg_entity_1 = require("../entity/hostcfg.entity");
const hwType_entity_1 = require("../entity/hwType.entity");
const itemProperty_entity_1 = require("../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../entity/itemRelation.entity");
const microservice_entity_1 = require("../entity/microservice.entity");
const microserviceJobs_entity_1 = require("../entity/microserviceJobs.entity");
const microserviceJobsStatus_entity_1 = require("../entity/microserviceJobsStatus.entity");
const objectItem_entity_1 = require("../entity/objectItem.entity");
const report_entity_1 = require("../entity/report.entity");
const reportFile_entity_1 = require("../entity/reportFile.entity");
const targetDestination_entity_1 = require("../entity/targetDestination.entity");
const targetDestinationHostcfg_entity_1 = require("../entity/targetDestinationHostcfg.entity");
const top_entity_1 = require("../entity/top.entity");
const mail_module_1 = require("../mail/mail.module");
const architecture_module_1 = require("../service/architecture/architecture.module");
const custom_group_module_1 = require("../service/custom_group/custom_group.module");
const heatmap_module_1 = require("../service/heatmap/heatmap.module");
const alert_task_1 = require("./alert.task");
const cleanup_task_1 = require("./cleanup.task");
const exporter_task_1 = require("./exporter.task");
const top_task_1 = require("./top.task");
const aggregation_task_1 = require("./aggregation.task");
const alert_handler_1 = require("./alert.handler");
const custom_task_1 = require("./custom.task");
const heatmap_task_1 = require("./heatmap.task");
const log_task_1 = require("./log.task");
const monitoring_task_1 = require("./monitoring.task");
const reporter_task_1 = require("./reporter.task");
const snmp_handler_1 = require("./snmp.handler");
const serviceNow_handler_1 = require("./serviceNow.handler");
const prediction_task_1 = require("./prediction.task");
const App_1 = require("../service/configuration/App");
const demo_task_1 = require("./demo.task");
const aggregation_entity_1 = require("../entity/aggregation.entity");
const storageMapping_entity_1 = require("../entity/storageMapping.entity");
const os_agent_task_1 = require("./os-agent.task");
const export_entity_1 = require("../entity/export.entity");
const hostcfgStatus_entity_1 = require("../entity/hostcfgStatus.entity");
const stuckJob_task_1 = require("./stuckJob.task");
const mailGroup_entity_1 = require("../entity/mailGroup.entity");
const taskQueue_entity_1 = require("../entity/taskQueue.entity");
const taskQueue_service_1 = require("./taskQueue.service");
const healthStatus_task_1 = require("./healthStatus.task");
const mail_service_1 = require("../mail/mail.service");
const healthStatusMirrorRel_entity_1 = require("../entity/healthStatusMirrorRel.entity");
const alertingHistory_entity_1 = require("../entity/alertingHistory.entity");
const alertingHistoryItem_entity_1 = require("../entity/alertingHistoryItem.entity");
const deviceGroupHwAlerting_entity_1 = require("../entity/deviceGroupHwAlerting.entity");
let providers = [heatmap_task_1.HeatmapTask, cleanup_task_1.CleanupTask, alert_task_1.AlertTask, alert_handler_1.AlertHandler, snmp_handler_1.SnmpHandler, exporter_task_1.ExporterTask, top_task_1.TopTask, reporter_task_1.ReporterTask, monitoring_task_1.MonitoringTask, aggregation_task_1.AggregationTask, log_task_1.LogTask, custom_task_1.CustomTask, prediction_task_1.PredictionTask, os_agent_task_1.OSAgentTask, stuckJob_task_1.StuckJobTask, serviceNow_handler_1.ServiceNowHandler, taskQueue_service_1.TaskQueueService, healthStatus_task_1.HealthStatusTask, mail_service_1.MailService];
if (App_1.App.isDemo()) {
    providers.push(demo_task_1.DemoTask);
}
let TaskServerModule = class TaskServerModule {
};
exports.TaskServerModule = TaskServerModule;
exports.TaskServerModule = TaskServerModule = __decorate([
    (0, common_1.Module)({
        imports: [
            typeorm_1.TypeOrmModule.forRootAsync({
                inject: [config_1.ConfigService],
                useFactory: async (configService) => ({ ...configService.get('database') }),
            }),
            config_1.ConfigModule.forRoot({ isGlobal: true, load: [db_config_1.default, bucket_config_1.default] }),
            schedule_1.ScheduleModule.forRoot(),
            heatmap_module_1.HeatmapModule,
            typeorm_1.TypeOrmModule.forFeature([
                hostcfg_entity_1.HostCfg,
                architecture_dto_1.Class,
                architecture_dto_1.Subsystem,
                hwType_entity_1.HwType,
                microservice_entity_1.Microservice,
                backend_entity_1.Backend,
                objectItem_entity_1.ObjectItem,
                itemRelation_entity_1.ItemRelation,
                itemProperty_entity_1.ItemProperty,
                microserviceJobsStatus_entity_1.MicroserviceJobStatus,
                microserviceJobs_entity_1.MicroserviceJob,
                healthStatus_entity_1.HealthStatus,
                alerting_entity_1.Alerting,
                alertingLaunch_entity_1.AlertingLaunch,
                alertingGroup_entity_1.AlertingGroup,
                heatmap_entity_1.Heatmap,
                heatmapTier_entity_1.HeatmapTier,
                heatmapTierItem_entity_1.HeatmapTierItem,
                top_entity_1.Top,
                export_entity_1.Export,
                customGroup_entity_1.CustomGroup,
                cleanup_task_1.CleanupTask,
                customGroupFolder_entity_1.CustomGroupFolder,
                reportFile_entity_1.ReportFile,
                healthStatusHistory_entity_1.HealthStatusHistory,
                alertingHwEmail_entity_1.AlertingHwEmail,
                targetDestination_entity_1.TargetDestination,
                targetDestinationHostcfg_entity_1.TargetDestinationHostcfg,
                report_entity_1.Report,
                healthStatusMirror_entity_1.HealthStatusMirror,
                healthStatusMirrorRel_entity_1.HealthStatusMirrorRel,
                aggregation_entity_1.Aggregation,
                storageMapping_entity_1.StorageMapping,
                hostcfgStatus_entity_1.HostcfgStatus,
                mailGroup_entity_1.MailGroup,
                taskQueue_entity_1.TaskQueue,
                healthStatus_entity_1.HealthStatus,
                healthStatusHistory_entity_1.HealthStatusHistory,
                alertingHistory_entity_1.AlertingHistory,
                alertingHistoryItem_entity_1.AlertingHistoryItem,
                deviceGroupHwAlerting_entity_1.HwEventDeviceGroup
            ]),
            mail_module_1.MailModule,
            architecture_module_1.ArchitectureModule,
            custom_group_module_1.CustomGroupModule,
        ],
        providers: providers
    })
], TaskServerModule);
//# sourceMappingURL=app.module.js.map