import { OnApplicationShutdown } from '@nestjs/common';
import { SettingsItem } from '@xormon/common/settings.dto';
import { AlertingHistory } from '@xormon/entity/alertingHistory.entity';
import { HealthStatus } from '@xormon/entity/healthStatus.entity';
import { Heatmap } from '@xormon/entity/heatmap.entity';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { MicroserviceJobStatus } from '@xormon/entity/microserviceJobsStatus.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { ReportFile } from '@xormon/entity/reportFile.entity';
import { StorageMapping } from '@xormon/entity/storageMapping.entity';
import { Repository } from 'typeorm';
export declare class CleanupTask implements OnApplicationShutdown {
    private objectItemsRepository;
    private ItemRelationsRepository;
    private ItemPropertiesRepository;
    private MicroservicesJobsStatus;
    private ReportFileRepository;
    private HealthStatus;
    private heatmapRepository;
    private storageMappingRepository;
    private alertingHistoryRepository;
    private settings;
    private winstonLogger;
    constructor(objectItemsRepository: Repository<ObjectItem>, ItemRelationsRepository: Repository<ItemRelation>, ItemPropertiesRepository: Repository<ItemProperty>, MicroservicesJobsStatus: Repository<MicroserviceJobStatus>, ReportFileRepository: Repository<ReportFile>, HealthStatus: Repository<HealthStatus>, heatmapRepository: Repository<Heatmap>, storageMappingRepository: Repository<StorageMapping>, alertingHistoryRepository: Repository<AlertingHistory>);
    onApplicationShutdown(signal?: string): void;
    handleFullVacuum(): Promise<void>;
    handleLessFrequentInterval(): Promise<void>;
    handleInterval(): Promise<void>;
    setSettings(settings: SettingsItem): this;
    tryWrapper(fnct: any, val: any): Promise<void>;
    getIdsPersubsys(response: any): {};
    calcTime(hours: number): string;
    cleanTmpReports(date: string): Promise<void>;
    cleanReports(date: string): Promise<void>;
    cleanHealthStatus(date: string): Promise<void>;
    cleanUpInactiveObjectItems(date: string, excludeList: {
        subsystems: string[];
        hw_types: string[];
    }): Promise<void>;
    cleanUpMoreFrequentItems(): Promise<any[]>;
    cleanUpStorageMapping(date: string): Promise<void>;
    alertingHistory(date: string): Promise<void>;
    cleanUpHeatmap(date: string): Promise<void>;
    cleanUpMetrics(tableRes: any): Promise<void>;
    cleanUpItemsRelations(date: string): Promise<void>;
    cleanMicroserviceJobsStatus(date: string): Promise<void>;
    getAllBundles(original: any, bundleSize: any): Promise<any[]>;
    getBundle(items: any[], index: number, multiplier: number): any[];
}
