import { Heatmap as HeatmapEntity } from '@xormon/entity/heatmap.entity';
import { HeatmapTier } from "@xormon/entity/heatmapTier.entity";
import { HeatmapTierItem } from "@xormon/entity/heatmapTierItem.entity";
import { ItemProperty } from "@xormon/entity/itemProperty.entity";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { Repository } from "typeorm";
import { ItemRelation } from "@xormon/entity/itemRelation.entity";
import { TargetDestination } from "@xormon/entity/targetDestination.entity";
import { TargetDestinationHostcfg } from "@xormon/entity/targetDestinationHostcfg.entity";
export declare class HeatmapTask {
    private heatmapRepository;
    private objectItemsRepository;
    private itemPropertiesRepository;
    private heatmapTierRepository;
    private heatmapTierItemRepository;
    private itemRelationRepository;
    private targetDestinationRepository;
    private targetDestinationHcfgRepository;
    private PAGE_LIMIT;
    constructor(heatmapRepository: Repository<HeatmapEntity>, objectItemsRepository: Repository<ObjectItem>, itemPropertiesRepository: Repository<ItemProperty>, heatmapTierRepository: Repository<HeatmapTier>, heatmapTierItemRepository: Repository<HeatmapTierItem>, itemRelationRepository: Repository<ItemRelation>, targetDestinationRepository: Repository<TargetDestination>, targetDestinationHcfgRepository: Repository<TargetDestinationHostcfg>);
    private createHeatmapTier;
    reloadHeatmap(): Promise<void>;
    reloadStorCapacityHeatmap(): Promise<void>;
    reloadComputedHeatmap(): Promise<void>;
    reloadSanHetmap(): Promise<void>;
    reloadLanHetmap(): Promise<void>;
    roundTo: (num: number, places: number) => number;
    getBundle(items: ObjectItem[], index: number, multiplier: number): ObjectItem[];
}
