"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnmpHandler = void 0;
const common_1 = require("@nestjs/common");
const WinstonLogger_1 = require("../service/log/WinstonLogger");
const snmp = require("net-snmp");
let SnmpHandler = class SnmpHandler {
    constructor() {
        this.winstonLogger = (0, WinstonLogger_1.LoggerFactory)('snmp');
    }
    onApplicationShutdown(signal) {
        this.winstonLogger.close();
    }
    async sendSNMPTrap(host, communityString, oidValues) {
        return new Promise((resolve, reject) => {
            const session = snmp.createSession(host, communityString);
            const varbinds = Object.entries(oidValues).map(([oid, value]) => ({
                oid,
                type: snmp.ObjectType.OctetString,
                value,
            }));
            varbinds.forEach((varbind) => {
                this.winstonLogger.debug(`OID: ${varbind.oid}, Type: ${varbind.type}, Value: ${varbind.value}`);
            });
            session.trap("1.3.6.1.4.1.40540.3.0.1.0.7", varbinds, (error) => {
                session.close();
                if (error) {
                    this.winstonLogger.error(error);
                    reject(error);
                }
                else {
                    this.winstonLogger.info(`SNMP trap sent to ${host}`);
                }
                resolve();
            });
        });
    }
};
exports.SnmpHandler = SnmpHandler;
exports.SnmpHandler = SnmpHandler = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [])
], SnmpHandler);
//# sourceMappingURL=snmp.handler.js.map