"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGlobalTaskCache = exports.createGlobalTaskCache = exports.Cache = exports.CacheItem = exports.CacheKeys = void 0;
var CacheKeys;
(function (CacheKeys) {
    CacheKeys["HEALTH_STATUS"] = "health_status";
})(CacheKeys || (exports.CacheKeys = CacheKeys = {}));
class CacheItem {
    constructor(value, ttl, onInterval) {
        this.value = value;
        this.onInterval = onInterval;
        this.interval = setInterval(() => {
            this.onInterval().then(val => {
                if (val) {
                    this.value = val;
                }
            });
        }, ttl);
    }
    cancelTimeout() {
        clearTimeout(this.interval);
        this.interval = null;
    }
    setValue(value) {
        this.value = value;
        return this;
    }
}
exports.CacheItem = CacheItem;
class Cache {
    constructor() {
        this.cache = new Map();
    }
    set(key, value) {
        this.cache.set(key, value);
    }
    get(key) {
        return this.cache.get(key);
    }
    update(key, value) {
        this.cache.delete(key);
        this.cache.set(key, value);
    }
    getValue(key) {
        return this.cache.get(key);
    }
    delete(key) {
        const cacheItem = this.cache.delete(key);
    }
}
exports.Cache = Cache;
const createGlobalTaskCache = () => {
    return global.taskCache = new Cache();
};
exports.createGlobalTaskCache = createGlobalTaskCache;
const getGlobalTaskCache = () => { return global.taskCache; };
exports.getGlobalTaskCache = getGlobalTaskCache;
//# sourceMappingURL=taskServerCache.js.map