import numpy as np
#import scipy

def sMAPE(data, prediction): 
    data, prediction = np.array(data), np.array(prediction)

    return np.mean(2 * np.abs(data - prediction) / (np.abs((data)) + np.abs((prediction)))) * 100


def MAPE(y, yhat):
    y = np.array(y)
    yhat = np.array(yhat)

    return np.multiply(np.abs(np.divide(np.subtract(y,yhat),y)).sum(), np.divide(100,y.size))


def AMAPE(y, yhat):
    # adjusted MAPE
    y = np.array(y)
    yhat = np.array(yhat)

    return np.multiply(np.abs(np.divide(np.subtract(y,yhat),np.divide(np.add(y,yhat),2))).sum(), np.divide(100,y.size))


def MAPE_norm(data, prediction):
    data, prediction = np.array(data), np.array(prediction)
    res =  np.mean(np.abs(data - prediction)) * 100 / sum(data)
    return res

#
#def rsquared_lin(x, y):
#    """ Return R^2 where x and y are array-like."""
#    slope, intercept, r_value, p_value, std_err = scipy.stats.linregress(x, y)
#    return r_value**2
#

def mse(test_data, prediction_series):
    mse = ((test_data - prediction_series[:len(test_data)])**2).mean()
    return mse


# Polynomial Regression
def rsquared(y, yhat):
    results = {}

    # fit values, and mean
    ybar = np.sum(y)/len(y)          # or sum(y)/len(y)
    ssreg = np.sum((yhat-ybar)**2)   # or sum([ (yihat - ybar)**2 for yihat in yhat])
    sstot = np.sum((y - ybar)**2)    # or sum([ (yi - ybar)**2 for yi in y])
    results['determination'] = ssreg / sstot

    return results['determination']

def theil_u_stat(y, yhat):
    y = np.array(y)
    yhat = np.array(yhat)

    m = np.power(np.power(np.subtract(y,yhat),2).sum(),0.5)
    d = np.power(np.power(y,2).sum(),0.5)+np.power(np.power(yhat,2).sum(),0.5)

    theil_u_stat = np.divide(m,d)

    return theil_u_stat

