#### Description
Service to analyze and predict Xormon NG timeseries data.

#### USED PACKAGES:
- numpy
- pandas
- psycopg2
- SQLAlchemy
- sqlalchemy-timescaledb
- urllib3

#### Installation into Xormon NG:
```
su -
apt install python3-venv
su xormon

cd ~/xormon-ng/server-nest/
python3 -m venv venv
venv/bin/python3 -m ensurepip --upgrade
venv/bin/python3 -m pip install --upgrade pip
venv/bin/python3 -m pip install -r microservices/analyzer/requirements/requirements.txt
```

#### PROJECT STRUCTURE:
```
.
|
|-- analyzer-service.py: http service
|
|-- controller.py: pass request and mediate all tasks
|
|-- analyzer.py: combines models and prepares prediction response
|
|
|-- classification: outlier/anomaly detection
|   `-- outlier.py
|
|-- importer: load data from database or other sources
|   |-- dbwork.py
|   `-- importer.py
|
|-- measure: timerun, model quality and performace
|   |-- evaluation_metrics.py
|   `-- timing.py
|
|-- model: all modelling work
|   |-- models.py
|   |-- seasons.py
|   `-- tools.py
|
|-- requirements: installation
|   |-- requirements-3.11.txt
|   |-- requirements-3.6.8.txt
|   `-- requirements.txt
|
|-- utility: commonly used methods, structure checks
|   |-- logger.py
|   |-- postprocess.py
|   |-- requestwork.py
|   `-- response_structure.py
|
`-- readme

```