package FetchTask;

use strict;
use warnings;

use parent 'Task';
use SYNOLOGY;
use Xormon;
use XormonLogger;
use Data::Dumper;

# FetchTask class to handle 'fetch' tasks
# This class extends the Task base class

# The execute method for the FetchTask
# It handles the specific logic for fetching data
sub execute {
    my ($self) = @_;  
    
    eval {        

        my $data = $self->{data};
        # Variable declaration, send_response and shutdown end the socket for writing and thus the reference to {client}->peerhost() is empty
        my $client_address = $self->{client}->peerhost();        
        my $text_log = "Task '$data->{task}' for ".$data->{data}->{hostalias}." successfully started.";        
        $self->log($text_log);
        
        $self->send_response($text_log);        
        $self->shutdown();
        
        my $xormon = Xormon->new(
            $client_address,
            $data->{jwt},
            'synology',
            $data->{data}->{hostcfg_id},
            $data->{data}->{hostalias}
        );
        #print "Xormon object created.\n";
        
        $xormon->startJob($data->{task}, $data->{data}->{hostalias}, $$);
        #print "Job started.\n";       
        
        my $response = SYNOLOGY::collect_data($xormon, $data->{data});   
        #print "Data collected.\n";
        #print $response;
        
        $xormon->endJob($data->{task}, $data->{data}->{hostalias}, $response, $$);
        #print "Job ended.\n";

        $self->log("Task '$data->{task}' for ".$data->{data}->{hostalias}." is done.")
    };
    if ($@) {
        print "An error occurred in execute: $@\n";
       }
}

1;
