use strict;
use warnings;

use lib '../../../perl-modules/MicroServiceCore'; #Core
use lib '../../../perl-modules/'; #Xormon
use lib '.';#Tasks

use MicroService;
use ServiceFactory;
use Server;
use Client;

use FetchTask;
use TestTask;

$SIG{CHLD} = 'IGNORE';

# Create the server UDP
my $service = ServiceFactory->create_microservice(
    port => 3235,
    host => '0.0.0.0',
    reuse_port => 1,
    listen => 5
);

# Define the client handler factory
$service->{server}->{client_handler_factory} = sub {
    my ($client_socket) = @_;
    return Client->new(
        client => $client_socket,
        tasks => {
            fetch => 'FetchTask',
            test  => 'TestTask',
        }
    );
};

# Start the microservice
$service->start();

END {
    if ($service && $service->{server}) {
        $service->{server}->close();        
    }
}