/// <reference types="node" />
import { INestApplicationContext, Logger } from '@nestjs/common';
import { AbstractWsAdapter } from '@nestjs/websockets';
import { MessageMappingProperties } from '@nestjs/websockets/gateway-metadata-explorer';
import * as http from 'http';
import { Observable } from 'rxjs';
type WsServerRegistryEntry = any[];
/**
 * @publicApi
 */
export declare class WsAdapter extends AbstractWsAdapter {
    protected readonly logger: Logger;
    protected readonly httpServersRegistry: Map<number, any>;
    protected readonly wsServersRegistry: Map<number, WsServerRegistryEntry>;
    constructor(appOrHttpServer?: INestApplicationContext | any);
    create(port: number, options?: Record<string, any> & {
        namespace?: string;
        server?: any;
        path?: string;
    }): any;
    bindMessageHandlers(client: any, handlers: MessageMappingProperties[], transform: (data: any) => Observable<any>): void;
    bindMessageHandler(buffer: any, handlers: MessageMappingProperties[], transform: (data: any) => Observable<any>): Observable<any>;
    bindErrorHandler(server: any): any;
    bindClientDisconnect(client: any, callback: Function): void;
    dispose(): Promise<void>;
    protected ensureHttpServerExists(port: number, httpServer?: http.Server<typeof http.IncomingMessage, typeof http.ServerResponse>): http.Server<typeof http.IncomingMessage, typeof http.ServerResponse>;
    protected addWsServerToRegistry<T extends Record<'path', string> = any>(wsServer: T, port: number, path: string): void;
}
export {};
