const path = require("./path.json");

//only core microservices
module.exports = {
  apps : [
    {
      name: "backend",
      script: 'dist/main.js',
      out_file: path ? path.LOGS_PATH + "/backend.log" : "logs/backend.log",
      error_file: path ? path.LOGS_PATH + "/backend-error.log" : "logs/backend-error.log",
      exec_mode : "cluster",
      instances : "2",
      treekill: false,
      log_date_format: "YYYY-MM-DD HH:mm:ss"
    },
    {
      name: "metrics-server",
      script: 'dist/metrics-server/main.js',
      out_file: path ? path.LOGS_PATH + "/metrics-server.log" : "logs/metrics-server.log",
      error_file: path ? path.LOGS_PATH + "/metrics-server-error.log" : "logs/metrics-server-error.log",
      exec_mode : "cluster",
      instances : "2",
      log_date_format: "YYYY-MM-DD HH:mm:ss"
    },
    {
      name: "tasks-server",
      script: 'dist/tasks-server/main.js',
      out_file: path ? path.LOGS_PATH + "/tasks-server.log" : "logs/tasks-server.log",
      error_file: path ? path.LOGS_PATH + "/tasks-server-error.log" : "logs/tasks-server-error.log",
      exec_mode : "cluster",
      instances : "1",
      log_date_format: "YYYY-MM-DD HH:mm:ss"
    }
    //{
    //  name: "api-worker",
    //  script: 'dist/api-worker/main.js',
    //  out_file: "logs/api-worker.log",
    //  error_file: "logs/api-worker-error.log",
    //  exec_mode : "cluster",
    //  instances : "2"
    //}
  ]
};
